/*mysqldump.php version 1.4 */
/* Table structure for table `ps_accessory` */
DROP TABLE IF EXISTS `ps_accessory`;

CREATE TABLE `ps_accessory` (
  `id_product_1` int(10) unsigned NOT NULL,
  `id_product_2` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_product_1`,`id_product_2`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_accessory` */
INSERT INTO `ps_accessory` VALUES
(1,2),
(1,5),
(1,6),
(1,10);

/* Table structure for table `ps_attachment` */
DROP TABLE IF EXISTS `ps_attachment`;

CREATE TABLE `ps_attachment` (
  `id_attachment` int(10) unsigned NOT NULL auto_increment,
  `file` varchar(40) NOT NULL,
  `file_name` varchar(128) NOT NULL,
  `mime` varchar(128) NOT NULL,
  PRIMARY KEY  (`id_attachment`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_attachment` */
INSERT INTO `ps_attachment` VALUES
(1,'47fa1cb8babfb92537afad38d3422abb3ab7cf5e','test_attachment.txt','text/plain');

/* Table structure for table `ps_attachment_lang` */
DROP TABLE IF EXISTS `ps_attachment_lang`;

CREATE TABLE `ps_attachment_lang` (
  `id_attachment` int(10) unsigned NOT NULL auto_increment,
  `id_lang` int(10) unsigned NOT NULL,
  `name` varchar(32) default NULL,
  `description` text,
  PRIMARY KEY  (`id_attachment`,`id_lang`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_attachment_lang` */
INSERT INTO `ps_attachment_lang` VALUES
(1,1,'Test Attachment','Lorem ipsum'),
(1,2,'Test Attachment',''),
(1,3,'Test Attachment',''),
(1,4,'Test Attachment',''),
(1,5,'Test Attachment','');

/* Table structure for table `ps_attribute` */
DROP TABLE IF EXISTS `ps_attribute`;

CREATE TABLE `ps_attribute` (
  `id_attribute` int(10) unsigned NOT NULL auto_increment,
  `id_attribute_group` int(10) unsigned NOT NULL,
  `color` varchar(32) default NULL,
  PRIMARY KEY  (`id_attribute`),
  KEY `attribute_group` (`id_attribute_group`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_attribute` */
INSERT INTO `ps_attribute` VALUES
(1,1,''),
(2,2,''),
(3,2,''),
(4,1,''),
(5,1,'');

/* Table structure for table `ps_attribute_group` */
DROP TABLE IF EXISTS `ps_attribute_group`;

CREATE TABLE `ps_attribute_group` (
  `id_attribute_group` int(10) unsigned NOT NULL auto_increment,
  `is_color_group` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id_attribute_group`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_attribute_group` */
INSERT INTO `ps_attribute_group` VALUES
(1,0),
(2,0);

/* Table structure for table `ps_attribute_group_lang` */
DROP TABLE IF EXISTS `ps_attribute_group_lang`;

CREATE TABLE `ps_attribute_group_lang` (
  `id_attribute_group` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `name` varchar(128) NOT NULL,
  `public_name` varchar(64) NOT NULL,
  PRIMARY KEY  (`id_attribute_group`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_attribute_group_lang` */
INSERT INTO `ps_attribute_group_lang` VALUES
(1,1,'Color','Color'),
(1,2,'Color','Color'),
(1,3,'Color','Color'),
(1,4,'Color','Color'),
(1,5,'Color','Color'),
(2,1,'Material','Material'),
(2,2,'Material','Material'),
(2,3,'Material','Material'),
(2,4,'Material','Material'),
(2,5,'Material','Material');

/* Table structure for table `ps_attribute_impact` */
DROP TABLE IF EXISTS `ps_attribute_impact`;

CREATE TABLE `ps_attribute_impact` (
  `id_attribute_impact` int(10) unsigned NOT NULL auto_increment,
  `id_product` int(11) unsigned NOT NULL,
  `id_attribute` int(11) unsigned NOT NULL,
  `weight` float NOT NULL,
  `price` decimal(17,2) NOT NULL,
  PRIMARY KEY  (`id_attribute_impact`),
  UNIQUE KEY `id_product` (`id_product`,`id_attribute`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


/* Table structure for table `ps_attribute_lang` */
DROP TABLE IF EXISTS `ps_attribute_lang`;

CREATE TABLE `ps_attribute_lang` (
  `id_attribute` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `name` varchar(128) NOT NULL,
  PRIMARY KEY  (`id_attribute`,`id_lang`),
  KEY `id_lang` (`id_lang`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_attribute_lang` */
INSERT INTO `ps_attribute_lang` VALUES
(1,1,'black'),
(1,2,'black'),
(1,3,'black'),
(1,4,'black'),
(1,5,'black'),
(2,1,'metal'),
(2,2,'metal'),
(2,3,'metal'),
(2,4,'metal'),
(2,5,'metal'),
(3,1,'plastic'),
(3,2,'plastic'),
(3,3,'plastic'),
(3,4,'plastic'),
(3,5,'plastic'),
(4,1,'red'),
(4,2,'red'),
(4,3,'red'),
(4,4,'red'),
(4,5,'red'),
(5,1,'green'),
(5,2,'green'),
(5,3,'green'),
(5,4,'green'),
(5,5,'green');

/* Table structure for table `ps_blocklink` */
DROP TABLE IF EXISTS `ps_blocklink`;

CREATE TABLE `ps_blocklink` (
  `id_blocklink` int(2) NOT NULL auto_increment,
  `url` varchar(255) NOT NULL,
  `new_window` tinyint(1) NOT NULL,
  PRIMARY KEY  (`id_blocklink`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_blocklink` */
INSERT INTO `ps_blocklink` VALUES
(1,'http://facebook.com/',0),
(2,'http://twitter.com/',0),
(3,'http://blog.templatemonster.com/',0),
(4,'http://www.templatemonster.com/all-rss.php',0);

/* Table structure for table `ps_blocklink_lang` */
DROP TABLE IF EXISTS `ps_blocklink_lang`;

CREATE TABLE `ps_blocklink_lang` (
  `id_blocklink` int(2) NOT NULL,
  `id_lang` int(2) NOT NULL,
  `text` varchar(64) NOT NULL,
  PRIMARY KEY  (`id_blocklink`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_blocklink_lang` */
INSERT INTO `ps_blocklink_lang` VALUES
(1,1,'Facebook Link'),
(1,2,'Facebook Link'),
(1,3,'Facebook Link'),
(2,1,'Twitter Link'),
(2,2,'Twitter Link'),
(2,3,'Twitter Link'),
(3,3,'http://blog.templatemonster.com/'),
(3,2,'http://blog.templatemonster.com/'),
(3,1,'Our Blog'),
(4,1,'All RSS'),
(4,2,'All RSS'),
(4,3,'All RSS');

/* Table structure for table `ps_category` */
DROP TABLE IF EXISTS `ps_category`;

CREATE TABLE `ps_category` (
  `id_category` int(10) unsigned NOT NULL auto_increment,
  `id_parent` int(10) unsigned NOT NULL,
  `level_depth` tinyint(3) unsigned NOT NULL default '0',
  `nleft` int(10) unsigned NOT NULL default '0',
  `nright` int(10) unsigned NOT NULL default '0',
  `active` tinyint(1) unsigned NOT NULL default '0',
  `date_add` datetime NOT NULL,
  `date_upd` datetime NOT NULL,
  `position` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_category`),
  KEY `category_parent` (`id_parent`),
  KEY `nleftright` (`nleft`,`nright`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_category` */
INSERT INTO `ps_category` VALUES
(1,0,0,1,22,1,'2012-05-21 14:38:05','2012-05-21 14:38:05',0),
(2,1,1,2,3,1,'2012-08-06 17:41:52','2012-08-06 17:41:52',0),
(3,1,1,4,5,1,'2012-08-06 17:41:52','2012-08-06 17:41:52',1),
(4,1,1,6,17,1,'2012-08-06 17:41:53','2012-08-06 17:41:53',2),
(5,4,2,7,8,1,'2012-08-06 17:41:54','2012-08-06 17:41:54',0),
(6,4,2,9,10,1,'2012-08-06 17:41:54','2012-08-06 17:41:54',1),
(7,4,2,11,12,1,'2012-08-06 17:41:55','2012-08-06 17:41:55',2),
(8,4,2,13,14,1,'2012-08-06 17:41:55','2012-08-06 17:41:55',3),
(9,4,2,15,16,1,'2012-08-06 17:41:56','2012-08-06 17:41:56',4),
(10,1,1,18,19,1,'2012-08-06 17:41:57','2012-08-06 17:41:57',3),
(11,1,1,20,21,1,'2012-08-06 17:41:57','2012-08-06 17:41:57',4);

/* Table structure for table `ps_category_group` */
DROP TABLE IF EXISTS `ps_category_group`;

CREATE TABLE `ps_category_group` (
  `id_category` int(10) unsigned NOT NULL,
  `id_group` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_category`,`id_group`),
  KEY `id_category` (`id_category`),
  KEY `id_group` (`id_group`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_category_group` */
INSERT INTO `ps_category_group` VALUES
(1,1),
(2,1),
(3,1),
(4,1),
(5,1),
(6,1),
(7,1),
(8,1),
(9,1),
(10,1),
(11,1);

/* Table structure for table `ps_category_lang` */
DROP TABLE IF EXISTS `ps_category_lang`;

CREATE TABLE `ps_category_lang` (
  `id_category` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `name` varchar(128) NOT NULL,
  `description` text,
  `link_rewrite` varchar(128) NOT NULL,
  `meta_title` varchar(128) default NULL,
  `meta_keywords` varchar(255) default NULL,
  `meta_description` varchar(255) default NULL,
  PRIMARY KEY  (`id_category`,`id_lang`),
  KEY `category_name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_category_lang` */
INSERT INTO `ps_category_lang` VALUES
(1,1,'Home','','home',null,null,null),
(1,2,'Accueil','','home',null,null,null),
(1,3,'Inicio','','home',null,null,null),
(1,4,'Start','','home',null,null,null),
(1,5,'Home page','','home',null,null,null),
(11,4,'Home Appliances','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands.','home-appliances','','',''),
(11,5,'Home Appliances','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands.','home-appliances','','',''),
(11,3,'Home Appliances','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands.','home-appliances','','',''),
(11,2,'Home Appliances','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands.','home-appliances','','',''),
(11,1,'Home Appliances','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands.','home-appliances','','',''),
(10,5,'Computing','If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.','computing','','',''),
(10,4,'Computing','If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.','computing','','',''),
(10,2,'Computing','If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.','computing','','',''),
(10,3,'Computing','If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.','computing','','',''),
(10,1,'Computing','If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.','computing','','',''),
(9,4,'Adipisicing','The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations.','adipisicing','','',''),
(9,5,'Adipisicing','The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations.','adipisicing','','',''),
(9,2,'Adipisicing','The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations.','adipisicing','','',''),
(9,3,'Adipisicing','The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations.','adipisicing','','',''),
(9,1,'Adipisicing','The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations.','adipisicing','','',''),
(8,4,'Ctetur','Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches.','ctetur','','',''),
(8,5,'Ctetur','Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches.','ctetur','','',''),
(8,3,'Ctetur','Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches.','ctetur','','',''),
(8,1,'Ctetur','Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches.','ctetur','','',''),
(8,2,'Ctetur','Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches.','ctetur','','',''),
(7,4,'Conse','But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.','conse','','',''),
(7,5,'Conse','But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.','conse','','',''),
(7,2,'Conse','But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.','conse','','',''),
(7,3,'Conse','But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.','conse','','',''),
(7,1,'Conse','But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.','conse','','',''),
(6,4,'Dolor sit amet','We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. Remember that only in our store you can buy fashionable, solid and very functional home electronics. ','dolor-sit-amet','','',''),
(6,5,'Dolor sit amet','We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. Remember that only in our store you can buy fashionable, solid and very functional home electronics. ','dolor-sit-amet','','',''),
(6,3,'Dolor sit amet','We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. Remember that only in our store you can buy fashionable, solid and very functional home electronics. ','dolor-sit-amet','','',''),
(6,1,'Dolor sit amet','We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. Remember that only in our store you can buy fashionable, solid and very functional home electronics. ','dolor-sit-amet','','',''),
(6,2,'Dolor sit amet','We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. Remember that only in our store you can buy fashionable, solid and very functional home electronics. ','dolor-sit-amet','','',''),
(5,5,'Lorem ipsum','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.','lorem-ipsum','','',''),
(5,3,'Lorem ipsum','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.','lorem-ipsum','','',''),
(5,4,'Lorem ipsum','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.','lorem-ipsum','','',''),
(5,1,'Lorem ipsum','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.','lorem-ipsum','','',''),
(5,2,'Lorem ipsum','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.','lorem-ipsum','','',''),
(4,4,'Mobile','Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable.','mobile','','',''),
(4,5,'Mobile','Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable.','mobile','','',''),
(4,3,'Mobile','Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable.','mobile','','',''),
(4,1,'Mobile','Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable.','mobile','','',''),
(4,2,'Mobile','Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable.','mobile','','',''),
(3,4,'Photo and Camcoders','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','photo-and-camcoders','','',''),
(3,5,'Photo and Camcoders','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','photo-and-camcoders','','',''),
(3,3,'Photo and Camcoders','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','photo-and-camcoders','','',''),
(3,1,'Photo and Camcoders','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','photo-and-camcoders','','',''),
(3,2,'Photo and Camcoders','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','photo-and-camcoders','','',''),
(2,5,'TV and Video','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands.','tv-and-video','','',''),
(2,4,'TV and Video','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands.','tv-and-video','','',''),
(2,3,'TV and Video','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands.','tv-and-video','','',''),
(2,2,'TV and Video','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands.','tv-and-video','','',''),
(2,1,'TV and Video','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands.','tv-and-video','','','');

/* Table structure for table `ps_category_product` */
DROP TABLE IF EXISTS `ps_category_product`;

CREATE TABLE `ps_category_product` (
  `id_category` int(10) unsigned NOT NULL,
  `id_product` int(10) unsigned NOT NULL,
  `position` int(10) unsigned NOT NULL default '0',
  UNIQUE KEY `category_product_index` (`id_category`,`id_product`),
  KEY `id_product` (`id_product`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_category_product` */
INSERT INTO `ps_category_product` VALUES
(1,1,0),
(2,1,0),
(8,1,0),
(1,2,1),
(2,2,1),
(8,2,1),
(1,3,2),
(2,3,2),
(8,3,2),
(1,4,3),
(2,4,3),
(8,4,3),
(1,5,4),
(2,5,4),
(8,5,4),
(1,6,5),
(2,6,5),
(8,6,5),
(1,7,6),
(3,7,0),
(9,7,0),
(1,8,7),
(3,8,1),
(9,8,1),
(1,9,8),
(3,9,2),
(9,9,2),
(1,10,9),
(3,10,3),
(9,10,3),
(1,11,10),
(3,11,4),
(9,11,4),
(1,12,11),
(3,12,5),
(9,12,5),
(1,13,12),
(5,13,0),
(10,13,0),
(1,14,13),
(5,14,1),
(10,14,1),
(1,15,14),
(5,15,2),
(10,15,2),
(1,16,15),
(5,16,3),
(10,16,3),
(1,17,16),
(5,17,4),
(10,17,4),
(1,18,17),
(5,18,5),
(10,18,5),
(1,19,18),
(6,19,0),
(11,19,0),
(1,20,19),
(6,20,1),
(11,20,1),
(1,21,20),
(6,21,2),
(11,21,2),
(1,22,21),
(6,22,3),
(11,22,3),
(1,23,22),
(6,23,4),
(11,23,4),
(1,24,23),
(6,24,5),
(11,24,5),
(1,25,24),
(7,25,0),
(1,26,25),
(7,26,1),
(1,27,26),
(7,27,2),
(1,28,27),
(7,28,3),
(1,29,28),
(7,29,4),
(1,30,29),
(7,30,5);

/* Table structure for table `ps_cms` */
DROP TABLE IF EXISTS `ps_cms`;

CREATE TABLE `ps_cms` (
  `id_cms` int(10) unsigned NOT NULL auto_increment,
  `id_cms_category` int(10) unsigned NOT NULL,
  `position` int(10) unsigned NOT NULL default '0',
  `active` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_cms`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_cms` */
INSERT INTO `ps_cms` VALUES
(1,1,0,1),
(2,1,1,1),
(3,1,2,1),
(4,1,3,1),
(5,1,4,1),
(6,1,5,1),
(7,1,6,1);

/* Table structure for table `ps_cms_block` */
DROP TABLE IF EXISTS `ps_cms_block`;

CREATE TABLE `ps_cms_block` (
  `id_cms_block` int(10) unsigned NOT NULL auto_increment,
  `id_cms_category` int(10) unsigned NOT NULL,
  `name` varchar(40) NOT NULL,
  `location` tinyint(1) unsigned NOT NULL,
  `position` int(10) unsigned NOT NULL default '0',
  `display_store` tinyint(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id_cms_block`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_cms_block` */
INSERT INTO `ps_cms_block` VALUES
(1,1,'',0,0,1);

/* Table structure for table `ps_cms_block_lang` */
DROP TABLE IF EXISTS `ps_cms_block_lang`;

CREATE TABLE `ps_cms_block_lang` (
  `id_cms_block` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `name` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`id_cms_block`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_cms_block_lang` */
INSERT INTO `ps_cms_block_lang` VALUES
(1,1,'Information'),
(1,2,'Informations'),
(1,3,'Informaciónes'),
(1,4,'Information'),
(1,5,'Informazioni');

/* Table structure for table `ps_cms_block_page` */
DROP TABLE IF EXISTS `ps_cms_block_page`;

CREATE TABLE `ps_cms_block_page` (
  `id_cms_block_page` int(10) unsigned NOT NULL auto_increment,
  `id_cms_block` int(10) unsigned NOT NULL,
  `id_cms` int(10) unsigned NOT NULL,
  `is_category` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY  (`id_cms_block_page`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_cms_block_page` */
INSERT INTO `ps_cms_block_page` VALUES
(1,1,1,0),
(2,1,2,0),
(3,1,3,0),
(4,1,4,0),
(5,1,5,0),
(6,1,6,0),
(7,1,7,0);

/* Table structure for table `ps_cms_category` */
DROP TABLE IF EXISTS `ps_cms_category`;

CREATE TABLE `ps_cms_category` (
  `id_cms_category` int(10) unsigned NOT NULL auto_increment,
  `id_parent` int(10) unsigned NOT NULL,
  `level_depth` tinyint(3) unsigned NOT NULL default '0',
  `active` tinyint(1) unsigned NOT NULL default '0',
  `date_add` datetime NOT NULL,
  `date_upd` datetime NOT NULL,
  `position` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_cms_category`),
  KEY `category_parent` (`id_parent`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_cms_category` */
INSERT INTO `ps_cms_category` VALUES
(1,0,0,1,'2012-05-21 14:38:05','2012-05-21 14:38:05',0);

/* Table structure for table `ps_cms_category_lang` */
DROP TABLE IF EXISTS `ps_cms_category_lang`;

CREATE TABLE `ps_cms_category_lang` (
  `id_cms_category` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `name` varchar(128) NOT NULL,
  `description` text,
  `link_rewrite` varchar(128) NOT NULL,
  `meta_title` varchar(128) default NULL,
  `meta_keywords` varchar(255) default NULL,
  `meta_description` varchar(255) default NULL,
  UNIQUE KEY `category_lang_index` (`id_cms_category`,`id_lang`),
  KEY `category_name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_cms_category_lang` */
INSERT INTO `ps_cms_category_lang` VALUES
(1,1,'Home','','home',null,null,null),
(1,2,'Accueil','','home',null,null,null),
(1,3,'Inicio','','home',null,null,null),
(1,4,'Start','','Start',null,null,null),
(1,5,'Home','','home',null,null,null);

/* Table structure for table `ps_cms_lang` */
DROP TABLE IF EXISTS `ps_cms_lang`;

CREATE TABLE `ps_cms_lang` (
  `id_cms` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `meta_title` varchar(128) NOT NULL,
  `meta_description` varchar(255) default NULL,
  `meta_keywords` varchar(255) default NULL,
  `content` longtext,
  `link_rewrite` varchar(128) NOT NULL,
  PRIMARY KEY  (`id_cms`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_cms_lang` */
INSERT INTO `ps_cms_lang` VALUES
(1,1,'Delivery','Our terms and conditions of delivery','conditions, delivery, delay, shipment, pack','<h2>Shipments and returns</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS.</span></p>\r\n<p>Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</p>\r\n<ul>\r\n<li>Lorem ipsum dolor sit amet</li>\r\n<li>Consectetur adipisicing elit, sed do eiusmod tempor</li>\r\n<li>Incididunt ut labore et dolore magna aliqua</li>\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n<li>Exercitation ullamco laboris nisi ut aliquip</li>\r\n</ul>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>\r\n<h2>Your pack shipment</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS.</span></p>\r\n<p>Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</p>\r\n<ul>\r\n<li>Exercitation ullamco laboris nisi ut aliquip</li>\r\n<li>Lorem ipsum dolor sit amet</li>\r\n<li>Consectetur adipisicing elit, sed do eiusmod tempor</li>\r\n<li>Incididunt ut labore et dolore magna aliqua</li>\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n</ul>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>','delivery'),
(1,2,'Livraison','Nos conditions générales de livraison','conditions, livraison, délais, transport, colis','<h2>Shipments and returns</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS.</span></p>\r\n<p>Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</p>\r\n<ul>\r\n<li>Lorem ipsum dolor sit amet</li>\r\n<li>Consectetur adipisicing elit, sed do eiusmod tempor</li>\r\n<li>Incididunt ut labore et dolore magna aliqua</li>\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n<li>Exercitation ullamco laboris nisi ut aliquip</li>\r\n</ul>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>\r\n<h2>Your pack shipment</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS.</span></p>\r\n<p>Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</p>\r\n<ul>\r\n<li>Exercitation ullamco laboris nisi ut aliquip</li>\r\n<li>Lorem ipsum dolor sit amet</li>\r\n<li>Consectetur adipisicing elit, sed do eiusmod tempor</li>\r\n<li>Incididunt ut labore et dolore magna aliqua</li>\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n</ul>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>','livraison'),
(2,1,'Legal Notice','Legal notice','notice, legal, credits','<h2>Legal</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS. Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</span></p>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>\r\n<h2>Credits</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS. Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</span></p>\r\n<ul>\r\n<li>Exercitation ullamco laboris nisi ut aliquip</li>\r\n<li>Lorem ipsum dolor sit amet</li>\r\n<li>Consectetur adipisicing elit, sed do eiusmod tempor</li>\r\n<li>Incididunt ut labore et dolore magna aliqua</li>\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n</ul>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>\r\n<hr />\r\n<p>This Web site was created using PrestaShop™ open-source software.</p>','legal-notice'),
(2,2,'Mentions légales','Mentions légales','mentions, légales, crédits','<h2>Legal</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS. Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</span></p>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>\r\n<h2>Credits</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS. Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</span></p>\r\n<ul>\r\n<li>Exercitation ullamco laboris nisi ut aliquip</li>\r\n<li>Lorem ipsum dolor sit amet</li>\r\n<li>Consectetur adipisicing elit, sed do eiusmod tempor</li>\r\n<li>Incididunt ut labore et dolore magna aliqua</li>\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n</ul>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>\r\n<hr />\r\n<p>This Web site was created using PrestaShop™ open-source software.</p>','mentions-legales'),
(3,1,'Terms and conditions of use','Our terms and conditions of use','conditions, terms, use, sell','<h2>Your terms and conditions of use</h2>\r\n<p><span style=\"font-size: 12pt;\">Welcome to our shop! If you visit our shop it means that you automatically accept all these terms and conditions. Please carefully read all information concerning our guidelines, terms and agreements. Nowadays it is very important to care about the information because we are living in the informational society and you can\'t underestimate the way information will be used and shared. Trust is the cornerstone of friendship and we appreciate your decision to choose our store. We are giving you a full access to different types of information concerning your account.</span></p>\r\n<p>Additionally please note that our website contains numerous trademarks which can belong both to our company and third party companies. Using the logos, icons and service names is prohibited in any manner that is likely to cause confusion among our customers, and will be considered a violation of copyright law. We reserve the right to make changes to these terms and conditions at any time without prior notifications. Our company is located in New York, USA and the laws of the state of New York shall govern any interpretation of these terms and conditions.</p>','terms-and-conditions-of-use'),
(3,2,'Conditions d\'utilisation','Nos conditions générales de ventes','conditions, utilisation, générales, ventes','<h2>Your terms and conditions of use</h2>\r\n<p><span style=\"font-size: 12pt;\">Welcome to our shop! If you visit our shop it means that you automatically accept all these terms and conditions. Please carefully read all information concerning our guidelines, terms and agreements. Nowadays it is very important to care about the information because we are living in the informational society and you can\'t underestimate the way information will be used and shared. Trust is the cornerstone of friendship and we appreciate your decision to choose our store. We are giving you a full access to different types of information concerning your account.</span></p>\r\n<p>Additionally please note that our website contains numerous trademarks which can belong both to our company and third party companies. Using the logos, icons and service names is prohibited in any manner that is likely to cause confusion among our customers, and will be considered a violation of copyright law. We reserve the right to make changes to these terms and conditions at any time without prior notifications. Our company is located in New York, USA and the laws of the state of New York shall govern any interpretation of these terms and conditions.</p>','conditions-generales-de-ventes'),
(4,1,'About us','Learn more about us','about us, informations','<h2>About us</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Our philosophy is all about professional entrepreneurship and perfectly serving our clients. Since the early days our team extends its passion to sell premium quality goods for your comfortable living. Through the years we\'ve managed to create one of the most famous brands in our country and now we are glad to share our products online with you. Our mission is not about gaining huge profits, we care about the people because by choosing our store you are giving us a chance to change a small part of your world and we are happy to do that professionally and passionately.</span></p>\r\n<p>Our business is growing day by day and we are glad to announce another milestone which is signified by the launch of our web store - another wonderful way to browse and enjoy the best commodities from our brand. Being an international store is a great challenge for our firm but we will take it with honor and dignity. We can promise you that you will feel all advantages of online shopping because this is way better and more comfortable than the traditional one.</p>','about-us'),
(4,2,'A propos','Apprenez-en d\'avantage sur nous','à propos, informations','<h2>About us</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Our philosophy is all about professional entrepreneurship and perfectly serving our clients. Since the early days our team extends its passion to sell premium quality goods for your comfortable living. Through the years we\'ve managed to create one of the most famous brands in our country and now we are glad to share our products online with you. Our mission is not about gaining huge profits, we care about the people because by choosing our store you are giving us a chance to change a small part of your world and we are happy to do that professionally and passionately.</span></p>\r\n<p>Our business is growing day by day and we are glad to announce another milestone which is signified by the launch of our web store - another wonderful way to browse and enjoy the best commodities from our brand. Being an international store is a great challenge for our firm but we will take it with honor and dignity. We can promise you that you will feel all advantages of online shopping because this is way better and more comfortable than the traditional one.</p>','a-propos'),
(5,1,'Secure payment','Our secure payment mean','secure payment, ssl, visa, mastercard, paypal','<h2>Secure payment</h2>\r\n<h3>Our secure payment</h3><p>With SSL</p>\r\n<h3>Using Visa/Mastercard/Paypal</h3><p>About this services</p>','secure-payment'),
(5,2,'Paiement sécurisé','Notre offre de paiement sécurisé','paiement sécurisé, ssl, visa, mastercard, paypal','<h2>Paiement sécurisé</h2>\r\n<h3>Notre offre de paiement sécurisé</h3><p>Avec SSL</p>\r\n<h3>Utilisation de Visa/Mastercard/Paypal</h3><p>A propos de ces services</p>','paiement-securise'),
(1,3,'Entrega','Nuestras condiciones de entrega','condiciones, plazos de entrega, transporte, paquetería','<h2>Shipments and returns</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS.</span></p>\r\n<p>Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</p>\r\n<ul>\r\n<li>Lorem ipsum dolor sit amet</li>\r\n<li>Consectetur adipisicing elit, sed do eiusmod tempor</li>\r\n<li>Incididunt ut labore et dolore magna aliqua</li>\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n<li>Exercitation ullamco laboris nisi ut aliquip</li>\r\n</ul>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>\r\n<h2>Your pack shipment</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS.</span></p>\r\n<p>Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</p>\r\n<ul>\r\n<li>Exercitation ullamco laboris nisi ut aliquip</li>\r\n<li>Lorem ipsum dolor sit amet</li>\r\n<li>Consectetur adipisicing elit, sed do eiusmod tempor</li>\r\n<li>Incididunt ut labore et dolore magna aliqua</li>\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n</ul>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>','entrega'),
(2,3,'Aviso legal','Aviso legal','términos, condiciones y créditos fotográficos','<h2>Legal</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS. Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</span></p>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>\r\n<h2>Credits</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Packages are generally dispatched within 2 days after receipt of payment and are shipped via UPS with tracking and drop-off without signature. If you prefer delivery by UPS. Extra with required signature, an additional cost will be applied, so please contact us before choosing this method. Whichever shipment choice you make, we will provide you with a link to track your package online.</span></p>\r\n<ul>\r\n<li>Exercitation ullamco laboris nisi ut aliquip</li>\r\n<li>Lorem ipsum dolor sit amet</li>\r\n<li>Consectetur adipisicing elit, sed do eiusmod tempor</li>\r\n<li>Incididunt ut labore et dolore magna aliqua</li>\r\n<li>Ut enim ad minim veniam, quis nostrud</li>\r\n</ul>\r\n<p>Shipping fees include handling and packing fees as well as postage costs. Handling fees are fixed, whereas transport fees vary according to total weight of the shipment. We advise you to group your items in one order. We cannot group two distinct orders placed separately, and shipping fees will apply to each of them. Your package will be dispatched at your own risk, but special care is taken to protect fragile objects.Boxes are amply sized and your items are well-protected.</p>\r\n<hr />\r\n<p>This Web site was created using PrestaShop™ open-source software.</p>','aviso-legal'),
(3,3,'Condiciones de uso','Condiciones de uso','condiciones, el consumo, las ventas generales','<h2>Your terms and conditions of use</h2>\r\n<p><span style=\"font-size: 12pt;\">Welcome to our shop! If you visit our shop it means that you automatically accept all these terms and conditions. Please carefully read all information concerning our guidelines, terms and agreements. Nowadays it is very important to care about the information because we are living in the informational society and you can\'t underestimate the way information will be used and shared. Trust is the cornerstone of friendship and we appreciate your decision to choose our store. We are giving you a full access to different types of information concerning your account.</span></p>\r\n<p>Additionally please note that our website contains numerous trademarks which can belong both to our company and third party companies. Using the logos, icons and service names is prohibited in any manner that is likely to cause confusion among our customers, and will be considered a violation of copyright law. We reserve the right to make changes to these terms and conditions at any time without prior notifications. Our company is located in New York, USA and the laws of the state of New York shall govern any interpretation of these terms and conditions.</p>','condiciones-de-uso'),
(4,3,'Sobre','Conozca más sobre nosotros','sobre, información','<h2>About us</h2>\r\n<p><span style=\"font-size: 12pt; color: #000000;\">Our philosophy is all about professional entrepreneurship and perfectly serving our clients. Since the early days our team extends its passion to sell premium quality goods for your comfortable living. Through the years we\'ve managed to create one of the most famous brands in our country and now we are glad to share our products online with you. Our mission is not about gaining huge profits, we care about the people because by choosing our store you are giving us a chance to change a small part of your world and we are happy to do that professionally and passionately.</span></p>\r\n<p>Our business is growing day by day and we are glad to announce another milestone which is signified by the launch of our web store - another wonderful way to browse and enjoy the best commodities from our brand. Being an international store is a great challenge for our firm but we will take it with honor and dignity. We can promise you that you will feel all advantages of online shopping because this is way better and more comfortable than the traditional one.</p>','sobre'),
(5,3,'Pago seguro','Ofrecemos pago seguro','pago seguro, ssl, visa, mastercard, paypal','<h2><span id=\"result_box\"><span style=\"background-color: #ffffff;\" title=\"Paiement sécurisé\">Pago seguro</span></span></h2>\r\n<h3><span id=\"result_box\"><span style=\"background-color: #ffffff;\" title=\"Notre offre de paiement sécurisé\">Ofrecemos pago seguro</span></span></h3>\r\n<p><span id=\"result_box\"><span style=\"background-color: #ffffff;\" title=\"Avec SSL\">SSL</span></span></p>\r\n<h3><span id=\"result_box\"><span style=\"background-color: #ffffff;\" title=\"Utilisation de Visa/Mastercard/Paypal\">Utilice Visa / Mastercard / Paypal</span></span></h3>\r\n<p><span id=\"result_box\"><span style=\"background-color: #ffffff;\" title=\"A propos de ces services\">Acerca de estos servicios</span></span></p>','pago-seguro'),
(1,4,'Lieferung','Unsere Lieferbedingungen','Bedingungen, Lieferung, Frist, Versand, Verpackung','<h2>Versand und Rücknahme</h2>\r\n<h3>Ihre Versandverpackung</h3>\r\n<p>Pakete werden normalerweise 2 Tage nach Zahlungseingang mit UPS mit Bestellverfolgemöglichkeit und Ablieferung ohne Unterschrift geliefert. Wenn Sie lieber eine UPS-Sendung per Einschreiben erhalten möchten, entstehen zusätzliche Kosten. Bitte kontaktieren Sie uns, bevor Sie dieses Liefermethode wählen. Wir senden Ihnen einen Link für die Bestellverfolgung unabhängig davon, welche Liefermethode Sie wählen.</p>\r\n<p>Die Versandkosten beinhalten Lade- und Verpackungsgebühren sowie die Portokosten. Die Verladegebühren stehen fest, wobei Transportkosten schwanken, je nach Gesamtgewicht des Pakets. Wir raten Ihnen, mehrere Artikel in einer Bestellung zusammenzufassen. Wir können zwei verschiedene Bestellungen nicht zusammenlegen, und die Versandkosten werden separat für jede Bestellung gerechnet. Ihr Paket wird auf Ihr Risiko versandt, aber zerbrechliche Ware wird besonders sorgsam behandelt.<br /><br />Die Versandschachteln sind weit geschnitten und ihre Ware wird gut geschützt verpackt.</p>','Lieferung'),
(2,4,'Rechtliche Hinweise','Rechtliche Hinweise','Hinweise, rechtlich, Gutscheine','<h2>Legal</h2>\r\n<h3>Credits</h3>\r\n<p>Konzept und Gestaltung:</p>\r\n<p>Diese Webseite wurde hergestellt unter Verwendung von <a href=\"http://www.prestashop.com\">PrestaShop</a>™ open-source software.</p>','rechtliche-hinweise'),
(3,4,'Allgemeine Nutzungsbedingungen','Unsere allgemeinen Nutzungsbedingungen','Voraussetzungen, Bedingungen, nutzen, verkaufen','<h2>Your terms and conditions of use</h2>\r\n<h3>Rule 1</h3>\r\n<p>Here is the rule 1 content</p>\r\n<h3>Rule 2</h3>\r\n<p>Here is the rule 2 content</p>\r\n<h3>Rule 3</h3>\r\n<p>Here is the rule 3 content</p>','allgemeine-nutzungsbedingungen'),
(4,4,'Über uns','Learn more about us','über uns, Informationen','<h2>About us</h2>\r\n<h3>Our company</h3>\r\n<p>Our company</p>\r\n<h3>Our team</h3>\r\n<p>Our team</p>\r\n<h3>Informations</h3>\r\n<p>Informations</p>','uber-uns'),
(5,4,'Sichere Zahlung','Unsere Sicherheits-Zahlungsmethoden','Sichere Zahlung, SSL, Visa, MasterCard, PayPal','<h2>Secure payment</h2>\r\n<h3>Our secure payment</h3><p>With SSL</p>\r\n<h3>Using Visa/Mastercard/Paypal</h3><p>About this services</p>','sichere-zahlung'),
(1,5,'Consegna','I nostri termini e condizioni di consegna','condizioni, consegna, tempo, spedizione, pacco','<h2>Spedizioni e resi</h2>\r\n<h3>Spedizione del tuo pacco</h3>\r\n<p>I pacchi sono solitamente spediti entro 2 giorni dopo il ricevimento del pagamento e inviati tramite UPS con controllo e consegna senza firma. Se preferisci una consegna con UPS Extra con richiesta di firma, sarà applicato un costo aggiuntivo, pertanto contattaci prima di scegliere questo mezzo. Qualunque tipo di spedizione tu scelga, ti garantiremo un link per controllare online il percorso del tuo pacco.</p>\r\n<p>Le spese di spedizione comprendono le spese di imballaggio e affrancatura. Le spese di imballaggio sono fisse, mentre quelle di trasporto variano in base al peso totale della spedizione. Ti consigliamo di raggruppare i tuoi articoli in un unico ordine. Non possiamo raggruppare due ordini distinti eseguiti separatamente, e ad ognuno di esso saranno applicate le spese di spedizione. Il tuo pacco sarà inviato sotto la tua responsabilità, ma un\'attenzione particolare è riservata agli oggetti fragili.<br /><br />Le scatole hanno dimensioni ragionevoli e i tuoi articoli sono ben protetti.</p>','consegna'),
(2,5,'Nota Legale','Nota legale','nota, legale, crediti','<h2>Legale</h2>\r\n<h3>Crediti</h3>\r\n<p>Creazione e produzione:</p>\r\n<p>Questo sito web è stato realizzato usando un software open-source<a href=\"http://www.prestashop.com\">PrestaShop</a>™.</p>','nota-legale'),
(3,5,'Termini e condizioni d\'uso','I nostri termini e condizioni d\'uso','condizioni, termini, uso, vendi','<h2>I tuoi termini e condizioni d\'uso</h2>\r\n<h3>Regola 1</h3>\r\n<p>Ecco il contenuto della regola 1</p>\r\n<h3>Regola 2</h3>\r\n<p>Ecco il contenuto della regola 2</p>\r\n<h3>Regola 3</h3>\r\n<p>Ecco il contenuto della regola 3</p>','termini-e-condizioni-di-uso'),
(4,5,'Chi siamo','Per sapere chi siamo','chi siamo, informazioni','<h2>Chi siamo</h2>\r\n<h3>La nostra azienda</h3>\r\n<p>La nostra azienda</p>\r\n<h3>Il nostro team</h3>\r\n<p>Il nostro team</p>\r\n<h3>Informazioni</h3>\r\n<p>Informazioni</p>','chi-siamo'),
(5,5,'Pagamento sicuro','Il nostro mezzo di pagamento sicuro','pagamento sicuro, ssl, visa, mastercard, paypal','<h2>Pagamento sicuro</h2>\r\n<h3>Il nostro pagamento sicuro</h3><p>Con SSL</p>\r\n<h3>Usando Visa/Mastercard/Paypal</h3><p>Cosa sono questi servizi</p>','pagamento-sicuro'),
(6,1,'Privacy policy','Privacy policy','Privacy policy','<h2>Privacy policy</h2>\r\n<p>Privacy policy</p>','privacy-policy'),
(7,1,'Right of withdrawal','Right of withdrawal','Right of withdrawal','<h2>Right of withdrawal</h2>\r\n<p>Right of withdrawal</p>','right-of-withdrawal'),
(6,2,'Politique de confidentialité','Politique de confidentialité','Politique de confidentialité','<h2>Politique de confidentialité</h2>\r\n<p>Politique de confidentialité</p>','politique-de-confidentialite'),
(7,2,'Droits de rétractation','Droit de rétractation','Droit de rétractation','<h2>Droit de rétractation</h2>\r\n<p>Droit de rétractation</p>','droit-de-retractation'),
(6,3,'Privacy policy','Privacy policy','Privacy policy','<h2>Privacy policy</h2>\r\n<p>Privacy policy</p>','privacy-policy'),
(7,3,'Right of withdrawal','Right of withdrawal','Right of withdrawal','<h2>Right of withdrawal</h2>\r\n<p>Right of withdrawal</p>','right-of-withdrawal'),
(6,4,'Privacy policy','Privacy policy','Privacy policy','<h2>Privacy policy</h2>\r\n<p>Privacy policy</p>','privacy-policy'),
(7,4,'Right of withdrawal','Right of withdrawal','Right of withdrawal','<h2>Right of withdrawal</h2>\r\n<p>Right of withdrawal</p>','right-of-withdrawal'),
(6,5,'Privacy policy','Privacy policy','Privacy policy','<h2>Privacy policy</h2>\r\n<p>Privacy policy</p>','privacy-policy'),
(7,5,'Right of withdrawal','Right of withdrawal','Right of withdrawal','<h2>Right of withdrawal</h2>\r\n<p>Right of withdrawal</p>','right-of-withdrawal');

/* Table structure for table `ps_compare` */
DROP TABLE IF EXISTS `ps_compare`;

CREATE TABLE `ps_compare` (
  `id_compare` int(10) unsigned NOT NULL auto_increment,
  `id_customer` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_compare`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


/* Table structure for table `ps_configuration` */
DROP TABLE IF EXISTS `ps_configuration`;

CREATE TABLE `ps_configuration` (
  `id_configuration` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL,
  `value` text,
  `date_add` datetime NOT NULL,
  `date_upd` datetime NOT NULL,
  PRIMARY KEY  (`id_configuration`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=225 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_configuration` */
INSERT INTO `ps_configuration` VALUES
(1,'PS_LANG_DEFAULT','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(2,'PS_CURRENCY_DEFAULT','2','2012-05-21 14:38:05','2012-05-21 13:38:26'),
(3,'PS_COUNTRY_DEFAULT','21','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(4,'PS_REWRITING_SETTINGS','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(5,'PS_ORDER_OUT_OF_STOCK','0','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(6,'PS_LAST_QTIES','3','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(7,'PS_CART_REDIRECT','1','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(8,'PS_HELPBOX','1','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(9,'PS_CONDITIONS','1','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(10,'PS_RECYCLABLE_PACK','1','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(11,'PS_GIFT_WRAPPING','1','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(12,'PS_GIFT_WRAPPING_PRICE','0','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(13,'PS_STOCK_MANAGEMENT','1','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(14,'PS_NAVIGATION_PIPE','>','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(15,'PS_PRODUCTS_PER_PAGE','6','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(16,'PS_PURCHASE_MINIMUM','0','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(17,'PS_PRODUCTS_ORDER_WAY','0','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(18,'PS_PRODUCTS_ORDER_BY','4','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(19,'PS_DISPLAY_QTIES','1','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(20,'PS_SHIPPING_HANDLING','2','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(21,'PS_SHIPPING_FREE_PRICE','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(22,'PS_SHIPPING_FREE_WEIGHT','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(23,'PS_SHIPPING_METHOD','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(24,'PS_TAX','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(25,'PS_SHOP_ENABLE','1','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(26,'PS_NB_DAYS_NEW_PRODUCT','20','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(27,'PS_SSL_ENABLED','0','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(28,'PS_WEIGHT_UNIT','lb','2012-05-21 14:38:05','2012-05-21 13:38:26'),
(29,'PS_BLOCK_CART_AJAX','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(30,'PS_ORDER_RETURN','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(31,'PS_ORDER_RETURN_NB_DAYS','7','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(32,'PS_MAIL_TYPE','3','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(33,'PS_PRODUCT_PICTURE_MAX_SIZE','131072','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(34,'PS_PRODUCT_PICTURE_WIDTH','64','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(35,'PS_PRODUCT_PICTURE_HEIGHT','64','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(36,'PS_INVOICE_PREFIX','IN','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(37,'PS_INVOICE_NUMBER','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(38,'PS_DELIVERY_PREFIX','DE','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(39,'PS_DELIVERY_NUMBER','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(40,'PS_INVOICE','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(41,'PS_PASSWD_TIME_BACK','360','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(42,'PS_PASSWD_TIME_FRONT','360','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(43,'PS_DISP_UNAVAILABLE_ATTR','1','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(44,'PS_VOUCHERS','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(45,'PS_SEARCH_MINWORDLEN','3','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(46,'PS_SEARCH_BLACKLIST','','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(47,'PS_SEARCH_WEIGHT_PNAME','6','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(48,'PS_SEARCH_WEIGHT_REF','10','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(49,'PS_SEARCH_WEIGHT_SHORTDESC','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(50,'PS_SEARCH_WEIGHT_DESC','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(51,'PS_SEARCH_WEIGHT_CNAME','3','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(52,'PS_SEARCH_WEIGHT_MNAME','3','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(53,'PS_SEARCH_WEIGHT_TAG','4','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(54,'PS_SEARCH_WEIGHT_ATTRIBUTE','2','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(55,'PS_SEARCH_WEIGHT_FEATURE','2','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(56,'PS_SEARCH_AJAX','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(57,'PS_TIMEZONE','Europe/Athens','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(58,'PS_THEME_V11','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(59,'PRESTASTORE_LIVE','1','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(60,'PS_TIN_ACTIVE','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(61,'PS_SHOW_ALL_MODULES','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(62,'PS_BACKUP_ALL','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(63,'PS_1_3_UPDATE_DATE','2012-05-21 14:38:05','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(64,'PS_PRICE_ROUND_MODE','2','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(65,'PS_1_3_2_UPDATE_DATE','2012-05-21 14:38:05','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(66,'PS_CONDITIONS_CMS_ID','3','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(67,'TRACKING_DIRECT_TRAFFIC','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(68,'PS_META_KEYWORDS','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(69,'PS_DISPLAY_JQZOOM','1','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(70,'PS_VOLUME_UNIT','gal','2012-05-21 14:38:05','2012-05-21 13:38:26'),
(71,'PS_CIPHER_ALGORITHM','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(72,'PS_ATTRIBUTE_CATEGORY_DISPLAY','1','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(73,'PS_CUSTOMER_SERVICE_FILE_UPLOAD','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(74,'PS_CUSTOMER_SERVICE_SIGNATURE','','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(75,'PS_BLOCK_BESTSELLERS_DISPLAY','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(76,'PS_BLOCK_NEWPRODUCTS_DISPLAY','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(77,'PS_BLOCK_SPECIALS_DISPLAY','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(78,'PS_STOCK_MVT_REASON_DEFAULT','3','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(79,'PS_COMPARATOR_MAX_ITEM','2','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(80,'PS_ORDER_PROCESS_TYPE','0','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(81,'PS_SPECIFIC_PRICE_PRIORITIES','id_shop;id_currency;id_country;id_group','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(82,'PS_TAX_DISPLAY','1','2012-05-21 14:38:05','2012-05-21 13:38:26'),
(83,'PS_SMARTY_FORCE_COMPILE','1','2012-05-21 14:38:05','2012-05-21 14:48:54'),
(84,'PS_DISTANCE_UNIT','mi','2012-05-21 14:38:05','2012-05-21 13:38:26'),
(85,'PS_STORES_DISPLAY_CMS','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(86,'PS_STORES_DISPLAY_FOOTER','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(87,'PS_STORES_SIMPLIFIED','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(88,'SHOP_LOGO_WIDTH','224','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(89,'SHOP_LOGO_HEIGHT','73','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(90,'EDITORIAL_IMAGE_WIDTH','530','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(91,'EDITORIAL_IMAGE_HEIGHT','228','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(92,'PS_STATSDATA_CUSTOMER_PAGESVIEWS','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(93,'PS_STATSDATA_PAGESVIEWS','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(94,'PS_STATSDATA_PLUGINS','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(95,'PS_GEOLOCATION_ENABLED','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(96,'PS_ALLOWED_COUNTRIES','AF;ZA;AX;AL;DZ;DE;AD;AO;AI;AQ;AG;AN;SA;AR;AM;AW;AU;AT;AZ;BS;BH;BD;BB;BY;BE;BZ;BJ;BM;BT;BO;BA;BW;BV;BR;BN;BG;BF;MM;BI;KY;KH;CM;CA;CV;CF;CL;CN;CX;CY;CC;CO;KM;CG;CD;CK;KR;KP;CR;CI;HR;CU;DK;DJ;DM;EG;IE;SV;AE;EC;ER;ES;EE;ET;FK;FO;FJ;FI;FR;GA;GM;GE;GS;GH;GI;GR;GD;GL;GP;GU;GT;GG;GN;GQ;GW;GY;GF;HT;HM;HN;HK;HU;IM;MU;VG;VI;IN;ID;IR;IQ;IS;IL;IT;JM;JP;JE;JO;KZ;KE;KG;KI;KW;LA;LS;LV;LB;LR;LY;LI;LT;LU;MO;MK;MG;MY;MW;MV;ML;MT;MP;MA;MH;MQ;MR;YT;MX;FM;MD;MC;MN;ME;MS;MZ;NA;NR;NP;NI;NE;NG;NU;NF;NO;NC;NZ;IO;OM;UG;UZ;PK;PW;PS;PA;PG;PY;NL;PE;PH;PN;PL;PF;PR;PT;QA;DO;CZ;RE;RO;GB;RU;RW;EH;BL;KN;SM;MF;PM;VA;VC;LC;SB;WS;AS;ST;SN;RS;SC;SL;SG;SK;SI;SO;SD;LK;SE;CH;SR;SJ;SZ;SY;TJ;TW;TZ;TD;TF;TH;TL;TG;TK;TO;TT;TN;TM;TC;TR;TV;UA;UY;US;VU;VE;VN;WF;YE;ZM;ZW','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(97,'PS_GEOLOCATION_BEHAVIOR','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(98,'PS_LOCALE_LANGUAGE','en','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(99,'PS_LOCALE_COUNTRY','US','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(100,'PS_ATTACHMENT_MAXIMUM_SIZE','2','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(101,'PS_SMARTY_CACHE','0','2012-05-21 14:38:05','2012-05-21 14:48:54'),
(102,'PS_DIMENSION_UNIT','in','2012-05-21 14:38:05','2012-05-21 13:38:26'),
(103,'PS_FORCE_SMARTY_2','0','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(104,'PS_GUEST_CHECKOUT_ENABLED','0','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(105,'PS_DISPLAY_SUPPLIERS','1','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(106,'PS_CATALOG_MODE','0','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(107,'PS_GEOLOCATION_WHITELIST','209.185.108;209.185.253;209.85.238;209.85.238.11;209.85.238.4;216.239.33.96;216.239.33.97;216.239.33.98;216.239.33.99;216.239.37.98;216.239.37.99;216.239.39.98;216.239.39.99;216.239.41.96;216.239.41.97;216.239.41.98;216.239.41.99;216.239.45.4;216.239.46;216.239.51.96;216.239.51.97;216.239.51.98;216.239.51.99;216.239.53.98;216.239.53.99;216.239.57.96;216.239.57.97;216.239.57.98;216.239.57.99;216.239.59.98;216.239.59.99;216.33.229.163;64.233.173.193;64.233.173.194;64.233.173.195;64.233.173.196;64.233.173.197;64.233.173.198;64.233.173.199;64.233.173.200;64.233.173.201;64.233.173.202;64.233.173.203;64.233.173.204;64.233.173.205;64.233.173.206;64.233.173.207;64.233.173.208;64.233.173.209;64.233.173.210;64.233.173.211;64.233.173.212;64.233.173.213;64.233.173.214;64.233.173.215;64.233.173.216;64.233.173.217;64.233.173.218;64.233.173.219;64.233.173.220;64.233.173.221;64.233.173.222;64.233.173.223;64.233.173.224;64.233.173.225;64.233.173.226;64.233.173.227;64.233.173.228;64.233.173.229;64.233.173.230;64.233.173.231;64.233.173.232;64.233.173.233;64.233.173.234;64.233.173.235;64.233.173.236;64.233.173.237;64.233.173.238;64.233.173.239;64.233.173.240;64.233.173.241;64.233.173.242;64.233.173.243;64.233.173.244;64.233.173.245;64.233.173.246;64.233.173.247;64.233.173.248;64.233.173.249;64.233.173.250;64.233.173.251;64.233.173.252;64.233.173.253;64.233.173.254;64.233.173.255;64.68.80;64.68.81;64.68.82;64.68.83;64.68.84;64.68.85;64.68.86;64.68.87;64.68.88;64.68.89;64.68.90.1;64.68.90.10;64.68.90.11;64.68.90.12;64.68.90.129;64.68.90.13;64.68.90.130;64.68.90.131;64.68.90.132;64.68.90.133;64.68.90.134;64.68.90.135;64.68.90.136;64.68.90.137;64.68.90.138;64.68.90.139;64.68.90.14;64.68.90.140;64.68.90.141;64.68.90.142;64.68.90.143;64.68.90.144;64.68.90.145;64.68.90.146;64.68.90.147;64.68.90.148;64.68.90.149;64.68.90.15;64.68.90.150;64.68.90.151;64.68.90.152;64.68.90.153;64.68.90.154;64.68.90.155;64.68.90.156;64.68.90.157;64.68.90.158;64.68.90.159;64.68.90.16;64.68.90.160;64.68.90.161;64.68.90.162;64.68.90.163;64.68.90.164;64.68.90.165;64.68.90.166;64.68.90.167;64.68.90.168;64.68.90.169;64.68.90.17;64.68.90.170;64.68.90.171;64.68.90.172;64.68.90.173;64.68.90.174;64.68.90.175;64.68.90.176;64.68.90.177;64.68.90.178;64.68.90.179;64.68.90.18;64.68.90.180;64.68.90.181;64.68.90.182;64.68.90.183;64.68.90.184;64.68.90.185;64.68.90.186;64.68.90.187;64.68.90.188;64.68.90.189;64.68.90.19;64.68.90.190;64.68.90.191;64.68.90.192;64.68.90.193;64.68.90.194;64.68.90.195;64.68.90.196;64.68.90.197;64.68.90.198;64.68.90.199;64.68.90.2;64.68.90.20;64.68.90.200;64.68.90.201;64.68.90.202;64.68.90.203;64.68.90.204;64.68.90.205;64.68.90.206;64.68.90.207;64.68.90.208;64.68.90.21;64.68.90.22;64.68.90.23;64.68.90.24;64.68.90.25;64.68.90.26;64.68.90.27;64.68.90.28;64.68.90.29;64.68.90.3;64.68.90.30;64.68.90.31;64.68.90.32;64.68.90.33;64.68.90.34;64.68.90.35;64.68.90.36;64.68.90.37;64.68.90.38;64.68.90.39;64.68.90.4;64.68.90.40;64.68.90.41;64.68.90.42;64.68.90.43;64.68.90.44;64.68.90.45;64.68.90.46;64.68.90.47;64.68.90.48;64.68.90.49;64.68.90.5;64.68.90.50;64.68.90.51;64.68.90.52;64.68.90.53;64.68.90.54;64.68.90.55;64.68.90.56;64.68.90.57;64.68.90.58;64.68.90.59;64.68.90.6;64.68.90.60;64.68.90.61;64.68.90.62;64.68.90.63;64.68.90.64;64.68.90.65;64.68.90.66;64.68.90.67;64.68.90.68;64.68.90.69;64.68.90.7;64.68.90.70;64.68.90.71;64.68.90.72;64.68.90.73;64.68.90.74;64.68.90.75;64.68.90.76;64.68.90.77;64.68.90.78;64.68.90.79;64.68.90.8;64.68.90.80;64.68.90.9;64.68.91;64.68.92;66.249.64;66.249.65;66.249.66;66.249.67;66.249.68;66.249.69;66.249.70;66.249.71;66.249.72;66.249.73;66.249.78;66.249.79;72.14.199;8.6.48','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(108,'PS_LOGS_BY_EMAIL','5','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(109,'PS_COOKIE_CHECKIP','1','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(110,'PS_STORES_CENTER_LAT','25.948969','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(111,'PS_STORES_CENTER_LONG','-80.226439','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(112,'PS_HOMEPAGE_PHP_SELF','index.php','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(113,'PS_USE_ECOTAX','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(114,'PS_CANONICAL_REDIRECT','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(115,'PS_IMG_UPDATE_TIME','1337600285','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(116,'PS_BACKUP_DROP_TABLE','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(117,'PS_OS_CHEQUE','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(118,'PS_OS_PAYMENT','2','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(119,'PS_OS_PREPARATION','3','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(120,'PS_OS_SHIPPING','4','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(121,'PS_OS_DELIVERED','5','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(122,'PS_OS_CANCELED','6','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(123,'PS_OS_REFUND','7','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(124,'PS_OS_ERROR','8','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(125,'PS_OS_OUTOFSTOCK','9','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(126,'PS_OS_BANKWIRE','10','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(127,'PS_OS_PAYPAL','11','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(128,'PS_OS_WS_PAYMENT','12','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(129,'PS_LEGACY_IMAGES','1','2012-05-21 14:38:05','2012-05-22 12:26:52'),
(130,'PS_IMAGE_QUALITY','png_all','2012-05-21 14:38:05','2012-08-08 16:38:07'),
(131,'PS_PNG_QUALITY','3','2012-05-21 14:38:05','2012-08-08 16:38:07'),
(132,'PS_JPEG_QUALITY','90','2012-05-21 14:38:05','2012-08-08 16:38:07'),
(133,'PS_COOKIE_LIFETIME_FO','480','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(134,'PS_COOKIE_LIFETIME_BO','480','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(135,'PS_RESTRICT_DELIVERED_COUNTRIES','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(136,'PS_LIMIT_UPLOAD_IMAGE_VALUE','2','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(137,'PS_LIMIT_UPLOAD_FILE_VALUE','2','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(138,'PS_CARRIER_DEFAULT','2','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(139,'PS_TAX_ADDRESS_TYPE','id_address_delivery','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(140,'MB_PAY_TO_EMAIL','','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(141,'MB_SECRET_WORD','','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(142,'MB_HIDE_LOGIN','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(143,'MB_ID_LOGO','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(144,'MB_ID_LOGO_WALLET','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(145,'MB_PARAMETERS','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(146,'MB_PARAMETERS_2','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(147,'MB_DISPLAY_MODE','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(148,'MB_CANCEL_URL','http://www.yoursite.com','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(149,'MB_LOCAL_METHODS','2','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(150,'MB_INTER_METHODS','5','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(151,'BANK_WIRE_CURRENCIES','2,1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(152,'CHEQUE_CURRENCIES','2,1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(153,'PRODUCTS_VIEWED_NBR','2','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(156,'MANUFACTURER_DISPLAY_FORM','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(157,'MANUFACTURER_DISPLAY_TEXT','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(158,'MANUFACTURER_DISPLAY_TEXT_NB','5','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(159,'NEW_PRODUCTS_NBR','5','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(160,'PS_TOKEN_ENABLE','1','2012-05-21 14:38:05','2012-05-21 16:57:53'),
(161,'PS_STATS_RENDER','graphxmlswfcharts','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(162,'PS_STATS_OLD_CONNECT_AUTO_CLEAN','never','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(163,'PS_STATS_GRID_RENDER','gridhtml','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(164,'BLOCKTAGS_NBR','10','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(165,'CHECKUP_DESCRIPTIONS_LT','100','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(166,'CHECKUP_DESCRIPTIONS_GT','400','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(167,'CHECKUP_IMAGES_LT','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(168,'CHECKUP_IMAGES_GT','2','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(169,'CHECKUP_SALES_LT','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(170,'CHECKUP_SALES_GT','2','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(171,'CHECKUP_STOCK_LT','1','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(172,'CHECKUP_STOCK_GT','3','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(193,'PS_SHOP_STATE','','2012-05-21 14:52:21','2012-08-06 17:03:42'),
(192,'PS_SHOP_COUNTRY','','2012-05-21 14:52:21','2012-08-06 17:03:42'),
(176,'BLOCKADVERT_LINK','0','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(177,'BLOCKSTORE_IMG','store.jpg','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(178,'PS_VERSION_DB','1.4.8.2','2012-05-21 14:38:05','2012-05-21 14:38:05'),
(179,'PS_BASE_DISTANCE_UNIT','ft','2012-05-21 13:38:26','2012-05-21 13:38:26'),
(180,'PS_SHOP_DOMAIN','','2012-05-21 14:38:27','2012-05-21 14:38:27'),
(181,'PS_SHOP_DOMAIN_SSL','','2012-05-21 14:38:27','2012-05-21 14:38:27'),
(182,'PS_INSTALL_VERSION','1.4.8.2','2012-05-21 14:38:27','2012-05-21 14:38:27'),
(183,'PS_SHOP_NAME','ElectroStore','2012-05-21 14:38:27','2012-08-06 17:03:43'),
(184,'PS_SHOP_EMAIL','admin@admin.com','2012-05-21 14:38:27','2012-08-06 17:03:43'),
(185,'PS_MAIL_METHOD','1','2012-05-21 14:38:27','2012-05-21 14:38:27'),
(186,'PS_SHOP_ACTIVITY','0','2012-05-21 14:38:27','2012-05-21 14:38:27'),
(187,'BLOCKADVERT_IMG_EXT','jpg','2012-05-21 14:47:50','2012-08-09 11:39:46'),
(188,'PS_LAST_VERSION','a:10:{s:4:\"name\";s:13:\"1.4.8.2 final\";s:3:\"num\";s:7:\"1.4.8.2\";s:4:\"link\";s:66:\"http://www.prestashop.com/download/releases/prestashop_1.4.8.2.zip\";s:3:\"md5\";s:32:\"fa95a95970489a27442a5c53ca4ca6f3\";s:11:\"autoupgrade\";i:1;s:18:\"autoupgrade_module\";i:1;s:24:\"autoupgrade_last_version\";s:5:\"0.3.4\";s:23:\"autoupgrade_module_link\";s:50:\"http://www.prestashop.com/download/autoupgrade.zip\";s:9:\"changelog\";s:0:\"\";s:4:\"desc\";s:0:\"\";}','2012-05-21 14:48:31','2012-08-08 16:05:46'),
(189,'PS_LAST_VERSION_CHECK','1344431146','2012-05-21 14:48:31','2012-08-08 16:05:46'),
(190,'PS_PREACTIVATION_PAYPAL_WARNING','','2012-05-21 14:48:32','2012-08-09 11:39:32'),
(191,'TS_TAB1_ENV_API','test','2012-05-21 14:49:10','2012-05-21 14:49:10'),
(194,'PS_SHOP_ADDR1','','2012-05-21 14:52:21','2012-08-06 17:03:43'),
(195,'PS_SHOP_ADDR2','','2012-05-21 14:52:21','2012-08-06 17:03:43'),
(196,'PS_SHOP_CITY','','2012-05-21 14:52:21','2012-08-06 17:03:43'),
(197,'PS_SHOP_STATE_ID','0','2012-05-21 14:52:21','2012-08-06 17:03:43'),
(198,'PS_SHOP_CODE','','2012-05-21 14:52:21','2012-08-06 17:03:43'),
(199,'PS_SHOP_COUNTRY_ID','0','2012-05-21 14:52:21','2012-08-06 17:03:43'),
(200,'PS_SHOP_PHONE','','2012-05-21 14:52:21','2012-08-06 17:03:43'),
(201,'PS_SHOP_DETAILS','','2012-05-21 14:52:21','2012-08-06 17:03:43'),
(202,'PS_SHOP_FAX','','2012-05-21 14:52:21','2012-08-06 17:03:43'),
(203,'HOME_FEATURED_NBR','6','2012-05-21 14:53:24','2012-05-21 14:53:24'),
(204,'PS_MAINTENANCE_IP','','2012-05-21 16:57:53','2012-05-21 16:57:53'),
(205,'PS_GIFT_WRAPPING_TAX','0','2012-05-21 16:57:53','2012-05-21 16:57:53'),
(206,'PS_CART_FOLLOWING','1','2012-05-21 16:57:53','2012-05-21 16:57:53'),
(207,'PS_HIDE_OPTIMIZATION_TIPS','0','2012-05-21 16:57:53','2012-05-21 16:57:53'),
(208,'PS_BLOCKLINK_TITLE','','2012-05-21 17:00:02','2012-05-21 17:00:02'),
(209,'RSS_FEED_TITLE','RSS feed','2012-05-21 17:00:02','2012-05-21 17:33:08'),
(210,'RSS_FEED_NBR','5','2012-05-21 17:00:02','2012-05-21 17:33:08'),
(211,'SUPPLIER_DISPLAY_TEXT','1','2012-05-21 17:00:02','2012-05-21 17:00:02'),
(212,'SUPPLIER_DISPLAY_TEXT_NB','5','2012-05-21 17:00:02','2012-05-21 17:00:02'),
(213,'SUPPLIER_DISPLAY_FORM','1','2012-05-21 17:00:02','2012-05-21 17:00:02'),
(214,'RSS_FEED_URL','http://blog.templatemonster.com/feed/','2012-05-21 17:33:08','2012-05-21 17:33:08'),
(215,'PS_PAYMENT_LOGO_CMS_ID','5','2012-05-21 17:43:22','2012-05-21 17:43:22'),
(216,'PS_PRODUCT_SHORT_DESC_LIMIT','0','2012-05-22 10:33:00','2012-05-22 12:26:52'),
(217,'PS_IMAGE_GENERATION_METHOD','0','2012-05-22 10:33:00','2012-05-22 12:26:52'),
(218,'PS_QTY_DISCOUNT_ON_COMBINATION','0','2012-05-22 10:33:00','2012-05-22 12:26:52'),
(222,'PRODUCT_COMMENTS_MINIMAL_TIME','0','2012-08-06 17:01:09','2012-08-06 17:01:17'),
(223,'PRODUCT_COMMENTS_ALLOW_GUESTS','1','2012-08-06 17:01:09','2012-08-06 17:01:17'),
(224,'PRODUCT_COMMENTS_MODERATE','0','2012-08-06 17:01:09','2012-08-06 17:01:17');

/* Table structure for table `ps_configuration_lang` */
DROP TABLE IF EXISTS `ps_configuration_lang`;

CREATE TABLE `ps_configuration_lang` (
  `id_configuration` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `value` text,
  `date_upd` datetime default NULL,
  PRIMARY KEY  (`id_configuration`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_configuration_lang` */
INSERT INTO `ps_configuration_lang` VALUES
(36,1,'IN','2012-05-21 14:38:05'),
(36,2,'FA','2012-05-21 14:38:05'),
(36,3,'CU','2012-05-21 14:38:05'),
(36,4,'FA','2012-05-21 14:38:05'),
(36,5,'FA','2012-05-21 14:38:05'),
(38,1,'DE','2012-05-21 14:38:05'),
(38,2,'LI','2012-05-21 14:38:05'),
(38,3,'EN','2012-05-21 14:38:05'),
(38,4,'LI','2012-05-21 14:38:05'),
(38,5,'BC','2012-05-21 14:38:05'),
(46,1,'a|the|of|on|in|and|to','2012-05-21 14:38:05'),
(46,2,'le|les|de|et|en|des|les|une','2012-05-21 14:38:05'),
(46,3,'de|los|las|lo|la|en|de|y|el|a','2012-05-21 14:38:05'),
(46,4,'','2012-05-21 14:38:05'),
(46,5,'','2012-05-21 14:38:05'),
(68,1,'0','2012-05-21 14:38:05'),
(68,2,'0','2012-05-21 14:38:05'),
(68,3,'0','2012-05-21 14:38:05'),
(68,4,'0','2012-05-21 14:38:05'),
(68,5,'0','2012-05-21 14:38:05'),
(74,1,'Dear Customer,\r\n\r\nRegards,\r\nCustomer service','2012-05-21 14:38:05'),
(74,2,'Cher client,\r\n\r\nCordialement,\r\nLe service client','2012-05-21 14:38:05'),
(74,3,'Estimado cliente,\r\n\r\nUn cordial saludo,\r\nAtención al cliente','2012-05-21 14:38:05'),
(74,4,'Lieber Kunde,\r\n\r\nMit freundlichen Grüßen,\r\nIhr Kundenservice','2012-05-21 14:38:05'),
(74,5,'Gentile Cliente,\r\n\r\nCordiali saluti,\r\nServizio Clienti','2012-05-21 14:38:05'),
(208,1,'Block link','2012-05-21 17:00:02'),
(208,2,'Bloc lien','2012-05-21 17:00:02');

/* Table structure for table `ps_currency` */
DROP TABLE IF EXISTS `ps_currency`;

CREATE TABLE `ps_currency` (
  `id_currency` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL,
  `iso_code` varchar(3) NOT NULL default '0',
  `iso_code_num` varchar(3) NOT NULL default '0',
  `sign` varchar(8) NOT NULL,
  `blank` tinyint(1) unsigned NOT NULL default '0',
  `format` tinyint(1) unsigned NOT NULL default '0',
  `decimals` tinyint(1) unsigned NOT NULL default '1',
  `conversion_rate` decimal(13,6) NOT NULL,
  `deleted` tinyint(1) unsigned NOT NULL default '0',
  `active` tinyint(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id_currency`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_currency` */
INSERT INTO `ps_currency` VALUES
(1,'Euro','EUR','978','€',1,2,1,'0.786102',0,1),
(2,'Dollar','USD','840','$',0,1,1,'1.000000',0,1),
(3,'Pound','GBP','826','£',0,1,1,'0.632183',0,1);

/* Table structure for table `ps_date_range` */
DROP TABLE IF EXISTS `ps_date_range`;

CREATE TABLE `ps_date_range` (
  `id_date_range` int(10) unsigned NOT NULL auto_increment,
  `time_start` datetime NOT NULL,
  `time_end` datetime NOT NULL,
  PRIMARY KEY  (`id_date_range`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


/* Table structure for table `ps_editorial` */
DROP TABLE IF EXISTS `ps_editorial`;

CREATE TABLE `ps_editorial` (
  `id_editorial` int(10) unsigned NOT NULL auto_increment,
  `body_home_logo_link` varchar(255) NOT NULL,
  PRIMARY KEY  (`id_editorial`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_editorial` */
INSERT INTO `ps_editorial` VALUES
(1,'http://www.prestashop.com');

/* Table structure for table `ps_editorial_lang` */
DROP TABLE IF EXISTS `ps_editorial_lang`;

CREATE TABLE `ps_editorial_lang` (
  `id_editorial` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `body_title` varchar(255) NOT NULL,
  `body_subheading` varchar(255) NOT NULL,
  `body_paragraph` text NOT NULL,
  `body_logo_subheading` varchar(255) NOT NULL,
  PRIMARY KEY  (`id_editorial`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_editorial_lang` */
INSERT INTO `ps_editorial_lang` VALUES
(1,1,'Lorem ipsum dolor sit amet','Consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum</p>','Excepteur sint prestashop cupidatat non proident'),
(1,2,'Lorem ipsum dolor sit amet','Excepteur sint occaecat cupidatat non proident','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum</p>','Lorem ipsum presta shop amet'),
(1,3,'Lorem ipsum dolor sit amet','Consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum</p>','Excepteur sint prestashop cupidatat non proident'),
(1,4,'Lorem ipsum dolor sit amet','Consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum</p>','Excepteur sint prestashop cupidatat non proident'),
(1,5,'Lorem ipsum dolor sit amet','Consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua','<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum</p>','Excepteur sint prestashop cupidatat non proident');

/* Table structure for table `ps_feature` */
DROP TABLE IF EXISTS `ps_feature`;

CREATE TABLE `ps_feature` (
  `id_feature` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id_feature`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_feature` */
INSERT INTO `ps_feature` VALUES
(1),
(2),
(3),
(4),
(5),
(6);

/* Table structure for table `ps_feature_lang` */
DROP TABLE IF EXISTS `ps_feature_lang`;

CREATE TABLE `ps_feature_lang` (
  `id_feature` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `name` varchar(128) default NULL,
  PRIMARY KEY  (`id_feature`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_feature_lang` */
INSERT INTO `ps_feature_lang` VALUES
(1,1,'Height'),
(1,2,'Hauteur'),
(2,1,'Width'),
(2,2,'Largeur'),
(3,1,'Depth'),
(3,2,'Profondeur'),
(4,1,'Weight'),
(4,2,'Poids'),
(5,1,'Headphone'),
(5,2,'Prise casque'),
(1,3,'Alto'),
(2,3,'Ancho'),
(3,3,'Profundo'),
(4,3,'Peso'),
(5,3,'Toma auriculares'),
(1,4,'Höhe'),
(2,4,'Breite'),
(3,4,'Tiefe'),
(4,4,'Gewicht'),
(5,4,'Kopfhörer'),
(1,5,'Altezza'),
(2,5,'Larghezza'),
(3,5,'Profondità'),
(4,5,'Peso'),
(5,5,'Auricolare'),
(6,1,'Size'),
(6,2,'Size'),
(6,3,'Size'),
(6,4,'Size'),
(6,5,'Size');

/* Table structure for table `ps_feature_product` */
DROP TABLE IF EXISTS `ps_feature_product`;

CREATE TABLE `ps_feature_product` (
  `id_feature` int(10) unsigned NOT NULL,
  `id_product` int(10) unsigned NOT NULL,
  `id_feature_value` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_feature`,`id_product`),
  KEY `id_feature_value` (`id_feature_value`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_feature_product` */
INSERT INTO `ps_feature_product` VALUES
(2,1,465),
(1,1,466),
(3,1,467),
(4,1,468),
(6,1,469),
(2,2,470),
(1,2,471),
(3,2,472),
(4,2,473),
(6,2,474),
(2,3,475),
(1,3,476),
(3,3,477),
(4,3,478),
(6,3,479),
(2,4,480),
(1,4,481),
(3,4,482),
(4,4,483),
(6,4,484),
(2,5,485),
(1,5,486),
(3,5,487),
(4,5,488),
(6,5,489),
(2,6,490),
(1,6,491),
(3,6,492),
(4,6,493),
(6,6,494),
(2,7,495),
(1,7,496),
(3,7,497),
(4,7,498),
(6,7,499),
(2,8,500),
(1,8,501),
(3,8,502),
(4,8,503),
(6,8,504),
(2,9,505),
(1,9,506),
(3,9,507),
(4,9,508),
(6,9,509),
(2,10,510),
(1,10,511),
(3,10,512),
(4,10,513),
(6,10,514),
(2,11,515),
(1,11,516),
(3,11,517),
(4,11,518),
(6,11,519),
(2,12,520),
(1,12,521),
(3,12,522),
(4,12,523),
(6,12,524),
(2,13,525),
(1,13,526),
(3,13,527),
(4,13,528),
(6,13,529),
(2,14,530),
(1,14,531),
(3,14,532),
(4,14,533),
(6,14,534),
(2,15,535),
(1,15,536),
(3,15,537),
(4,15,538),
(6,15,539),
(2,16,540),
(1,16,541),
(3,16,542),
(4,16,543),
(6,16,544),
(2,17,545),
(1,17,546),
(3,17,547),
(4,17,548),
(6,17,549),
(2,18,550),
(1,18,551),
(3,18,552),
(4,18,553),
(6,18,554),
(2,19,555),
(1,19,556),
(3,19,557),
(4,19,558),
(6,19,559),
(2,20,560),
(1,20,561),
(3,20,562),
(4,20,563),
(6,20,564),
(2,21,565),
(1,21,566),
(3,21,567),
(4,21,568),
(6,21,569),
(2,22,570),
(1,22,571),
(3,22,572),
(4,22,573),
(6,22,574),
(2,23,575),
(1,23,576),
(3,23,577),
(4,23,578),
(6,23,579),
(2,24,580),
(1,24,581),
(3,24,582),
(4,24,583),
(6,24,584),
(2,25,585),
(1,25,586),
(3,25,587),
(4,25,588),
(6,25,589),
(2,26,590),
(1,26,591),
(3,26,592),
(4,26,593),
(6,26,594),
(2,27,595),
(1,27,596),
(3,27,597),
(4,27,598),
(6,27,599),
(2,28,600),
(1,28,601),
(3,28,602),
(4,28,603),
(6,28,604),
(2,29,605),
(1,29,606),
(3,29,607),
(4,29,608),
(6,29,609),
(2,30,610),
(1,30,611),
(3,30,612),
(4,30,613),
(6,30,614);

/* Table structure for table `ps_feature_value` */
DROP TABLE IF EXISTS `ps_feature_value`;

CREATE TABLE `ps_feature_value` (
  `id_feature_value` int(10) unsigned NOT NULL auto_increment,
  `id_feature` int(10) unsigned NOT NULL,
  `custom` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`id_feature_value`),
  KEY `feature` (`id_feature`)
) ENGINE=MyISAM AUTO_INCREMENT=615 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_feature_value` */
INSERT INTO `ps_feature_value` VALUES
(11,1,1),
(15,1,1),
(12,2,1),
(16,2,1),
(14,3,1),
(18,3,1),
(13,4,1),
(17,4,1),
(26,3,1),
(25,4,1),
(24,2,1),
(23,1,1),
(9,5,0),
(10,5,0),
(27,2,1),
(28,1,1),
(29,3,1),
(30,4,1),
(31,6,1),
(32,2,1),
(33,1,1),
(34,3,1),
(35,4,1),
(36,6,1),
(37,2,1),
(38,1,1),
(39,3,1),
(40,4,1),
(41,6,1),
(42,2,1),
(43,1,1),
(44,3,1),
(45,4,1),
(46,6,1),
(47,2,1),
(48,1,1),
(49,3,1),
(50,4,1),
(51,6,1),
(52,2,1),
(53,1,1),
(54,3,1),
(55,4,1),
(56,6,1),
(57,2,1),
(58,1,1),
(59,3,1),
(60,4,1),
(61,6,1),
(62,2,1),
(63,1,1),
(64,3,1),
(65,4,1),
(66,6,1),
(67,2,1),
(68,1,1),
(69,3,1),
(70,4,1),
(71,6,1),
(72,2,1),
(73,1,1),
(74,3,1),
(75,4,1),
(76,6,1),
(77,2,1),
(78,1,1),
(79,3,1),
(80,4,1),
(81,6,1),
(82,2,1),
(83,1,1),
(84,3,1),
(85,4,1),
(86,6,1),
(87,2,1),
(88,1,1),
(89,3,1),
(90,4,1),
(91,6,1),
(92,2,1),
(93,1,1),
(94,3,1),
(95,4,1),
(96,6,1),
(97,2,1),
(98,1,1),
(99,3,1),
(100,4,1),
(101,6,1),
(102,2,1),
(103,1,1),
(104,3,1),
(105,4,1),
(106,6,1),
(107,2,1),
(108,1,1),
(109,3,1),
(110,4,1),
(111,6,1),
(112,2,1),
(113,1,1),
(114,3,1),
(115,4,1),
(116,6,1),
(117,2,1),
(118,1,1),
(119,3,1),
(120,4,1),
(121,6,1),
(122,2,1),
(123,1,1),
(124,3,1),
(125,4,1),
(126,6,1),
(127,2,1),
(128,1,1),
(129,3,1),
(130,4,1),
(131,6,1),
(132,2,1),
(133,1,1),
(134,3,1),
(135,4,1),
(136,6,1),
(137,2,1),
(138,1,1),
(139,3,1),
(140,4,1),
(141,6,1),
(142,2,1),
(143,1,1),
(144,3,1),
(145,4,1),
(146,6,1),
(147,2,1),
(148,1,1),
(149,3,1),
(150,4,1),
(151,6,1),
(152,2,1),
(153,1,1),
(154,3,1),
(155,4,1),
(156,6,1),
(157,2,1),
(158,1,1),
(159,3,1),
(160,4,1),
(161,6,1),
(162,2,1),
(163,1,1),
(164,3,1),
(165,4,1),
(166,6,1),
(167,2,1),
(168,1,1),
(169,3,1),
(170,4,1),
(171,6,1),
(172,2,1),
(173,1,1),
(174,3,1),
(175,4,1),
(176,6,1),
(177,2,1),
(178,1,1),
(179,3,1),
(180,4,1),
(181,6,1),
(182,2,1),
(183,1,1),
(184,3,1),
(185,4,1),
(186,6,1),
(187,2,1),
(188,1,1),
(189,3,1),
(190,4,1),
(191,6,1),
(192,2,1),
(193,1,1),
(194,3,1),
(195,4,1),
(196,6,1),
(197,2,1),
(198,1,1),
(199,3,1),
(200,4,1),
(201,6,1),
(202,2,1),
(203,1,1),
(204,3,1),
(205,4,1),
(206,6,1),
(207,2,1),
(208,1,1),
(209,3,1),
(210,4,1),
(211,6,1),
(212,2,1),
(213,1,1),
(214,3,1),
(215,4,1),
(216,6,1),
(217,2,1),
(218,1,1),
(219,3,1),
(220,4,1),
(221,6,1),
(222,2,1),
(223,1,1),
(224,3,1),
(225,4,1),
(226,6,1),
(227,2,1),
(228,1,1),
(229,3,1),
(230,4,1),
(231,6,1),
(232,2,1),
(233,1,1),
(234,3,1),
(235,4,1),
(236,6,1),
(237,2,1),
(238,1,1),
(239,3,1),
(240,4,1),
(241,6,1),
(242,2,1),
(243,1,1),
(244,3,1),
(245,4,1),
(246,6,1),
(247,2,1),
(248,1,1),
(249,3,1),
(250,4,1),
(251,6,1),
(252,2,1),
(253,1,1),
(254,3,1),
(255,4,1),
(256,6,1),
(257,2,1),
(258,1,1),
(259,3,1),
(260,4,1),
(261,6,1),
(262,2,1),
(263,1,1),
(264,3,1),
(265,4,1),
(266,6,1),
(267,2,1),
(268,1,1),
(269,3,1),
(270,4,1),
(271,2,1),
(272,1,1),
(273,3,1),
(274,4,1),
(275,2,1),
(276,1,1),
(277,3,1),
(278,4,1),
(279,2,1),
(280,1,1),
(281,3,1),
(282,4,1),
(283,2,1),
(284,1,1),
(285,3,1),
(286,4,1),
(287,2,1),
(288,1,1),
(289,3,1),
(290,4,1),
(291,2,1),
(292,1,1),
(293,3,1),
(294,4,1),
(295,2,1),
(296,1,1),
(297,3,1),
(298,4,1),
(299,2,1),
(300,1,1),
(301,3,1),
(302,4,1),
(303,2,1),
(304,1,1),
(305,3,1),
(306,4,1),
(307,2,1),
(308,1,1),
(309,3,1),
(310,4,1),
(311,2,1),
(312,1,1),
(313,3,1),
(314,4,1),
(315,2,1),
(316,1,1),
(317,3,1),
(318,4,1),
(319,6,1),
(320,2,1),
(321,1,1),
(322,3,1),
(323,4,1),
(324,6,1),
(325,2,1),
(326,1,1),
(327,3,1),
(328,4,1),
(329,6,1),
(330,2,1),
(331,1,1),
(332,3,1),
(333,4,1),
(334,6,1),
(335,2,1),
(336,1,1),
(337,3,1),
(338,4,1),
(339,6,1),
(340,2,1),
(341,1,1),
(342,3,1),
(343,4,1),
(344,6,1),
(345,2,1),
(346,1,1),
(347,3,1),
(348,4,1),
(349,6,1),
(350,2,1),
(351,1,1),
(352,3,1),
(353,4,1),
(354,6,1),
(355,2,1),
(356,1,1),
(357,3,1),
(358,4,1),
(359,6,1),
(360,2,1),
(361,1,1),
(362,3,1),
(363,4,1),
(364,6,1),
(365,2,1),
(366,1,1),
(367,3,1),
(368,4,1),
(369,6,1),
(370,2,1),
(371,1,1),
(372,3,1),
(373,4,1),
(374,6,1),
(375,2,1),
(376,1,1),
(377,3,1),
(378,4,1),
(379,6,1),
(380,2,1),
(381,1,1),
(382,3,1),
(383,4,1),
(384,6,1),
(385,2,1),
(386,1,1),
(387,3,1),
(388,4,1),
(389,6,1),
(390,2,1),
(391,1,1),
(392,3,1),
(393,4,1),
(394,6,1),
(395,2,1),
(396,1,1),
(397,3,1),
(398,4,1),
(399,6,1),
(400,2,1),
(401,1,1),
(402,3,1),
(403,4,1),
(404,6,1),
(405,2,1),
(406,1,1),
(407,3,1),
(408,4,1),
(409,6,1),
(410,2,1),
(411,1,1),
(412,3,1),
(413,4,1),
(414,6,1),
(415,2,1),
(416,1,1),
(417,3,1),
(418,4,1),
(419,6,1),
(420,2,1),
(421,1,1),
(422,3,1),
(423,4,1),
(424,6,1),
(425,2,1),
(426,1,1),
(427,3,1),
(428,4,1),
(429,6,1),
(430,2,1),
(431,1,1),
(432,3,1),
(433,4,1),
(434,6,1),
(435,2,1),
(436,1,1),
(437,3,1),
(438,4,1),
(439,6,1),
(440,2,1),
(441,1,1),
(442,3,1),
(443,4,1),
(444,6,1),
(445,2,1),
(446,1,1),
(447,3,1),
(448,4,1),
(449,6,1),
(450,2,1),
(451,1,1),
(452,3,1),
(453,4,1),
(454,6,1),
(455,2,1),
(456,1,1),
(457,3,1),
(458,4,1),
(459,6,1),
(460,2,1),
(461,1,1),
(462,3,1),
(463,4,1),
(464,6,1),
(465,2,1),
(466,1,1),
(467,3,1),
(468,4,1),
(469,6,1),
(470,2,1),
(471,1,1),
(472,3,1),
(473,4,1),
(474,6,1),
(475,2,1),
(476,1,1),
(477,3,1),
(478,4,1),
(479,6,1),
(480,2,1),
(481,1,1),
(482,3,1),
(483,4,1),
(484,6,1),
(485,2,1),
(486,1,1),
(487,3,1),
(488,4,1),
(489,6,1),
(490,2,1),
(491,1,1),
(492,3,1),
(493,4,1),
(494,6,1),
(495,2,1),
(496,1,1),
(497,3,1),
(498,4,1),
(499,6,1),
(500,2,1),
(501,1,1),
(502,3,1),
(503,4,1),
(504,6,1),
(505,2,1),
(506,1,1),
(507,3,1),
(508,4,1),
(509,6,1),
(510,2,1),
(511,1,1),
(512,3,1),
(513,4,1),
(514,6,1),
(515,2,1),
(516,1,1),
(517,3,1),
(518,4,1),
(519,6,1),
(520,2,1),
(521,1,1),
(522,3,1),
(523,4,1),
(524,6,1),
(525,2,1),
(526,1,1),
(527,3,1),
(528,4,1),
(529,6,1),
(530,2,1),
(531,1,1),
(532,3,1),
(533,4,1),
(534,6,1),
(535,2,1),
(536,1,1),
(537,3,1),
(538,4,1),
(539,6,1),
(540,2,1),
(541,1,1),
(542,3,1),
(543,4,1),
(544,6,1),
(545,2,1),
(546,1,1),
(547,3,1),
(548,4,1),
(549,6,1),
(550,2,1),
(551,1,1),
(552,3,1),
(553,4,1),
(554,6,1),
(555,2,1),
(556,1,1),
(557,3,1),
(558,4,1),
(559,6,1),
(560,2,1),
(561,1,1),
(562,3,1),
(563,4,1),
(564,6,1),
(565,2,1),
(566,1,1),
(567,3,1),
(568,4,1),
(569,6,1),
(570,2,1),
(571,1,1),
(572,3,1),
(573,4,1),
(574,6,1),
(575,2,1),
(576,1,1),
(577,3,1),
(578,4,1),
(579,6,1),
(580,2,1),
(581,1,1),
(582,3,1),
(583,4,1),
(584,6,1),
(585,2,1),
(586,1,1),
(587,3,1),
(588,4,1),
(589,6,1),
(590,2,1),
(591,1,1),
(592,3,1),
(593,4,1),
(594,6,1),
(595,2,1),
(596,1,1),
(597,3,1),
(598,4,1),
(599,6,1),
(600,2,1),
(601,1,1),
(602,3,1),
(603,4,1),
(604,6,1),
(605,2,1),
(606,1,1),
(607,3,1),
(608,4,1),
(609,6,1),
(610,2,1),
(611,1,1),
(612,3,1),
(613,4,1),
(614,6,1);

/* Table structure for table `ps_feature_value_lang` */
DROP TABLE IF EXISTS `ps_feature_value_lang`;

CREATE TABLE `ps_feature_value_lang` (
  `id_feature_value` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `value` varchar(255) default NULL,
  PRIMARY KEY  (`id_feature_value`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_feature_value_lang` */
INSERT INTO `ps_feature_value_lang` VALUES
(13,1,'49.2 g'),
(13,2,'49,2 g'),
(13,3,'49,2 g'),
(13,4,'49.2 g'),
(13,5,'49.2 g'),
(12,2,'52,3 mm'),
(12,1,'2.06 in'),
(12,3,'52.3 mm'),
(12,4,'52.3 mm'),
(12,5,'52.3 mm'),
(11,2,'69,8 mm'),
(11,1,'2.75 in'),
(11,3,'69.8 mm'),
(11,4,'69.8 mm'),
(11,5,'69.8 mm'),
(17,2,'15,5 g'),
(17,1,'15.5 g'),
(17,3,'15.5 g'),
(17,4,'15.5 g'),
(17,5,'15.5 g'),
(16,2,'41,2 mm'),
(16,1,'1.62 in'),
(16,3,'41.2 mm'),
(16,4,'41.2 mm'),
(16,5,'41.2 mm'),
(15,2,'27,3 mm'),
(15,1,'1.07 in'),
(15,3,'27.3 mm'),
(15,4,'27.3 mm'),
(15,5,'27.3 mm'),
(9,1,'Jack stereo'),
(9,4,'Jack stereo'),
(9,5,'Jack stereo'),
(9,2,'Jack stéréo'),
(9,3,'Jack stereo'),
(10,1,'Mini-jack stereo'),
(10,2,'Mini-jack stéréo'),
(10,3,'Mini-jack stéréo'),
(10,4,'Mini-jack stéréo'),
(10,5,'Mini-jack stéréo'),
(14,1,'0.26 in'),
(14,2,'6,5 mm'),
(14,3,'6,5 mm'),
(14,4,'6,5 mm'),
(14,5,'6,5 mm'),
(18,4,'10,5 mm'),
(18,5,'10,5 mm)'),
(18,1,'0.41 in (clip included)'),
(18,2,'10,5 mm (clip compris)'),
(18,3,'10,5 mm (clip incluyendo)'),
(26,2,'8 mm'),
(26,1,'0.31 in'),
(26,3,'8 mm'),
(26,4,'8 mm'),
(26,5,'8 mm'),
(25,2,'120g'),
(25,3,'120g'),
(25,4,'120g'),
(25,5,'120g'),
(25,1,'120g'),
(24,2,'70 mm'),
(24,1,'2.76 in'),
(24,3,'70 mm'),
(24,4,'70 mm'),
(24,5,'70 mm'),
(23,2,'110 mm'),
(23,3,'110 mm'),
(23,1,'4.33 in'),
(23,4,'4.33 in'),
(23,5,'4.33 in'),
(27,1,'10\"'),
(27,2,'10\"'),
(27,3,'10\"'),
(27,4,'10\"'),
(27,5,'10\"'),
(28,1,'15\"'),
(28,2,'15\"'),
(28,3,'15\"'),
(28,4,'15\"'),
(28,5,'15\"'),
(29,1,'10\"'),
(29,2,'10\"'),
(29,3,'10\"'),
(29,4,'10\"'),
(29,5,'10\"'),
(30,1,'0.5 kg'),
(30,2,'0.5 kg'),
(30,3,'0.5 kg'),
(30,4,'0.5 kg'),
(30,5,'0.5 kg'),
(31,1,'L'),
(31,2,'L'),
(31,3,'L'),
(31,4,'L'),
(31,5,'L'),
(32,1,'15\"'),
(32,2,'15\"'),
(32,3,'15\"'),
(32,4,'15\"'),
(32,5,'15\"'),
(33,1,'5\"'),
(33,2,'5\"'),
(33,3,'5\"'),
(33,4,'5\"'),
(33,5,'5\"'),
(34,1,'15\"'),
(34,2,'15\"'),
(34,3,'15\"'),
(34,4,'15\"'),
(34,5,'15\"'),
(35,1,'1 kg'),
(35,2,'1 kg'),
(35,3,'1 kg'),
(35,4,'1 kg'),
(35,5,'1 kg'),
(36,1,'XL'),
(36,2,'XL'),
(36,3,'XL'),
(36,4,'XL'),
(36,5,'XL'),
(37,1,'5\"'),
(37,2,'5\"'),
(37,3,'5\"'),
(37,4,'5\"'),
(37,5,'5\"'),
(38,1,'10\"'),
(38,2,'10\"'),
(38,3,'10\"'),
(38,4,'10\"'),
(38,5,'10\"'),
(39,1,'5\"'),
(39,2,'5\"'),
(39,3,'5\"'),
(39,4,'5\"'),
(39,5,'5\"'),
(40,1,'0.3 kg'),
(40,2,'0.3 kg'),
(40,3,'0.3 kg'),
(40,4,'0.3 kg'),
(40,5,'0.3 kg'),
(41,1,'XXL'),
(41,2,'XXL'),
(41,3,'XXL'),
(41,4,'XXL'),
(41,5,'XXL'),
(42,1,'10\"'),
(42,2,'10\"'),
(42,3,'10\"'),
(42,4,'10\"'),
(42,5,'10\"'),
(43,1,'15\"'),
(43,2,'15\"'),
(43,3,'15\"'),
(43,4,'15\"'),
(43,5,'15\"'),
(44,1,'10\"'),
(44,2,'10\"'),
(44,3,'10\"'),
(44,4,'10\"'),
(44,5,'10\"'),
(45,1,'2 kg'),
(45,2,'2 kg'),
(45,3,'2 kg'),
(45,4,'2 kg'),
(45,5,'2 kg'),
(46,1,'L'),
(46,2,'L'),
(46,3,'L'),
(46,4,'L'),
(46,5,'L'),
(47,1,'15\"'),
(47,2,'15\"'),
(47,3,'15\"'),
(47,4,'15\"'),
(47,5,'15\"'),
(48,1,'10\"'),
(48,2,'10\"'),
(48,3,'10\"'),
(48,4,'10\"'),
(48,5,'10\"'),
(49,1,'15\"'),
(49,2,'15\"'),
(49,3,'15\"'),
(49,4,'15\"'),
(49,5,'15\"'),
(50,1,'0.5 kg'),
(50,2,'0.5 kg'),
(50,3,'0.5 kg'),
(50,4,'0.5 kg'),
(50,5,'0.5 kg'),
(51,1,'XL'),
(51,2,'XL'),
(51,3,'XL'),
(51,4,'XL'),
(51,5,'XL'),
(52,1,'5\"'),
(52,2,'5\"'),
(52,3,'5\"'),
(52,4,'5\"'),
(52,5,'5\"'),
(53,1,'15\"'),
(53,2,'15\"'),
(53,3,'15\"'),
(53,4,'15\"'),
(53,5,'15\"'),
(54,1,'10\"'),
(54,2,'10\"'),
(54,3,'10\"'),
(54,4,'10\"'),
(54,5,'10\"'),
(55,1,'1 kg'),
(55,2,'1 kg'),
(55,3,'1 kg'),
(55,4,'1 kg'),
(55,5,'1 kg'),
(56,1,'M'),
(56,2,'M'),
(56,3,'M'),
(56,4,'M'),
(56,5,'M'),
(57,1,'5\"'),
(57,2,'5\"'),
(57,3,'5\"'),
(57,4,'5\"'),
(57,5,'5\"'),
(58,1,'5\"'),
(58,2,'5\"'),
(58,3,'5\"'),
(58,4,'5\"'),
(58,5,'5\"'),
(59,1,'15\"'),
(59,2,'15\"'),
(59,3,'15\"'),
(59,4,'15\"'),
(59,5,'15\"'),
(60,1,'0.3 kg'),
(60,2,'0.3 kg'),
(60,3,'0.3 kg'),
(60,4,'0.3 kg'),
(60,5,'0.3 kg'),
(61,1,'L'),
(61,2,'L'),
(61,3,'L'),
(61,4,'L'),
(61,5,'L'),
(62,1,'10\"'),
(62,2,'10\"'),
(62,3,'10\"'),
(62,4,'10\"'),
(62,5,'10\"'),
(63,1,'10\"'),
(63,2,'10\"'),
(63,3,'10\"'),
(63,4,'10\"'),
(63,5,'10\"'),
(64,1,'5\"'),
(64,2,'5\"'),
(64,3,'5\"'),
(64,4,'5\"'),
(64,5,'5\"'),
(65,1,'2 kg'),
(65,2,'2 kg'),
(65,3,'2 kg'),
(65,4,'2 kg'),
(65,5,'2 kg'),
(66,1,'XL'),
(66,2,'XL'),
(66,3,'XL'),
(66,4,'XL'),
(66,5,'XL'),
(67,1,'15\"'),
(67,2,'15\"'),
(67,3,'15\"'),
(67,4,'15\"'),
(67,5,'15\"'),
(68,1,'15\"'),
(68,2,'15\"'),
(68,3,'15\"'),
(68,4,'15\"'),
(68,5,'15\"'),
(69,1,'10\"'),
(69,2,'10\"'),
(69,3,'10\"'),
(69,4,'10\"'),
(69,5,'10\"'),
(70,1,'3 kg'),
(70,2,'3 kg'),
(70,3,'3 kg'),
(70,4,'3 kg'),
(70,5,'3 kg'),
(71,1,'M'),
(71,2,'M'),
(71,3,'M'),
(71,4,'M'),
(71,5,'M'),
(72,1,'5\"'),
(72,2,'5\"'),
(72,3,'5\"'),
(72,4,'5\"'),
(72,5,'5\"'),
(73,1,'10\"'),
(73,2,'10\"'),
(73,3,'10\"'),
(73,4,'10\"'),
(73,5,'10\"'),
(74,1,'15\"'),
(74,2,'15\"'),
(74,3,'15\"'),
(74,4,'15\"'),
(74,5,'15\"'),
(75,1,'5 kg'),
(75,2,'5 kg'),
(75,3,'5 kg'),
(75,4,'5 kg'),
(75,5,'5 kg'),
(76,1,'M'),
(76,2,'M'),
(76,3,'M'),
(76,4,'M'),
(76,5,'M'),
(77,1,'10\"'),
(77,2,'10\"'),
(77,3,'10\"'),
(77,4,'10\"'),
(77,5,'10\"'),
(78,1,'15\"'),
(78,2,'15\"'),
(78,3,'15\"'),
(78,4,'15\"'),
(78,5,'15\"'),
(79,1,'10\"'),
(79,2,'10\"'),
(79,3,'10\"'),
(79,4,'10\"'),
(79,5,'10\"'),
(80,1,'0.5 kg'),
(80,2,'0.5 kg'),
(80,3,'0.5 kg'),
(80,4,'0.5 kg'),
(80,5,'0.5 kg'),
(81,1,'L'),
(81,2,'L'),
(81,3,'L'),
(81,4,'L'),
(81,5,'L'),
(82,1,'15\"'),
(82,2,'15\"'),
(82,3,'15\"'),
(82,4,'15\"'),
(82,5,'15\"'),
(83,1,'5\"'),
(83,2,'5\"'),
(83,3,'5\"'),
(83,4,'5\"'),
(83,5,'5\"'),
(84,1,'15\"'),
(84,2,'15\"'),
(84,3,'15\"'),
(84,4,'15\"'),
(84,5,'15\"'),
(85,1,'1 kg'),
(85,2,'1 kg'),
(85,3,'1 kg'),
(85,4,'1 kg'),
(85,5,'1 kg'),
(86,1,'XL'),
(86,2,'XL'),
(86,3,'XL'),
(86,4,'XL'),
(86,5,'XL'),
(87,1,'5\"'),
(87,2,'5\"'),
(87,3,'5\"'),
(87,4,'5\"'),
(87,5,'5\"'),
(88,1,'10\"'),
(88,2,'10\"'),
(88,3,'10\"'),
(88,4,'10\"'),
(88,5,'10\"'),
(89,1,'5\"'),
(89,2,'5\"'),
(89,3,'5\"'),
(89,4,'5\"'),
(89,5,'5\"'),
(90,1,'0.3 kg'),
(90,2,'0.3 kg'),
(90,3,'0.3 kg'),
(90,4,'0.3 kg'),
(90,5,'0.3 kg'),
(91,1,'XXL'),
(91,2,'XXL'),
(91,3,'XXL'),
(91,4,'XXL'),
(91,5,'XXL'),
(92,1,'5\"'),
(92,2,'5\"'),
(92,3,'5\"'),
(92,4,'5\"'),
(92,5,'5\"'),
(93,1,'15\"'),
(93,2,'15\"'),
(93,3,'15\"'),
(93,4,'15\"'),
(93,5,'15\"'),
(94,1,'10\"'),
(94,2,'10\"'),
(94,3,'10\"'),
(94,4,'10\"'),
(94,5,'10\"'),
(95,1,'2 kg'),
(95,2,'2 kg'),
(95,3,'2 kg'),
(95,4,'2 kg'),
(95,5,'2 kg'),
(96,1,'L'),
(96,2,'L'),
(96,3,'L'),
(96,4,'L'),
(96,5,'L'),
(97,1,'10\"'),
(97,2,'10\"'),
(97,3,'10\"'),
(97,4,'10\"'),
(97,5,'10\"'),
(98,1,'10\"'),
(98,2,'10\"'),
(98,3,'10\"'),
(98,4,'10\"'),
(98,5,'10\"'),
(99,1,'10\"'),
(99,2,'10\"'),
(99,3,'10\"'),
(99,4,'10\"'),
(99,5,'10\"'),
(100,1,'0.5 kg'),
(100,2,'0.5 kg'),
(100,3,'0.5 kg'),
(100,4,'0.5 kg'),
(100,5,'0.5 kg'),
(101,1,'XL'),
(101,2,'XL'),
(101,3,'XL'),
(101,4,'XL'),
(101,5,'XL'),
(102,1,'15\"'),
(102,2,'15\"'),
(102,3,'15\"'),
(102,4,'15\"'),
(102,5,'15\"'),
(103,1,'15\"'),
(103,2,'15\"'),
(103,3,'15\"'),
(103,4,'15\"'),
(103,5,'15\"'),
(104,1,'15\"'),
(104,2,'15\"'),
(104,3,'15\"'),
(104,4,'15\"'),
(104,5,'15\"'),
(105,1,'1 kg'),
(105,2,'1 kg'),
(105,3,'1 kg'),
(105,4,'1 kg'),
(105,5,'1 kg'),
(106,1,'M'),
(106,2,'M'),
(106,3,'M'),
(106,4,'M'),
(106,5,'M'),
(107,1,'15\"'),
(107,2,'15\"'),
(107,3,'15\"'),
(107,4,'15\"'),
(107,5,'15\"'),
(108,1,'10\"'),
(108,2,'10\"'),
(108,3,'10\"'),
(108,4,'10\"'),
(108,5,'10\"'),
(109,1,'15\"'),
(109,2,'15\"'),
(109,3,'15\"'),
(109,4,'15\"'),
(109,5,'15\"'),
(110,1,'2 kg'),
(110,2,'2 kg'),
(110,3,'2 kg'),
(110,4,'2 kg'),
(110,5,'2 kg'),
(111,1,'XL'),
(111,2,'XL'),
(111,3,'XL'),
(111,4,'XL'),
(111,5,'XL'),
(112,1,'5\"'),
(112,2,'5\"'),
(112,3,'5\"'),
(112,4,'5\"'),
(112,5,'5\"'),
(113,1,'15\"'),
(113,2,'15\"'),
(113,3,'15\"'),
(113,4,'15\"'),
(113,5,'15\"'),
(114,1,'5\"'),
(114,2,'5\"'),
(114,3,'5\"'),
(114,4,'5\"'),
(114,5,'5\"'),
(115,1,'3 kg'),
(115,2,'3 kg'),
(115,3,'3 kg'),
(115,4,'3 kg'),
(115,5,'3 kg'),
(116,1,'M'),
(116,2,'M'),
(116,3,'M'),
(116,4,'M'),
(116,5,'M'),
(117,1,'5\"'),
(117,2,'5\"'),
(117,3,'5\"'),
(117,4,'5\"'),
(117,5,'5\"'),
(118,1,'10\"'),
(118,2,'10\"'),
(118,3,'10\"'),
(118,4,'10\"'),
(118,5,'10\"'),
(119,1,'15\"'),
(119,2,'15\"'),
(119,3,'15\"'),
(119,4,'15\"'),
(119,5,'15\"'),
(120,1,'5 kg'),
(120,2,'5 kg'),
(120,3,'5 kg'),
(120,4,'5 kg'),
(120,5,'5 kg'),
(121,1,'M'),
(121,2,'M'),
(121,3,'M'),
(121,4,'M'),
(121,5,'M'),
(122,1,'10\"'),
(122,2,'10\"'),
(122,3,'10\"'),
(122,4,'10\"'),
(122,5,'10\"'),
(123,1,'15\"'),
(123,2,'15\"'),
(123,3,'15\"'),
(123,4,'15\"'),
(123,5,'15\"'),
(124,1,'10\"'),
(124,2,'10\"'),
(124,3,'10\"'),
(124,4,'10\"'),
(124,5,'10\"'),
(125,1,'0.5 kg'),
(125,2,'0.5 kg'),
(125,3,'0.5 kg'),
(125,4,'0.5 kg'),
(125,5,'0.5 kg'),
(126,1,'L'),
(126,2,'L'),
(126,3,'L'),
(126,4,'L'),
(126,5,'L'),
(127,1,'15\"'),
(127,2,'15\"'),
(127,3,'15\"'),
(127,4,'15\"'),
(127,5,'15\"'),
(128,1,'5\"'),
(128,2,'5\"'),
(128,3,'5\"'),
(128,4,'5\"'),
(128,5,'5\"'),
(129,1,'15\"'),
(129,2,'15\"'),
(129,3,'15\"'),
(129,4,'15\"'),
(129,5,'15\"'),
(130,1,'1 kg'),
(130,2,'1 kg'),
(130,3,'1 kg'),
(130,4,'1 kg'),
(130,5,'1 kg'),
(131,1,'XL'),
(131,2,'XL'),
(131,3,'XL'),
(131,4,'XL'),
(131,5,'XL'),
(132,1,'5\"'),
(132,2,'5\"'),
(132,3,'5\"'),
(132,4,'5\"'),
(132,5,'5\"'),
(133,1,'10\"'),
(133,2,'10\"'),
(133,3,'10\"'),
(133,4,'10\"'),
(133,5,'10\"'),
(134,1,'5\"'),
(134,2,'5\"'),
(134,3,'5\"'),
(134,4,'5\"'),
(134,5,'5\"'),
(135,1,'0.3 kg'),
(135,2,'0.3 kg'),
(135,3,'0.3 kg'),
(135,4,'0.3 kg'),
(135,5,'0.3 kg'),
(136,1,'XXL'),
(136,2,'XXL'),
(136,3,'XXL'),
(136,4,'XXL'),
(136,5,'XXL'),
(137,1,'10\"'),
(137,2,'10\"'),
(137,3,'10\"'),
(137,4,'10\"'),
(137,5,'10\"'),
(138,1,'15\"'),
(138,2,'15\"'),
(138,3,'15\"'),
(138,4,'15\"'),
(138,5,'15\"'),
(139,1,'10\"'),
(139,2,'10\"'),
(139,3,'10\"'),
(139,4,'10\"'),
(139,5,'10\"'),
(140,1,'2 kg'),
(140,2,'2 kg'),
(140,3,'2 kg'),
(140,4,'2 kg'),
(140,5,'2 kg'),
(141,1,'L'),
(141,2,'L'),
(141,3,'L'),
(141,4,'L'),
(141,5,'L'),
(142,1,'15\"'),
(142,2,'15\"'),
(142,3,'15\"'),
(142,4,'15\"'),
(142,5,'15\"'),
(143,1,'10\"'),
(143,2,'10\"'),
(143,3,'10\"'),
(143,4,'10\"'),
(143,5,'10\"'),
(144,1,'15\"'),
(144,2,'15\"'),
(144,3,'15\"'),
(144,4,'15\"'),
(144,5,'15\"'),
(145,1,'0.5 kg'),
(145,2,'0.5 kg'),
(145,3,'0.5 kg'),
(145,4,'0.5 kg'),
(145,5,'0.5 kg'),
(146,1,'XL'),
(146,2,'XL'),
(146,3,'XL'),
(146,4,'XL'),
(146,5,'XL'),
(147,1,'5\"'),
(147,2,'5\"'),
(147,3,'5\"'),
(147,4,'5\"'),
(147,5,'5\"'),
(148,1,'15\"'),
(148,2,'15\"'),
(148,3,'15\"'),
(148,4,'15\"'),
(148,5,'15\"'),
(149,1,'10\"'),
(149,2,'10\"'),
(149,3,'10\"'),
(149,4,'10\"'),
(149,5,'10\"'),
(150,1,'1 kg'),
(150,2,'1 kg'),
(150,3,'1 kg'),
(150,4,'1 kg'),
(150,5,'1 kg'),
(151,1,'M'),
(151,2,'M'),
(151,3,'M'),
(151,4,'M'),
(151,5,'M'),
(152,1,'5\"'),
(152,2,'5\"'),
(152,3,'5\"'),
(152,4,'5\"'),
(152,5,'5\"'),
(153,1,'5\"'),
(153,2,'5\"'),
(153,3,'5\"'),
(153,4,'5\"'),
(153,5,'5\"'),
(154,1,'15\"'),
(154,2,'15\"'),
(154,3,'15\"'),
(154,4,'15\"'),
(154,5,'15\"'),
(155,1,'0.3 kg'),
(155,2,'0.3 kg'),
(155,3,'0.3 kg'),
(155,4,'0.3 kg'),
(155,5,'0.3 kg'),
(156,1,'L'),
(156,2,'L'),
(156,3,'L'),
(156,4,'L'),
(156,5,'L'),
(157,1,'10\"'),
(157,2,'10\"'),
(157,3,'10\"'),
(157,4,'10\"'),
(157,5,'10\"'),
(158,1,'10\"'),
(158,2,'10\"'),
(158,3,'10\"'),
(158,4,'10\"'),
(158,5,'10\"'),
(159,1,'5\"'),
(159,2,'5\"'),
(159,3,'5\"'),
(159,4,'5\"'),
(159,5,'5\"'),
(160,1,'2 kg'),
(160,2,'2 kg'),
(160,3,'2 kg'),
(160,4,'2 kg'),
(160,5,'2 kg'),
(161,1,'XL'),
(161,2,'XL'),
(161,3,'XL'),
(161,4,'XL'),
(161,5,'XL'),
(162,1,'15\"'),
(162,2,'15\"'),
(162,3,'15\"'),
(162,4,'15\"'),
(162,5,'15\"'),
(163,1,'15\"'),
(163,2,'15\"'),
(163,3,'15\"'),
(163,4,'15\"'),
(163,5,'15\"'),
(164,1,'10\"'),
(164,2,'10\"'),
(164,3,'10\"'),
(164,4,'10\"'),
(164,5,'10\"'),
(165,1,'3 kg'),
(165,2,'3 kg'),
(165,3,'3 kg'),
(165,4,'3 kg'),
(165,5,'3 kg'),
(166,1,'M'),
(166,2,'M'),
(166,3,'M'),
(166,4,'M'),
(166,5,'M'),
(167,1,'5\"'),
(167,2,'5\"'),
(167,3,'5\"'),
(167,4,'5\"'),
(167,5,'5\"'),
(168,1,'10\"'),
(168,2,'10\"'),
(168,3,'10\"'),
(168,4,'10\"'),
(168,5,'10\"'),
(169,1,'15\"'),
(169,2,'15\"'),
(169,3,'15\"'),
(169,4,'15\"'),
(169,5,'15\"'),
(170,1,'5 kg'),
(170,2,'5 kg'),
(170,3,'5 kg'),
(170,4,'5 kg'),
(170,5,'5 kg'),
(171,1,'M'),
(171,2,'M'),
(171,3,'M'),
(171,4,'M'),
(171,5,'M'),
(172,1,'10\"'),
(172,2,'10\"'),
(172,3,'10\"'),
(172,4,'10\"'),
(172,5,'10\"'),
(173,1,'15\"'),
(173,2,'15\"'),
(173,3,'15\"'),
(173,4,'15\"'),
(173,5,'15\"'),
(174,1,'10\"'),
(174,2,'10\"'),
(174,3,'10\"'),
(174,4,'10\"'),
(174,5,'10\"'),
(175,1,'0.5 kg'),
(175,2,'0.5 kg'),
(175,3,'0.5 kg'),
(175,4,'0.5 kg'),
(175,5,'0.5 kg'),
(176,1,'L'),
(176,2,'L'),
(176,3,'L'),
(176,4,'L'),
(176,5,'L'),
(177,1,'10\"'),
(177,2,'10\"'),
(177,3,'10\"'),
(177,4,'10\"'),
(177,5,'10\"'),
(178,1,'10\"'),
(178,2,'10\"'),
(178,3,'10\"'),
(178,4,'10\"'),
(178,5,'10\"'),
(179,1,'5\"'),
(179,2,'5\"'),
(179,3,'5\"'),
(179,4,'5\"'),
(179,5,'5\"'),
(180,1,'2 kg'),
(180,2,'2 kg'),
(180,3,'2 kg'),
(180,4,'2 kg'),
(180,5,'2 kg'),
(181,1,'M'),
(181,2,'M'),
(181,3,'M'),
(181,4,'M'),
(181,5,'M'),
(182,1,'15\"'),
(182,2,'15\"'),
(182,3,'15\"'),
(182,4,'15\"'),
(182,5,'15\"'),
(183,1,'15\"'),
(183,2,'15\"'),
(183,3,'15\"'),
(183,4,'15\"'),
(183,5,'15\"'),
(184,1,'10\"'),
(184,2,'10\"'),
(184,3,'10\"'),
(184,4,'10\"'),
(184,5,'10\"'),
(185,1,'3 kg'),
(185,2,'3 kg'),
(185,3,'3 kg'),
(185,4,'3 kg'),
(185,5,'3 kg'),
(186,1,'L'),
(186,2,'L'),
(186,3,'L'),
(186,4,'L'),
(186,5,'L'),
(187,1,'5\"'),
(187,2,'5\"'),
(187,3,'5\"'),
(187,4,'5\"'),
(187,5,'5\"'),
(188,1,'10\"'),
(188,2,'10\"'),
(188,3,'10\"'),
(188,4,'10\"'),
(188,5,'10\"'),
(189,1,'15\"'),
(189,2,'15\"'),
(189,3,'15\"'),
(189,4,'15\"'),
(189,5,'15\"'),
(190,1,'5 kg'),
(190,2,'5 kg'),
(190,3,'5 kg'),
(190,4,'5 kg'),
(190,5,'5 kg'),
(191,1,'XL'),
(191,2,'XL'),
(191,3,'XL'),
(191,4,'XL'),
(191,5,'XL'),
(192,1,'10\"'),
(192,2,'10\"'),
(192,3,'10\"'),
(192,4,'10\"'),
(192,5,'10\"'),
(193,1,'15\"'),
(193,2,'15\"'),
(193,3,'15\"'),
(193,4,'15\"'),
(193,5,'15\"'),
(194,1,'10\"'),
(194,2,'10\"'),
(194,3,'10\"'),
(194,4,'10\"'),
(194,5,'10\"'),
(195,1,'0.5 kg'),
(195,2,'0.5 kg'),
(195,3,'0.5 kg'),
(195,4,'0.5 kg'),
(195,5,'0.5 kg'),
(196,1,'XXL'),
(196,2,'XXL'),
(196,3,'XXL'),
(196,4,'XXL'),
(196,5,'XXL'),
(197,1,'15\"'),
(197,2,'15\"'),
(197,3,'15\"'),
(197,4,'15\"'),
(197,5,'15\"'),
(198,1,'5\"'),
(198,2,'5\"'),
(198,3,'5\"'),
(198,4,'5\"'),
(198,5,'5\"'),
(199,1,'15\"'),
(199,2,'15\"'),
(199,3,'15\"'),
(199,4,'15\"'),
(199,5,'15\"'),
(200,1,'1 kg'),
(200,2,'1 kg'),
(200,3,'1 kg'),
(200,4,'1 kg'),
(200,5,'1 kg'),
(201,1,'L'),
(201,2,'L'),
(201,3,'L'),
(201,4,'L'),
(201,5,'L'),
(202,1,'5\"'),
(202,2,'5\"'),
(202,3,'5\"'),
(202,4,'5\"'),
(202,5,'5\"'),
(203,1,'10\"'),
(203,2,'10\"'),
(203,3,'10\"'),
(203,4,'10\"'),
(203,5,'10\"'),
(204,1,'5\"'),
(204,2,'5\"'),
(204,3,'5\"'),
(204,4,'5\"'),
(204,5,'5\"'),
(205,1,'0.3 kg'),
(205,2,'0.3 kg'),
(205,3,'0.3 kg'),
(205,4,'0.3 kg'),
(205,5,'0.3 kg'),
(206,1,'XL'),
(206,2,'XL'),
(206,3,'XL'),
(206,4,'XL'),
(206,5,'XL'),
(207,1,'5\"'),
(207,2,'5\"'),
(207,3,'5\"'),
(207,4,'5\"'),
(207,5,'5\"'),
(208,1,'5\"'),
(208,2,'5\"'),
(208,3,'5\"'),
(208,4,'5\"'),
(208,5,'5\"'),
(209,1,'15\"'),
(209,2,'15\"'),
(209,3,'15\"'),
(209,4,'15\"'),
(209,5,'15\"'),
(210,1,'0.3 kg'),
(210,2,'0.3 kg'),
(210,3,'0.3 kg'),
(210,4,'0.3 kg'),
(210,5,'0.3 kg'),
(211,1,'L'),
(211,2,'L'),
(211,3,'L'),
(211,4,'L'),
(211,5,'L'),
(212,1,'10\"'),
(212,2,'10\"'),
(212,3,'10\"'),
(212,4,'10\"'),
(212,5,'10\"'),
(213,1,'10\"'),
(213,2,'10\"'),
(213,3,'10\"'),
(213,4,'10\"'),
(213,5,'10\"'),
(214,1,'5\"'),
(214,2,'5\"'),
(214,3,'5\"'),
(214,4,'5\"'),
(214,5,'5\"'),
(215,1,'2 kg'),
(215,2,'2 kg'),
(215,3,'2 kg'),
(215,4,'2 kg'),
(215,5,'2 kg'),
(216,1,'XL'),
(216,2,'XL'),
(216,3,'XL'),
(216,4,'XL'),
(216,5,'XL'),
(217,1,'15\"'),
(217,2,'15\"'),
(217,3,'15\"'),
(217,4,'15\"'),
(217,5,'15\"'),
(218,1,'15\"'),
(218,2,'15\"'),
(218,3,'15\"'),
(218,4,'15\"'),
(218,5,'15\"'),
(219,1,'10\"'),
(219,2,'10\"'),
(219,3,'10\"'),
(219,4,'10\"'),
(219,5,'10\"'),
(220,1,'3 kg'),
(220,2,'3 kg'),
(220,3,'3 kg'),
(220,4,'3 kg'),
(220,5,'3 kg'),
(221,1,'M'),
(221,2,'M'),
(221,3,'M'),
(221,4,'M'),
(221,5,'M'),
(222,1,'5\"'),
(222,2,'5\"'),
(222,3,'5\"'),
(222,4,'5\"'),
(222,5,'5\"'),
(223,1,'10\"'),
(223,2,'10\"'),
(223,3,'10\"'),
(223,4,'10\"'),
(223,5,'10\"'),
(224,1,'15\"'),
(224,2,'15\"'),
(224,3,'15\"'),
(224,4,'15\"'),
(224,5,'15\"'),
(225,1,'5 kg'),
(225,2,'5 kg'),
(225,3,'5 kg'),
(225,4,'5 kg'),
(225,5,'5 kg'),
(226,1,'M'),
(226,2,'M'),
(226,3,'M'),
(226,4,'M'),
(226,5,'M'),
(227,1,'10\"'),
(227,2,'10\"'),
(227,3,'10\"'),
(227,4,'10\"'),
(227,5,'10\"'),
(228,1,'15\"'),
(228,2,'15\"'),
(228,3,'15\"'),
(228,4,'15\"'),
(228,5,'15\"'),
(229,1,'10\"'),
(229,2,'10\"'),
(229,3,'10\"'),
(229,4,'10\"'),
(229,5,'10\"'),
(230,1,'0.5 kg'),
(230,2,'0.5 kg'),
(230,3,'0.5 kg'),
(230,4,'0.5 kg'),
(230,5,'0.5 kg'),
(231,1,'L'),
(231,2,'L'),
(231,3,'L'),
(231,4,'L'),
(231,5,'L'),
(232,1,'10\"'),
(232,2,'10\"'),
(232,3,'10\"'),
(232,4,'10\"'),
(232,5,'10\"'),
(233,1,'10\"'),
(233,2,'10\"'),
(233,3,'10\"'),
(233,4,'10\"'),
(233,5,'10\"'),
(234,1,'5\"'),
(234,2,'5\"'),
(234,3,'5\"'),
(234,4,'5\"'),
(234,5,'5\"'),
(235,1,'2 kg'),
(235,2,'2 kg'),
(235,3,'2 kg'),
(235,4,'2 kg'),
(235,5,'2 kg'),
(236,1,'M'),
(236,2,'M'),
(236,3,'M'),
(236,4,'M'),
(236,5,'M'),
(237,1,'15\"'),
(237,2,'15\"'),
(237,3,'15\"'),
(237,4,'15\"'),
(237,5,'15\"'),
(238,1,'15\"'),
(238,2,'15\"'),
(238,3,'15\"'),
(238,4,'15\"'),
(238,5,'15\"'),
(239,1,'10\"'),
(239,2,'10\"'),
(239,3,'10\"'),
(239,4,'10\"'),
(239,5,'10\"'),
(240,1,'3 kg'),
(240,2,'3 kg'),
(240,3,'3 kg'),
(240,4,'3 kg'),
(240,5,'3 kg'),
(241,1,'L'),
(241,2,'L'),
(241,3,'L'),
(241,4,'L'),
(241,5,'L'),
(242,1,'5\"'),
(242,2,'5\"'),
(242,3,'5\"'),
(242,4,'5\"'),
(242,5,'5\"'),
(243,1,'10\"'),
(243,2,'10\"'),
(243,3,'10\"'),
(243,4,'10\"'),
(243,5,'10\"'),
(244,1,'15\"'),
(244,2,'15\"'),
(244,3,'15\"'),
(244,4,'15\"'),
(244,5,'15\"'),
(245,1,'5 kg'),
(245,2,'5 kg'),
(245,3,'5 kg'),
(245,4,'5 kg'),
(245,5,'5 kg'),
(246,1,'XL'),
(246,2,'XL'),
(246,3,'XL'),
(246,4,'XL'),
(246,5,'XL'),
(247,1,'10\"'),
(247,2,'10\"'),
(247,3,'10\"'),
(247,4,'10\"'),
(247,5,'10\"'),
(248,1,'15\"'),
(248,2,'15\"'),
(248,3,'15\"'),
(248,4,'15\"'),
(248,5,'15\"'),
(249,1,'10\"'),
(249,2,'10\"'),
(249,3,'10\"'),
(249,4,'10\"'),
(249,5,'10\"'),
(250,1,'0.5 kg'),
(250,2,'0.5 kg'),
(250,3,'0.5 kg'),
(250,4,'0.5 kg'),
(250,5,'0.5 kg'),
(251,1,'XXL'),
(251,2,'XXL'),
(251,3,'XXL'),
(251,4,'XXL'),
(251,5,'XXL'),
(252,1,'5\"'),
(252,2,'5\"'),
(252,3,'5\"'),
(252,4,'5\"'),
(252,5,'5\"'),
(253,1,'5\"'),
(253,2,'5\"'),
(253,3,'5\"'),
(253,4,'5\"'),
(253,5,'5\"'),
(254,1,'15\"'),
(254,2,'15\"'),
(254,3,'15\"'),
(254,4,'15\"'),
(254,5,'15\"'),
(255,1,'0.3 kg'),
(255,2,'0.3 kg'),
(255,3,'0.3 kg'),
(255,4,'0.3 kg'),
(255,5,'0.3 kg'),
(256,1,'L'),
(256,2,'L'),
(256,3,'L'),
(256,4,'L'),
(256,5,'L'),
(257,1,'10\"'),
(257,2,'10\"'),
(257,3,'10\"'),
(257,4,'10\"'),
(257,5,'10\"'),
(258,1,'10\"'),
(258,2,'10\"'),
(258,3,'10\"'),
(258,4,'10\"'),
(258,5,'10\"'),
(259,1,'5\"'),
(259,2,'5\"'),
(259,3,'5\"'),
(259,4,'5\"'),
(259,5,'5\"'),
(260,1,'2 kg'),
(260,2,'2 kg'),
(260,3,'2 kg'),
(260,4,'2 kg'),
(260,5,'2 kg'),
(261,1,'XL'),
(261,2,'XL'),
(261,3,'XL'),
(261,4,'XL'),
(261,5,'XL'),
(262,1,'15\"'),
(262,2,'15\"'),
(262,3,'15\"'),
(262,4,'15\"'),
(262,5,'15\"'),
(263,1,'15\"'),
(263,2,'15\"'),
(263,3,'15\"'),
(263,4,'15\"'),
(263,5,'15\"'),
(264,1,'10\"'),
(264,2,'10\"'),
(264,3,'10\"'),
(264,4,'10\"'),
(264,5,'10\"'),
(265,1,'3 kg'),
(265,2,'3 kg'),
(265,3,'3 kg'),
(265,4,'3 kg'),
(265,5,'3 kg'),
(266,1,'M'),
(266,2,'M'),
(266,3,'M'),
(266,4,'M'),
(266,5,'M'),
(267,1,'5\"'),
(267,2,'5\"'),
(267,3,'5\"'),
(267,4,'5\"'),
(267,5,'5\"'),
(268,1,'15\"'),
(268,2,'15\"'),
(268,3,'15\"'),
(268,4,'15\"'),
(268,5,'15\"'),
(269,1,'10\"'),
(269,2,'10\"'),
(269,3,'10\"'),
(269,4,'10\"'),
(269,5,'10\"'),
(270,1,'2 kg'),
(270,2,'2 kg'),
(270,3,'2 kg'),
(270,4,'2 kg'),
(270,5,'2 kg'),
(271,1,'10\"'),
(271,2,'10\"'),
(271,3,'10\"'),
(271,4,'10\"'),
(271,5,'10\"'),
(272,1,'10\"'),
(272,2,'10\"'),
(272,3,'10\"'),
(272,4,'10\"'),
(272,5,'10\"'),
(273,1,'10\"'),
(273,2,'10\"'),
(273,3,'10\"'),
(273,4,'10\"'),
(273,5,'10\"'),
(274,1,'0.5 kg'),
(274,2,'0.5 kg'),
(274,3,'0.5 kg'),
(274,4,'0.5 kg'),
(274,5,'0.5 kg'),
(275,1,'15\"'),
(275,2,'15\"'),
(275,3,'15\"'),
(275,4,'15\"'),
(275,5,'15\"'),
(276,1,'15\"'),
(276,2,'15\"'),
(276,3,'15\"'),
(276,4,'15\"'),
(276,5,'15\"'),
(277,1,'15\"'),
(277,2,'15\"'),
(277,3,'15\"'),
(277,4,'15\"'),
(277,5,'15\"'),
(278,1,'1 kg'),
(278,2,'1 kg'),
(278,3,'1 kg'),
(278,4,'1 kg'),
(278,5,'1 kg'),
(279,1,'15\"'),
(279,2,'15\"'),
(279,3,'15\"'),
(279,4,'15\"'),
(279,5,'15\"'),
(280,1,'10\"'),
(280,2,'10\"'),
(280,3,'10\"'),
(280,4,'10\"'),
(280,5,'10\"'),
(281,1,'15\"'),
(281,2,'15\"'),
(281,3,'15\"'),
(281,4,'15\"'),
(281,5,'15\"'),
(282,1,'2 kg'),
(282,2,'2 kg'),
(282,3,'2 kg'),
(282,4,'2 kg'),
(282,5,'2 kg'),
(283,1,'5\"'),
(283,2,'5\"'),
(283,3,'5\"'),
(283,4,'5\"'),
(283,5,'5\"'),
(284,1,'15\"'),
(284,2,'15\"'),
(284,3,'15\"'),
(284,4,'15\"'),
(284,5,'15\"'),
(285,1,'5\"'),
(285,2,'5\"'),
(285,3,'5\"'),
(285,4,'5\"'),
(285,5,'5\"'),
(286,1,'3 kg'),
(286,2,'3 kg'),
(286,3,'3 kg'),
(286,4,'3 kg'),
(286,5,'3 kg'),
(287,1,'5\"'),
(287,2,'5\"'),
(287,3,'5\"'),
(287,4,'5\"'),
(287,5,'5\"'),
(288,1,'10\"'),
(288,2,'10\"'),
(288,3,'10\"'),
(288,4,'10\"'),
(288,5,'10\"'),
(289,1,'15\"'),
(289,2,'15\"'),
(289,3,'15\"'),
(289,4,'15\"'),
(289,5,'15\"'),
(290,1,'5 kg'),
(290,2,'5 kg'),
(290,3,'5 kg'),
(290,4,'5 kg'),
(290,5,'5 kg'),
(291,1,'10\"'),
(291,2,'10\"'),
(291,3,'10\"'),
(291,4,'10\"'),
(291,5,'10\"'),
(292,1,'15\"'),
(292,2,'15\"'),
(292,3,'15\"'),
(292,4,'15\"'),
(292,5,'15\"'),
(293,1,'10\"'),
(293,2,'10\"'),
(293,3,'10\"'),
(293,4,'10\"'),
(293,5,'10\"'),
(294,1,'0.5 kg'),
(294,2,'0.5 kg'),
(294,3,'0.5 kg'),
(294,4,'0.5 kg'),
(294,5,'0.5 kg'),
(295,1,'15\"'),
(295,2,'15\"'),
(295,3,'15\"'),
(295,4,'15\"'),
(295,5,'15\"'),
(296,1,'5\"'),
(296,2,'5\"'),
(296,3,'5\"'),
(296,4,'5\"'),
(296,5,'5\"'),
(297,1,'15\"'),
(297,2,'15\"'),
(297,3,'15\"'),
(297,4,'15\"'),
(297,5,'15\"'),
(298,1,'1 kg'),
(298,2,'1 kg'),
(298,3,'1 kg'),
(298,4,'1 kg'),
(298,5,'1 kg'),
(299,1,'5\"'),
(299,2,'5\"'),
(299,3,'5\"'),
(299,4,'5\"'),
(299,5,'5\"'),
(300,1,'10\"'),
(300,2,'10\"'),
(300,3,'10\"'),
(300,4,'10\"'),
(300,5,'10\"'),
(301,1,'5\"'),
(301,2,'5\"'),
(301,3,'5\"'),
(301,4,'5\"'),
(301,5,'5\"'),
(302,1,'0.3 kg'),
(302,2,'0.3 kg'),
(302,3,'0.3 kg'),
(302,4,'0.3 kg'),
(302,5,'0.3 kg'),
(303,1,'10\"'),
(303,2,'10\"'),
(303,3,'10\"'),
(303,4,'10\"'),
(303,5,'10\"'),
(304,1,'15\"'),
(304,2,'15\"'),
(304,3,'15\"'),
(304,4,'15\"'),
(304,5,'15\"'),
(305,1,'10\"'),
(305,2,'10\"'),
(305,3,'10\"'),
(305,4,'10\"'),
(305,5,'10\"'),
(306,1,'2 kg'),
(306,2,'2 kg'),
(306,3,'2 kg'),
(306,4,'2 kg'),
(306,5,'2 kg'),
(307,1,'15\"'),
(307,2,'15\"'),
(307,3,'15\"'),
(307,4,'15\"'),
(307,5,'15\"'),
(308,1,'10\"'),
(308,2,'10\"'),
(308,3,'10\"'),
(308,4,'10\"'),
(308,5,'10\"'),
(309,1,'15\"'),
(309,2,'15\"'),
(309,3,'15\"'),
(309,4,'15\"'),
(309,5,'15\"'),
(310,1,'0.5 kg'),
(310,2,'0.5 kg'),
(310,3,'0.5 kg'),
(310,4,'0.5 kg'),
(310,5,'0.5 kg'),
(311,1,'5\"'),
(311,2,'5\"'),
(311,3,'5\"'),
(311,4,'5\"'),
(311,5,'5\"'),
(312,1,'15\"'),
(312,2,'15\"'),
(312,3,'15\"'),
(312,4,'15\"'),
(312,5,'15\"'),
(313,1,'10\"'),
(313,2,'10\"'),
(313,3,'10\"'),
(313,4,'10\"'),
(313,5,'10\"'),
(314,1,'1 kg'),
(314,2,'1 kg'),
(314,3,'1 kg'),
(314,4,'1 kg'),
(314,5,'1 kg'),
(315,1,'10\"'),
(315,2,'10\"'),
(315,3,'10\"'),
(315,4,'10\"'),
(315,5,'10\"'),
(316,1,'15\"'),
(316,2,'15\"'),
(316,3,'15\"'),
(316,4,'15\"'),
(316,5,'15\"'),
(317,1,'10\"'),
(317,2,'10\"'),
(317,3,'10\"'),
(317,4,'10\"'),
(317,5,'10\"'),
(318,1,'0.5 kg'),
(318,2,'0.5 kg'),
(318,3,'0.5 kg'),
(318,4,'0.5 kg'),
(318,5,'0.5 kg'),
(319,1,'L'),
(319,2,'L'),
(319,3,'L'),
(319,4,'L'),
(319,5,'L'),
(320,1,'15\"'),
(320,2,'15\"'),
(320,3,'15\"'),
(320,4,'15\"'),
(320,5,'15\"'),
(321,1,'5\"'),
(321,2,'5\"'),
(321,3,'5\"'),
(321,4,'5\"'),
(321,5,'5\"'),
(322,1,'15\"'),
(322,2,'15\"'),
(322,3,'15\"'),
(322,4,'15\"'),
(322,5,'15\"'),
(323,1,'1 kg'),
(323,2,'1 kg'),
(323,3,'1 kg'),
(323,4,'1 kg'),
(323,5,'1 kg'),
(324,1,'XL'),
(324,2,'XL'),
(324,3,'XL'),
(324,4,'XL'),
(324,5,'XL'),
(325,1,'5\"'),
(325,2,'5\"'),
(325,3,'5\"'),
(325,4,'5\"'),
(325,5,'5\"'),
(326,1,'10\"'),
(326,2,'10\"'),
(326,3,'10\"'),
(326,4,'10\"'),
(326,5,'10\"'),
(327,1,'5\"'),
(327,2,'5\"'),
(327,3,'5\"'),
(327,4,'5\"'),
(327,5,'5\"'),
(328,1,'0.3 kg'),
(328,2,'0.3 kg'),
(328,3,'0.3 kg'),
(328,4,'0.3 kg'),
(328,5,'0.3 kg'),
(329,1,'XXL'),
(329,2,'XXL'),
(329,3,'XXL'),
(329,4,'XXL'),
(329,5,'XXL'),
(330,1,'10\"'),
(330,2,'10\"'),
(330,3,'10\"'),
(330,4,'10\"'),
(330,5,'10\"'),
(331,1,'15\"'),
(331,2,'15\"'),
(331,3,'15\"'),
(331,4,'15\"'),
(331,5,'15\"'),
(332,1,'10\"'),
(332,2,'10\"'),
(332,3,'10\"'),
(332,4,'10\"'),
(332,5,'10\"'),
(333,1,'2 kg'),
(333,2,'2 kg'),
(333,3,'2 kg'),
(333,4,'2 kg'),
(333,5,'2 kg'),
(334,1,'L'),
(334,2,'L'),
(334,3,'L'),
(334,4,'L'),
(334,5,'L'),
(335,1,'15\"'),
(335,2,'15\"'),
(335,3,'15\"'),
(335,4,'15\"'),
(335,5,'15\"'),
(336,1,'10\"'),
(336,2,'10\"'),
(336,3,'10\"'),
(336,4,'10\"'),
(336,5,'10\"'),
(337,1,'15\"'),
(337,2,'15\"'),
(337,3,'15\"'),
(337,4,'15\"'),
(337,5,'15\"'),
(338,1,'0.5 kg'),
(338,2,'0.5 kg'),
(338,3,'0.5 kg'),
(338,4,'0.5 kg'),
(338,5,'0.5 kg'),
(339,1,'XL'),
(339,2,'XL'),
(339,3,'XL'),
(339,4,'XL'),
(339,5,'XL'),
(340,1,'5\"'),
(340,2,'5\"'),
(340,3,'5\"'),
(340,4,'5\"'),
(340,5,'5\"'),
(341,1,'15\"'),
(341,2,'15\"'),
(341,3,'15\"'),
(341,4,'15\"'),
(341,5,'15\"'),
(342,1,'10\"'),
(342,2,'10\"'),
(342,3,'10\"'),
(342,4,'10\"'),
(342,5,'10\"'),
(343,1,'1 kg'),
(343,2,'1 kg'),
(343,3,'1 kg'),
(343,4,'1 kg'),
(343,5,'1 kg'),
(344,1,'M'),
(344,2,'M'),
(344,3,'M'),
(344,4,'M'),
(344,5,'M'),
(345,1,'5\"'),
(345,2,'5\"'),
(345,3,'5\"'),
(345,4,'5\"'),
(345,5,'5\"'),
(346,1,'5\"'),
(346,2,'5\"'),
(346,3,'5\"'),
(346,4,'5\"'),
(346,5,'5\"'),
(347,1,'15\"'),
(347,2,'15\"'),
(347,3,'15\"'),
(347,4,'15\"'),
(347,5,'15\"'),
(348,1,'0.3 kg'),
(348,2,'0.3 kg'),
(348,3,'0.3 kg'),
(348,4,'0.3 kg'),
(348,5,'0.3 kg'),
(349,1,'L'),
(349,2,'L'),
(349,3,'L'),
(349,4,'L'),
(349,5,'L'),
(350,1,'10\"'),
(350,2,'10\"'),
(350,3,'10\"'),
(350,4,'10\"'),
(350,5,'10\"'),
(351,1,'10\"'),
(351,2,'10\"'),
(351,3,'10\"'),
(351,4,'10\"'),
(351,5,'10\"'),
(352,1,'5\"'),
(352,2,'5\"'),
(352,3,'5\"'),
(352,4,'5\"'),
(352,5,'5\"'),
(353,1,'2 kg'),
(353,2,'2 kg'),
(353,3,'2 kg'),
(353,4,'2 kg'),
(353,5,'2 kg'),
(354,1,'XL'),
(354,2,'XL'),
(354,3,'XL'),
(354,4,'XL'),
(354,5,'XL'),
(355,1,'15\"'),
(355,2,'15\"'),
(355,3,'15\"'),
(355,4,'15\"'),
(355,5,'15\"'),
(356,1,'15\"'),
(356,2,'15\"'),
(356,3,'15\"'),
(356,4,'15\"'),
(356,5,'15\"'),
(357,1,'10\"'),
(357,2,'10\"'),
(357,3,'10\"'),
(357,4,'10\"'),
(357,5,'10\"'),
(358,1,'3 kg'),
(358,2,'3 kg'),
(358,3,'3 kg'),
(358,4,'3 kg'),
(358,5,'3 kg'),
(359,1,'M'),
(359,2,'M'),
(359,3,'M'),
(359,4,'M'),
(359,5,'M'),
(360,1,'5\"'),
(360,2,'5\"'),
(360,3,'5\"'),
(360,4,'5\"'),
(360,5,'5\"'),
(361,1,'10\"'),
(361,2,'10\"'),
(361,3,'10\"'),
(361,4,'10\"'),
(361,5,'10\"'),
(362,1,'15\"'),
(362,2,'15\"'),
(362,3,'15\"'),
(362,4,'15\"'),
(362,5,'15\"'),
(363,1,'5 kg'),
(363,2,'5 kg'),
(363,3,'5 kg'),
(363,4,'5 kg'),
(363,5,'5 kg'),
(364,1,'M'),
(364,2,'M'),
(364,3,'M'),
(364,4,'M'),
(364,5,'M'),
(365,1,'10\"'),
(365,2,'10\"'),
(365,3,'10\"'),
(365,4,'10\"'),
(365,5,'10\"'),
(366,1,'15\"'),
(366,2,'15\"'),
(366,3,'15\"'),
(366,4,'15\"'),
(366,5,'15\"'),
(367,1,'10\"'),
(367,2,'10\"'),
(367,3,'10\"'),
(367,4,'10\"'),
(367,5,'10\"'),
(368,1,'0.5 kg'),
(368,2,'0.5 kg'),
(368,3,'0.5 kg'),
(368,4,'0.5 kg'),
(368,5,'0.5 kg'),
(369,1,'L'),
(369,2,'L'),
(369,3,'L'),
(369,4,'L'),
(369,5,'L'),
(370,1,'15\"'),
(370,2,'15\"'),
(370,3,'15\"'),
(370,4,'15\"'),
(370,5,'15\"'),
(371,1,'5\"'),
(371,2,'5\"'),
(371,3,'5\"'),
(371,4,'5\"'),
(371,5,'5\"'),
(372,1,'15\"'),
(372,2,'15\"'),
(372,3,'15\"'),
(372,4,'15\"'),
(372,5,'15\"'),
(373,1,'1 kg'),
(373,2,'1 kg'),
(373,3,'1 kg'),
(373,4,'1 kg'),
(373,5,'1 kg'),
(374,1,'XL'),
(374,2,'XL'),
(374,3,'XL'),
(374,4,'XL'),
(374,5,'XL'),
(375,1,'5\"'),
(375,2,'5\"'),
(375,3,'5\"'),
(375,4,'5\"'),
(375,5,'5\"'),
(376,1,'10\"'),
(376,2,'10\"'),
(376,3,'10\"'),
(376,4,'10\"'),
(376,5,'10\"'),
(377,1,'5\"'),
(377,2,'5\"'),
(377,3,'5\"'),
(377,4,'5\"'),
(377,5,'5\"'),
(378,1,'0.3 kg'),
(378,2,'0.3 kg'),
(378,3,'0.3 kg'),
(378,4,'0.3 kg'),
(378,5,'0.3 kg'),
(379,1,'XXL'),
(379,2,'XXL'),
(379,3,'XXL'),
(379,4,'XXL'),
(379,5,'XXL'),
(380,1,'5\"'),
(380,2,'5\"'),
(380,3,'5\"'),
(380,4,'5\"'),
(380,5,'5\"'),
(381,1,'15\"'),
(381,2,'15\"'),
(381,3,'15\"'),
(381,4,'15\"'),
(381,5,'15\"'),
(382,1,'10\"'),
(382,2,'10\"'),
(382,3,'10\"'),
(382,4,'10\"'),
(382,5,'10\"'),
(383,1,'2 kg'),
(383,2,'2 kg'),
(383,3,'2 kg'),
(383,4,'2 kg'),
(383,5,'2 kg'),
(384,1,'L'),
(384,2,'L'),
(384,3,'L'),
(384,4,'L'),
(384,5,'L'),
(385,1,'10\"'),
(385,2,'10\"'),
(385,3,'10\"'),
(385,4,'10\"'),
(385,5,'10\"'),
(386,1,'10\"'),
(386,2,'10\"'),
(386,3,'10\"'),
(386,4,'10\"'),
(386,5,'10\"'),
(387,1,'10\"'),
(387,2,'10\"'),
(387,3,'10\"'),
(387,4,'10\"'),
(387,5,'10\"'),
(388,1,'0.5 kg'),
(388,2,'0.5 kg'),
(388,3,'0.5 kg'),
(388,4,'0.5 kg'),
(388,5,'0.5 kg'),
(389,1,'XL'),
(389,2,'XL'),
(389,3,'XL'),
(389,4,'XL'),
(389,5,'XL'),
(390,1,'15\"'),
(390,2,'15\"'),
(390,3,'15\"'),
(390,4,'15\"'),
(390,5,'15\"'),
(391,1,'15\"'),
(391,2,'15\"'),
(391,3,'15\"'),
(391,4,'15\"'),
(391,5,'15\"'),
(392,1,'15\"'),
(392,2,'15\"'),
(392,3,'15\"'),
(392,4,'15\"'),
(392,5,'15\"'),
(393,1,'1 kg'),
(393,2,'1 kg'),
(393,3,'1 kg'),
(393,4,'1 kg'),
(393,5,'1 kg'),
(394,1,'M'),
(394,2,'M'),
(394,3,'M'),
(394,4,'M'),
(394,5,'M'),
(395,1,'15\"'),
(395,2,'15\"'),
(395,3,'15\"'),
(395,4,'15\"'),
(395,5,'15\"'),
(396,1,'10\"'),
(396,2,'10\"'),
(396,3,'10\"'),
(396,4,'10\"'),
(396,5,'10\"'),
(397,1,'15\"'),
(397,2,'15\"'),
(397,3,'15\"'),
(397,4,'15\"'),
(397,5,'15\"'),
(398,1,'2 kg'),
(398,2,'2 kg'),
(398,3,'2 kg'),
(398,4,'2 kg'),
(398,5,'2 kg'),
(399,1,'XL'),
(399,2,'XL'),
(399,3,'XL'),
(399,4,'XL'),
(399,5,'XL'),
(400,1,'5\"'),
(400,2,'5\"'),
(400,3,'5\"'),
(400,4,'5\"'),
(400,5,'5\"'),
(401,1,'15\"'),
(401,2,'15\"'),
(401,3,'15\"'),
(401,4,'15\"'),
(401,5,'15\"'),
(402,1,'5\"'),
(402,2,'5\"'),
(402,3,'5\"'),
(402,4,'5\"'),
(402,5,'5\"'),
(403,1,'3 kg'),
(403,2,'3 kg'),
(403,3,'3 kg'),
(403,4,'3 kg'),
(403,5,'3 kg'),
(404,1,'M'),
(404,2,'M'),
(404,3,'M'),
(404,4,'M'),
(404,5,'M'),
(405,1,'5\"'),
(405,2,'5\"'),
(405,3,'5\"'),
(405,4,'5\"'),
(405,5,'5\"'),
(406,1,'10\"'),
(406,2,'10\"'),
(406,3,'10\"'),
(406,4,'10\"'),
(406,5,'10\"'),
(407,1,'15\"'),
(407,2,'15\"'),
(407,3,'15\"'),
(407,4,'15\"'),
(407,5,'15\"'),
(408,1,'5 kg'),
(408,2,'5 kg'),
(408,3,'5 kg'),
(408,4,'5 kg'),
(408,5,'5 kg'),
(409,1,'M'),
(409,2,'M'),
(409,3,'M'),
(409,4,'M'),
(409,5,'M'),
(410,1,'10\"'),
(410,2,'10\"'),
(410,3,'10\"'),
(410,4,'10\"'),
(410,5,'10\"'),
(411,1,'15\"'),
(411,2,'15\"'),
(411,3,'15\"'),
(411,4,'15\"'),
(411,5,'15\"'),
(412,1,'10\"'),
(412,2,'10\"'),
(412,3,'10\"'),
(412,4,'10\"'),
(412,5,'10\"'),
(413,1,'0.5 kg'),
(413,2,'0.5 kg'),
(413,3,'0.5 kg'),
(413,4,'0.5 kg'),
(413,5,'0.5 kg'),
(414,1,'L'),
(414,2,'L'),
(414,3,'L'),
(414,4,'L'),
(414,5,'L'),
(415,1,'15\"'),
(415,2,'15\"'),
(415,3,'15\"'),
(415,4,'15\"'),
(415,5,'15\"'),
(416,1,'5\"'),
(416,2,'5\"'),
(416,3,'5\"'),
(416,4,'5\"'),
(416,5,'5\"'),
(417,1,'15\"'),
(417,2,'15\"'),
(417,3,'15\"'),
(417,4,'15\"'),
(417,5,'15\"'),
(418,1,'1 kg'),
(418,2,'1 kg'),
(418,3,'1 kg'),
(418,4,'1 kg'),
(418,5,'1 kg'),
(419,1,'XL'),
(419,2,'XL'),
(419,3,'XL'),
(419,4,'XL'),
(419,5,'XL'),
(420,1,'5\"'),
(420,2,'5\"'),
(420,3,'5\"'),
(420,4,'5\"'),
(420,5,'5\"'),
(421,1,'10\"'),
(421,2,'10\"'),
(421,3,'10\"'),
(421,4,'10\"'),
(421,5,'10\"'),
(422,1,'5\"'),
(422,2,'5\"'),
(422,3,'5\"'),
(422,4,'5\"'),
(422,5,'5\"'),
(423,1,'0.3 kg'),
(423,2,'0.3 kg'),
(423,3,'0.3 kg'),
(423,4,'0.3 kg'),
(423,5,'0.3 kg'),
(424,1,'XXL'),
(424,2,'XXL'),
(424,3,'XXL'),
(424,4,'XXL'),
(424,5,'XXL'),
(425,1,'10\"'),
(425,2,'10\"'),
(425,3,'10\"'),
(425,4,'10\"'),
(425,5,'10\"'),
(426,1,'15\"'),
(426,2,'15\"'),
(426,3,'15\"'),
(426,4,'15\"'),
(426,5,'15\"'),
(427,1,'10\"'),
(427,2,'10\"'),
(427,3,'10\"'),
(427,4,'10\"'),
(427,5,'10\"'),
(428,1,'2 kg'),
(428,2,'2 kg'),
(428,3,'2 kg'),
(428,4,'2 kg'),
(428,5,'2 kg'),
(429,1,'L'),
(429,2,'L'),
(429,3,'L'),
(429,4,'L'),
(429,5,'L'),
(430,1,'15\"'),
(430,2,'15\"'),
(430,3,'15\"'),
(430,4,'15\"'),
(430,5,'15\"'),
(431,1,'10\"'),
(431,2,'10\"'),
(431,3,'10\"'),
(431,4,'10\"'),
(431,5,'10\"'),
(432,1,'15\"'),
(432,2,'15\"'),
(432,3,'15\"'),
(432,4,'15\"'),
(432,5,'15\"'),
(433,1,'0.5 kg'),
(433,2,'0.5 kg'),
(433,3,'0.5 kg'),
(433,4,'0.5 kg'),
(433,5,'0.5 kg'),
(434,1,'XL'),
(434,2,'XL'),
(434,3,'XL'),
(434,4,'XL'),
(434,5,'XL'),
(435,1,'5\"'),
(435,2,'5\"'),
(435,3,'5\"'),
(435,4,'5\"'),
(435,5,'5\"'),
(436,1,'15\"'),
(436,2,'15\"'),
(436,3,'15\"'),
(436,4,'15\"'),
(436,5,'15\"'),
(437,1,'10\"'),
(437,2,'10\"'),
(437,3,'10\"'),
(437,4,'10\"'),
(437,5,'10\"'),
(438,1,'1 kg'),
(438,2,'1 kg'),
(438,3,'1 kg'),
(438,4,'1 kg'),
(438,5,'1 kg'),
(439,1,'M'),
(439,2,'M'),
(439,3,'M'),
(439,4,'M'),
(439,5,'M'),
(440,1,'5\"'),
(440,2,'5\"'),
(440,3,'5\"'),
(440,4,'5\"'),
(440,5,'5\"'),
(441,1,'5\"'),
(441,2,'5\"'),
(441,3,'5\"'),
(441,4,'5\"'),
(441,5,'5\"'),
(442,1,'15\"'),
(442,2,'15\"'),
(442,3,'15\"'),
(442,4,'15\"'),
(442,5,'15\"'),
(443,1,'0.3 kg'),
(443,2,'0.3 kg'),
(443,3,'0.3 kg'),
(443,4,'0.3 kg'),
(443,5,'0.3 kg'),
(444,1,'L'),
(444,2,'L'),
(444,3,'L'),
(444,4,'L'),
(444,5,'L'),
(445,1,'10\"'),
(445,2,'10\"'),
(445,3,'10\"'),
(445,4,'10\"'),
(445,5,'10\"'),
(446,1,'10\"'),
(446,2,'10\"'),
(446,3,'10\"'),
(446,4,'10\"'),
(446,5,'10\"'),
(447,1,'5\"'),
(447,2,'5\"'),
(447,3,'5\"'),
(447,4,'5\"'),
(447,5,'5\"'),
(448,1,'2 kg'),
(448,2,'2 kg'),
(448,3,'2 kg'),
(448,4,'2 kg'),
(448,5,'2 kg'),
(449,1,'XL'),
(449,2,'XL'),
(449,3,'XL'),
(449,4,'XL'),
(449,5,'XL'),
(450,1,'15\"'),
(450,2,'15\"'),
(450,3,'15\"'),
(450,4,'15\"'),
(450,5,'15\"'),
(451,1,'15\"'),
(451,2,'15\"'),
(451,3,'15\"'),
(451,4,'15\"'),
(451,5,'15\"'),
(452,1,'10\"'),
(452,2,'10\"'),
(452,3,'10\"'),
(452,4,'10\"'),
(452,5,'10\"'),
(453,1,'3 kg'),
(453,2,'3 kg'),
(453,3,'3 kg'),
(453,4,'3 kg'),
(453,5,'3 kg'),
(454,1,'M'),
(454,2,'M'),
(454,3,'M'),
(454,4,'M'),
(454,5,'M'),
(455,1,'5\"'),
(455,2,'5\"'),
(455,3,'5\"'),
(455,4,'5\"'),
(455,5,'5\"'),
(456,1,'10\"'),
(456,2,'10\"'),
(456,3,'10\"'),
(456,4,'10\"'),
(456,5,'10\"'),
(457,1,'15\"'),
(457,2,'15\"'),
(457,3,'15\"'),
(457,4,'15\"'),
(457,5,'15\"'),
(458,1,'5 kg'),
(458,2,'5 kg'),
(458,3,'5 kg'),
(458,4,'5 kg'),
(458,5,'5 kg'),
(459,1,'M'),
(459,2,'M'),
(459,3,'M'),
(459,4,'M'),
(459,5,'M'),
(460,1,'10\"'),
(460,2,'10\"'),
(460,3,'10\"'),
(460,4,'10\"'),
(460,5,'10\"'),
(461,1,'15\"'),
(461,2,'15\"'),
(461,3,'15\"'),
(461,4,'15\"'),
(461,5,'15\"'),
(462,1,'10\"'),
(462,2,'10\"'),
(462,3,'10\"'),
(462,4,'10\"'),
(462,5,'10\"'),
(463,1,'0.5 kg'),
(463,2,'0.5 kg'),
(463,3,'0.5 kg'),
(463,4,'0.5 kg'),
(463,5,'0.5 kg'),
(464,1,'L'),
(464,2,'L'),
(464,3,'L'),
(464,4,'L'),
(464,5,'L'),
(465,1,'10\"'),
(465,2,'10\"'),
(465,3,'10\"'),
(465,4,'10\"'),
(465,5,'10\"'),
(466,1,'15\"'),
(466,2,'15\"'),
(466,3,'15\"'),
(466,4,'15\"'),
(466,5,'15\"'),
(467,1,'10\"'),
(467,2,'10\"'),
(467,3,'10\"'),
(467,4,'10\"'),
(467,5,'10\"'),
(468,1,'0.5 kg'),
(468,2,'0.5 kg'),
(468,3,'0.5 kg'),
(468,4,'0.5 kg'),
(468,5,'0.5 kg'),
(469,1,'L'),
(469,2,'L'),
(469,3,'L'),
(469,4,'L'),
(469,5,'L'),
(470,1,'15\"'),
(470,2,'15\"'),
(470,3,'15\"'),
(470,4,'15\"'),
(470,5,'15\"'),
(471,1,'5\"'),
(471,2,'5\"'),
(471,3,'5\"'),
(471,4,'5\"'),
(471,5,'5\"'),
(472,1,'15\"'),
(472,2,'15\"'),
(472,3,'15\"'),
(472,4,'15\"'),
(472,5,'15\"'),
(473,1,'1 kg'),
(473,2,'1 kg'),
(473,3,'1 kg'),
(473,4,'1 kg'),
(473,5,'1 kg'),
(474,1,'XL'),
(474,2,'XL'),
(474,3,'XL'),
(474,4,'XL'),
(474,5,'XL'),
(475,1,'5\"'),
(475,2,'5\"'),
(475,3,'5\"'),
(475,4,'5\"'),
(475,5,'5\"'),
(476,1,'10\"'),
(476,2,'10\"'),
(476,3,'10\"'),
(476,4,'10\"'),
(476,5,'10\"'),
(477,1,'5\"'),
(477,2,'5\"'),
(477,3,'5\"'),
(477,4,'5\"'),
(477,5,'5\"'),
(478,1,'0.3 kg'),
(478,2,'0.3 kg'),
(478,3,'0.3 kg'),
(478,4,'0.3 kg'),
(478,5,'0.3 kg'),
(479,1,'XXL'),
(479,2,'XXL'),
(479,3,'XXL'),
(479,4,'XXL'),
(479,5,'XXL'),
(480,1,'10\"'),
(480,2,'10\"'),
(480,3,'10\"'),
(480,4,'10\"'),
(480,5,'10\"'),
(481,1,'15\"'),
(481,2,'15\"'),
(481,3,'15\"'),
(481,4,'15\"'),
(481,5,'15\"'),
(482,1,'10\"'),
(482,2,'10\"'),
(482,3,'10\"'),
(482,4,'10\"'),
(482,5,'10\"'),
(483,1,'2 kg'),
(483,2,'2 kg'),
(483,3,'2 kg'),
(483,4,'2 kg'),
(483,5,'2 kg'),
(484,1,'L'),
(484,2,'L'),
(484,3,'L'),
(484,4,'L'),
(484,5,'L'),
(485,1,'15\"'),
(485,2,'15\"'),
(485,3,'15\"'),
(485,4,'15\"'),
(485,5,'15\"'),
(486,1,'10\"'),
(486,2,'10\"'),
(486,3,'10\"'),
(486,4,'10\"'),
(486,5,'10\"'),
(487,1,'15\"'),
(487,2,'15\"'),
(487,3,'15\"'),
(487,4,'15\"'),
(487,5,'15\"'),
(488,1,'0.5 kg'),
(488,2,'0.5 kg'),
(488,3,'0.5 kg'),
(488,4,'0.5 kg'),
(488,5,'0.5 kg'),
(489,1,'XL'),
(489,2,'XL'),
(489,3,'XL'),
(489,4,'XL'),
(489,5,'XL'),
(490,1,'5\"'),
(490,2,'5\"'),
(490,3,'5\"'),
(490,4,'5\"'),
(490,5,'5\"'),
(491,1,'15\"'),
(491,2,'15\"'),
(491,3,'15\"'),
(491,4,'15\"'),
(491,5,'15\"'),
(492,1,'10\"'),
(492,2,'10\"'),
(492,3,'10\"'),
(492,4,'10\"'),
(492,5,'10\"'),
(493,1,'1 kg'),
(493,2,'1 kg'),
(493,3,'1 kg'),
(493,4,'1 kg'),
(493,5,'1 kg'),
(494,1,'M'),
(494,2,'M'),
(494,3,'M'),
(494,4,'M'),
(494,5,'M'),
(495,1,'5\"'),
(495,2,'5\"'),
(495,3,'5\"'),
(495,4,'5\"'),
(495,5,'5\"'),
(496,1,'5\"'),
(496,2,'5\"'),
(496,3,'5\"'),
(496,4,'5\"'),
(496,5,'5\"'),
(497,1,'15\"'),
(497,2,'15\"'),
(497,3,'15\"'),
(497,4,'15\"'),
(497,5,'15\"'),
(498,1,'0.3 kg'),
(498,2,'0.3 kg'),
(498,3,'0.3 kg'),
(498,4,'0.3 kg'),
(498,5,'0.3 kg'),
(499,1,'L'),
(499,2,'L'),
(499,3,'L'),
(499,4,'L'),
(499,5,'L'),
(500,1,'10\"'),
(500,2,'10\"'),
(500,3,'10\"'),
(500,4,'10\"'),
(500,5,'10\"'),
(501,1,'10\"'),
(501,2,'10\"'),
(501,3,'10\"'),
(501,4,'10\"'),
(501,5,'10\"'),
(502,1,'5\"'),
(502,2,'5\"'),
(502,3,'5\"'),
(502,4,'5\"'),
(502,5,'5\"'),
(503,1,'2 kg'),
(503,2,'2 kg'),
(503,3,'2 kg'),
(503,4,'2 kg'),
(503,5,'2 kg'),
(504,1,'XL'),
(504,2,'XL'),
(504,3,'XL'),
(504,4,'XL'),
(504,5,'XL'),
(505,1,'15\"'),
(505,2,'15\"'),
(505,3,'15\"'),
(505,4,'15\"'),
(505,5,'15\"'),
(506,1,'15\"'),
(506,2,'15\"'),
(506,3,'15\"'),
(506,4,'15\"'),
(506,5,'15\"'),
(507,1,'10\"'),
(507,2,'10\"'),
(507,3,'10\"'),
(507,4,'10\"'),
(507,5,'10\"'),
(508,1,'3 kg'),
(508,2,'3 kg'),
(508,3,'3 kg'),
(508,4,'3 kg'),
(508,5,'3 kg'),
(509,1,'M'),
(509,2,'M'),
(509,3,'M'),
(509,4,'M'),
(509,5,'M'),
(510,1,'5\"'),
(510,2,'5\"'),
(510,3,'5\"'),
(510,4,'5\"'),
(510,5,'5\"'),
(511,1,'10\"'),
(511,2,'10\"'),
(511,3,'10\"'),
(511,4,'10\"'),
(511,5,'10\"'),
(512,1,'15\"'),
(512,2,'15\"'),
(512,3,'15\"'),
(512,4,'15\"'),
(512,5,'15\"'),
(513,1,'5 kg'),
(513,2,'5 kg'),
(513,3,'5 kg'),
(513,4,'5 kg'),
(513,5,'5 kg'),
(514,1,'M'),
(514,2,'M'),
(514,3,'M'),
(514,4,'M'),
(514,5,'M'),
(515,1,'10\"'),
(515,2,'10\"'),
(515,3,'10\"'),
(515,4,'10\"'),
(515,5,'10\"'),
(516,1,'15\"'),
(516,2,'15\"'),
(516,3,'15\"'),
(516,4,'15\"'),
(516,5,'15\"'),
(517,1,'10\"'),
(517,2,'10\"'),
(517,3,'10\"'),
(517,4,'10\"'),
(517,5,'10\"'),
(518,1,'0.5 kg'),
(518,2,'0.5 kg'),
(518,3,'0.5 kg'),
(518,4,'0.5 kg'),
(518,5,'0.5 kg'),
(519,1,'L'),
(519,2,'L'),
(519,3,'L'),
(519,4,'L'),
(519,5,'L'),
(520,1,'15\"'),
(520,2,'15\"'),
(520,3,'15\"'),
(520,4,'15\"'),
(520,5,'15\"'),
(521,1,'5\"'),
(521,2,'5\"'),
(521,3,'5\"'),
(521,4,'5\"'),
(521,5,'5\"'),
(522,1,'15\"'),
(522,2,'15\"'),
(522,3,'15\"'),
(522,4,'15\"'),
(522,5,'15\"'),
(523,1,'1 kg'),
(523,2,'1 kg'),
(523,3,'1 kg'),
(523,4,'1 kg'),
(523,5,'1 kg'),
(524,1,'XL'),
(524,2,'XL'),
(524,3,'XL'),
(524,4,'XL'),
(524,5,'XL'),
(525,1,'5\"'),
(525,2,'5\"'),
(525,3,'5\"'),
(525,4,'5\"'),
(525,5,'5\"'),
(526,1,'10\"'),
(526,2,'10\"'),
(526,3,'10\"'),
(526,4,'10\"'),
(526,5,'10\"'),
(527,1,'5\"'),
(527,2,'5\"'),
(527,3,'5\"'),
(527,4,'5\"'),
(527,5,'5\"'),
(528,1,'0.3 kg'),
(528,2,'0.3 kg'),
(528,3,'0.3 kg'),
(528,4,'0.3 kg'),
(528,5,'0.3 kg'),
(529,1,'XXL'),
(529,2,'XXL'),
(529,3,'XXL'),
(529,4,'XXL'),
(529,5,'XXL'),
(530,1,'5\"'),
(530,2,'5\"'),
(530,3,'5\"'),
(530,4,'5\"'),
(530,5,'5\"'),
(531,1,'15\"'),
(531,2,'15\"'),
(531,3,'15\"'),
(531,4,'15\"'),
(531,5,'15\"'),
(532,1,'10\"'),
(532,2,'10\"'),
(532,3,'10\"'),
(532,4,'10\"'),
(532,5,'10\"'),
(533,1,'2 kg'),
(533,2,'2 kg'),
(533,3,'2 kg'),
(533,4,'2 kg'),
(533,5,'2 kg'),
(534,1,'L'),
(534,2,'L'),
(534,3,'L'),
(534,4,'L'),
(534,5,'L'),
(535,1,'10\"'),
(535,2,'10\"'),
(535,3,'10\"'),
(535,4,'10\"'),
(535,5,'10\"'),
(536,1,'10\"'),
(536,2,'10\"'),
(536,3,'10\"'),
(536,4,'10\"'),
(536,5,'10\"'),
(537,1,'10\"'),
(537,2,'10\"'),
(537,3,'10\"'),
(537,4,'10\"'),
(537,5,'10\"'),
(538,1,'0.5 kg'),
(538,2,'0.5 kg'),
(538,3,'0.5 kg'),
(538,4,'0.5 kg'),
(538,5,'0.5 kg'),
(539,1,'XL'),
(539,2,'XL'),
(539,3,'XL'),
(539,4,'XL'),
(539,5,'XL'),
(540,1,'15\"'),
(540,2,'15\"'),
(540,3,'15\"'),
(540,4,'15\"'),
(540,5,'15\"'),
(541,1,'15\"'),
(541,2,'15\"'),
(541,3,'15\"'),
(541,4,'15\"'),
(541,5,'15\"'),
(542,1,'15\"'),
(542,2,'15\"'),
(542,3,'15\"'),
(542,4,'15\"'),
(542,5,'15\"'),
(543,1,'1 kg'),
(543,2,'1 kg'),
(543,3,'1 kg'),
(543,4,'1 kg'),
(543,5,'1 kg'),
(544,1,'M'),
(544,2,'M'),
(544,3,'M'),
(544,4,'M'),
(544,5,'M'),
(545,1,'15\"'),
(545,2,'15\"'),
(545,3,'15\"'),
(545,4,'15\"'),
(545,5,'15\"'),
(546,1,'10\"'),
(546,2,'10\"'),
(546,3,'10\"'),
(546,4,'10\"'),
(546,5,'10\"'),
(547,1,'15\"'),
(547,2,'15\"'),
(547,3,'15\"'),
(547,4,'15\"'),
(547,5,'15\"'),
(548,1,'2 kg'),
(548,2,'2 kg'),
(548,3,'2 kg'),
(548,4,'2 kg'),
(548,5,'2 kg'),
(549,1,'XL'),
(549,2,'XL'),
(549,3,'XL'),
(549,4,'XL'),
(549,5,'XL'),
(550,1,'5\"'),
(550,2,'5\"'),
(550,3,'5\"'),
(550,4,'5\"'),
(550,5,'5\"'),
(551,1,'15\"'),
(551,2,'15\"'),
(551,3,'15\"'),
(551,4,'15\"'),
(551,5,'15\"'),
(552,1,'5\"'),
(552,2,'5\"'),
(552,3,'5\"'),
(552,4,'5\"'),
(552,5,'5\"'),
(553,1,'3 kg'),
(553,2,'3 kg'),
(553,3,'3 kg'),
(553,4,'3 kg'),
(553,5,'3 kg'),
(554,1,'M'),
(554,2,'M'),
(554,3,'M'),
(554,4,'M'),
(554,5,'M'),
(555,1,'5\"'),
(555,2,'5\"'),
(555,3,'5\"'),
(555,4,'5\"'),
(555,5,'5\"'),
(556,1,'10\"'),
(556,2,'10\"'),
(556,3,'10\"'),
(556,4,'10\"'),
(556,5,'10\"'),
(557,1,'15\"'),
(557,2,'15\"'),
(557,3,'15\"'),
(557,4,'15\"'),
(557,5,'15\"'),
(558,1,'5 kg'),
(558,2,'5 kg'),
(558,3,'5 kg'),
(558,4,'5 kg'),
(558,5,'5 kg'),
(559,1,'M'),
(559,2,'M'),
(559,3,'M'),
(559,4,'M'),
(559,5,'M'),
(560,1,'10\"'),
(560,2,'10\"'),
(560,3,'10\"'),
(560,4,'10\"'),
(560,5,'10\"'),
(561,1,'15\"'),
(561,2,'15\"'),
(561,3,'15\"'),
(561,4,'15\"'),
(561,5,'15\"'),
(562,1,'10\"'),
(562,2,'10\"'),
(562,3,'10\"'),
(562,4,'10\"'),
(562,5,'10\"'),
(563,1,'0.5 kg'),
(563,2,'0.5 kg'),
(563,3,'0.5 kg'),
(563,4,'0.5 kg'),
(563,5,'0.5 kg'),
(564,1,'L'),
(564,2,'L'),
(564,3,'L'),
(564,4,'L'),
(564,5,'L'),
(565,1,'15\"'),
(565,2,'15\"'),
(565,3,'15\"'),
(565,4,'15\"'),
(565,5,'15\"'),
(566,1,'5\"'),
(566,2,'5\"'),
(566,3,'5\"'),
(566,4,'5\"'),
(566,5,'5\"'),
(567,1,'15\"'),
(567,2,'15\"'),
(567,3,'15\"'),
(567,4,'15\"'),
(567,5,'15\"'),
(568,1,'1 kg'),
(568,2,'1 kg'),
(568,3,'1 kg'),
(568,4,'1 kg'),
(568,5,'1 kg'),
(569,1,'XL'),
(569,2,'XL'),
(569,3,'XL'),
(569,4,'XL'),
(569,5,'XL'),
(570,1,'5\"'),
(570,2,'5\"'),
(570,3,'5\"'),
(570,4,'5\"'),
(570,5,'5\"'),
(571,1,'10\"'),
(571,2,'10\"'),
(571,3,'10\"'),
(571,4,'10\"'),
(571,5,'10\"'),
(572,1,'5\"'),
(572,2,'5\"'),
(572,3,'5\"'),
(572,4,'5\"'),
(572,5,'5\"'),
(573,1,'0.3 kg'),
(573,2,'0.3 kg'),
(573,3,'0.3 kg'),
(573,4,'0.3 kg'),
(573,5,'0.3 kg'),
(574,1,'XXL'),
(574,2,'XXL'),
(574,3,'XXL'),
(574,4,'XXL'),
(574,5,'XXL'),
(575,1,'10\"'),
(575,2,'10\"'),
(575,3,'10\"'),
(575,4,'10\"'),
(575,5,'10\"'),
(576,1,'15\"'),
(576,2,'15\"'),
(576,3,'15\"'),
(576,4,'15\"'),
(576,5,'15\"'),
(577,1,'10\"'),
(577,2,'10\"'),
(577,3,'10\"'),
(577,4,'10\"'),
(577,5,'10\"'),
(578,1,'2 kg'),
(578,2,'2 kg'),
(578,3,'2 kg'),
(578,4,'2 kg'),
(578,5,'2 kg'),
(579,1,'L'),
(579,2,'L'),
(579,3,'L'),
(579,4,'L'),
(579,5,'L'),
(580,1,'15\"'),
(580,2,'15\"'),
(580,3,'15\"'),
(580,4,'15\"'),
(580,5,'15\"'),
(581,1,'10\"'),
(581,2,'10\"'),
(581,3,'10\"'),
(581,4,'10\"'),
(581,5,'10\"'),
(582,1,'15\"'),
(582,2,'15\"'),
(582,3,'15\"'),
(582,4,'15\"'),
(582,5,'15\"'),
(583,1,'0.5 kg'),
(583,2,'0.5 kg'),
(583,3,'0.5 kg'),
(583,4,'0.5 kg'),
(583,5,'0.5 kg'),
(584,1,'XL'),
(584,2,'XL'),
(584,3,'XL'),
(584,4,'XL'),
(584,5,'XL'),
(585,1,'5\"'),
(585,2,'5\"'),
(585,3,'5\"'),
(585,4,'5\"'),
(585,5,'5\"'),
(586,1,'15\"'),
(586,2,'15\"'),
(586,3,'15\"'),
(586,4,'15\"'),
(586,5,'15\"'),
(587,1,'10\"'),
(587,2,'10\"'),
(587,3,'10\"'),
(587,4,'10\"'),
(587,5,'10\"'),
(588,1,'1 kg'),
(588,2,'1 kg'),
(588,3,'1 kg'),
(588,4,'1 kg'),
(588,5,'1 kg'),
(589,1,'M'),
(589,2,'M'),
(589,3,'M'),
(589,4,'M'),
(589,5,'M'),
(590,1,'5\"'),
(590,2,'5\"'),
(590,3,'5\"'),
(590,4,'5\"'),
(590,5,'5\"'),
(591,1,'5\"'),
(591,2,'5\"'),
(591,3,'5\"'),
(591,4,'5\"'),
(591,5,'5\"'),
(592,1,'15\"'),
(592,2,'15\"'),
(592,3,'15\"'),
(592,4,'15\"'),
(592,5,'15\"'),
(593,1,'0.3 kg'),
(593,2,'0.3 kg'),
(593,3,'0.3 kg'),
(593,4,'0.3 kg'),
(593,5,'0.3 kg'),
(594,1,'L'),
(594,2,'L'),
(594,3,'L'),
(594,4,'L'),
(594,5,'L'),
(595,1,'10\"'),
(595,2,'10\"'),
(595,3,'10\"'),
(595,4,'10\"'),
(595,5,'10\"'),
(596,1,'10\"'),
(596,2,'10\"'),
(596,3,'10\"'),
(596,4,'10\"'),
(596,5,'10\"'),
(597,1,'5\"'),
(597,2,'5\"'),
(597,3,'5\"'),
(597,4,'5\"'),
(597,5,'5\"'),
(598,1,'2 kg'),
(598,2,'2 kg'),
(598,3,'2 kg'),
(598,4,'2 kg'),
(598,5,'2 kg'),
(599,1,'XL'),
(599,2,'XL'),
(599,3,'XL'),
(599,4,'XL'),
(599,5,'XL'),
(600,1,'15\"'),
(600,2,'15\"'),
(600,3,'15\"'),
(600,4,'15\"'),
(600,5,'15\"'),
(601,1,'15\"'),
(601,2,'15\"'),
(601,3,'15\"'),
(601,4,'15\"'),
(601,5,'15\"'),
(602,1,'10\"'),
(602,2,'10\"'),
(602,3,'10\"'),
(602,4,'10\"'),
(602,5,'10\"'),
(603,1,'3 kg'),
(603,2,'3 kg'),
(603,3,'3 kg'),
(603,4,'3 kg'),
(603,5,'3 kg'),
(604,1,'M'),
(604,2,'M'),
(604,3,'M'),
(604,4,'M'),
(604,5,'M'),
(605,1,'5\"'),
(605,2,'5\"'),
(605,3,'5\"'),
(605,4,'5\"'),
(605,5,'5\"'),
(606,1,'10\"'),
(606,2,'10\"'),
(606,3,'10\"'),
(606,4,'10\"'),
(606,5,'10\"'),
(607,1,'15\"'),
(607,2,'15\"'),
(607,3,'15\"'),
(607,4,'15\"'),
(607,5,'15\"'),
(608,1,'5 kg'),
(608,2,'5 kg'),
(608,3,'5 kg'),
(608,4,'5 kg'),
(608,5,'5 kg'),
(609,1,'M'),
(609,2,'M'),
(609,3,'M'),
(609,4,'M'),
(609,5,'M'),
(610,1,'10\"'),
(610,2,'10\"'),
(610,3,'10\"'),
(610,4,'10\"'),
(610,5,'10\"'),
(611,1,'15\"'),
(611,2,'15\"'),
(611,3,'15\"'),
(611,4,'15\"'),
(611,5,'15\"'),
(612,1,'10\"'),
(612,2,'10\"'),
(612,3,'10\"'),
(612,4,'10\"'),
(612,5,'10\"'),
(613,1,'0.5 kg'),
(613,2,'0.5 kg'),
(613,3,'0.5 kg'),
(613,4,'0.5 kg'),
(613,5,'0.5 kg'),
(614,1,'L'),
(614,2,'L'),
(614,3,'L'),
(614,4,'L'),
(614,5,'L');

/* Table structure for table `ps_hook` */
DROP TABLE IF EXISTS `ps_hook`;

CREATE TABLE `ps_hook` (
  `id_hook` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(64) NOT NULL,
  `title` varchar(64) NOT NULL,
  `description` text,
  `position` tinyint(1) NOT NULL default '1',
  `live_edit` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id_hook`),
  UNIQUE KEY `hook_name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=97 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_hook` */
INSERT INTO `ps_hook` VALUES
(1,'payment','Payment',null,1,1),
(2,'newOrder','New orders',null,0,0),
(3,'paymentConfirm','Payment confirmation',null,0,0),
(4,'paymentReturn','Payment return',null,0,0),
(5,'updateQuantity','Quantity update','Quantity is updated only when the customer effectively <b>place</b> his order.',0,0),
(6,'rightColumn','Right column blocks',null,1,1),
(7,'leftColumn','Left column blocks',null,1,1),
(8,'home','Homepage content',null,1,1),
(9,'header','Header of pages','A hook which allow you to do things in the header of each pages',1,0),
(10,'cart','Cart creation and update',null,0,0),
(11,'authentication','Successful customer authentication',null,0,0),
(12,'addproduct','Product creation',null,0,0),
(13,'updateproduct','Product Update',null,0,0),
(14,'top','Top of pages','A hook which allow you to do things a the top of each pages.',1,0),
(15,'extraRight','Extra actions on the product page (right column).',null,0,0),
(16,'deleteproduct','Product deletion','This hook is called when a product is deleted',0,0),
(17,'productfooter','Product footer','Add new blocks under the product description',1,1),
(18,'invoice','Invoice','Add blocks to invoice (order)',1,0),
(19,'updateOrderStatus','Order\'s status update event','Launch modules when the order\'s status of an order change.',0,0),
(20,'adminOrder','Display in Back-Office, tab AdminOrder','Launch modules when the tab AdminOrder is displayed on back-office.',0,0),
(21,'footer','Footer','Add block in footer',1,0),
(22,'PDFInvoice','PDF Invoice','Allow the display of extra informations into the PDF invoice',0,0),
(23,'adminCustomers','Display in Back-Office, tab AdminCustomers','Launch modules when the tab AdminCustomers is displayed on back-office.',0,0),
(24,'orderConfirmation','Order confirmation page','Called on order confirmation page',0,0),
(25,'createAccount','Successful customer create account','Called when new customer create account successfuled',0,0),
(26,'customerAccount','Customer account page display in front office','Display on page account of the customer',1,0),
(27,'orderSlip','Called when a order slip is created','Called when a quantity of one product change in an order.',0,0),
(28,'productTab','Tabs on product page','Called on order product page tabs',0,0),
(29,'productTabContent','Content of tabs on product page','Called on order product page tabs',0,0),
(30,'shoppingCart','Shopping cart footer','Display some specific informations on the shopping cart page',0,0),
(31,'createAccountForm','Customer account creation form','Display some information on the form to create a customer account',1,0),
(32,'AdminStatsModules','Stats - Modules',null,1,0),
(33,'GraphEngine','Graph Engines',null,0,0),
(34,'orderReturn','Product returned',null,0,0),
(35,'productActions','Product actions','Put new action buttons on product page',1,0),
(36,'backOfficeHome','Administration panel homepage',null,1,0),
(37,'GridEngine','Grid Engines',null,0,0),
(38,'watermark','Watermark',null,0,0),
(39,'cancelProduct','Product cancelled','This hook is called when you cancel a product in an order',0,0),
(40,'extraLeft','Extra actions on the product page (left column).',null,0,0),
(41,'productOutOfStock','Product out of stock','Make action while product is out of stock',1,0),
(42,'updateProductAttribute','Product attribute update',null,0,0),
(43,'extraCarrier','Extra carrier (module mode)',null,0,0),
(44,'shoppingCartExtra','Shopping cart extra button','Display some specific informations',1,0),
(45,'search','Search',null,0,0),
(46,'backBeforePayment','Redirect in order process','Redirect user to the module instead of displaying payment modules',0,0),
(47,'updateCarrier','Carrier Update','This hook is called when a carrier is updated',0,0),
(48,'postUpdateOrderStatus','Post update of order status',null,0,0),
(49,'createAccountTop','Block above the form for create an account',null,1,0),
(50,'backOfficeHeader','Administration panel header',null,0,0),
(51,'backOfficeTop','Administration panel hover the tabs',null,1,0),
(52,'backOfficeFooter','Administration panel footer',null,1,0),
(53,'deleteProductAttribute','Product Attribute Deletion',null,0,0),
(54,'processCarrier','Carrier Process',null,0,0),
(55,'orderDetail','Order Detail','To set the follow-up in smarty when order detail is called',0,0),
(56,'beforeCarrier','Before carrier list','This hook is display before the carrier list on Front office',1,0),
(57,'orderDetailDisplayed','Order detail displayed','Displayed on order detail on front office',1,0),
(58,'paymentCCAdded','Payment CC added','Payment CC added',0,0),
(59,'extraProductComparison','Extra Product Comparison','Extra Product Comparison',0,0),
(60,'categoryAddition','Category creation','',0,0),
(61,'categoryUpdate','Category modification','',0,0),
(62,'categoryDeletion','Category removal','',0,0),
(63,'beforeAuthentication','Before Authentication','Before authentication',0,0),
(64,'paymentTop','Top of payment page','Top of payment page',0,0),
(65,'afterCreateHtaccess','After htaccess creation','After htaccess creation',0,0),
(66,'afterSaveAdminMeta','After save configuration in AdminMeta','After save configuration in AdminMeta',0,0),
(67,'attributeGroupForm','Add fields to the form \"attribute group\"','Add fields to the form \"attribute group\"',0,0),
(68,'afterSaveAttributeGroup','On saving attribute group','On saving attribute group',0,0),
(69,'afterDeleteAttributeGroup','On deleting attribute group','On deleting attribute group',0,0),
(70,'featureForm','Add fields to the form \"feature\"','Add fields to the form \"feature\"',0,0),
(71,'afterSaveFeature','On saving attribute feature','On saving attribute feature',0,0),
(72,'afterDeleteFeature','On deleting attribute feature','On deleting attribute feature',0,0),
(73,'afterSaveProduct','On saving products','On saving products',0,0),
(74,'productListAssign','Assign product list to a category','Assign product list to a category',0,0),
(75,'postProcessAttributeGroup','On post-process in admin attribute group','On post-process in admin attribute group',0,0),
(76,'postProcessFeature','On post-process in admin feature','On post-process in admin feature',0,0),
(77,'featureValueForm','Add fields to the form \"feature value\"','Add fields to the form \"feature value\"',0,0),
(78,'postProcessFeatureValue','On post-process in admin feature value','On post-process in admin feature value',0,0),
(79,'afterDeleteFeatureValue','On deleting attribute feature value','On deleting attribute feature value',0,0),
(90,'afterSaveFeatureValue','On saving attribute feature value','On saving attribute feature value',0,0),
(91,'attributeForm','Add fields to the form \"attribute value\"','Add fields to the form \"attribute value\"',0,0),
(92,'postProcessAttribute','On post-process in admin feature value','On post-process in admin feature value',0,0),
(93,'afterDeleteAttribute','On deleting attribute feature value','On deleting attribute feature value',0,0),
(94,'afterSaveAttribute','On saving attribute feature value','On saving attribute feature value',0,0),
(95,'frontCanonicalRedirect','Front Canonical Redirect','Check for 404 errors before canonical redirects',0,0),
(96,'myAccountBlock','My account block','Display extra informations inside the \"my account\" block',1,0);

/* Table structure for table `ps_hook_module` */
DROP TABLE IF EXISTS `ps_hook_module`;

CREATE TABLE `ps_hook_module` (
  `id_module` int(10) unsigned NOT NULL,
  `id_hook` int(10) unsigned NOT NULL,
  `position` tinyint(2) unsigned NOT NULL,
  PRIMARY KEY  (`id_module`,`id_hook`),
  KEY `id_hook` (`id_hook`),
  KEY `id_module` (`id_module`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_hook_module` */
INSERT INTO `ps_hook_module` VALUES
(3,1,1),
(6,1,2),
(4,1,3),
(4,4,3),
(8,2,1),
(3,4,1),
(6,4,2),
(9,6,1),
(16,6,5),
(8,6,6),
(20,6,4),
(54,6,17),
(61,9,18),
(1,8,1),
(11,14,5),
(13,14,3),
(57,21,1),
(19,14,2),
(22,14,4),
(8,19,1),
(60,9,17),
(25,11,1),
(25,21,3),
(26,32,1),
(27,32,2),
(28,32,3),
(30,32,4),
(31,32,5),
(32,32,6),
(33,32,7),
(34,33,1),
(35,33,2),
(36,33,3),
(37,33,4),
(39,37,1),
(40,32,8),
(41,32,9),
(42,32,10),
(42,95,1),
(43,32,11),
(42,14,8),
(43,14,9),
(44,32,12),
(45,32,13),
(46,32,15),
(47,32,14),
(48,32,16),
(49,32,17),
(55,32,22),
(50,32,18),
(51,32,19),
(51,45,1),
(25,25,1),
(41,20,2),
(52,32,20),
(53,32,21),
(17,9,1),
(58,14,1),
(24,9,2),
(9,9,3),
(15,9,4),
(8,9,5),
(20,9,6),
(11,9,7),
(16,9,8),
(22,9,9),
(13,9,10),
(14,9,11),
(7,9,12),
(21,9,13),
(54,9,14),
(19,9,15),
(56,30,1),
(56,9,16),
(62,9,19),
(24,6,7),
(21,6,8),
(15,6,9),
(60,6,10),
(14,6,11),
(62,6,12),
(59,6,13),
(61,6,14),
(7,6,15),
(17,6,16),
(63,40,1),
(65,29,1),
(65,28,1),
(65,59,1),
(65,9,20),
(66,6,2),
(66,19,2),
(67,14,6),
(67,60,1),
(67,61,1),
(67,62,1),
(67,66,1),
(68,21,2),
(71,14,7),
(70,6,3);

/* Table structure for table `ps_hook_module_exceptions` */
DROP TABLE IF EXISTS `ps_hook_module_exceptions`;

CREATE TABLE `ps_hook_module_exceptions` (
  `id_hook_module_exceptions` int(10) unsigned NOT NULL auto_increment,
  `id_module` int(10) unsigned NOT NULL,
  `id_hook` int(10) unsigned NOT NULL,
  `file_name` varchar(255) default NULL,
  PRIMARY KEY  (`id_hook_module_exceptions`),
  KEY `id_module` (`id_module`),
  KEY `id_hook` (`id_hook`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_hook_module_exceptions` */
INSERT INTO `ps_hook_module_exceptions` VALUES
(1,9,6,'index.php');

/* Table structure for table `ps_image` */
DROP TABLE IF EXISTS `ps_image`;

CREATE TABLE `ps_image` (
  `id_image` int(10) unsigned NOT NULL auto_increment,
  `id_product` int(10) unsigned NOT NULL,
  `position` smallint(2) unsigned NOT NULL default '0',
  `cover` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_image`),
  UNIQUE KEY `product_position` (`id_product`,`position`),
  KEY `image_product` (`id_product`),
  KEY `id_product_cover` (`id_product`,`cover`)
) ENGINE=MyISAM AUTO_INCREMENT=98 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_image` */
INSERT INTO `ps_image` VALUES
(1,1,1,1),
(2,1,2,0),
(3,1,3,0),
(4,2,1,1),
(5,2,2,0),
(6,2,3,0),
(7,3,1,1),
(8,3,2,0),
(9,3,3,0),
(10,4,1,1),
(11,4,2,0),
(12,4,3,0),
(13,5,1,1),
(14,5,2,0),
(15,5,3,0),
(93,6,3,0),
(92,6,2,0),
(91,6,1,1),
(96,7,3,0),
(95,7,2,0),
(94,7,1,1),
(22,8,1,1),
(23,8,2,0),
(24,8,3,0),
(25,9,1,1),
(26,9,2,0),
(27,9,3,0),
(28,10,1,1),
(29,10,2,0),
(30,10,3,0),
(31,11,1,1),
(32,11,2,0),
(33,11,3,0),
(34,12,1,1),
(35,12,2,0),
(36,12,3,0),
(37,13,1,1),
(38,13,2,0),
(39,13,3,0),
(40,14,1,1),
(41,14,2,0),
(42,14,3,0),
(43,15,1,1),
(44,15,2,0),
(45,15,3,0),
(46,16,1,1),
(47,16,2,0),
(48,16,3,0),
(49,17,1,1),
(50,17,2,0),
(51,17,3,0),
(52,18,1,1),
(53,18,2,0),
(54,18,3,0),
(55,19,1,1),
(56,19,2,0),
(57,19,3,0),
(58,20,1,1),
(59,20,2,0),
(60,20,3,0),
(61,21,1,1),
(62,21,2,0),
(63,21,3,0),
(64,22,1,1),
(65,22,2,0),
(66,22,3,0),
(67,23,1,1),
(68,23,2,0),
(69,23,3,0),
(70,24,1,1),
(71,24,2,0),
(72,24,3,0),
(73,25,1,1),
(74,25,2,0),
(75,25,3,0),
(76,26,1,1),
(77,26,2,0),
(78,26,3,0),
(79,27,1,1),
(80,27,2,0),
(81,27,3,0),
(82,28,1,1),
(83,28,2,0),
(84,28,3,0),
(85,29,1,1),
(86,29,2,0),
(87,29,3,0),
(88,30,1,1),
(89,30,2,0),
(90,30,3,0),
(97,1,4,0);

/* Table structure for table `ps_image_lang` */
DROP TABLE IF EXISTS `ps_image_lang`;

CREATE TABLE `ps_image_lang` (
  `id_image` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `legend` varchar(128) default NULL,
  PRIMARY KEY  (`id_image`,`id_lang`),
  KEY `id_image` (`id_image`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_image_lang` */
INSERT INTO `ps_image_lang` VALUES
(1,1,'Water Kettler SWK 1753'),
(1,2,'Water Kettler SWK 1753'),
(1,3,'Water Kettler SWK 1753'),
(1,4,'Water Kettler SWK 1753'),
(1,5,'Water Kettler SWK 1753'),
(2,1,'Water Kettler SWK 1753'),
(2,2,'Water Kettler SWK 1753'),
(2,3,'Water Kettler SWK 1753'),
(2,4,'Water Kettler SWK 1753'),
(2,5,'Water Kettler SWK 1753'),
(3,1,'Water Kettler SWK 1753'),
(3,2,'Water Kettler SWK 1753'),
(3,3,'Water Kettler SWK 1753'),
(3,4,'Water Kettler SWK 1753'),
(3,5,'Water Kettler SWK 1753'),
(4,1,'Eclipse Electrolux Vacuum Cleaner'),
(4,2,'Eclipse Electrolux Vacuum Cleaner'),
(4,3,'Eclipse Electrolux Vacuum Cleaner'),
(4,4,'Eclipse Electrolux Vacuum Cleaner'),
(4,5,'Eclipse Electrolux Vacuum Cleaner'),
(5,1,'Eclipse Electrolux Vacuum Cleaner'),
(5,2,'Eclipse Electrolux Vacuum Cleaner'),
(5,3,'Eclipse Electrolux Vacuum Cleaner'),
(5,4,'Eclipse Electrolux Vacuum Cleaner'),
(5,5,'Eclipse Electrolux Vacuum Cleaner'),
(6,1,'Eclipse Electrolux Vacuum Cleaner'),
(6,2,'Eclipse Electrolux Vacuum Cleaner'),
(6,3,'Eclipse Electrolux Vacuum Cleaner'),
(6,4,'Eclipse Electrolux Vacuum Cleaner'),
(6,5,'Eclipse Electrolux Vacuum Cleaner'),
(7,1,'Hood Scholtes HSE 159 IX'),
(7,2,'Hood Scholtes HSE 159 IX'),
(7,3,'Hood Scholtes HSE 159 IX'),
(7,4,'Hood Scholtes HSE 159 IX'),
(7,5,'Hood Scholtes HSE 159 IX'),
(8,1,'Hood Scholtes HSE 159 IX'),
(8,2,'Hood Scholtes HSE 159 IX'),
(8,3,'Hood Scholtes HSE 159 IX'),
(8,4,'Hood Scholtes HSE 159 IX'),
(8,5,'Hood Scholtes HSE 159 IX'),
(9,1,'Hood Scholtes HSE 159 IX'),
(9,2,'Hood Scholtes HSE 159 IX'),
(9,3,'Hood Scholtes HSE 159 IX'),
(9,4,'Hood Scholtes HSE 159 IX'),
(9,5,'Hood Scholtes HSE 159 IX'),
(10,1,'AEG Ultra-active Vacuum Cleaner'),
(10,2,'AEG Ultra-active Vacuum Cleaner'),
(10,3,'AEG Ultra-active Vacuum Cleaner'),
(10,4,'AEG Ultra-active Vacuum Cleaner'),
(10,5,'AEG Ultra-active Vacuum Cleaner'),
(11,1,'AEG Ultra-active Vacuum Cleaner'),
(11,2,'AEG Ultra-active Vacuum Cleaner'),
(11,3,'AEG Ultra-active Vacuum Cleaner'),
(11,4,'AEG Ultra-active Vacuum Cleaner'),
(11,5,'AEG Ultra-active Vacuum Cleaner'),
(12,1,'AEG Ultra-active Vacuum Cleaner'),
(12,2,'AEG Ultra-active Vacuum Cleaner'),
(12,3,'AEG Ultra-active Vacuum Cleaner'),
(12,4,'AEG Ultra-active Vacuum Cleaner'),
(12,5,'AEG Ultra-active Vacuum Cleaner'),
(13,1,'Siemens KD-36NA-40 fridge freezer'),
(13,2,'Siemens KD-36NA-40 fridge freezer'),
(13,3,'Siemens KD-36NA-40 fridge freezer'),
(13,4,'Siemens KD-36NA-40 fridge freezer'),
(13,5,'Siemens KD-36NA-40 fridge freezer'),
(14,1,'Siemens KD-36NA-40 fridge freezer'),
(14,2,'Siemens KD-36NA-40 fridge freezer'),
(14,3,'Siemens KD-36NA-40 fridge freezer'),
(14,4,'Siemens KD-36NA-40 fridge freezer'),
(14,5,'Siemens KD-36NA-40 fridge freezer'),
(15,1,'Siemens KD-36NA-40 fridge freezer'),
(15,2,'Siemens KD-36NA-40 fridge freezer'),
(15,3,'Siemens KD-36NA-40 fridge freezer'),
(15,4,'Siemens KD-36NA-40 fridge freezer'),
(15,5,'Siemens KD-36NA-40 fridge freezer'),
(93,5,'Meat Grinder  SMG 4382'),
(93,4,'Meat Grinder  SMG 4382'),
(93,3,'Meat Grinder  SMG 4382'),
(93,2,'Meat Grinder  SMG 4382'),
(93,1,'Meat Grinder  SMG 4382'),
(92,5,'Meat Grinder  SMG 4382'),
(92,4,'Meat Grinder  SMG 4382'),
(92,3,'Meat Grinder  SMG 4382'),
(92,2,'Meat Grinder  SMG 4382'),
(92,1,'Meat Grinder  SMG 4382'),
(91,5,'Meat Grinder  SMG 4382'),
(91,4,'Meat Grinder  SMG 4382'),
(91,3,'Meat Grinder  SMG 4382'),
(91,2,'Meat Grinder  SMG 4382'),
(91,1,'Meat Grinder  SMG 4382'),
(96,5,'Applica FP1600B B&D 7 Cup Food Processor'),
(96,4,'Applica FP1600B B&D 7 Cup Food Processor'),
(96,3,'Applica FP1600B B&D 7 Cup Food Processor'),
(96,2,'Applica FP1600B B&D 7 Cup Food Processor'),
(96,1,'Applica FP1600B B&D 7 Cup Food Processor'),
(95,5,'Applica FP1600B B&D 7 Cup Food Processor'),
(95,4,'Applica FP1600B B&D 7 Cup Food Processor'),
(95,3,'Applica FP1600B B&D 7 Cup Food Processor'),
(95,2,'Applica FP1600B B&D 7 Cup Food Processor'),
(95,1,'Applica FP1600B B&D 7 Cup Food Processor'),
(94,5,'Applica FP1600B B&D 7 Cup Food Processor'),
(94,4,'Applica FP1600B B&D 7 Cup Food Processor'),
(94,3,'Applica FP1600B B&D 7 Cup Food Processor'),
(94,2,'Applica FP1600B B&D 7 Cup Food Processor'),
(94,1,'Applica FP1600B B&D 7 Cup Food Processor'),
(22,1,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(22,2,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(22,3,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(22,4,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(22,5,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(23,1,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(23,2,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(23,3,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(23,4,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(23,5,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(24,1,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(24,2,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(24,3,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(24,4,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(24,5,'Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron'),
(25,1,'Coffee Machine Bugatti Diva'),
(25,2,'Coffee Machine Bugatti Diva'),
(25,3,'Coffee Machine Bugatti Diva'),
(25,4,'Coffee Machine Bugatti Diva'),
(25,5,'Coffee Machine Bugatti Diva'),
(26,1,'Coffee Machine Bugatti Diva'),
(26,2,'Coffee Machine Bugatti Diva'),
(26,3,'Coffee Machine Bugatti Diva'),
(26,4,'Coffee Machine Bugatti Diva'),
(26,5,'Coffee Machine Bugatti Diva'),
(27,1,'Coffee Machine Bugatti Diva'),
(27,2,'Coffee Machine Bugatti Diva'),
(27,3,'Coffee Machine Bugatti Diva'),
(27,4,'Coffee Machine Bugatti Diva'),
(27,5,'Coffee Machine Bugatti Diva'),
(28,1,'Coffee Machine Kalorik Aztec'),
(28,2,'Coffee Machine Kalorik Aztec'),
(28,3,'Coffee Machine Kalorik Aztec'),
(28,4,'Coffee Machine Kalorik Aztec'),
(28,5,'Coffee Machine Kalorik Aztec'),
(29,1,'Coffee Machine Kalorik Aztec'),
(29,2,'Coffee Machine Kalorik Aztec'),
(29,3,'Coffee Machine Kalorik Aztec'),
(29,4,'Coffee Machine Kalorik Aztec'),
(29,5,'Coffee Machine Kalorik Aztec'),
(30,1,'Coffee Machine Kalorik Aztec'),
(30,2,'Coffee Machine Kalorik Aztec'),
(30,3,'Coffee Machine Kalorik Aztec'),
(30,4,'Coffee Machine Kalorik Aztec'),
(30,5,'Coffee Machine Kalorik Aztec'),
(31,1,'Coffee Machine Malongo Espresso-gold'),
(31,2,'Coffee Machine Malongo Espresso-gold'),
(31,3,'Coffee Machine Malongo Espresso-gold'),
(31,4,'Coffee Machine Malongo Espresso-gold'),
(31,5,'Coffee Machine Malongo Espresso-gold'),
(32,1,'Coffee Machine Malongo Espresso-gold'),
(32,2,'Coffee Machine Malongo Espresso-gold'),
(32,3,'Coffee Machine Malongo Espresso-gold'),
(32,4,'Coffee Machine Malongo Espresso-gold'),
(32,5,'Coffee Machine Malongo Espresso-gold'),
(33,1,'Coffee Machine Malongo Espresso-gold'),
(33,2,'Coffee Machine Malongo Espresso-gold'),
(33,3,'Coffee Machine Malongo Espresso-gold'),
(33,4,'Coffee Machine Malongo Espresso-gold'),
(33,5,'Coffee Machine Malongo Espresso-gold'),
(34,1,'Coffee Maker Bosch Assimo'),
(34,2,'Coffee Maker Bosch Assimo'),
(34,3,'Coffee Maker Bosch Assimo'),
(34,4,'Coffee Maker Bosch Assimo'),
(34,5,'Coffee Maker Bosch Assimo'),
(35,1,'Coffee Maker Bosch Assimo'),
(35,2,'Coffee Maker Bosch Assimo'),
(35,3,'Coffee Maker Bosch Assimo'),
(35,4,'Coffee Maker Bosch Assimo'),
(35,5,'Coffee Maker Bosch Assimo'),
(36,1,'Coffee Maker Bosch Assimo'),
(36,2,'Coffee Maker Bosch Assimo'),
(36,3,'Coffee Maker Bosch Assimo'),
(36,4,'Coffee Maker Bosch Assimo'),
(36,5,'Coffee Maker Bosch Assimo'),
(37,1,'DEF 18W-804'),
(37,2,'DEF 18W-804'),
(37,3,'DEF 18W-804'),
(37,4,'DEF 18W-804'),
(37,5,'DEF 18W-804'),
(38,1,'DEF 18W-804'),
(38,2,'DEF 18W-804'),
(38,3,'DEF 18W-804'),
(38,4,'DEF 18W-804'),
(38,5,'DEF 18W-804'),
(39,1,'DEF 18W-804'),
(39,2,'DEF 18W-804'),
(39,3,'DEF 18W-804'),
(39,4,'DEF 18W-804'),
(39,5,'DEF 18W-804'),
(40,1,'Hairdryer D-4444 Shine Dryer HR 1'),
(40,2,'Hairdryer D-4444 Shine Dryer HR 1'),
(40,3,'Hairdryer D-4444 Shine Dryer HR 1'),
(40,4,'Hairdryer D-4444 Shine Dryer HR 1'),
(40,5,'Hairdryer D-4444 Shine Dryer HR 1'),
(41,1,'Hairdryer D-4444 Shine Dryer HR 1'),
(41,2,'Hairdryer D-4444 Shine Dryer HR 1'),
(41,3,'Hairdryer D-4444 Shine Dryer HR 1'),
(41,4,'Hairdryer D-4444 Shine Dryer HR 1'),
(41,5,'Hairdryer D-4444 Shine Dryer HR 1'),
(42,1,'Hairdryer D-4444 Shine Dryer HR 1'),
(42,2,'Hairdryer D-4444 Shine Dryer HR 1'),
(42,3,'Hairdryer D-4444 Shine Dryer HR 1'),
(42,4,'Hairdryer D-4444 Shine Dryer HR 1'),
(42,5,'Hairdryer D-4444 Shine Dryer HR 1'),
(43,1,'Hairdryer FHD 10C-666'),
(43,2,'Hairdryer FHD 10C-666'),
(43,3,'Hairdryer FHD 10C-666'),
(43,4,'Hairdryer FHD 10C-666'),
(43,5,'Hairdryer FHD 10C-666'),
(44,1,'Hairdryer FHD 10C-666'),
(44,2,'Hairdryer FHD 10C-666'),
(44,3,'Hairdryer FHD 10C-666'),
(44,4,'Hairdryer FHD 10C-666'),
(44,5,'Hairdryer FHD 10C-666'),
(45,1,'Hairdryer FHD 10C-666'),
(45,2,'Hairdryer FHD 10C-666'),
(45,3,'Hairdryer FHD 10C-666'),
(45,4,'Hairdryer FHD 10C-666'),
(45,5,'Hairdryer FHD 10C-666'),
(46,1,'Hairdryer PHD 30B-661'),
(46,2,'Hairdryer PHD 30B-661'),
(46,3,'Hairdryer PHD 30B-661'),
(46,4,'Hairdryer PHD 30B-661'),
(46,5,'Hairdryer PHD 30B-661'),
(47,1,'Hairdryer PHD 30B-661'),
(47,2,'Hairdryer PHD 30B-661'),
(47,3,'Hairdryer PHD 30B-661'),
(47,4,'Hairdryer PHD 30B-661'),
(47,5,'Hairdryer PHD 30B-661'),
(48,1,'Hairdryer PHD 30B-661'),
(48,2,'Hairdryer PHD 30B-661'),
(48,3,'Hairdryer PHD 30B-661'),
(48,4,'Hairdryer PHD 30B-661'),
(48,5,'Hairdryer PHD 30B-661'),
(49,1,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(49,2,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(49,3,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(49,4,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(49,5,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(50,1,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(50,2,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(50,3,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(50,4,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(50,5,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(51,1,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(51,2,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(51,3,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(51,4,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(51,5,'Hamilton Beach 72703 Ensemble 3 Cup Chopper'),
(52,1,'Hood CDA EVCK4SS 40cm Cylinder'),
(52,2,'Hood CDA EVCK4SS 40cm Cylinder'),
(52,3,'Hood CDA EVCK4SS 40cm Cylinder'),
(52,4,'Hood CDA EVCK4SS 40cm Cylinder'),
(52,5,'Hood CDA EVCK4SS 40cm Cylinder'),
(53,1,'Hood CDA EVCK4SS 40cm Cylinder'),
(53,2,'Hood CDA EVCK4SS 40cm Cylinder'),
(53,3,'Hood CDA EVCK4SS 40cm Cylinder'),
(53,4,'Hood CDA EVCK4SS 40cm Cylinder'),
(53,5,'Hood CDA EVCK4SS 40cm Cylinder'),
(54,1,'Hood CDA EVCK4SS 40cm Cylinder'),
(54,2,'Hood CDA EVCK4SS 40cm Cylinder'),
(54,3,'Hood CDA EVCK4SS 40cm Cylinder'),
(54,4,'Hood CDA EVCK4SS 40cm Cylinder'),
(54,5,'Hood CDA EVCK4SS 40cm Cylinder'),
(55,1,'Hood Faber Klima - black'),
(55,2,'Hood Faber Klima - black'),
(55,3,'Hood Faber Klima - black'),
(55,4,'Hood Faber Klima - black'),
(55,5,'Hood Faber Klima - black'),
(56,1,'Hood Faber Klima - black'),
(56,2,'Hood Faber Klima - black'),
(56,3,'Hood Faber Klima - black'),
(56,4,'Hood Faber Klima - black'),
(56,5,'Hood Faber Klima - black'),
(57,1,'Hood Faber Klima - black'),
(57,2,'Hood Faber Klima - black'),
(57,3,'Hood Faber Klima - black'),
(57,4,'Hood Faber Klima - black'),
(57,5,'Hood Faber Klima - black'),
(58,1,'Hood Whirpool AKR806IX'),
(58,2,'Hood Whirpool AKR806IX'),
(58,3,'Hood Whirpool AKR806IX'),
(58,4,'Hood Whirpool AKR806IX'),
(58,5,'Hood Whirpool AKR806IX'),
(59,1,'Hood Whirpool AKR806IX'),
(59,2,'Hood Whirpool AKR806IX'),
(59,3,'Hood Whirpool AKR806IX'),
(59,4,'Hood Whirpool AKR806IX'),
(59,5,'Hood Whirpool AKR806IX'),
(60,1,'Hood Whirpool AKR806IX'),
(60,2,'Hood Whirpool AKR806IX'),
(60,3,'Hood Whirpool AKR806IX'),
(60,4,'Hood Whirpool AKR806IX'),
(60,5,'Hood Whirpool AKR806IX'),
(61,1,'Hoover Xarion bagless vacuum cleaner'),
(61,2,'Hoover Xarion bagless vacuum cleaner'),
(61,3,'Hoover Xarion bagless vacuum cleaner'),
(61,4,'Hoover Xarion bagless vacuum cleaner'),
(61,5,'Hoover Xarion bagless vacuum cleaner'),
(62,1,'Hoover Xarion bagless vacuum cleaner'),
(62,2,'Hoover Xarion bagless vacuum cleaner'),
(62,3,'Hoover Xarion bagless vacuum cleaner'),
(62,4,'Hoover Xarion bagless vacuum cleaner'),
(62,5,'Hoover Xarion bagless vacuum cleaner'),
(63,1,'Hoover Xarion bagless vacuum cleaner'),
(63,2,'Hoover Xarion bagless vacuum cleaner'),
(63,3,'Hoover Xarion bagless vacuum cleaner'),
(63,4,'Hoover Xarion bagless vacuum cleaner'),
(63,5,'Hoover Xarion bagless vacuum cleaner'),
(64,1,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(64,2,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(64,3,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(64,4,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(64,5,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(65,1,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(65,2,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(65,3,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(65,4,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(65,5,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(66,1,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(66,2,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(66,3,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(66,4,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(66,5,'Kalorik Meat Grinder MGR25959 Stainless Steel Blade'),
(67,1,'LG Refrigerator - Floral collection T676'),
(67,2,'LG Refrigerator - Floral collection T676'),
(67,3,'LG Refrigerator - Floral collection T676'),
(67,4,'LG Refrigerator - Floral collection T676'),
(67,5,'LG Refrigerator - Floral collection T676'),
(68,1,'LG Refrigerator - Floral collection T676'),
(68,2,'LG Refrigerator - Floral collection T676'),
(68,3,'LG Refrigerator - Floral collection T676'),
(68,4,'LG Refrigerator - Floral collection T676'),
(68,5,'LG Refrigerator - Floral collection T676'),
(69,1,'LG Refrigerator - Floral collection T676'),
(69,2,'LG Refrigerator - Floral collection T676'),
(69,3,'LG Refrigerator - Floral collection T676'),
(69,4,'LG Refrigerator - Floral collection T676'),
(69,5,'LG Refrigerator - Floral collection T676'),
(70,1,'MEAT GRINDER Avilla av-0304'),
(70,2,'MEAT GRINDER Avilla av-0304'),
(70,3,'MEAT GRINDER Avilla av-0304'),
(70,4,'MEAT GRINDER Avilla av-0304'),
(70,5,'MEAT GRINDER Avilla av-0304'),
(71,1,'MEAT GRINDER Avilla av-0304'),
(71,2,'MEAT GRINDER Avilla av-0304'),
(71,3,'MEAT GRINDER Avilla av-0304'),
(71,4,'MEAT GRINDER Avilla av-0304'),
(71,5,'MEAT GRINDER Avilla av-0304'),
(72,1,'MEAT GRINDER Avilla av-0304'),
(72,2,'MEAT GRINDER Avilla av-0304'),
(72,3,'MEAT GRINDER Avilla av-0304'),
(72,4,'MEAT GRINDER Avilla av-0304'),
(72,5,'MEAT GRINDER Avilla av-0304'),
(73,1,'Meat Grinder MG-2050(R)'),
(73,2,'Meat Grinder MG-2050(R)'),
(73,3,'Meat Grinder MG-2050(R)'),
(73,4,'Meat Grinder MG-2050(R)'),
(73,5,'Meat Grinder MG-2050(R)'),
(74,1,'Meat Grinder MG-2050(R)'),
(74,2,'Meat Grinder MG-2050(R)'),
(74,3,'Meat Grinder MG-2050(R)'),
(74,4,'Meat Grinder MG-2050(R)'),
(74,5,'Meat Grinder MG-2050(R)'),
(75,1,'Meat Grinder MG-2050(R)'),
(75,2,'Meat Grinder MG-2050(R)'),
(75,3,'Meat Grinder MG-2050(R)'),
(75,4,'Meat Grinder MG-2050(R)'),
(75,5,'Meat Grinder MG-2050(R)'),
(76,1,'Modern fridge freezer Fagor FFA-8865'),
(76,2,'Modern fridge freezer Fagor FFA-8865'),
(76,3,'Modern fridge freezer Fagor FFA-8865'),
(76,4,'Modern fridge freezer Fagor FFA-8865'),
(76,5,'Modern fridge freezer Fagor FFA-8865'),
(77,1,'Modern fridge freezer Fagor FFA-8865'),
(77,2,'Modern fridge freezer Fagor FFA-8865'),
(77,3,'Modern fridge freezer Fagor FFA-8865'),
(77,4,'Modern fridge freezer Fagor FFA-8865'),
(77,5,'Modern fridge freezer Fagor FFA-8865'),
(78,1,'Modern fridge freezer Fagor FFA-8865'),
(78,2,'Modern fridge freezer Fagor FFA-8865'),
(78,3,'Modern fridge freezer Fagor FFA-8865'),
(78,4,'Modern fridge freezer Fagor FFA-8865'),
(78,5,'Modern fridge freezer Fagor FFA-8865'),
(79,1,'Side-by-side ELECTROLUX Refrigerator'),
(79,2,'Side-by-side ELECTROLUX Refrigerator'),
(79,3,'Side-by-side ELECTROLUX Refrigerator'),
(79,4,'Side-by-side ELECTROLUX Refrigerator'),
(79,5,'Side-by-side ELECTROLUX Refrigerator'),
(80,1,'Side-by-side ELECTROLUX Refrigerator'),
(80,2,'Side-by-side ELECTROLUX Refrigerator'),
(80,3,'Side-by-side ELECTROLUX Refrigerator'),
(80,4,'Side-by-side ELECTROLUX Refrigerator'),
(80,5,'Side-by-side ELECTROLUX Refrigerator'),
(81,1,'Side-by-side ELECTROLUX Refrigerator'),
(81,2,'Side-by-side ELECTROLUX Refrigerator'),
(81,3,'Side-by-side ELECTROLUX Refrigerator'),
(81,4,'Side-by-side ELECTROLUX Refrigerator'),
(81,5,'Side-by-side ELECTROLUX Refrigerator'),
(82,1,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(82,2,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(82,3,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(82,4,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(82,5,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(83,1,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(83,2,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(83,3,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(83,4,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(83,5,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(84,1,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(84,2,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(84,3,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(84,4,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(84,5,'SMEG - Compact Refrigerator Mini-fridge FAB-10UJ'),
(85,1,'SMEG - Contemporary Refrigerator FPD'),
(85,2,'SMEG - Contemporary Refrigerator FPD'),
(85,3,'SMEG - Contemporary Refrigerator FPD'),
(85,4,'SMEG - Contemporary Refrigerator FPD'),
(85,5,'SMEG - Contemporary Refrigerator FPD'),
(86,1,'SMEG - Contemporary Refrigerator FPD'),
(86,2,'SMEG - Contemporary Refrigerator FPD'),
(86,3,'SMEG - Contemporary Refrigerator FPD'),
(86,4,'SMEG - Contemporary Refrigerator FPD'),
(86,5,'SMEG - Contemporary Refrigerator FPD'),
(87,1,'SMEG - Contemporary Refrigerator FPD'),
(87,2,'SMEG - Contemporary Refrigerator FPD'),
(87,3,'SMEG - Contemporary Refrigerator FPD'),
(87,4,'SMEG - Contemporary Refrigerator FPD'),
(87,5,'SMEG - Contemporary Refrigerator FPD'),
(88,1,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(88,2,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(88,3,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(88,4,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(88,5,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(89,1,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(89,2,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(89,3,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(89,4,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(89,5,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(90,1,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(90,2,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(90,3,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(90,4,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(90,5,'Wash Vacuum Cleaner THOMAS TWIN t2'),
(97,1,'Water Kettler SWK 1753'),
(97,2,'Water Kettler SWK 1753'),
(97,3,'Water Kettler SWK 1753'),
(97,4,'Water Kettler SWK 1753'),
(97,5,'Water Kettler SWK 1753');

/* Table structure for table `ps_image_type` */
DROP TABLE IF EXISTS `ps_image_type`;

CREATE TABLE `ps_image_type` (
  `id_image_type` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(16) NOT NULL,
  `width` int(10) unsigned NOT NULL,
  `height` int(10) unsigned NOT NULL,
  `products` tinyint(1) NOT NULL default '1',
  `categories` tinyint(1) NOT NULL default '1',
  `manufacturers` tinyint(1) NOT NULL default '1',
  `suppliers` tinyint(1) NOT NULL default '1',
  `scenes` tinyint(1) NOT NULL default '1',
  `stores` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id_image_type`),
  KEY `image_type_name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_image_type` */
INSERT INTO `ps_image_type` VALUES
(1,'small',66,66,1,1,1,1,0,0),
(2,'medium',80,80,1,1,1,1,0,1),
(3,'large',304,304,1,1,1,1,0,0),
(4,'thickbox',600,600,1,0,0,0,0,0),
(5,'category',180,165,0,1,0,0,0,0),
(6,'home',180,165,1,0,0,0,0,0),
(7,'large_scene',556,200,0,0,0,0,1,0),
(8,'thumb_scene',161,58,0,0,0,0,1,0);

/* Table structure for table `ps_lang` */
DROP TABLE IF EXISTS `ps_lang`;

CREATE TABLE `ps_lang` (
  `id_lang` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL,
  `active` tinyint(3) unsigned NOT NULL default '0',
  `iso_code` char(2) NOT NULL,
  `language_code` char(5) NOT NULL,
  `date_format_lite` char(32) NOT NULL default 'Y-m-d',
  `date_format_full` char(32) NOT NULL default 'Y-m-d H:i:s',
  `is_rtl` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id_lang`),
  KEY `lang_iso_code` (`iso_code`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_lang` */
INSERT INTO `ps_lang` VALUES
(1,'English (English)',1,'en','en-us','m/j/Y','m/j/Y H:i:s',0),
(2,'Français (French)',1,'fr','fr','d/m/Y','d/m/Y H:i:s',0),
(3,'Español (Spanish)',1,'es','es','d/m/Y','d/m/Y H:i:s',0),
(4,'Deutsch (German)',0,'de','de','d.m.Y','d.m.Y H:i:s',0),
(5,'Italiano (Italian)',0,'it','it','d/m/Y','d/m/Y H:i:s',0);

/* Table structure for table `ps_manufacturer` */
DROP TABLE IF EXISTS `ps_manufacturer`;

CREATE TABLE `ps_manufacturer` (
  `id_manufacturer` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(64) NOT NULL,
  `date_add` datetime NOT NULL,
  `date_upd` datetime NOT NULL,
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id_manufacturer`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_manufacturer` */
INSERT INTO `ps_manufacturer` VALUES
(1,'Adipisicing','2012-05-21 14:38:05','2012-05-22 12:59:04',1),
(2,'Consectetur elit','2012-05-21 14:38:05','2012-05-22 13:00:07',1),
(3,'Lorem Ipsum','2012-05-22 13:00:33','2012-05-22 13:00:44',1);

/* Table structure for table `ps_manufacturer_lang` */
DROP TABLE IF EXISTS `ps_manufacturer_lang`;

CREATE TABLE `ps_manufacturer_lang` (
  `id_manufacturer` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `description` text,
  `short_description` varchar(254) default NULL,
  `meta_title` varchar(128) default NULL,
  `meta_keywords` varchar(255) default NULL,
  `meta_description` varchar(255) default NULL,
  PRIMARY KEY  (`id_manufacturer`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_manufacturer_lang` */
INSERT INTO `ps_manufacturer_lang` VALUES
(1,1,'<p>Donec condimentum accumsan erat ut vestibulum. Aenean vestibulum commodo faucibus</p>','','','',''),
(1,2,'','','','',''),
(1,3,'','','','',''),
(1,4,'','','','',''),
(1,5,'','','','',''),
(2,1,'','','','',''),
(2,2,'','','','',''),
(2,3,'','','','',''),
(2,4,'','','','',''),
(2,5,'','','','',''),
(3,1,'<p>Sodales id felis. Nullam lacinia nibh ac nibh interdum sit amet varius purus imperdiet</p>','','','',''),
(3,2,'','','','',''),
(3,3,'','','','',''),
(3,4,'','','','',''),
(3,5,'','','','','');

/* Table structure for table `ps_module` */
DROP TABLE IF EXISTS `ps_module`;

CREATE TABLE `ps_module` (
  `id_module` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(64) NOT NULL,
  `active` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id_module`),
  KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=72 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_module` */
INSERT INTO `ps_module` VALUES
(1,'homefeatured',1),
(2,'gsitemap',1),
(3,'cheque',1),
(4,'moneybookers',1),
(58,'tmheaderlinks',1),
(6,'bankwire',1),
(7,'blockadvertising',0),
(8,'blockbestsellers',0),
(9,'blockcart',1),
(11,'blockcurrencies',1),
(13,'blocklanguages',1),
(14,'blockmanufacturer',0),
(15,'blockmyaccount',0),
(16,'blocknewproducts',0),
(17,'blockpaymentlogo',0),
(57,'tmfooterlinks',1),
(19,'blocksearch',1),
(20,'blockspecials',0),
(21,'blocktags',0),
(22,'blockuserinfo',1),
(24,'blockviewed',0),
(25,'statsdata',1),
(26,'statsvisits',1),
(27,'statssales',1),
(28,'statsregistrations',1),
(30,'statspersonalinfos',1),
(31,'statslive',1),
(32,'statsequipment',1),
(33,'statscatalog',1),
(34,'graphvisifire',1),
(35,'graphxmlswfcharts',1),
(36,'graphgooglechart',1),
(37,'graphartichow',1),
(39,'gridhtml',1),
(40,'statsbestcustomers',1),
(41,'statsorigin',1),
(42,'pagesnotfound',1),
(43,'sekeywords',1),
(44,'statsproduct',1),
(45,'statsbestproducts',1),
(46,'statsbestcategories',1),
(47,'statsbestvouchers',1),
(48,'statsbestsuppliers',1),
(49,'statscarrier',1),
(50,'statsnewsletter',1),
(51,'statssearch',1),
(52,'statscheckup',1),
(53,'statsstock',1),
(54,'blockstore',0),
(55,'statsforecast',1),
(56,'carriercompare',1),
(59,'blocklink',0),
(60,'blocknewsletter',0),
(61,'blockrss',0),
(62,'blocksupplier',0),
(63,'sendtoafriend',1),
(65,'productcomments',1),
(66,'tmbestsellers',1),
(67,'tmcategories',1),
(68,'tmcontacts',1),
(71,'tmnivoslider',1),
(70,'tmslider1',1);

/* Table structure for table `ps_module_country` */
DROP TABLE IF EXISTS `ps_module_country`;

CREATE TABLE `ps_module_country` (
  `id_module` int(10) unsigned NOT NULL,
  `id_country` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_module`,`id_country`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_module_country` */
INSERT INTO `ps_module_country` VALUES
(3,1),
(3,2),
(3,3),
(3,4),
(3,5),
(3,6),
(3,7),
(3,8),
(3,9),
(3,10),
(3,11),
(3,12),
(3,13),
(3,14),
(3,15),
(3,16),
(3,17),
(3,18),
(3,19),
(3,20),
(3,21),
(3,22),
(3,23),
(3,24),
(3,25),
(3,26),
(3,27),
(3,28),
(3,29),
(3,30),
(3,31),
(3,32),
(3,33),
(3,34),
(4,1),
(4,2),
(4,3),
(4,4),
(4,5),
(4,6),
(4,7),
(4,8),
(4,9),
(4,10),
(4,11),
(4,12),
(4,13),
(4,14),
(4,15),
(4,16),
(4,17),
(4,18),
(4,19),
(4,20),
(4,21),
(4,22),
(4,23),
(4,24),
(4,25),
(4,26),
(4,27),
(4,28),
(4,29),
(4,30),
(4,31),
(4,32),
(4,33),
(4,34),
(6,1),
(6,2),
(6,3),
(6,4),
(6,5),
(6,6),
(6,7),
(6,8),
(6,9),
(6,10),
(6,11),
(6,12),
(6,13),
(6,14),
(6,15),
(6,16),
(6,17),
(6,18),
(6,19),
(6,20),
(6,21),
(6,22),
(6,23),
(6,24),
(6,25),
(6,26),
(6,27),
(6,28),
(6,29),
(6,30),
(6,31),
(6,32),
(6,33),
(6,34);

/* Table structure for table `ps_module_currency` */
DROP TABLE IF EXISTS `ps_module_currency`;

CREATE TABLE `ps_module_currency` (
  `id_module` int(10) unsigned NOT NULL,
  `id_currency` int(11) NOT NULL,
  PRIMARY KEY  (`id_module`,`id_currency`),
  KEY `id_module` (`id_module`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_module_currency` */
INSERT INTO `ps_module_currency` VALUES
(3,1),
(3,2),
(3,3),
(4,1),
(4,2),
(4,3),
(6,1),
(6,2),
(6,3);

/* Table structure for table `ps_module_group` */
DROP TABLE IF EXISTS `ps_module_group`;

CREATE TABLE `ps_module_group` (
  `id_module` int(10) unsigned NOT NULL,
  `id_group` int(11) unsigned NOT NULL,
  PRIMARY KEY  (`id_module`,`id_group`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_module_group` */
INSERT INTO `ps_module_group` VALUES
(3,1),
(4,1),
(6,1);

/* Table structure for table `ps_product` */
DROP TABLE IF EXISTS `ps_product`;

CREATE TABLE `ps_product` (
  `id_product` int(10) unsigned NOT NULL auto_increment,
  `id_supplier` int(10) unsigned default NULL,
  `id_manufacturer` int(10) unsigned default NULL,
  `id_tax_rules_group` int(10) unsigned NOT NULL,
  `id_category_default` int(10) unsigned default NULL,
  `id_color_default` int(10) unsigned default NULL,
  `on_sale` tinyint(1) unsigned NOT NULL default '0',
  `online_only` tinyint(1) unsigned NOT NULL default '0',
  `ean13` varchar(13) default NULL,
  `upc` varchar(12) default NULL,
  `ecotax` decimal(17,6) NOT NULL default '0.000000',
  `quantity` int(10) NOT NULL default '0',
  `minimal_quantity` int(10) unsigned NOT NULL default '1',
  `price` decimal(20,6) NOT NULL default '0.000000',
  `wholesale_price` decimal(20,6) NOT NULL default '0.000000',
  `unity` varchar(255) default NULL,
  `unit_price_ratio` decimal(20,6) NOT NULL default '0.000000',
  `additional_shipping_cost` decimal(20,2) NOT NULL default '0.00',
  `reference` varchar(32) default NULL,
  `supplier_reference` varchar(32) default NULL,
  `location` varchar(64) default NULL,
  `width` float NOT NULL default '0',
  `height` float NOT NULL default '0',
  `depth` float NOT NULL default '0',
  `weight` float NOT NULL default '0',
  `out_of_stock` int(10) unsigned NOT NULL default '2',
  `quantity_discount` tinyint(1) default '0',
  `customizable` tinyint(2) NOT NULL default '0',
  `uploadable_files` tinyint(4) NOT NULL default '0',
  `text_fields` tinyint(4) NOT NULL default '0',
  `active` tinyint(1) unsigned NOT NULL default '0',
  `available_for_order` tinyint(1) NOT NULL default '1',
  `condition` enum('new','used','refurbished') NOT NULL default 'new',
  `show_price` tinyint(1) NOT NULL default '1',
  `indexed` tinyint(1) NOT NULL default '0',
  `cache_is_pack` tinyint(1) NOT NULL default '0',
  `cache_has_attachments` tinyint(1) NOT NULL default '0',
  `cache_default_attribute` int(10) unsigned default NULL,
  `date_add` datetime NOT NULL,
  `date_upd` datetime NOT NULL,
  PRIMARY KEY  (`id_product`),
  KEY `product_supplier` (`id_supplier`),
  KEY `product_manufacturer` (`id_manufacturer`),
  KEY `id_category_default` (`id_category_default`),
  KEY `id_color_default` (`id_color_default`),
  KEY `date_add` (`date_add`)
) ENGINE=MyISAM AUTO_INCREMENT=31 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_product` */
INSERT INTO `ps_product` VALUES
(1,1,1,0,1,0,1,1,'','','0.000000',599,1,'549.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,1,0,1,1,1,'new',1,1,1,1,1,'2012-08-08 16:26:53','2012-08-08 18:29:23'),
(2,1,1,0,1,0,0,0,'','','0.000000',599,1,'215.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(3,0,1,0,1,0,0,0,'','','0.000000',17,1,'49.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(4,0,2,0,1,0,0,0,'','','0.000000',100,1,'315.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(5,0,0,0,1,0,0,0,'','','0.000000',100,1,'270.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(6,0,0,0,1,0,0,0,'','','0.000000',599,1,'620.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,31,'2012-08-08 16:26:53','2012-08-08 17:02:52'),
(7,0,0,0,1,0,0,0,'','','0.000000',99,1,'345.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','2012-08-08 17:21:37'),
(8,0,0,0,1,0,0,0,'','','0.000000',100,1,'549.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(9,0,0,0,1,0,0,0,'','','0.000000',100,1,'215.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(10,0,0,0,1,0,0,0,'','','0.000000',98,1,'49.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(11,0,0,0,1,0,0,0,'','','0.000000',100,1,'315.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(12,0,0,0,1,0,0,0,'','','0.000000',100,1,'270.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(13,0,0,0,1,0,0,0,'','','0.000000',100,1,'620.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(14,0,0,0,1,0,0,0,'','','0.000000',100,1,'345.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(15,0,0,0,1,0,0,0,'','','0.000000',100,1,'520.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(16,0,0,0,1,0,0,0,'','','0.000000',100,1,'150.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(17,0,0,0,1,0,0,0,'','','0.000000',100,1,'270.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(18,0,0,0,1,0,0,0,'','','0.000000',100,1,'80.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(19,0,0,0,1,0,0,0,'','','0.000000',100,1,'145.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(20,0,0,0,1,0,0,0,'','','0.000000',100,1,'215.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(21,0,0,0,1,0,0,0,'','','0.000000',100,1,'49.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(22,0,0,0,1,0,0,0,'','','0.000000',100,1,'315.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(23,0,0,0,1,0,0,0,'','','0.000000',100,1,'49.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(24,0,0,0,1,0,0,0,'','','0.000000',100,1,'315.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(25,0,0,0,1,0,0,0,'','','0.000000',100,1,'270.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(26,0,0,0,1,0,0,0,'','','0.000000',100,1,'620.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(27,0,0,0,1,0,0,0,'','','0.000000',100,1,'345.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(28,0,0,0,1,0,0,0,'','','0.000000',100,1,'549.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(29,0,0,0,1,0,0,0,'','','0.000000',100,1,'215.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00'),
(30,0,0,0,1,0,0,0,'','','0.000000',100,1,'49.000000','0.000000','','0.000000','0.00','','','','0','0','0','0',2,0,0,0,0,1,1,'new',1,1,0,0,0,'2012-08-08 16:26:53','0000-00-00 00:00:00');

/* Table structure for table `ps_product_attachment` */
DROP TABLE IF EXISTS `ps_product_attachment`;

CREATE TABLE `ps_product_attachment` (
  `id_product` int(10) unsigned NOT NULL,
  `id_attachment` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_product`,`id_attachment`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_product_attachment` */
INSERT INTO `ps_product_attachment` VALUES
(1,1);

/* Table structure for table `ps_product_attribute` */
DROP TABLE IF EXISTS `ps_product_attribute`;

CREATE TABLE `ps_product_attribute` (
  `id_product_attribute` int(10) unsigned NOT NULL auto_increment,
  `id_product` int(10) unsigned NOT NULL,
  `reference` varchar(32) default NULL,
  `supplier_reference` varchar(32) default NULL,
  `location` varchar(64) default NULL,
  `ean13` varchar(13) default NULL,
  `upc` varchar(12) default NULL,
  `wholesale_price` decimal(20,6) NOT NULL default '0.000000',
  `price` decimal(20,6) NOT NULL default '0.000000',
  `ecotax` decimal(17,6) NOT NULL default '0.000000',
  `quantity` int(10) NOT NULL default '0',
  `weight` float NOT NULL default '0',
  `unit_price_impact` decimal(17,2) NOT NULL default '0.00',
  `default_on` tinyint(1) unsigned NOT NULL default '0',
  `minimal_quantity` int(10) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id_product_attribute`),
  KEY `product_attribute_product` (`id_product`),
  KEY `reference` (`reference`),
  KEY `supplier_reference` (`supplier_reference`),
  KEY `product_default` (`id_product`,`default_on`),
  KEY `id_product_id_product_attribute` (`id_product_attribute`,`id_product`)
) ENGINE=MyISAM AUTO_INCREMENT=37 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_product_attribute` */
INSERT INTO `ps_product_attribute` VALUES
(1,1,'','','','','','0.000000','0.000000','0.000000',99,'0','0.00',0,1),
(2,1,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(3,1,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(4,1,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(5,1,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(6,1,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(7,2,'','','','','','0.000000','0.000000','0.000000',99,'0','0.00',0,1),
(8,2,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(9,2,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(10,2,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(11,2,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(12,2,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(13,3,'','','','','','0.000000','0.000000','0.000000',2,'0','0.00',0,1),
(14,3,'','','','','','0.000000','0.000000','0.000000',3,'0','0.00',0,1),
(15,3,'','','','','','0.000000','0.000000','0.000000',3,'0','0.00',0,1),
(16,3,'','','','','','0.000000','0.000000','0.000000',3,'0','0.00',0,1),
(17,3,'','','','','','0.000000','0.000000','0.000000',3,'0','0.00',0,1),
(18,3,'','','','','','0.000000','0.000000','0.000000',3,'0','0.00',0,1),
(19,4,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(20,4,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(21,4,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(22,4,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(23,4,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(24,4,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(25,5,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(26,5,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(27,5,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(28,5,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(29,5,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(30,5,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(31,6,'','','','','','0.000000','0.000000','0.000000',99,'0','0.00',0,1),
(32,6,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(33,6,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(34,6,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(35,6,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1),
(36,6,'','','','','','0.000000','0.000000','0.000000',100,'0','0.00',0,1);

/* Table structure for table `ps_product_attribute_combination` */
DROP TABLE IF EXISTS `ps_product_attribute_combination`;

CREATE TABLE `ps_product_attribute_combination` (
  `id_attribute` int(10) unsigned NOT NULL,
  `id_product_attribute` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_attribute`,`id_product_attribute`),
  KEY `id_product_attribute` (`id_product_attribute`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_product_attribute_combination` */
INSERT INTO `ps_product_attribute_combination` VALUES
(1,1),
(1,2),
(1,7),
(1,8),
(1,13),
(1,14),
(1,19),
(1,20),
(1,25),
(1,26),
(1,31),
(1,32),
(2,1),
(2,3),
(2,5),
(2,7),
(2,9),
(2,11),
(2,13),
(2,15),
(2,17),
(2,19),
(2,21),
(2,23),
(2,25),
(2,27),
(2,29),
(2,31),
(2,33),
(2,35),
(3,2),
(3,4),
(3,6),
(3,8),
(3,10),
(3,12),
(3,14),
(3,16),
(3,18),
(3,20),
(3,22),
(3,24),
(3,26),
(3,28),
(3,30),
(3,32),
(3,34),
(3,36),
(4,3),
(4,4),
(4,9),
(4,10),
(4,15),
(4,16),
(4,21),
(4,22),
(4,27),
(4,28),
(4,33),
(4,34),
(5,5),
(5,6),
(5,11),
(5,12),
(5,17),
(5,18),
(5,23),
(5,24),
(5,29),
(5,30),
(5,35),
(5,36);

/* Table structure for table `ps_product_attribute_image` */
DROP TABLE IF EXISTS `ps_product_attribute_image`;

CREATE TABLE `ps_product_attribute_image` (
  `id_product_attribute` int(10) unsigned NOT NULL,
  `id_image` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_product_attribute`,`id_image`),
  KEY `id_image` (`id_image`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


/* Table structure for table `ps_product_country_tax` */
DROP TABLE IF EXISTS `ps_product_country_tax`;

CREATE TABLE `ps_product_country_tax` (
  `id_product` int(11) NOT NULL,
  `id_country` int(11) NOT NULL,
  `id_tax` int(11) NOT NULL,
  PRIMARY KEY  (`id_product`,`id_country`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


/* Table structure for table `ps_product_group_reduction_cache` */
DROP TABLE IF EXISTS `ps_product_group_reduction_cache`;

CREATE TABLE `ps_product_group_reduction_cache` (
  `id_product` int(10) unsigned NOT NULL,
  `id_group` int(10) unsigned NOT NULL,
  `reduction` decimal(4,3) NOT NULL,
  PRIMARY KEY  (`id_product`,`id_group`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


/* Table structure for table `ps_product_lang` */
DROP TABLE IF EXISTS `ps_product_lang`;

CREATE TABLE `ps_product_lang` (
  `id_product` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `description` text,
  `description_short` text,
  `link_rewrite` varchar(128) NOT NULL,
  `meta_description` varchar(255) default NULL,
  `meta_keywords` varchar(255) default NULL,
  `meta_title` varchar(128) default NULL,
  `name` varchar(128) NOT NULL,
  `available_now` varchar(255) default NULL,
  `available_later` varchar(255) default NULL,
  PRIMARY KEY  (`id_product`,`id_lang`),
  KEY `id_lang` (`id_lang`),
  KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_product_lang` */
INSERT INTO `ps_product_lang` VALUES
(1,1,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p>\r\n<p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p>','water-kettler-swk-1753','','','','Water Kettler SWK 1753','',''),
(1,2,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p>\r\n<p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p>','water-kettler-swk-1753','','','','Water Kettler SWK 1753','',''),
(1,3,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p>\r\n<p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p>','water-kettler-swk-1753','','','','Water Kettler SWK 1753','',''),
(1,4,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p>\r\n<p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p>','water-kettler-swk-1753','','','','Water Kettler SWK 1753','',''),
(1,5,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p>\r\n<p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p>','water-kettler-swk-1753','','','','Water Kettler SWK 1753','',''),
(2,1,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.','eclipse-electrolux-vacuum-cleaner','','','','Eclipse Electrolux Vacuum Cleaner','',''),
(2,2,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.','eclipse-electrolux-vacuum-cleaner','','','','Eclipse Electrolux Vacuum Cleaner','',''),
(2,3,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.','eclipse-electrolux-vacuum-cleaner','','','','Eclipse Electrolux Vacuum Cleaner','',''),
(2,4,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.','eclipse-electrolux-vacuum-cleaner','','','','Eclipse Electrolux Vacuum Cleaner','',''),
(2,5,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.','eclipse-electrolux-vacuum-cleaner','','','','Eclipse Electrolux Vacuum Cleaner','',''),
(3,1,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','hood-scholtes-hse-159-ix','','','','Hood Scholtes HSE 159 IX','',''),
(3,2,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','hood-scholtes-hse-159-ix','','','','Hood Scholtes HSE 159 IX','',''),
(3,3,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','hood-scholtes-hse-159-ix','','','','Hood Scholtes HSE 159 IX','',''),
(3,4,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','hood-scholtes-hse-159-ix','','','','Hood Scholtes HSE 159 IX','',''),
(3,5,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','hood-scholtes-hse-159-ix','','','','Hood Scholtes HSE 159 IX','',''),
(4,1,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.','aeg-ultra-active-vacuum-cleaner','','','','AEG Ultra-active Vacuum Cleaner','',''),
(4,2,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.','aeg-ultra-active-vacuum-cleaner','','','','AEG Ultra-active Vacuum Cleaner','',''),
(4,3,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.','aeg-ultra-active-vacuum-cleaner','','','','AEG Ultra-active Vacuum Cleaner','',''),
(4,4,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.','aeg-ultra-active-vacuum-cleaner','','','','AEG Ultra-active Vacuum Cleaner','',''),
(4,5,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.','aeg-ultra-active-vacuum-cleaner','','','','AEG Ultra-active Vacuum Cleaner','',''),
(5,1,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!','siemens-kd-36na-40-fridge-freezer','','','','Siemens KD-36NA-40 fridge freezer','',''),
(5,2,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!','siemens-kd-36na-40-fridge-freezer','','','','Siemens KD-36NA-40 fridge freezer','',''),
(5,3,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!','siemens-kd-36na-40-fridge-freezer','','','','Siemens KD-36NA-40 fridge freezer','',''),
(5,4,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!','siemens-kd-36na-40-fridge-freezer','','','','Siemens KD-36NA-40 fridge freezer','',''),
(5,5,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!','siemens-kd-36na-40-fridge-freezer','','','','Siemens KD-36NA-40 fridge freezer','',''),
(6,1,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p>\r\n<p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','<p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','meat-grinder-smg-4382','','','','Meat Grinder  SMG 4382','',''),
(6,2,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p>\r\n<p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','<p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','meat-grinder-smg-4382','','','','Meat Grinder  SMG 4382','',''),
(6,3,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p>\r\n<p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','<p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','meat-grinder-smg-4382','','','','Meat Grinder  SMG 4382','',''),
(6,4,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p>\r\n<p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','<p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','meat-grinder-smg-4382','','','','Meat Grinder  SMG 4382','',''),
(6,5,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p>\r\n<p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','<p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','meat-grinder-smg-4382','','','','Meat Grinder  SMG 4382','',''),
(7,1,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p>\r\n<p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p>','applica-fp1600b-bd-7-cup-food-processor','','','','Applica FP1600B B&D 7 Cup Food Processor','',''),
(7,2,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p>\r\n<p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p>','applica-fp1600b-bd-7-cup-food-processor','','','','Applica FP1600B B&D 7 Cup Food Processor','',''),
(7,3,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p>\r\n<p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p>','applica-fp1600b-bd-7-cup-food-processor','','','','Applica FP1600B B&D 7 Cup Food Processor','',''),
(7,4,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p>\r\n<p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p>','applica-fp1600b-bd-7-cup-food-processor','','','','Applica FP1600B B&D 7 Cup Food Processor','',''),
(7,5,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p>\r\n<p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p>','applica-fp1600b-bd-7-cup-food-processor','','','','Applica FP1600B B&D 7 Cup Food Processor','',''),
(8,1,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.','bosch-tds3569gb-2800w-sensixx-b35l-premier-power-steam-generator-iron','','','','Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron','',''),
(8,2,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.','bosch-tds3569gb-2800w-sensixx-b35l-premier-power-steam-generator-iron','','','','Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron','',''),
(8,3,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.','bosch-tds3569gb-2800w-sensixx-b35l-premier-power-steam-generator-iron','','','','Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron','',''),
(8,4,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.','bosch-tds3569gb-2800w-sensixx-b35l-premier-power-steam-generator-iron','','','','Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron','',''),
(8,5,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.','bosch-tds3569gb-2800w-sensixx-b35l-premier-power-steam-generator-iron','','','','Bosch TDS3569GB 2800W Sensixx B35L Premier Power Steam Generator Iron','',''),
(9,1,'<p>The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.</p><p>We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.</p>','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.','coffee-machine-bugatti-diva','','','','Coffee Machine Bugatti Diva','',''),
(9,2,'<p>The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.</p><p>We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.</p>','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.','coffee-machine-bugatti-diva','','','','Coffee Machine Bugatti Diva','',''),
(9,3,'<p>The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.</p><p>We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.</p>','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.','coffee-machine-bugatti-diva','','','','Coffee Machine Bugatti Diva','',''),
(9,4,'<p>The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.</p><p>We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.</p>','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.','coffee-machine-bugatti-diva','','','','Coffee Machine Bugatti Diva','',''),
(9,5,'<p>The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.</p><p>We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.</p>','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.','coffee-machine-bugatti-diva','','','','Coffee Machine Bugatti Diva','',''),
(10,1,'<p>If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. </p><p>Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.</p>','Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.','coffee-machine-kalorik-aztec','','','','Coffee Machine Kalorik Aztec','',''),
(10,2,'<p>If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. </p><p>Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.</p>','Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.','coffee-machine-kalorik-aztec','','','','Coffee Machine Kalorik Aztec','',''),
(10,3,'<p>If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. </p><p>Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.</p>','Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.','coffee-machine-kalorik-aztec','','','','Coffee Machine Kalorik Aztec','',''),
(10,4,'<p>If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. </p><p>Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.</p>','Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.','coffee-machine-kalorik-aztec','','','','Coffee Machine Kalorik Aztec','',''),
(10,5,'<p>If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. </p><p>Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.</p>','Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.','coffee-machine-kalorik-aztec','','','','Coffee Machine Kalorik Aztec','',''),
(11,1,'<p>Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.</p><p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p>','We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.','coffee-machine-malongo-espresso-gold','','','','Coffee Machine Malongo Espresso-gold','',''),
(11,2,'<p>Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.</p><p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p>','We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.','coffee-machine-malongo-espresso-gold','','','','Coffee Machine Malongo Espresso-gold','',''),
(11,3,'<p>Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.</p><p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p>','We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.','coffee-machine-malongo-espresso-gold','','','','Coffee Machine Malongo Espresso-gold','',''),
(11,4,'<p>Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.</p><p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p>','We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.','coffee-machine-malongo-espresso-gold','','','','Coffee Machine Malongo Espresso-gold','',''),
(11,5,'<p>Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.</p><p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p>','We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.','coffee-machine-malongo-espresso-gold','','','','Coffee Machine Malongo Espresso-gold','',''),
(12,1,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p><p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.','coffee-maker-bosch-assimo','','','','Coffee Maker Bosch Assimo','',''),
(12,2,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p><p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.','coffee-maker-bosch-assimo','','','','Coffee Maker Bosch Assimo','',''),
(12,3,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p><p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.','coffee-maker-bosch-assimo','','','','Coffee Maker Bosch Assimo','',''),
(12,4,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p><p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.','coffee-maker-bosch-assimo','','','','Coffee Maker Bosch Assimo','',''),
(12,5,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p><p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.','coffee-maker-bosch-assimo','','','','Coffee Maker Bosch Assimo','',''),
(13,1,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.','def-18w-804','','','','DEF 18W-804','',''),
(13,2,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.','def-18w-804','','','','DEF 18W-804','',''),
(13,3,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.','def-18w-804','','','','DEF 18W-804','',''),
(13,4,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.','def-18w-804','','','','DEF 18W-804','',''),
(13,5,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.','def-18w-804','','','','DEF 18W-804','',''),
(14,1,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.','hairdryer-d-4444-shine-dryer-hr-1','','','','Hairdryer D-4444 Shine Dryer HR 1','',''),
(14,2,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.','hairdryer-d-4444-shine-dryer-hr-1','','','','Hairdryer D-4444 Shine Dryer HR 1','',''),
(14,3,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.','hairdryer-d-4444-shine-dryer-hr-1','','','','Hairdryer D-4444 Shine Dryer HR 1','',''),
(14,4,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.','hairdryer-d-4444-shine-dryer-hr-1','','','','Hairdryer D-4444 Shine Dryer HR 1','',''),
(14,5,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.','hairdryer-d-4444-shine-dryer-hr-1','','','','Hairdryer D-4444 Shine Dryer HR 1','',''),
(15,1,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.','hairdryer-fhd-10c-666','','','','Hairdryer FHD 10C-666','',''),
(15,2,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.','hairdryer-fhd-10c-666','','','','Hairdryer FHD 10C-666','',''),
(15,3,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.','hairdryer-fhd-10c-666','','','','Hairdryer FHD 10C-666','',''),
(15,4,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.','hairdryer-fhd-10c-666','','','','Hairdryer FHD 10C-666','',''),
(15,5,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.','hairdryer-fhd-10c-666','','','','Hairdryer FHD 10C-666','',''),
(16,1,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.','hairdryer-phd-30b-661','','','','Hairdryer PHD 30B-661','',''),
(16,2,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.','hairdryer-phd-30b-661','','','','Hairdryer PHD 30B-661','',''),
(16,3,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.','hairdryer-phd-30b-661','','','','Hairdryer PHD 30B-661','',''),
(16,4,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.','hairdryer-phd-30b-661','','','','Hairdryer PHD 30B-661','',''),
(16,5,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.','hairdryer-phd-30b-661','','','','Hairdryer PHD 30B-661','',''),
(17,1,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p><p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.','hamilton-beach-72703-ensemble-3-cup-chopper','','','','Hamilton Beach 72703 Ensemble 3 Cup Chopper','',''),
(17,2,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p><p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.','hamilton-beach-72703-ensemble-3-cup-chopper','','','','Hamilton Beach 72703 Ensemble 3 Cup Chopper','',''),
(17,3,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p><p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.','hamilton-beach-72703-ensemble-3-cup-chopper','','','','Hamilton Beach 72703 Ensemble 3 Cup Chopper','',''),
(17,4,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p><p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.','hamilton-beach-72703-ensemble-3-cup-chopper','','','','Hamilton Beach 72703 Ensemble 3 Cup Chopper','',''),
(17,5,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p><p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.','hamilton-beach-72703-ensemble-3-cup-chopper','','','','Hamilton Beach 72703 Ensemble 3 Cup Chopper','',''),
(18,1,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p><p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.','hood-cda-evck4ss-40cm-cylinder','','','','Hood CDA EVCK4SS 40cm Cylinder','',''),
(18,2,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p><p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.','hood-cda-evck4ss-40cm-cylinder','','','','Hood CDA EVCK4SS 40cm Cylinder','',''),
(18,3,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p><p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.','hood-cda-evck4ss-40cm-cylinder','','','','Hood CDA EVCK4SS 40cm Cylinder','',''),
(18,4,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p><p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.','hood-cda-evck4ss-40cm-cylinder','','','','Hood CDA EVCK4SS 40cm Cylinder','',''),
(18,5,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p><p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.','hood-cda-evck4ss-40cm-cylinder','','','','Hood CDA EVCK4SS 40cm Cylinder','',''),
(19,1,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. ','hood-faber-klima-black','','','','Hood Faber Klima - black','',''),
(19,2,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. ','hood-faber-klima-black','','','','Hood Faber Klima - black','',''),
(19,3,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. ','hood-faber-klima-black','','','','Hood Faber Klima - black','',''),
(19,4,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. ','hood-faber-klima-black','','','','Hood Faber Klima - black','',''),
(19,5,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. ','hood-faber-klima-black','','','','Hood Faber Klima - black','',''),
(20,1,'<p>The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.</p><p>We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.</p>','Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.','hood-whirpool-akr806ix','','','','Hood Whirpool AKR806IX','',''),
(20,2,'<p>The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.</p><p>We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.</p>','Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.','hood-whirpool-akr806ix','','','','Hood Whirpool AKR806IX','',''),
(20,3,'<p>The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.</p><p>We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.</p>','Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.','hood-whirpool-akr806ix','','','','Hood Whirpool AKR806IX','',''),
(20,4,'<p>The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.</p><p>We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.</p>','Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.','hood-whirpool-akr806ix','','','','Hood Whirpool AKR806IX','',''),
(20,5,'<p>The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Our goods are the combination of perfect design and an ideal functionality.</p><p>We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. We have a tremendous variety of different models.</p>','Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.','hood-whirpool-akr806ix','','','','Hood Whirpool AKR806IX','',''),
(21,1,'<p>If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. </p><p>Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.</p>','Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.','hoover-xarion-bagless-vacuum-cleaner','','','','Hoover Xarion bagless vacuum cleaner','',''),
(21,2,'<p>If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. </p><p>Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.</p>','Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.','hoover-xarion-bagless-vacuum-cleaner','','','','Hoover Xarion bagless vacuum cleaner','',''),
(21,3,'<p>If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. </p><p>Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.</p>','Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.','hoover-xarion-bagless-vacuum-cleaner','','','','Hoover Xarion bagless vacuum cleaner','',''),
(21,4,'<p>If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. </p><p>Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.</p>','Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.','hoover-xarion-bagless-vacuum-cleaner','','','','Hoover Xarion bagless vacuum cleaner','',''),
(21,5,'<p>If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics. </p><p>Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits. Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. Recipe of our success is a fair price and premium quality.</p>','Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.','hoover-xarion-bagless-vacuum-cleaner','','','','Hoover Xarion bagless vacuum cleaner','',''),
(22,1,'<p>Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.</p><p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p>','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.','kalorik-meat-grinder-mgr25959-stainless-steel-blade','','','','Kalorik Meat Grinder MGR25959 Stainless Steel Blade','',''),
(22,2,'<p>Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.</p><p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p>','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.','kalorik-meat-grinder-mgr25959-stainless-steel-blade','','','','Kalorik Meat Grinder MGR25959 Stainless Steel Blade','',''),
(22,3,'<p>Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.</p><p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p>','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.','kalorik-meat-grinder-mgr25959-stainless-steel-blade','','','','Kalorik Meat Grinder MGR25959 Stainless Steel Blade','',''),
(22,4,'<p>Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.</p><p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p>','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.','kalorik-meat-grinder-mgr25959-stainless-steel-blade','','','','Kalorik Meat Grinder MGR25959 Stainless Steel Blade','',''),
(22,5,'<p>Remember that only in our store you can buy fashionable, solid and very functional home electronics.  Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. Recipe of our success is a fair price and premium quality.</p><p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p>','Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.','kalorik-meat-grinder-mgr25959-stainless-steel-blade','','','','Kalorik Meat Grinder MGR25959 Stainless Steel Blade','',''),
(23,1,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p><p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.','lg-refrigerator-floral-collection-t676','','','','LG Refrigerator - Floral collection T676','',''),
(23,2,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p><p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.','lg-refrigerator-floral-collection-t676','','','','LG Refrigerator - Floral collection T676','',''),
(23,3,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p><p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.','lg-refrigerator-floral-collection-t676','','','','LG Refrigerator - Floral collection T676','',''),
(23,4,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p><p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.','lg-refrigerator-floral-collection-t676','','','','LG Refrigerator - Floral collection T676','',''),
(23,5,'<p>Comfort is a very important thing nowadays because it is a condition of satisfaction and calmness. It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Recipe of our success is a fair price and premium quality.</p><p>It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.</p>','It is clear that our way of life must be as comfortable as possible. Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. Our goods are the combination of perfect design and an ideal functionality.','lg-refrigerator-floral-collection-t676','','','','LG Refrigerator - Floral collection T676','',''),
(24,1,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','meat-grinder-avilla-av-0304','','','','MEAT GRINDER Avilla av-0304','',''),
(24,2,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','meat-grinder-avilla-av-0304','','','','MEAT GRINDER Avilla av-0304','',''),
(24,3,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','meat-grinder-avilla-av-0304','','','','MEAT GRINDER Avilla av-0304','',''),
(24,4,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','meat-grinder-avilla-av-0304','','','','MEAT GRINDER Avilla av-0304','',''),
(24,5,'<p>Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.</p><p>We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.</p>','Home electronics satisfy our wishes and make our life more pleasant. We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities.','meat-grinder-avilla-av-0304','','','','MEAT GRINDER Avilla av-0304','',''),
(25,1,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.','meat-grinder-mg-2050r','','','','Meat Grinder MG-2050(R)','',''),
(25,2,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.','meat-grinder-mg-2050r','','','','Meat Grinder MG-2050(R)','',''),
(25,3,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.','meat-grinder-mg-2050r','','','','Meat Grinder MG-2050(R)','',''),
(25,4,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.','meat-grinder-mg-2050r','','','','Meat Grinder MG-2050(R)','',''),
(25,5,'<p>Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!</p><p>You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.</p>','We must admit that our way of life depends on quality of different goods of popular brands. Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality.','meat-grinder-mg-2050r','','','','Meat Grinder MG-2050(R)','',''),
(26,1,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!','modern-fridge-freezer-fagor-ffa-8865','','','','Modern fridge freezer Fagor FFA-8865','',''),
(26,2,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!','modern-fridge-freezer-fagor-ffa-8865','','','','Modern fridge freezer Fagor FFA-8865','',''),
(26,3,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!','modern-fridge-freezer-fagor-ffa-8865','','','','Modern fridge freezer Fagor FFA-8865','',''),
(26,4,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!','modern-fridge-freezer-fagor-ffa-8865','','','','Modern fridge freezer Fagor FFA-8865','',''),
(26,5,'<p>Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.</p><p>We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.</p>','Many of our clients were surprised by the incredible assortment of products in our store. You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. Here you can find something more than just home electronics, you can find real comfort and satisfaction here!','modern-fridge-freezer-fagor-ffa-8865','','','','Modern fridge freezer Fagor FFA-8865','',''),
(27,1,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.','side-by-side-electrolux-refrigerator','','','','Side-by-side ELECTROLUX Refrigerator','',''),
(27,2,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.','side-by-side-electrolux-refrigerator','','','','Side-by-side ELECTROLUX Refrigerator','',''),
(27,3,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.','side-by-side-electrolux-refrigerator','','','','Side-by-side ELECTROLUX Refrigerator','',''),
(27,4,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.','side-by-side-electrolux-refrigerator','','','','Side-by-side ELECTROLUX Refrigerator','',''),
(27,5,'<p>Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.</p><p>Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability.</p>','You know, we have many devoted customers all over the world, and this fact proves that we sell only quality commodities. Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Our goods are the combination of perfect design and an ideal functionality.','side-by-side-electrolux-refrigerator','','','','Side-by-side ELECTROLUX Refrigerator','',''),
(28,1,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p><p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.','smeg-compact-refrigerator-mini-fridge-fab-10uj','','','','SMEG - Compact Refrigerator Mini-fridge FAB-10UJ','',''),
(28,2,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p><p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.','smeg-compact-refrigerator-mini-fridge-fab-10uj','','','','SMEG - Compact Refrigerator Mini-fridge FAB-10UJ','',''),
(28,3,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p><p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.','smeg-compact-refrigerator-mini-fridge-fab-10uj','','','','SMEG - Compact Refrigerator Mini-fridge FAB-10UJ','',''),
(28,4,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p><p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.','smeg-compact-refrigerator-mini-fridge-fab-10uj','','','','SMEG - Compact Refrigerator Mini-fridge FAB-10UJ','',''),
(28,5,'<p>We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also we provide different economical, social and even technological researches.</p><p>Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Also you can save some money at our store because we always provide different promos and you can get good discount and other benefits.</p>','Recipe of our success is a fair price and premium quality. We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality.','smeg-compact-refrigerator-mini-fridge-fab-10uj','','','','SMEG - Compact Refrigerator Mini-fridge FAB-10UJ','',''),
(29,1,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p><p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.','smeg-contemporary-refrigerator-fpd','','','','SMEG - Contemporary Refrigerator FPD','',''),
(29,2,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p><p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.','smeg-contemporary-refrigerator-fpd','','','','SMEG - Contemporary Refrigerator FPD','',''),
(29,3,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p><p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.','smeg-contemporary-refrigerator-fpd','','','','SMEG - Contemporary Refrigerator FPD','',''),
(29,4,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p><p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.','smeg-contemporary-refrigerator-fpd','','','','SMEG - Contemporary Refrigerator FPD','',''),
(29,5,'<p>But we provide only real bestsellers and our products have a great number of options that can really help you. You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. We are trying to introduce positive results of our explorations.</p><p>You’ll be amazed with its simplicity and durability. Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data.</p>','We understand that it is very complicated to amaze present clients, they are so whimsical, but our products are very flexible and reliable. Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models.','smeg-contemporary-refrigerator-fpd','','','','SMEG - Contemporary Refrigerator FPD','',''),
(30,1,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.','wash-vacuum-cleaner-thomas-twin-t2','','','','Wash Vacuum Cleaner THOMAS TWIN t2','',''),
(30,2,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.','wash-vacuum-cleaner-thomas-twin-t2','','','','Wash Vacuum Cleaner THOMAS TWIN t2','',''),
(30,3,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.','wash-vacuum-cleaner-thomas-twin-t2','','','','Wash Vacuum Cleaner THOMAS TWIN t2','',''),
(30,4,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.','wash-vacuum-cleaner-thomas-twin-t2','','','','Wash Vacuum Cleaner THOMAS TWIN t2','',''),
(30,5,'<p>Our manufacturers and vendors provide only new technologies and it is very important because nowadays we see a furious development of electronics industry. Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. Recipe of our success is a fair price and premium quality.</p><p>Also we provide different economical, social and even technological researches. The main goal of their analysis is to find out the changes of clients’ demands and other useful data. We are trying to introduce positive results of our explorations. If you want to know more information about our goods, terms, guarantees and other features, you can address our superb 24/7 support system.</p>','Here you can find something more than just home electronics, you can find real comfort and satisfaction here! Our goods are the combination of perfect design and an ideal functionality. We have a tremendous variety of different models. Nowadays clients’ claims become so scrupulous that sometimes it is very hard to satisfy them. We are trying to introduce positive results of our explorations.','wash-vacuum-cleaner-thomas-twin-t2','','','','Wash Vacuum Cleaner THOMAS TWIN t2','','');

/* Table structure for table `ps_product_sale` */
DROP TABLE IF EXISTS `ps_product_sale`;

CREATE TABLE `ps_product_sale` (
  `id_product` int(10) unsigned NOT NULL,
  `quantity` int(10) unsigned NOT NULL default '0',
  `sale_nbr` int(10) unsigned NOT NULL default '0',
  `date_upd` date NOT NULL,
  PRIMARY KEY  (`id_product`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_product_sale` */
INSERT INTO `ps_product_sale` VALUES
(1,100,1,'2012-03-06'),
(3,100,1,'2012-03-06'),
(4,100,1,'2012-03-06'),
(7,100,1,'2012-03-06'),
(9,100,1,'2012-03-06'),
(12,100,1,'2012-03-06'),
(13,100,1,'2012-03-06'),
(16,100,1,'2012-03-06'),
(23,100,1,'2012-03-06'),
(27,100,2,'2012-03-06');

/* Table structure for table `ps_product_tag` */
DROP TABLE IF EXISTS `ps_product_tag`;

CREATE TABLE `ps_product_tag` (
  `id_product` int(10) unsigned NOT NULL,
  `id_tag` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_product`,`id_tag`),
  KEY `id_tag` (`id_tag`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_product_tag` */
INSERT INTO `ps_product_tag` VALUES
(2,6),
(6,5),
(7,5),
(10,5),
(10,6),
(13,5),
(23,5),
(23,7),
(26,5),
(28,5);

/* Table structure for table `ps_scene` */
DROP TABLE IF EXISTS `ps_scene`;

CREATE TABLE `ps_scene` (
  `id_scene` int(10) unsigned NOT NULL auto_increment,
  `active` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id_scene`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;


/* Table structure for table `ps_scene_category` */
DROP TABLE IF EXISTS `ps_scene_category`;

CREATE TABLE `ps_scene_category` (
  `id_scene` int(10) unsigned NOT NULL,
  `id_category` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_scene`,`id_category`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


/* Table structure for table `ps_scene_lang` */
DROP TABLE IF EXISTS `ps_scene_lang`;

CREATE TABLE `ps_scene_lang` (
  `id_scene` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY  (`id_scene`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


/* Table structure for table `ps_scene_products` */
DROP TABLE IF EXISTS `ps_scene_products`;

CREATE TABLE `ps_scene_products` (
  `id_scene` int(10) unsigned NOT NULL,
  `id_product` int(10) unsigned NOT NULL,
  `x_axis` int(4) NOT NULL,
  `y_axis` int(4) NOT NULL,
  `zone_width` int(3) NOT NULL,
  `zone_height` int(3) NOT NULL,
  PRIMARY KEY  (`id_scene`,`id_product`,`x_axis`,`y_axis`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


/* Table structure for table `ps_search_engine` */
DROP TABLE IF EXISTS `ps_search_engine`;

CREATE TABLE `ps_search_engine` (
  `id_search_engine` int(10) unsigned NOT NULL auto_increment,
  `server` varchar(64) NOT NULL,
  `getvar` varchar(16) NOT NULL,
  PRIMARY KEY  (`id_search_engine`)
) ENGINE=MyISAM AUTO_INCREMENT=39 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_search_engine` */
INSERT INTO `ps_search_engine` VALUES
(1,'google','q'),
(2,'aol','q'),
(3,'yandex','text'),
(4,'ask.com','q'),
(5,'nhl.com','q'),
(6,'yahoo','p'),
(7,'baidu','wd'),
(8,'lycos','query'),
(9,'exalead','q'),
(10,'search.live','q'),
(11,'voila','rdata'),
(12,'altavista','q'),
(13,'bing','q'),
(14,'daum','q'),
(15,'eniro','search_word'),
(16,'naver','query'),
(17,'msn','q'),
(18,'netscape','query'),
(19,'cnn','query'),
(20,'about','terms'),
(21,'mamma','query'),
(22,'alltheweb','q'),
(23,'virgilio','qs'),
(24,'alice','qs'),
(25,'najdi','q'),
(26,'mama','query'),
(27,'seznam','q'),
(28,'onet','qt'),
(29,'szukacz','q'),
(30,'yam','k'),
(31,'pchome','q'),
(32,'kvasir','q'),
(33,'sesam','q'),
(34,'ozu','q'),
(35,'terra','query'),
(36,'mynet','q'),
(37,'ekolay','q'),
(38,'rambler','words');

/* Table structure for table `ps_search_index` */
DROP TABLE IF EXISTS `ps_search_index`;

CREATE TABLE `ps_search_index` (
  `id_product` int(11) unsigned NOT NULL,
  `id_word` int(11) unsigned NOT NULL,
  `weight` smallint(4) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id_word`,`id_product`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_search_index` */
INSERT INTO `ps_search_index` VALUES
(1,1,6),
(1,2,6),
(1,3,6),
(1,4,6),
(1,5,2),
(1,6,2),
(1,7,2),
(1,8,2),
(1,9,2),
(1,10,2),
(1,11,2),
(1,12,2),
(1,13,2),
(1,14,3),
(1,15,6),
(1,16,17),
(1,17,6),
(1,18,9),
(1,19,6),
(1,20,3),
(1,21,3),
(1,22,6),
(1,23,3),
(1,24,3),
(1,25,3),
(1,26,3),
(1,27,3),
(1,28,3),
(1,29,3),
(1,30,3),
(1,31,5),
(1,32,3),
(1,33,4),
(1,34,3),
(1,35,3),
(1,36,2),
(1,37,2),
(1,38,2),
(1,39,2),
(1,40,2),
(1,41,1),
(1,42,1),
(1,43,1),
(1,44,1),
(1,45,1),
(1,46,1),
(1,47,1),
(1,48,1),
(1,49,1),
(1,50,1),
(1,51,1),
(1,52,1),
(1,53,1),
(1,54,1),
(1,55,3),
(1,56,4),
(1,57,4),
(1,58,6),
(1,59,6),
(1,60,4),
(1,61,6),
(1,62,6),
(1,63,6),
(1,64,6),
(1,65,2),
(1,66,2),
(1,67,2),
(1,68,2),
(1,69,2),
(1,70,2),
(1,71,2),
(1,72,2),
(1,73,8),
(1,74,2),
(1,75,3),
(1,76,6),
(1,77,17),
(1,78,6),
(1,79,9),
(1,80,6),
(1,81,3),
(1,82,3),
(1,83,3),
(1,84,3),
(1,85,3),
(1,86,3),
(1,87,3),
(1,88,3),
(1,89,3),
(1,90,3),
(1,91,3),
(1,92,5),
(1,93,3),
(1,94,4),
(1,95,3),
(1,96,3),
(1,97,2),
(1,98,2),
(1,99,2),
(1,100,2),
(1,101,2),
(1,102,1),
(1,103,1),
(1,104,1),
(1,105,1),
(1,106,2),
(1,107,1),
(1,108,1),
(1,109,1),
(1,110,1),
(1,111,1),
(1,112,1),
(1,113,1),
(1,114,1),
(1,115,1),
(1,116,1),
(1,117,3),
(1,118,3),
(1,119,4),
(1,120,4),
(1,121,6),
(1,122,6),
(1,123,4),
(1,124,6),
(1,125,6),
(1,126,6),
(1,127,6),
(1,128,2),
(1,129,2),
(1,130,2),
(1,131,2),
(1,132,2),
(1,133,2),
(1,134,2),
(1,135,2),
(1,136,8),
(1,137,2),
(1,138,3),
(1,139,6),
(1,140,17),
(1,141,6),
(1,142,9),
(1,143,6),
(1,144,3),
(1,145,3),
(1,146,3),
(1,147,3),
(1,148,3),
(1,149,3),
(1,150,3),
(1,151,3),
(1,152,3),
(1,153,3),
(1,154,3),
(1,155,5),
(1,156,3),
(1,157,4),
(1,158,3),
(1,159,3),
(1,160,2),
(1,161,2),
(1,162,2),
(1,163,2),
(1,164,2),
(1,165,1),
(1,166,1),
(1,167,1),
(1,168,1),
(1,169,2),
(1,170,1),
(1,171,1),
(1,172,1),
(1,173,1),
(1,174,1),
(1,175,1),
(1,176,1),
(1,177,1),
(1,178,1),
(1,179,1),
(1,180,3),
(1,181,3),
(1,182,4),
(1,183,4),
(1,184,6),
(1,185,6),
(1,186,4),
(1,187,6),
(1,188,6),
(1,189,6),
(1,190,6),
(1,191,2),
(1,192,2),
(1,193,2),
(1,194,2),
(1,195,2),
(1,196,2),
(1,197,2),
(1,198,2),
(1,199,8),
(1,200,2),
(1,201,3),
(1,202,6),
(1,203,17),
(1,204,6),
(1,205,9),
(1,206,6),
(1,207,3),
(1,208,3),
(1,209,3),
(1,210,3),
(1,211,3),
(1,212,3),
(1,213,3),
(1,214,3),
(1,215,3),
(1,216,3),
(1,217,3),
(1,218,5),
(1,219,3),
(1,220,4),
(1,221,3),
(1,222,3),
(1,223,2),
(1,224,2),
(1,225,2),
(1,226,2),
(1,227,2),
(1,228,1),
(1,229,1),
(1,230,1),
(1,231,1),
(1,232,2),
(1,233,1),
(1,234,1),
(1,235,1),
(1,236,1),
(1,237,1),
(1,238,1),
(1,239,1),
(1,240,1),
(1,241,1),
(1,242,1),
(1,243,3),
(1,244,3),
(1,245,4),
(1,246,4),
(1,247,6),
(1,248,6),
(1,249,4),
(1,250,6),
(1,251,6),
(1,252,6),
(1,253,6),
(1,254,2),
(1,255,2),
(1,256,2),
(1,257,2),
(1,258,2),
(1,259,2),
(1,260,2),
(1,261,2),
(1,262,8),
(1,263,2),
(1,264,3),
(1,265,6),
(1,266,17),
(1,267,6),
(1,268,9),
(1,269,6),
(1,270,3),
(1,271,3),
(1,272,6),
(1,273,3),
(1,274,3),
(1,275,3),
(1,276,3),
(1,277,3),
(1,278,3),
(1,279,3),
(1,280,3),
(1,281,5),
(1,282,3),
(1,283,4),
(1,284,3),
(1,285,3),
(1,286,2),
(1,287,2),
(1,288,2),
(1,289,2),
(1,290,2),
(1,291,1),
(1,292,1),
(1,293,1),
(1,294,1),
(1,295,2),
(1,296,1),
(1,297,1),
(1,298,1),
(1,299,1),
(1,300,1),
(1,301,1),
(1,302,1),
(1,303,1),
(1,304,1),
(1,305,1),
(1,306,3),
(1,307,3),
(1,308,4),
(1,309,4),
(1,310,6),
(1,311,6),
(1,312,4),
(10,290,1),
(10,289,1),
(10,288,1),
(10,287,1),
(10,286,1),
(10,263,1),
(10,261,1),
(10,260,1),
(10,257,1),
(10,256,1),
(10,254,1),
(10,273,2),
(10,272,5),
(10,1047,2),
(10,1046,2),
(10,1045,2),
(10,1044,2),
(10,1043,2),
(10,777,2),
(10,775,2),
(10,774,2),
(10,773,2),
(10,772,2),
(10,771,2),
(10,259,3),
(10,299,4),
(10,770,2),
(10,769,2),
(10,768,2),
(10,762,2),
(10,992,1),
(10,991,1),
(10,990,1),
(10,989,1),
(10,988,1),
(10,987,1),
(10,776,3),
(10,986,1),
(10,985,1),
(10,984,1),
(10,983,1),
(10,277,1),
(10,390,1),
(10,982,1),
(10,677,1),
(10,676,1),
(10,675,1),
(10,674,1),
(10,673,1),
(10,389,10),
(10,672,1),
(10,671,1),
(10,492,8),
(10,670,1),
(10,669,1),
(10,668,1),
(10,298,1),
(10,667,1),
(10,497,1),
(10,401,3),
(10,666,3),
(10,504,1),
(10,660,1),
(10,274,1),
(10,659,1),
(10,255,4),
(10,658,1),
(10,265,4),
(10,657,1),
(10,656,1),
(10,655,1),
(10,292,1),
(10,258,2),
(10,540,1),
(10,282,3),
(10,539,1),
(10,538,1),
(10,391,2),
(10,305,1),
(10,304,1),
(10,262,12),
(10,303,1),
(10,302,1),
(10,301,1),
(10,295,1),
(10,300,1),
(10,283,2),
(10,266,9),
(10,1042,6),
(10,1041,6),
(10,1010,6),
(10,1009,6),
(10,243,3),
(10,218,1),
(10,227,1),
(10,226,1),
(10,225,1),
(10,224,1),
(10,223,1),
(10,200,1),
(10,198,1),
(10,197,1),
(10,194,1),
(10,193,1),
(10,191,1),
(10,210,2),
(10,209,2),
(10,1040,2),
(10,1039,2),
(10,1038,2),
(10,1037,2),
(10,1036,2),
(10,757,2),
(10,755,2),
(10,754,2),
(10,753,2),
(10,752,2),
(10,751,2),
(10,196,3),
(10,236,4),
(10,750,2),
(10,749,2),
(10,748,2),
(10,742,2),
(10,971,1),
(10,970,1),
(10,969,1),
(10,968,1),
(10,967,1),
(10,966,1),
(10,756,3),
(10,965,1),
(10,964,1),
(10,963,1),
(10,962,1),
(10,214,1),
(10,372,1),
(10,961,1),
(10,650,1),
(10,649,1),
(10,648,1),
(10,647,1),
(10,646,1),
(10,371,10),
(10,645,1),
(10,644,1),
(10,471,8),
(10,643,1),
(10,642,1),
(10,641,1),
(10,235,1),
(10,640,1),
(10,476,1),
(10,383,3),
(10,639,3),
(10,483,1),
(10,633,1),
(10,211,1),
(10,632,1),
(10,192,4),
(10,631,1),
(10,202,4),
(10,630,1),
(10,629,1),
(10,628,1),
(10,229,1),
(10,195,2),
(10,533,1),
(10,219,3),
(10,532,1),
(10,531,1),
(10,373,2),
(10,242,1),
(10,241,1),
(10,199,12),
(10,240,1),
(10,239,1),
(10,238,1),
(10,232,1),
(10,237,1),
(10,220,2),
(10,203,9),
(10,1035,6),
(10,1034,6),
(10,1006,6),
(10,1005,6),
(10,180,3),
(10,155,1),
(10,164,1),
(10,163,1),
(10,162,1),
(10,161,1),
(10,160,1),
(10,137,1),
(10,135,1),
(10,134,1),
(10,131,1),
(10,130,1),
(10,128,1),
(10,147,2),
(10,146,2),
(10,1033,2),
(10,1032,2),
(10,1031,2),
(10,1030,2),
(10,1029,2),
(10,737,2),
(10,735,2),
(10,734,2),
(10,733,2),
(10,732,2),
(10,731,2),
(10,133,3),
(10,173,4),
(10,730,2),
(10,729,2),
(10,728,2),
(10,722,2),
(10,950,1),
(10,949,1),
(10,948,1),
(10,947,1),
(10,946,1),
(10,945,1),
(10,736,3),
(10,944,1),
(10,943,1),
(10,942,1),
(10,941,1),
(10,151,1),
(10,354,1),
(10,940,1),
(10,623,1),
(10,622,1),
(10,621,1),
(10,620,1),
(10,619,1),
(10,353,10),
(10,618,1),
(10,617,1),
(10,450,8),
(10,616,1),
(10,615,1),
(10,614,1),
(10,172,1),
(10,613,1),
(10,455,1),
(10,365,3),
(10,612,3),
(10,462,1),
(10,606,1),
(10,148,1),
(10,605,1),
(10,129,4),
(10,604,1),
(10,139,4),
(10,603,1),
(10,602,1),
(10,601,1),
(10,166,1),
(10,132,2),
(10,526,1),
(10,156,3),
(10,525,1),
(10,524,1),
(10,355,2),
(10,179,1),
(10,178,1),
(10,136,12),
(10,177,1),
(10,176,1),
(10,175,1),
(10,169,1),
(10,174,1),
(10,157,2),
(10,140,9),
(10,1028,6),
(10,1027,6),
(10,1002,6),
(10,1001,6),
(10,117,3),
(10,92,1),
(10,101,1),
(10,100,1),
(10,99,1),
(10,98,1),
(10,97,1),
(10,74,1),
(10,72,1),
(10,71,1),
(10,68,1),
(10,67,1),
(10,65,1),
(10,84,2),
(10,83,2),
(10,1026,2),
(10,1025,2),
(10,1024,2),
(10,1023,2),
(10,1022,2),
(10,717,2),
(10,715,2),
(10,714,2),
(10,713,2),
(10,712,2),
(10,711,2),
(10,70,3),
(10,110,4),
(10,710,2),
(10,709,2),
(10,708,2),
(10,702,2),
(10,929,1),
(10,928,1),
(10,927,1),
(10,926,1),
(10,925,1),
(10,924,1),
(10,716,3),
(10,923,1),
(10,922,1),
(10,921,1),
(10,920,1),
(10,88,1),
(10,336,1),
(10,919,1),
(10,596,1),
(10,595,1),
(10,594,1),
(10,593,1),
(10,592,1),
(10,335,10),
(10,591,1),
(10,590,1),
(10,429,8),
(10,589,1),
(10,588,1),
(3,403,6),
(3,404,6),
(3,405,6),
(3,406,6),
(3,22,5),
(3,23,2),
(3,24,1),
(3,16,11),
(3,25,1),
(3,26,1),
(3,18,2),
(3,27,2),
(3,28,1),
(3,19,1),
(3,29,1),
(3,15,5),
(3,17,1),
(3,30,1),
(3,31,6),
(3,32,1),
(3,33,2),
(3,34,1),
(3,35,1),
(3,41,5),
(3,42,3),
(3,43,2),
(3,44,2),
(3,45,2),
(3,46,2),
(3,47,3),
(3,48,2),
(3,317,5),
(3,318,3),
(3,319,3),
(3,320,3),
(3,321,3),
(3,322,3),
(3,323,3),
(3,324,3),
(3,325,3),
(3,326,3),
(3,327,3),
(3,328,3),
(3,329,3),
(3,330,3),
(3,36,2),
(3,37,2),
(3,38,2),
(3,39,2),
(3,40,2),
(3,407,2),
(3,408,2),
(3,409,2),
(3,410,1),
(3,411,1),
(3,412,1),
(3,413,1),
(3,5,1),
(3,12,1),
(3,414,1),
(3,6,2),
(3,415,1),
(3,416,1),
(3,417,1),
(3,418,1),
(3,49,3),
(3,419,1),
(3,420,1),
(3,421,1),
(3,422,1),
(3,50,1),
(3,51,1),
(3,52,1),
(3,53,1),
(3,54,1),
(3,55,3),
(3,56,4),
(3,57,4),
(3,58,6),
(3,59,6),
(3,60,4),
(3,423,2),
(3,424,6),
(3,425,6),
(3,426,6),
(3,427,6),
(3,83,2),
(3,84,2),
(3,85,1),
(3,77,11),
(3,86,1),
(3,73,9),
(3,87,1),
(3,79,2),
(3,88,2),
(3,89,1),
(3,80,1),
(3,90,1),
(3,76,5),
(3,78,1),
(3,91,1),
(3,92,6),
(3,93,1),
(3,94,2),
(3,95,1),
(3,96,1),
(3,102,5),
(3,103,3),
(3,104,2),
(3,105,2),
(3,106,6),
(3,107,2),
(3,108,2),
(3,109,3),
(3,110,2),
(3,335,5),
(3,336,3),
(3,337,3),
(3,338,3),
(3,339,3),
(3,340,3),
(3,341,3),
(3,342,3),
(3,343,3),
(3,344,3),
(3,345,3),
(3,346,3),
(3,347,3),
(3,348,3),
(3,97,2),
(3,98,2),
(3,99,2),
(3,100,2),
(3,101,2),
(3,428,2),
(3,429,2),
(3,430,2),
(3,431,1),
(3,432,1),
(3,433,1),
(3,434,1),
(3,65,1),
(3,72,1),
(3,435,1),
(3,66,2),
(3,436,1),
(3,437,1),
(3,438,1),
(3,439,1),
(3,111,3),
(3,440,1),
(3,441,1),
(3,442,1),
(3,443,1),
(3,112,1),
(3,113,1),
(3,114,1),
(3,115,1),
(3,116,1),
(3,117,3),
(3,118,3),
(3,119,4),
(3,120,4),
(3,121,6),
(3,122,6),
(3,123,4),
(3,444,2),
(3,445,6),
(3,446,6),
(3,447,6),
(3,448,6),
(3,146,2),
(3,147,2),
(3,148,1),
(3,140,11),
(3,149,1),
(3,136,9),
(3,150,1),
(3,142,2),
(3,151,2),
(3,152,1),
(3,143,1),
(3,153,1),
(3,139,5),
(3,141,1),
(3,154,1),
(3,155,6),
(3,156,1),
(3,157,2),
(3,158,1),
(3,159,1),
(3,165,5),
(3,166,3),
(3,167,2),
(3,168,2),
(3,169,6),
(3,170,2),
(3,171,2),
(3,172,3),
(3,173,2),
(3,353,5),
(3,354,3),
(3,355,3),
(3,356,3),
(3,357,3),
(3,358,3),
(3,359,3),
(3,360,3),
(3,361,3),
(3,362,3),
(3,363,3),
(3,364,3),
(3,365,3),
(3,366,3),
(3,160,2),
(3,161,2),
(3,162,2),
(3,163,2),
(3,164,2),
(3,449,2),
(3,450,2),
(3,451,2),
(3,452,1),
(3,453,1),
(3,454,1),
(3,455,1),
(3,128,1),
(3,135,1),
(3,456,1),
(3,129,2),
(3,457,1),
(3,458,1),
(3,459,1),
(3,460,1),
(3,174,3),
(3,461,1),
(3,462,1),
(3,463,1),
(3,464,1),
(3,175,1),
(3,176,1),
(3,177,1),
(3,178,1),
(3,179,1),
(3,180,3),
(3,181,3),
(3,182,4),
(3,183,4),
(3,184,6),
(3,185,6),
(3,186,4),
(3,465,2),
(3,466,6),
(3,467,6),
(3,468,6),
(3,469,6),
(3,209,2),
(3,210,2),
(3,211,1),
(3,203,11),
(3,212,1),
(3,199,9),
(3,213,1),
(3,205,2),
(3,214,2),
(3,215,1),
(3,206,1),
(3,216,1),
(3,202,5),
(3,204,1),
(3,217,1),
(3,218,6),
(3,219,1),
(3,220,2),
(3,221,1),
(3,222,1),
(3,228,5),
(3,229,3),
(3,230,2),
(3,231,2),
(3,232,6),
(3,233,2),
(3,234,2),
(3,235,3),
(3,236,2),
(3,371,5),
(3,372,3),
(3,373,3),
(3,374,3),
(3,375,3),
(3,376,3),
(3,377,3),
(3,378,3),
(3,379,3),
(3,380,3),
(3,381,3),
(3,382,3),
(3,383,3),
(3,384,3),
(3,223,2),
(3,224,2),
(3,225,2),
(3,226,2),
(3,227,2),
(3,470,2),
(3,471,2),
(3,472,2),
(3,473,1),
(3,474,1),
(3,475,1),
(3,476,1),
(3,191,1),
(3,198,1),
(3,477,1),
(3,192,2),
(3,478,1),
(3,479,1),
(3,480,1),
(3,481,1),
(3,237,3),
(3,482,1),
(3,483,1),
(3,484,1),
(3,485,1),
(3,238,1),
(3,239,1),
(3,240,1),
(3,241,1),
(3,242,1),
(3,243,3),
(3,244,3),
(3,245,4),
(3,246,4),
(3,247,6),
(3,248,6),
(3,249,4),
(3,486,2),
(3,487,6),
(3,488,6),
(3,489,6),
(3,490,6),
(3,272,5),
(3,273,2),
(3,274,1),
(3,266,11),
(3,275,1),
(3,262,9),
(3,276,1),
(3,268,2),
(3,277,2),
(3,278,1),
(3,269,1),
(3,279,1),
(3,265,5),
(3,267,1),
(3,280,1),
(3,281,6),
(3,282,1),
(3,283,2),
(3,284,1),
(3,285,1),
(3,291,5),
(3,292,3),
(3,293,2),
(3,294,2),
(3,295,6),
(3,296,2),
(3,297,2),
(3,298,3),
(3,299,2),
(3,389,5),
(3,390,3),
(3,391,3),
(3,392,3),
(3,393,3),
(3,394,3),
(3,395,3),
(3,396,3),
(3,397,3),
(3,398,3),
(3,399,3),
(3,400,3),
(3,401,3),
(3,402,3),
(3,286,2),
(3,287,2),
(3,288,2),
(3,289,2),
(3,290,2),
(3,491,2),
(3,492,2),
(3,493,2),
(3,494,1),
(3,495,1),
(3,496,1),
(3,497,1),
(3,254,1),
(3,261,1),
(3,498,1),
(3,255,2),
(3,499,1),
(3,500,1),
(3,501,1),
(3,502,1),
(3,300,3),
(3,503,1),
(3,504,1),
(3,505,1),
(3,506,1),
(3,301,1),
(3,302,1),
(3,303,1),
(3,304,1),
(3,305,1),
(3,306,3),
(3,307,3),
(3,308,4),
(3,309,4),
(3,310,6),
(3,311,6),
(3,312,4),
(3,507,2),
(4,508,6),
(4,509,6),
(4,315,6),
(4,316,6),
(4,19,1),
(4,29,1),
(4,15,4),
(4,16,9),
(4,17,1),
(4,18,1),
(4,30,1),
(4,31,4),
(4,32,2),
(4,33,3),
(4,34,1),
(4,35,1),
(4,41,2),
(4,42,3),
(4,43,1),
(4,44,1),
(4,45,1),
(4,46,1),
(4,47,3),
(4,48,1),
(4,317,5),
(4,318,1),
(4,319,2),
(4,320,1),
(4,321,1),
(4,322,1),
(4,323,1),
(4,324,1),
(4,325,1),
(4,326,1),
(4,327,1),
(4,328,1),
(4,329,1),
(4,330,1),
(4,36,2),
(4,37,2),
(4,38,2),
(4,39,2),
(4,40,2),
(4,414,2),
(4,6,4),
(4,415,2),
(4,416,2),
(4,417,2),
(4,418,2),
(4,49,6),
(4,419,2),
(4,420,2),
(4,421,2),
(4,422,2),
(4,407,4),
(4,408,4),
(4,409,4),
(4,410,2),
(4,27,2),
(4,411,2),
(4,412,2),
(4,22,5),
(4,23,2),
(4,413,2),
(4,5,2),
(4,12,2),
(4,50,2),
(4,51,2),
(4,52,2),
(4,53,2),
(4,54,2),
(4,510,1),
(4,511,1),
(4,512,1),
(4,513,3),
(4,514,3),
(4,56,4),
(4,57,4),
(4,58,6),
(4,59,6),
(4,60,4),
(4,515,6),
(4,516,6),
(4,333,6),
(4,334,6),
(4,80,1),
(4,90,1),
(4,76,4),
(4,77,9),
(4,78,1),
(4,79,1),
(4,91,1),
(4,92,4),
(4,93,2),
(4,94,3),
(4,95,1),
(4,96,1),
(4,102,2),
(4,103,3),
(4,104,1),
(4,105,1),
(4,106,4),
(4,107,1),
(4,108,1),
(4,109,3),
(4,110,1),
(4,335,5),
(4,336,1),
(4,337,2),
(4,338,1),
(4,339,1),
(4,340,1),
(4,341,1),
(4,342,1),
(4,73,9),
(4,343,1),
(4,344,1),
(4,345,1),
(4,346,1),
(4,347,1),
(4,348,1),
(4,97,2),
(4,98,2),
(4,99,2),
(4,100,2),
(4,101,2),
(4,435,2),
(4,66,4),
(4,436,2),
(4,437,2),
(4,438,2),
(4,439,2),
(4,111,6),
(4,440,2),
(4,441,2),
(4,442,2),
(4,443,2),
(4,428,4),
(4,429,4),
(4,430,4),
(4,431,2),
(4,88,2),
(4,432,2),
(4,433,2),
(4,83,2),
(4,84,2),
(4,434,2),
(4,65,2),
(4,72,2),
(4,112,2),
(4,113,2),
(4,114,2),
(4,115,2),
(4,116,2),
(4,517,1),
(4,518,1),
(4,519,1),
(4,117,3),
(4,520,3),
(4,521,3),
(4,119,4),
(4,120,4),
(4,121,6),
(4,122,6),
(4,123,4),
(4,522,6),
(4,523,6),
(4,351,6),
(4,352,6),
(4,143,1),
(4,153,1),
(4,139,4),
(4,140,9),
(4,141,1),
(4,142,1),
(4,154,1),
(4,155,4),
(4,156,2),
(4,157,3),
(4,158,1),
(4,159,1),
(4,165,2),
(4,166,3),
(4,167,1),
(4,168,1),
(4,169,4),
(4,170,1),
(4,171,1),
(4,172,3),
(4,173,1),
(4,353,5),
(4,354,1),
(4,355,2),
(4,356,1),
(4,357,1),
(4,358,1),
(4,359,1),
(4,360,1),
(4,136,9),
(4,361,1),
(4,362,1),
(4,363,1),
(4,364,1),
(4,365,1),
(4,366,1),
(4,160,2),
(4,161,2),
(4,162,2),
(4,163,2),
(4,164,2),
(4,456,2),
(4,129,4),
(4,457,2),
(4,458,2),
(4,459,2),
(4,460,2),
(4,174,6),
(4,461,2),
(4,462,2),
(4,463,2),
(4,464,2),
(4,449,4),
(4,450,4),
(4,451,4),
(4,452,2),
(4,151,2),
(4,453,2),
(4,454,2),
(4,146,2),
(4,147,2),
(4,455,2),
(4,128,2),
(4,135,2),
(4,175,2),
(4,176,2),
(4,177,2),
(4,178,2),
(4,179,2),
(4,524,1),
(4,525,1),
(4,526,1),
(4,180,3),
(4,527,3),
(4,528,3),
(4,182,4),
(4,183,4),
(4,184,6),
(4,185,6),
(4,186,4),
(4,529,6),
(4,530,6),
(4,369,6),
(4,370,6),
(4,206,1),
(4,216,1),
(4,202,4),
(4,203,9),
(4,204,1),
(4,205,1),
(4,217,1),
(4,218,4),
(4,219,2),
(4,220,3),
(4,221,1),
(4,222,1),
(4,228,2),
(4,229,3),
(4,230,1),
(4,231,1),
(4,232,4),
(4,233,1),
(4,234,1),
(4,235,3),
(4,236,1),
(4,371,5),
(4,372,1),
(4,373,2),
(4,374,1),
(4,375,1),
(4,376,1),
(4,377,1),
(4,378,1),
(4,199,9),
(4,379,1),
(4,380,1),
(4,381,1),
(4,382,1),
(4,383,1),
(4,384,1),
(4,223,2),
(4,224,2),
(4,225,2),
(4,226,2),
(4,227,2),
(4,477,2),
(4,192,4),
(4,478,2),
(4,479,2),
(4,480,2),
(4,481,2),
(4,237,6),
(4,482,2),
(4,483,2),
(4,484,2),
(4,485,2),
(4,470,4),
(4,471,4),
(4,472,4),
(4,473,2),
(4,214,2),
(4,474,2),
(4,475,2),
(4,209,2),
(4,210,2),
(4,476,2),
(4,191,2),
(4,198,2),
(4,238,2),
(4,239,2),
(4,240,2),
(4,241,2),
(4,242,2),
(4,531,1),
(4,532,1),
(4,533,1),
(4,243,3),
(4,534,3),
(4,535,3),
(4,245,4),
(4,246,4),
(4,247,6),
(4,248,6),
(4,249,4),
(4,536,6),
(4,537,6),
(4,387,6),
(4,388,6),
(4,269,1),
(4,279,1),
(4,265,4),
(4,266,9),
(4,267,1),
(4,268,1),
(4,280,1),
(4,281,4),
(4,282,2),
(4,283,3),
(4,284,1),
(4,285,1),
(4,291,2),
(4,292,3),
(4,293,1),
(4,294,1),
(4,295,4),
(4,296,1),
(4,297,1),
(4,298,3),
(4,299,1),
(4,389,5),
(4,390,1),
(4,391,2),
(4,392,1),
(4,393,1),
(4,394,1),
(4,395,1),
(4,396,1),
(4,262,9),
(4,397,1),
(4,398,1),
(4,399,1),
(4,400,1),
(4,401,1),
(4,402,1),
(4,286,2),
(4,287,2),
(4,288,2),
(4,289,2),
(4,290,2),
(4,498,2),
(4,255,4),
(4,499,2),
(4,500,2),
(4,501,2),
(4,502,2),
(4,300,6),
(4,503,2),
(4,504,2),
(4,505,2),
(4,506,2),
(4,491,4),
(4,492,4),
(4,493,4),
(4,494,2),
(4,277,2),
(4,495,2),
(4,496,2),
(4,272,5),
(4,273,2),
(4,497,2),
(4,254,2),
(4,261,2),
(4,301,2),
(4,302,2),
(4,303,2),
(4,304,2),
(4,305,2),
(4,538,1),
(4,539,1),
(4,540,1),
(4,306,3),
(4,541,3),
(4,542,3),
(4,308,4),
(4,309,4),
(4,310,6),
(4,311,6),
(4,312,4),
(5,543,6),
(5,544,6),
(5,545,6),
(5,546,6),
(5,41,2),
(5,16,7),
(5,42,3),
(5,43,1),
(5,44,1),
(5,45,1),
(5,46,1),
(5,47,2),
(5,48,1),
(5,317,7),
(5,318,1),
(5,319,4),
(5,320,1),
(5,321,1),
(5,322,1),
(5,323,1),
(5,324,1),
(5,325,1),
(5,326,1),
(5,327,1),
(5,15,4),
(5,328,1),
(5,329,2),
(5,31,2),
(5,330,1),
(5,36,1),
(5,37,1),
(5,38,1),
(5,39,1),
(5,40,1),
(5,407,4),
(5,408,5),
(5,409,4),
(5,410,2),
(5,27,2),
(5,411,2),
(5,412,2),
(5,22,5),
(5,23,2),
(5,413,3),
(5,5,2),
(5,12,2),
(5,33,2),
(5,49,3),
(5,50,2),
(5,51,2),
(5,52,2),
(5,53,2),
(5,54,2),
(5,510,2),
(5,511,2),
(5,32,2),
(5,512,2),
(5,9,2),
(5,547,2),
(5,548,2),
(5,549,2),
(5,550,2),
(5,6,2),
(5,551,2),
(5,24,2),
(5,552,2),
(5,553,1),
(5,554,1),
(5,555,1),
(5,556,1),
(5,557,1),
(5,420,1),
(5,558,1),
(5,559,1),
(5,560,1),
(5,561,1),
(5,562,1),
(5,563,1),
(5,564,1),
(5,565,1),
(5,566,1),
(5,567,1),
(5,568,1),
(5,569,1),
(5,56,4),
(5,57,4),
(5,58,6),
(5,59,6),
(5,60,4),
(5,570,6),
(5,571,6),
(5,572,6),
(5,573,6),
(5,102,2),
(5,77,7),
(5,103,3),
(5,104,1),
(5,105,1),
(5,106,4),
(5,107,1),
(5,108,1),
(5,109,2),
(5,110,1),
(5,335,7),
(5,336,1),
(5,337,4),
(5,338,1),
(5,339,1),
(5,340,1),
(5,341,1),
(5,342,1),
(5,73,8),
(5,343,1),
(5,344,1),
(5,345,1),
(5,76,4),
(5,346,1),
(5,347,2),
(5,92,2),
(5,348,1),
(5,97,1),
(5,98,1),
(5,99,1),
(5,100,1),
(5,101,1),
(5,428,4),
(5,429,5),
(5,430,4),
(5,431,2),
(5,88,2),
(5,432,2),
(5,433,2),
(5,83,2),
(5,84,2),
(5,434,3),
(5,65,2),
(5,72,2),
(5,94,2),
(5,111,3),
(5,112,2),
(5,113,2),
(5,114,2),
(5,115,2),
(5,116,2),
(5,517,2),
(5,518,2),
(5,93,2),
(5,519,2),
(5,69,2),
(5,574,2),
(5,575,2),
(5,576,2),
(5,577,2),
(5,66,2),
(5,578,2),
(5,85,2),
(5,579,2),
(5,580,1),
(5,581,1),
(5,582,1),
(5,583,1),
(5,584,1),
(5,441,1),
(5,585,1),
(5,586,1),
(5,587,1),
(5,588,1),
(5,589,1),
(5,590,1),
(5,591,1),
(5,592,1),
(5,593,1),
(5,594,1),
(5,595,1),
(5,596,1),
(5,117,3),
(5,119,4),
(5,120,4),
(5,121,6),
(5,122,6),
(5,123,4),
(5,597,6),
(5,598,6),
(5,599,6),
(5,600,6),
(5,165,2),
(5,140,7),
(5,166,3),
(5,167,1),
(5,168,1),
(5,169,4),
(5,170,1),
(5,171,1),
(5,172,2),
(5,173,1),
(5,353,7),
(5,354,1),
(5,355,4),
(5,356,1),
(5,357,1),
(5,358,1),
(5,359,1),
(5,360,1),
(5,136,8),
(5,361,1),
(5,362,1),
(5,363,1),
(5,139,4),
(5,364,1),
(5,365,2),
(5,155,2),
(5,366,1),
(5,160,1),
(5,161,1),
(5,162,1),
(5,163,1),
(5,164,1),
(5,449,4),
(5,450,5),
(5,451,4),
(5,452,2),
(5,151,2),
(5,453,2),
(5,454,2),
(5,146,2),
(5,147,2),
(5,455,3),
(5,128,2),
(5,135,2),
(5,157,2),
(5,174,3),
(5,175,2),
(5,176,2),
(5,177,2),
(5,178,2),
(5,179,2),
(5,524,2),
(5,525,2),
(5,156,2),
(5,526,2),
(5,132,2),
(5,601,2),
(5,602,2),
(5,603,2),
(5,604,2),
(5,129,2),
(5,605,2),
(5,148,2),
(5,606,2),
(5,607,1),
(5,608,1),
(5,609,1),
(5,610,1),
(5,611,1),
(5,462,1),
(5,612,1),
(5,613,1),
(5,614,1),
(5,615,1),
(5,616,1),
(5,617,1),
(5,618,1),
(5,619,1),
(5,620,1),
(5,621,1),
(5,622,1),
(5,623,1),
(5,180,3),
(5,182,4),
(5,183,4),
(5,184,6),
(5,185,6),
(5,186,4),
(5,624,6),
(5,625,6),
(5,626,6),
(5,627,6),
(5,228,2),
(5,203,7),
(5,229,3),
(5,230,1),
(5,231,1),
(5,232,4),
(5,233,1),
(5,234,1),
(5,235,2),
(5,236,1),
(5,371,7),
(5,372,1),
(5,373,4),
(5,374,1),
(5,375,1),
(5,376,1),
(5,377,1),
(5,378,1),
(5,199,8),
(5,379,1),
(5,380,1),
(5,381,1),
(5,202,4),
(5,382,1),
(5,383,2),
(5,218,2),
(5,384,1),
(5,223,1),
(5,224,1),
(5,225,1),
(5,226,1),
(5,227,1),
(5,470,4),
(5,471,5),
(5,472,4),
(5,473,2),
(5,214,2),
(5,474,2),
(5,475,2),
(5,209,2),
(5,210,2),
(5,476,3),
(5,191,2),
(5,198,2),
(5,220,2),
(5,237,3),
(5,238,2),
(5,239,2),
(5,240,2),
(5,241,2),
(5,242,2),
(5,531,2),
(5,532,2),
(5,219,2),
(5,533,2),
(5,195,2),
(5,628,2),
(5,629,2),
(5,630,2),
(5,631,2),
(5,192,2),
(5,632,2),
(5,211,2),
(5,633,2),
(5,634,1),
(5,635,1),
(5,636,1),
(5,637,1),
(5,638,1),
(5,483,1),
(5,639,1),
(5,640,1),
(5,641,1),
(5,642,1),
(5,643,1),
(5,644,1),
(5,645,1),
(5,646,1),
(5,647,1),
(5,648,1),
(5,649,1),
(5,650,1),
(5,243,3),
(5,245,4),
(5,246,4),
(5,247,6),
(5,248,6),
(5,249,4),
(5,651,6),
(5,652,6),
(5,653,6),
(5,654,6),
(5,291,2),
(5,266,7),
(5,292,3),
(5,293,1),
(5,294,1),
(5,295,4),
(5,296,1),
(5,297,1),
(5,298,2),
(5,299,1),
(5,389,7),
(5,390,1),
(5,391,4),
(5,392,1),
(5,393,1),
(5,394,1),
(5,395,1),
(5,396,1),
(5,262,8),
(5,397,1),
(5,398,1),
(5,399,1),
(5,265,4),
(5,400,1),
(5,401,2),
(5,281,2),
(5,402,1),
(5,286,1),
(5,287,1),
(5,288,1),
(5,289,1),
(5,290,1),
(5,491,4),
(5,492,5),
(5,493,4),
(5,494,2),
(5,277,2),
(5,495,2),
(5,496,2),
(5,272,5),
(5,273,2),
(5,497,3),
(5,254,2),
(5,261,2),
(5,283,2),
(5,300,3),
(5,301,2),
(5,302,2),
(5,303,2),
(5,304,2),
(5,305,2),
(5,538,2),
(5,539,2),
(5,282,2),
(5,540,2),
(5,258,2),
(5,655,2),
(5,656,2),
(5,657,2),
(5,658,2),
(5,255,2),
(5,659,2),
(5,274,2),
(5,660,2),
(5,661,1),
(5,662,1),
(5,663,1),
(5,664,1),
(5,665,1),
(5,504,1),
(5,666,1),
(5,667,1),
(5,668,1),
(5,669,1),
(5,670,1),
(5,671,1),
(5,672,1),
(5,673,1),
(5,674,1),
(5,675,1),
(5,676,1),
(5,677,1),
(5,306,3),
(5,308,4),
(5,309,4),
(5,310,6),
(5,311,6),
(5,312,4),
(28,766,1),
(28,765,1),
(28,764,1),
(28,763,1),
(28,762,2),
(28,677,2),
(28,676,2),
(28,675,2),
(28,674,2),
(28,673,2),
(28,672,2),
(28,671,2),
(28,670,2),
(28,669,2),
(28,668,2),
(28,667,2),
(28,401,2),
(28,666,4),
(28,660,2),
(28,274,2),
(28,659,2),
(28,658,2),
(28,657,2),
(28,656,2),
(28,655,2),
(28,258,2),
(28,540,1),
(28,282,3),
(28,539,1),
(28,538,1),
(28,391,3),
(28,305,1),
(28,304,1),
(28,303,1),
(28,302,1),
(28,301,1),
(28,295,1),
(28,283,1),
(28,261,1),
(28,254,1),
(28,497,3),
(28,273,1),
(28,272,4),
(28,496,1),
(28,495,1),
(28,277,1),
(28,494,1),
(28,493,2),
(28,492,6),
(28,389,8),
(28,491,2),
(28,506,1),
(28,505,1),
(28,298,3),
(28,504,3),
(28,503,1),
(28,300,3),
(28,502,1),
(28,292,3),
(28,501,1),
(28,500,1),
(28,499,1),
(28,255,4),
(28,265,5),
(28,498,1),
(28,281,1),
(28,290,1),
(28,262,11),
(28,289,1),
(28,288,1),
(28,287,1),
(28,266,6),
(28,286,1),
(28,1292,6),
(28,1291,6),
(28,1234,6),
(28,1290,6),
(28,1289,6),
(28,243,3),
(28,757,1),
(28,756,1),
(28,755,1),
(28,754,1),
(28,753,1),
(28,752,1),
(28,751,1),
(28,196,1),
(28,236,1),
(28,750,1),
(28,749,1),
(28,748,1),
(28,747,1),
(28,746,1),
(28,745,1),
(28,744,1),
(28,743,1),
(28,742,2),
(28,650,2),
(28,649,2),
(28,648,2),
(28,647,2),
(28,646,2),
(28,645,2),
(28,644,2),
(28,643,2),
(28,642,2),
(28,641,2),
(28,640,2),
(28,383,2),
(28,639,4),
(28,633,2),
(28,211,2),
(28,632,2),
(28,631,2),
(28,630,2),
(28,629,2),
(28,628,2),
(28,195,2),
(28,533,1),
(28,219,3),
(28,532,1),
(28,531,1),
(28,373,3),
(28,242,1),
(28,241,1),
(28,240,1),
(28,239,1),
(28,238,1),
(28,232,1),
(28,220,1),
(28,198,1),
(28,191,1),
(28,476,3),
(28,210,1),
(28,209,1),
(28,475,1),
(28,474,1),
(28,214,1),
(28,473,1),
(28,472,2),
(28,471,6),
(28,371,8),
(28,470,2),
(28,485,1),
(28,484,1),
(28,235,3),
(28,483,3),
(28,482,1),
(28,237,3),
(28,481,1),
(28,229,3),
(28,480,1),
(28,479,1),
(28,478,1),
(28,192,4),
(28,202,5),
(28,477,1),
(28,218,1),
(28,227,1),
(28,199,11),
(28,226,1),
(28,225,1),
(28,224,1),
(28,203,6),
(28,223,1),
(28,1288,6),
(28,1287,6),
(28,1230,6),
(28,1286,6),
(28,1285,6),
(28,180,3),
(28,737,1),
(28,736,1),
(28,735,1),
(28,734,1),
(28,733,1),
(28,732,1),
(28,731,1),
(28,133,1),
(28,173,1),
(28,730,1),
(28,729,1),
(28,728,1),
(28,727,1),
(28,726,1),
(28,725,1),
(28,724,1),
(28,723,1),
(28,722,2),
(28,623,2),
(28,622,2),
(28,621,2),
(28,620,2),
(28,619,2),
(28,618,2),
(28,617,2),
(28,616,2),
(28,615,2),
(28,614,2),
(28,613,2),
(28,365,2),
(28,612,4),
(28,606,2),
(28,148,2),
(28,605,2),
(28,604,2),
(28,603,2),
(28,602,2),
(28,601,2),
(28,132,2),
(28,526,1),
(28,156,3),
(28,525,1),
(28,524,1),
(28,355,3),
(28,179,1),
(28,178,1),
(28,177,1),
(28,176,1),
(28,175,1),
(28,169,1),
(28,157,1),
(28,135,1),
(28,128,1),
(28,455,3),
(28,147,1),
(28,146,1),
(28,454,1),
(28,453,1),
(28,151,1),
(28,452,1),
(28,451,2),
(28,450,6),
(28,353,8),
(28,449,2),
(28,464,1),
(28,463,1),
(28,172,3),
(28,462,3),
(28,461,1),
(28,174,3),
(28,460,1),
(28,166,3),
(28,459,1),
(28,458,1),
(28,457,1),
(28,129,4),
(28,139,5),
(28,456,1),
(28,155,1),
(28,164,1),
(28,136,11),
(28,163,1),
(28,162,1),
(28,161,1),
(28,140,6),
(28,160,1),
(28,1284,6),
(28,1283,6),
(28,1226,6),
(28,1282,6),
(28,1281,6),
(28,117,3),
(28,717,1),
(28,716,1),
(28,715,1),
(28,714,1),
(28,713,1),
(28,712,1),
(28,711,1),
(28,70,1),
(28,110,1),
(28,710,1),
(28,709,1),
(28,708,1),
(28,707,1),
(28,706,1),
(28,705,1),
(28,704,1),
(28,703,1),
(28,702,2),
(28,596,2),
(28,595,2),
(28,594,2),
(28,593,2),
(28,592,2),
(28,591,2),
(28,590,2),
(28,589,2),
(28,588,2),
(28,587,2),
(28,586,2),
(28,347,2),
(28,585,4),
(28,579,2),
(28,85,2),
(28,578,2),
(28,577,2),
(28,576,2),
(28,575,2),
(28,574,2),
(28,69,2),
(28,519,1),
(28,93,3),
(28,518,1),
(28,517,1),
(28,337,3),
(28,116,1),
(28,115,1),
(28,114,1),
(28,113,1),
(28,112,1),
(28,106,1),
(28,94,1),
(28,72,1),
(28,65,1),
(28,434,3),
(28,84,1),
(28,83,1),
(28,433,1),
(28,432,1),
(28,88,1),
(28,431,1),
(28,430,2),
(28,429,6),
(28,335,8),
(28,428,2),
(28,443,1),
(28,442,1),
(28,109,3),
(28,441,3),
(28,440,1),
(28,111,3),
(28,439,1),
(28,103,3),
(28,438,1),
(28,437,1),
(28,436,1),
(28,66,4),
(28,76,5),
(28,435,1),
(28,92,1),
(28,101,1),
(28,73,11),
(28,100,1),
(28,99,1),
(28,98,1),
(28,77,6),
(28,97,1),
(28,1280,6),
(28,1279,6),
(28,1222,6),
(28,1278,6),
(28,1277,6),
(28,1319,4),
(28,1318,4),
(28,697,1),
(28,696,1),
(28,695,1),
(28,694,1),
(28,693,1),
(28,692,1),
(28,691,1),
(28,10,1),
(28,48,1),
(28,690,1),
(28,689,1),
(28,688,1),
(28,687,1),
(28,686,1),
(28,685,1),
(28,684,1),
(28,683,1),
(28,682,2),
(28,569,2),
(28,568,2),
(28,567,2),
(28,566,2),
(28,565,2),
(28,564,2),
(28,563,2),
(28,562,2),
(28,561,2),
(28,560,2),
(28,559,2),
(28,329,2),
(28,558,4),
(28,552,2),
(28,24,2),
(28,551,2),
(28,550,2),
(28,549,2),
(28,548,2),
(28,547,2),
(28,9,2),
(28,512,1),
(28,32,3),
(28,511,1),
(28,510,1),
(28,319,3),
(28,54,1),
(28,53,1),
(28,52,1),
(28,51,1),
(28,50,1),
(28,33,1),
(28,12,1),
(28,5,1),
(28,413,3),
(28,23,1),
(28,22,4),
(28,412,1),
(28,411,1),
(28,27,1),
(28,410,1),
(28,409,2),
(28,408,6),
(28,317,8),
(28,407,2),
(28,422,1),
(28,421,1),
(28,47,3),
(28,420,3),
(28,419,1),
(28,49,3),
(28,418,1),
(28,42,3),
(28,417,1),
(28,416,1),
(28,415,1),
(28,6,4),
(28,15,5),
(28,414,1),
(28,31,1),
(28,40,1),
(28,39,1),
(28,38,1),
(28,37,1),
(28,16,6),
(28,36,1),
(28,1276,6),
(28,1275,6),
(28,1218,6),
(28,1274,6),
(28,1273,6),
(26,306,3),
(26,540,1),
(26,282,1),
(26,539,1),
(26,538,1),
(26,305,2),
(26,304,2),
(26,303,2),
(26,302,2),
(26,301,2),
(26,283,2),
(26,506,2),
(26,505,2),
(26,504,2),
(26,503,2),
(26,300,6),
(26,502,2),
(26,501,2),
(26,500,2),
(26,499,2),
(26,255,4),
(26,498,2),
(26,261,3),
(26,254,3),
(26,497,3),
(26,273,3),
(26,272,6),
(26,496,3),
(26,495,3),
(26,277,3),
(26,494,3),
(26,493,6),
(26,492,6),
(26,491,6),
(26,290,2),
(26,289,2),
(26,288,2),
(26,287,2),
(26,286,2),
(26,402,1),
(26,281,3),
(26,401,1),
(26,400,1),
(26,265,3),
(26,399,1),
(26,398,1),
(26,397,1),
(26,262,10),
(26,396,1),
(26,395,1),
(26,394,1),
(26,393,1),
(26,392,1),
(26,391,2),
(26,390,1),
(26,389,7),
(26,299,1),
(26,298,3),
(26,297,1),
(26,296,1),
(26,295,4),
(26,294,1),
(26,293,1),
(26,292,3),
(26,266,8),
(26,291,2),
(26,1267,6),
(26,1266,6),
(26,654,6),
(26,653,6),
(26,1265,6),
(26,243,3),
(26,533,1),
(26,219,1),
(26,532,1),
(26,531,1),
(26,242,2),
(26,241,2),
(26,240,2),
(26,239,2),
(26,238,2),
(26,220,2),
(26,485,2),
(26,484,2),
(26,483,2),
(26,482,2),
(26,237,6),
(26,481,2),
(26,480,2),
(26,479,2),
(26,478,2),
(26,192,4),
(26,477,2),
(26,198,3),
(26,191,3),
(26,476,3),
(26,210,3),
(26,209,3),
(26,475,3),
(26,474,3),
(26,214,3),
(26,473,3),
(26,472,6),
(26,471,6),
(26,470,6),
(26,227,2),
(26,226,2),
(26,225,2),
(26,224,2),
(26,223,2),
(26,384,1),
(26,218,3),
(26,383,1),
(26,382,1),
(26,202,3),
(26,381,1),
(26,380,1),
(26,379,1),
(26,199,10),
(26,378,1),
(26,377,1),
(26,376,1),
(26,375,1),
(26,374,1),
(26,373,2),
(26,372,1),
(26,371,7),
(26,236,1),
(26,235,3),
(26,234,1),
(26,233,1),
(26,232,4),
(26,231,1),
(26,230,1),
(26,229,3),
(26,203,8),
(26,228,2),
(26,1264,6),
(26,1263,6),
(26,627,6),
(26,626,6),
(26,1262,6),
(26,180,3),
(26,526,1),
(26,156,1),
(26,525,1),
(26,524,1),
(26,179,2),
(26,178,2),
(26,177,2),
(26,176,2),
(26,175,2),
(26,157,2),
(26,464,2),
(26,463,2),
(26,462,2),
(26,461,2),
(26,174,6),
(26,460,2),
(26,459,2),
(26,458,2),
(26,457,2),
(26,129,4),
(26,456,2),
(26,135,3),
(26,128,3),
(26,455,3),
(26,147,3),
(26,146,3),
(26,454,3),
(26,453,3),
(26,151,3),
(26,452,3),
(26,451,6),
(26,450,6),
(26,449,6),
(26,164,2),
(26,163,2),
(26,162,2),
(26,161,2),
(26,160,2),
(26,366,1),
(26,155,3),
(26,365,1),
(26,364,1),
(26,139,3),
(26,363,1),
(26,362,1),
(26,361,1),
(26,136,10),
(26,360,1),
(26,359,1),
(26,358,1),
(26,357,1),
(26,356,1),
(26,355,2),
(26,354,1),
(26,353,7),
(26,173,1),
(26,172,3),
(26,171,1),
(26,170,1),
(26,169,4),
(26,168,1),
(26,167,1),
(26,166,3),
(26,140,8),
(26,165,2),
(26,1261,6),
(26,1260,6),
(26,600,6),
(26,599,6),
(26,1259,6),
(26,117,3),
(26,519,1),
(26,93,1),
(26,518,1),
(26,517,1),
(26,116,2),
(26,115,2),
(26,114,2),
(26,113,2),
(26,112,2),
(26,94,2),
(26,443,2),
(26,442,2),
(26,441,2),
(26,440,2),
(26,111,6),
(26,439,2),
(26,438,2),
(26,437,2),
(26,436,2),
(26,66,4),
(26,435,2),
(26,72,3),
(26,65,3),
(26,434,3),
(26,84,3),
(26,83,3),
(26,433,3),
(26,432,3),
(26,88,3),
(26,431,3),
(26,430,6),
(26,429,6),
(26,428,6),
(26,101,2),
(26,100,2),
(26,99,2),
(26,98,2),
(26,97,2),
(26,348,1),
(26,92,3),
(26,347,1),
(26,346,1),
(26,76,3),
(26,345,1),
(26,344,1),
(26,343,1),
(26,73,10),
(26,342,1),
(26,341,1),
(26,340,1),
(26,339,1),
(26,338,1),
(26,337,2),
(26,336,1),
(26,335,7),
(26,110,1),
(26,109,3),
(26,108,1),
(26,107,1),
(26,106,4),
(26,105,1),
(26,104,1),
(26,103,3),
(26,77,8),
(26,102,2),
(26,1258,6),
(26,1257,6),
(26,573,6),
(26,572,6),
(26,1256,6),
(26,1319,4),
(26,1318,4),
(26,512,1),
(26,32,1),
(26,511,1),
(26,510,1),
(26,54,2),
(26,53,2),
(26,52,2),
(26,51,2),
(26,50,2),
(26,33,2),
(26,422,2),
(26,421,2),
(26,420,2),
(26,419,2),
(26,49,6),
(26,418,2),
(26,417,2),
(26,416,2),
(26,415,2),
(26,6,4),
(26,414,2),
(26,12,3),
(26,5,3),
(26,413,3),
(26,23,3),
(26,22,6),
(26,412,3),
(26,411,3),
(26,27,3),
(26,410,3),
(26,409,6),
(26,408,6),
(26,407,6),
(26,40,2),
(26,39,2),
(26,38,2),
(26,37,2),
(26,36,2),
(26,330,1),
(26,31,3),
(26,329,1),
(26,328,1),
(26,15,3),
(26,327,1),
(26,326,1),
(26,325,1),
(26,324,1),
(26,323,1),
(26,322,1),
(26,321,1),
(26,320,1),
(26,319,2),
(26,318,1),
(26,317,7),
(26,48,1),
(26,47,3),
(26,46,1),
(26,45,1),
(26,44,1),
(26,43,1),
(26,42,3),
(26,16,8),
(26,41,2),
(26,1255,6),
(26,1254,6),
(26,546,6),
(26,545,6),
(26,1253,6),
(23,289,1),
(23,288,1),
(23,287,1),
(23,286,1),
(23,263,1),
(23,261,1),
(23,260,1),
(23,259,1),
(23,258,1),
(23,257,1),
(23,256,1),
(23,255,1),
(23,254,1),
(23,305,2),
(23,304,2),
(23,303,2),
(23,302,2),
(23,301,2),
(23,300,2),
(23,299,2),
(23,298,2),
(23,297,2),
(23,296,2),
(23,295,4),
(23,294,2),
(23,293,2),
(23,292,2),
(23,291,2),
(23,285,3),
(23,284,3),
(23,283,5),
(23,282,3),
(23,281,4),
(23,280,3),
(23,279,3),
(23,278,3),
(23,277,3),
(23,276,3),
(23,262,7),
(23,275,3),
(23,274,3),
(23,273,3),
(23,272,6),
(23,271,3),
(23,270,3),
(23,269,6),
(23,268,9),
(23,267,6),
(23,266,19),
(23,265,6),
(23,264,3),
(23,1237,6),
(23,1236,6),
(23,1235,6),
(23,1234,6),
(23,243,3),
(23,227,1),
(23,226,1),
(23,225,1),
(23,224,1),
(23,223,1),
(23,200,1),
(23,198,1),
(23,197,1),
(23,196,1),
(23,195,1),
(23,194,1),
(23,193,1),
(23,192,1),
(23,191,1),
(23,242,2),
(23,241,2),
(23,240,2),
(23,239,2),
(23,238,2),
(23,237,2),
(23,236,2),
(23,235,2),
(23,234,2),
(23,233,2),
(23,232,4),
(23,231,2),
(23,230,2),
(23,229,2),
(23,228,2),
(23,222,3),
(23,221,3),
(23,220,5),
(23,219,3),
(23,218,4),
(23,217,3),
(23,216,3),
(23,215,3),
(23,214,3),
(23,213,3),
(23,199,7),
(23,212,3),
(23,211,3),
(23,210,3),
(23,209,3),
(23,208,3),
(23,207,3),
(23,206,6),
(23,205,9),
(23,204,6),
(23,203,19),
(23,202,6),
(23,201,3),
(23,1233,6),
(23,1232,6),
(23,1231,6),
(23,1230,6),
(23,180,3),
(23,164,1),
(23,163,1),
(23,162,1),
(23,161,1),
(23,160,1),
(23,137,1),
(23,135,1),
(23,134,1),
(23,133,1),
(23,132,1),
(23,131,1),
(23,130,1),
(23,129,1),
(23,128,1),
(23,179,2),
(23,178,2),
(23,177,2),
(23,176,2),
(23,175,2),
(23,174,2),
(23,173,2),
(23,172,2),
(23,171,2),
(23,170,2),
(23,169,4),
(23,168,2),
(23,167,2),
(23,166,2),
(23,165,2),
(23,159,3),
(23,158,3),
(23,157,5),
(23,156,3),
(23,155,4),
(23,154,3),
(23,153,3),
(23,152,3),
(23,151,3),
(23,150,3),
(23,136,7),
(23,149,3),
(23,148,3),
(23,147,3),
(23,146,3),
(23,145,3),
(23,144,3),
(23,143,6),
(23,142,9),
(23,141,6),
(8,888,6),
(8,889,6),
(8,890,6),
(8,891,6),
(8,892,6),
(8,893,6),
(8,894,6),
(8,895,6),
(8,896,6),
(8,897,6),
(8,414,1),
(8,15,1),
(8,6,3),
(8,415,1),
(8,416,1),
(8,417,1),
(8,42,3),
(8,418,1),
(8,49,4),
(8,419,1),
(8,420,1),
(8,16,7),
(8,47,1),
(8,421,1),
(8,422,1),
(8,407,2),
(8,317,4),
(8,408,3),
(8,409,4),
(8,410,1),
(8,27,2),
(8,411,1),
(8,412,1),
(8,22,4),
(8,23,2),
(8,413,1),
(8,5,1),
(8,12,1),
(8,33,2),
(8,50,1),
(8,51,1),
(8,52,1),
(8,53,1),
(8,54,1),
(8,319,1),
(8,510,1),
(8,511,1),
(8,32,3),
(8,512,1),
(8,783,1),
(8,784,1),
(8,558,3),
(8,329,1),
(8,785,1),
(8,786,1),
(8,7,1),
(8,10,1),
(8,9,1),
(8,787,1),
(8,788,1),
(8,789,1),
(8,790,1),
(8,682,2),
(8,683,2),
(8,684,2),
(8,685,2),
(8,686,2),
(8,687,2),
(8,791,2),
(8,792,2),
(8,793,2),
(8,794,2),
(8,795,2),
(8,796,2),
(8,797,2),
(8,696,3),
(8,798,2),
(8,799,2),
(8,36,1),
(8,37,1),
(8,38,1),
(8,39,1),
(8,40,1),
(8,31,1),
(8,553,1),
(8,554,1),
(8,555,1),
(8,556,1),
(8,557,1),
(8,898,1),
(8,318,1),
(8,899,1),
(8,900,1),
(8,901,1),
(8,902,1),
(8,903,1),
(8,904,1),
(8,905,1),
(8,906,1),
(8,907,1),
(8,908,1),
(8,909,6),
(8,910,6),
(8,911,6),
(8,912,6),
(8,913,6),
(8,914,6),
(8,915,6),
(8,916,6),
(8,917,6),
(8,918,6),
(8,435,1),
(8,76,1),
(8,66,3),
(8,436,1),
(8,437,1),
(8,438,1),
(8,103,3),
(8,439,1),
(8,111,4),
(8,440,1),
(8,441,1),
(8,77,7),
(8,109,1),
(8,442,1),
(8,73,11),
(8,443,1),
(8,428,2),
(8,335,4),
(8,429,3),
(8,430,4),
(8,431,1),
(8,88,2),
(8,432,1),
(8,433,1),
(8,83,1),
(8,84,2),
(8,434,1),
(8,65,1),
(8,72,1),
(8,94,2),
(8,106,5),
(8,112,1),
(8,113,1),
(8,114,1),
(8,115,1),
(8,116,1),
(8,337,1),
(8,517,1),
(8,518,1),
(8,93,3),
(8,519,1),
(8,805,1),
(8,806,1),
(8,585,3),
(8,347,1),
(8,807,1),
(8,808,1),
(8,67,1),
(8,70,1),
(8,69,1),
(8,809,1),
(8,810,1),
(8,811,1),
(8,812,1),
(8,702,2),
(8,703,2),
(8,704,2),
(8,705,2),
(8,706,2),
(8,707,2),
(8,813,2),
(8,814,2),
(8,815,2),
(8,816,2),
(8,817,2),
(8,818,2),
(8,819,2),
(8,716,3),
(8,820,2),
(8,821,2),
(8,97,1),
(8,98,1),
(8,99,1),
(8,100,1),
(8,101,1),
(8,92,1),
(8,580,1),
(8,581,1),
(8,582,1),
(8,583,1),
(8,584,1),
(8,919,1),
(8,336,1),
(8,920,1),
(8,921,1),
(8,922,1),
(8,923,1),
(8,924,1),
(8,925,1),
(8,926,1),
(8,927,1),
(8,928,1),
(8,929,1),
(8,117,3),
(8,930,6),
(8,931,6),
(8,932,6),
(8,933,6),
(8,934,6),
(8,935,6),
(8,936,6),
(8,937,6),
(8,938,6),
(8,939,6),
(8,456,1),
(8,139,1),
(8,129,3),
(8,457,1),
(8,458,1),
(8,459,1),
(8,166,3),
(8,460,1),
(8,174,4),
(8,461,1),
(8,462,1),
(8,140,7),
(8,172,1),
(8,463,1),
(8,136,11),
(8,464,1),
(8,449,2),
(8,353,4),
(8,450,3),
(8,451,4),
(8,452,1),
(8,151,2),
(8,453,1),
(8,454,1),
(8,146,1),
(8,147,2),
(8,455,1),
(8,128,1),
(8,135,1),
(8,157,2),
(8,169,5),
(8,175,1),
(8,176,1),
(8,177,1),
(8,178,1),
(8,179,1),
(8,355,1),
(8,524,1),
(8,525,1),
(8,156,3),
(8,526,1),
(8,827,1),
(8,828,1),
(8,612,3),
(8,365,1),
(8,829,1),
(8,830,1),
(8,130,1),
(8,133,1),
(8,132,1),
(8,831,1),
(8,832,1),
(8,833,1),
(8,834,1),
(8,722,2),
(8,723,2),
(8,724,2),
(8,725,2),
(8,726,2),
(8,727,2),
(8,835,2),
(8,836,2),
(8,837,2),
(8,838,2),
(8,839,2),
(8,840,2),
(8,841,2),
(8,736,3),
(8,842,2),
(8,843,2),
(8,160,1),
(8,161,1),
(8,162,1),
(8,163,1),
(8,164,1),
(8,155,1),
(8,607,1),
(8,608,1),
(8,609,1),
(8,610,1),
(8,611,1),
(8,940,1),
(8,354,1),
(8,941,1),
(8,942,1),
(8,943,1),
(8,944,1),
(8,945,1),
(8,946,1),
(8,947,1),
(8,948,1),
(8,949,1),
(8,950,1),
(8,180,3),
(8,951,6),
(8,952,6),
(8,953,6),
(8,954,6),
(8,955,6),
(8,956,6),
(8,957,6),
(8,958,6),
(8,959,6),
(8,960,6),
(8,477,1),
(8,202,1),
(8,192,3),
(8,478,1),
(8,479,1),
(8,480,1),
(8,229,3),
(8,481,1),
(8,237,4),
(8,482,1),
(8,483,1),
(8,203,7),
(8,235,1),
(8,484,1),
(8,199,11),
(8,485,1),
(8,470,2),
(8,371,4),
(8,471,3),
(8,472,4),
(8,473,1),
(8,214,2),
(8,474,1),
(8,475,1),
(8,209,1),
(8,210,2),
(8,476,1),
(8,191,1),
(8,198,1),
(8,220,2),
(8,232,5),
(8,238,1),
(8,239,1),
(8,240,1),
(8,241,1),
(8,242,1),
(8,373,1),
(8,531,1),
(8,532,1),
(8,219,3),
(8,533,1),
(8,849,1),
(8,850,1),
(8,639,3),
(8,383,1),
(8,851,1),
(8,852,1),
(8,193,1),
(8,196,1),
(8,195,1),
(8,853,1),
(8,854,1),
(8,855,1),
(8,856,1),
(8,742,2),
(8,743,2),
(8,744,2),
(8,745,2),
(8,746,2),
(8,747,2),
(8,857,2),
(8,858,2),
(8,859,2),
(8,860,2),
(8,861,2),
(8,862,2),
(8,863,2),
(8,756,3),
(8,864,2),
(8,865,2),
(8,223,1),
(8,224,1),
(8,225,1),
(8,226,1),
(8,227,1),
(8,218,1),
(8,634,1),
(8,635,1),
(8,636,1),
(8,637,1),
(8,638,1),
(8,961,1),
(8,372,1),
(8,962,1),
(8,963,1),
(8,964,1),
(8,965,1),
(8,966,1),
(8,967,1),
(8,968,1),
(8,969,1),
(8,970,1),
(8,971,1),
(8,243,3),
(8,972,6),
(8,973,6),
(8,974,6),
(8,975,6),
(8,976,6),
(8,977,6),
(8,978,6),
(8,979,6),
(8,980,6),
(8,981,6),
(8,498,1),
(8,265,1),
(8,255,3),
(8,499,1),
(8,500,1),
(8,501,1),
(8,292,3),
(8,502,1),
(8,300,4),
(8,503,1),
(8,504,1),
(8,266,7),
(8,298,1),
(8,505,1),
(8,262,11),
(8,506,1),
(8,491,2),
(8,389,4),
(8,492,3),
(8,493,4),
(8,494,1),
(8,277,2),
(8,495,1),
(8,496,1),
(8,272,4),
(8,273,2),
(8,497,1),
(8,254,1),
(8,261,1),
(8,283,2),
(8,295,5),
(8,301,1),
(8,302,1),
(8,303,1),
(8,304,1),
(8,305,1),
(8,391,1),
(8,538,1),
(8,539,1),
(8,282,3),
(8,540,1),
(8,871,1),
(8,872,1),
(8,666,3),
(8,401,1),
(8,873,1),
(8,874,1),
(8,256,1),
(8,259,1),
(8,258,1),
(8,875,1),
(8,876,1),
(8,877,1),
(8,878,1),
(8,762,2),
(8,763,2),
(8,764,2),
(8,765,2),
(8,766,2),
(8,767,2),
(8,879,2),
(8,880,2),
(8,881,2),
(8,882,2),
(8,883,2),
(8,884,2),
(8,885,2),
(8,776,3),
(8,886,2),
(8,887,2),
(8,286,1),
(8,287,1),
(8,288,1),
(8,289,1),
(8,290,1),
(8,281,1),
(8,661,1),
(8,662,1),
(8,663,1),
(8,664,1),
(8,665,1),
(8,982,1),
(8,390,1),
(8,983,1),
(8,984,1),
(8,985,1),
(8,986,1),
(8,987,1),
(8,988,1),
(8,989,1),
(8,990,1),
(8,991,1),
(8,992,1),
(8,306,3),
(9,993,6),
(9,994,6),
(9,995,6),
(9,996,6),
(9,407,2),
(9,317,8),
(9,408,6),
(9,409,3),
(9,410,1),
(9,27,3),
(9,411,1),
(9,412,1),
(9,22,4),
(9,23,1),
(9,413,1),
(9,5,1),
(9,12,1),
(9,16,10),
(9,33,4),
(9,49,5),
(9,50,2),
(9,51,2),
(9,52,2),
(9,53,2),
(9,54,2),
(9,319,2),
(9,510,2),
(9,511,2),
(9,32,3),
(9,512,2),
(9,9,1),
(9,42,2),
(9,547,1),
(9,548,1),
(9,549,1),
(9,15,1),
(9,550,1),
(9,6,1),
(9,551,1),
(9,24,1),
(9,552,1),
(9,553,3),
(9,554,3),
(9,555,3),
(9,556,3),
(9,557,3),
(9,791,1),
(9,792,1),
(9,793,1),
(9,794,1),
(9,795,1),
(9,796,1),
(9,797,1),
(9,696,4),
(9,798,1),
(9,799,1),
(9,898,2),
(9,318,2),
(9,899,2),
(9,900,2),
(9,901,2),
(9,902,2),
(9,903,2),
(9,904,2),
(9,905,2),
(9,906,2),
(9,907,2),
(9,908,2),
(9,682,1),
(9,688,1),
(9,689,1),
(9,690,1),
(9,48,1),
(9,10,1),
(9,691,1),
(9,558,1),
(9,692,1),
(9,693,1),
(9,694,1),
(9,695,1),
(9,697,1),
(9,997,6),
(9,998,6),
(9,999,6),
(9,1000,6),
(9,428,2),
(9,335,8),
(9,429,6),
(9,430,3),
(9,431,1),
(9,88,3),
(9,432,1),
(9,433,1),
(9,83,1),
(9,84,1),
(9,434,1),
(9,65,1),
(9,73,8),
(9,72,1),
(9,77,10),
(9,94,4),
(9,111,5),
(9,106,4),
(9,112,2),
(9,113,2),
(9,114,2),
(9,115,2),
(9,116,2),
(9,337,2),
(9,517,2),
(9,518,2),
(9,93,3),
(9,519,2),
(9,69,1),
(9,103,2),
(9,574,1),
(9,575,1),
(9,576,1),
(9,76,1),
(9,577,1),
(9,66,1),
(9,578,1),
(9,85,1),
(9,579,1),
(9,580,3),
(9,581,3),
(9,582,3),
(9,583,3),
(9,584,3),
(9,813,1),
(9,814,1),
(9,815,1),
(9,816,1),
(9,817,1),
(9,818,1),
(9,819,1),
(9,716,4),
(9,820,1),
(9,821,1),
(9,919,2),
(9,336,2),
(9,920,2),
(9,921,2),
(9,922,2),
(9,923,2),
(9,924,2),
(9,925,2),
(9,926,2),
(9,927,2),
(9,928,2),
(9,929,2),
(9,702,1),
(9,708,1),
(9,709,1),
(9,710,1),
(9,110,1),
(9,70,1),
(9,711,1),
(9,585,1),
(9,712,1),
(9,713,1),
(9,714,1),
(9,715,1),
(9,717,1),
(9,117,3),
(9,1001,6),
(9,1002,6),
(9,1003,6),
(9,1004,6),
(9,449,2),
(9,353,8),
(9,450,6),
(9,451,3),
(9,452,1),
(9,151,3),
(9,453,1),
(9,454,1),
(9,146,1),
(9,147,1),
(9,455,1),
(9,128,1),
(9,136,8),
(9,135,1),
(9,140,10),
(9,157,4),
(9,174,5),
(9,169,4),
(9,175,2),
(9,176,2),
(9,177,2),
(9,178,2),
(9,179,2),
(9,355,2),
(9,524,2),
(9,525,2),
(9,156,3),
(9,526,2),
(9,132,1),
(9,166,2),
(9,601,1),
(9,602,1),
(9,603,1),
(9,139,1),
(9,604,1),
(9,129,1),
(9,605,1),
(9,148,1),
(9,606,1),
(9,607,3),
(9,608,3),
(9,609,3),
(9,610,3),
(9,611,3),
(9,835,1),
(9,836,1),
(9,837,1),
(9,838,1),
(9,839,1),
(9,840,1),
(9,841,1),
(9,736,4),
(9,842,1),
(9,843,1),
(9,940,2),
(9,354,2),
(9,941,2),
(9,942,2),
(9,943,2),
(9,944,2),
(9,945,2),
(9,946,2),
(9,947,2),
(9,948,2),
(9,949,2),
(9,950,2),
(9,722,1),
(9,728,1),
(9,729,1),
(9,730,1),
(9,173,1),
(9,133,1),
(9,731,1),
(9,612,1),
(9,732,1),
(9,733,1),
(9,734,1),
(9,735,1),
(9,737,1),
(9,180,3),
(9,1005,6),
(9,1006,6),
(9,1007,6),
(9,1008,6),
(9,470,2),
(9,371,8),
(9,471,6),
(9,472,3),
(9,473,1),
(9,214,3),
(9,474,1),
(9,475,1),
(9,209,1),
(9,210,1),
(9,476,1),
(9,191,1),
(9,199,8),
(9,198,1),
(9,203,10),
(9,220,4),
(9,237,5),
(9,232,4),
(9,238,2),
(9,239,2),
(9,240,2),
(9,241,2),
(9,242,2),
(9,373,2),
(9,531,2),
(9,532,2),
(9,219,3),
(9,533,2),
(9,195,1),
(9,229,2),
(9,628,1),
(9,629,1),
(9,630,1),
(9,202,1),
(9,631,1),
(9,192,1),
(9,632,1),
(9,211,1),
(9,633,1),
(9,634,3),
(9,635,3),
(9,636,3),
(9,637,3),
(9,638,3),
(9,857,1),
(9,858,1),
(9,859,1),
(9,860,1),
(9,861,1),
(9,862,1),
(9,863,1),
(9,756,4),
(9,864,1),
(9,865,1),
(9,961,2),
(9,372,2),
(9,962,2),
(9,963,2),
(9,964,2),
(9,965,2),
(9,966,2),
(9,967,2),
(9,968,2),
(9,969,2),
(9,970,2),
(9,971,2),
(9,742,1),
(9,748,1),
(9,749,1),
(9,750,1),
(9,236,1),
(9,196,1),
(9,751,1),
(9,639,1),
(9,752,1),
(9,753,1),
(9,754,1),
(9,755,1),
(9,757,1),
(9,243,3),
(9,1009,6),
(9,1010,6),
(9,1011,6),
(9,1012,6),
(9,491,2),
(9,389,8),
(9,492,6),
(9,493,3),
(9,494,1),
(9,277,3),
(9,495,1),
(9,496,1),
(9,272,4),
(9,273,1),
(9,497,1),
(9,254,1),
(9,262,8),
(9,261,1),
(9,266,10),
(9,283,4),
(9,300,5),
(9,295,4),
(9,301,2),
(9,302,2),
(9,303,2),
(9,304,2),
(9,305,2),
(9,391,2),
(9,538,2),
(9,539,2),
(9,282,3),
(9,540,2),
(9,258,1),
(9,292,2),
(9,655,1),
(9,656,1),
(9,657,1),
(9,265,1),
(9,658,1),
(9,255,1),
(9,659,1),
(9,274,1),
(9,660,1),
(9,661,3),
(9,662,3),
(9,663,3),
(9,664,3),
(9,665,3),
(9,879,1),
(9,880,1),
(9,881,1),
(9,882,1),
(9,883,1),
(9,884,1),
(9,885,1),
(9,776,4),
(9,886,1),
(9,887,1),
(9,982,2),
(9,390,2),
(9,983,2),
(9,984,2),
(9,985,2),
(9,986,2),
(9,987,2),
(9,988,2),
(9,989,2),
(9,990,2),
(9,991,2),
(9,992,2),
(9,762,1),
(9,768,1),
(9,769,1),
(9,770,1),
(9,299,1),
(9,259,1),
(9,771,1),
(9,666,1),
(9,772,1),
(9,773,1),
(9,774,1),
(9,775,1),
(9,777,1),
(9,306,3),
(23,140,19),
(23,139,6),
(23,138,3),
(23,1229,6),
(23,1228,6),
(23,1227,6),
(23,1226,6),
(23,117,3),
(23,101,1),
(23,100,1),
(23,99,1),
(23,98,1),
(23,97,1),
(23,74,1),
(23,72,1),
(23,71,1),
(23,70,1),
(23,69,1),
(23,68,1),
(23,67,1),
(23,66,1),
(23,65,1),
(23,116,2),
(23,115,2),
(23,114,2),
(23,113,2),
(23,112,2),
(23,111,2),
(23,110,2),
(23,109,2),
(23,108,2),
(23,107,2),
(23,106,4),
(23,105,2),
(23,104,2),
(23,103,2),
(23,102,2),
(23,96,3),
(23,95,3),
(23,94,5),
(23,93,3),
(23,92,4),
(23,91,3),
(23,90,3),
(23,89,3),
(23,88,3),
(23,87,3),
(23,73,7),
(23,86,3),
(23,85,3),
(23,84,3),
(23,83,3),
(23,82,3),
(23,81,3),
(23,80,6),
(23,79,9),
(23,78,6),
(23,77,19),
(23,76,6),
(23,75,3),
(23,1225,6),
(23,1224,6),
(23,1223,6),
(23,1222,6),
(23,1322,4),
(23,1321,4),
(23,1319,4),
(23,1318,4),
(23,40,1),
(23,39,1),
(23,38,1),
(23,37,1),
(23,36,1),
(23,13,1),
(23,12,1),
(23,11,1),
(23,10,1),
(23,9,1),
(23,8,1),
(23,7,1),
(23,6,1),
(23,5,1),
(23,54,2),
(23,53,2),
(23,52,2),
(23,51,2),
(23,50,2),
(23,49,2),
(23,48,2),
(23,47,2),
(23,46,2),
(23,45,2),
(23,44,2),
(23,43,2),
(23,42,2),
(23,41,2),
(23,35,3),
(23,34,3),
(23,33,5),
(23,32,3),
(23,31,4),
(23,30,3),
(23,29,3),
(23,28,3),
(23,27,3),
(23,26,3),
(23,25,3),
(23,24,3),
(23,23,3),
(23,22,6),
(23,21,3),
(23,20,3),
(23,19,6),
(23,18,9),
(23,17,6),
(23,16,19),
(23,15,6),
(23,14,3),
(23,1221,6),
(23,1220,6),
(23,1219,6),
(23,1218,6),
(13,507,2),
(13,306,3),
(13,290,1),
(13,289,1),
(13,288,1),
(13,287,1),
(13,286,1),
(13,402,2),
(13,400,2),
(13,399,2),
(13,398,2),
(13,397,2),
(13,396,2),
(13,395,2),
(13,394,2),
(13,393,2),
(13,392,2),
(13,390,2),
(13,299,2),
(13,297,2),
(13,296,2),
(13,295,4),
(13,294,2),
(13,293,2),
(13,292,2),
(13,291,4),
(13,285,2),
(13,284,2),
(13,283,2),
(13,282,2),
(13,281,5),
(13,280,2),
(13,267,2),
(13,279,2),
(13,269,2),
(13,278,1),
(13,277,1),
(13,268,3),
(13,276,1),
(13,275,1),
(13,274,1),
(13,272,4),
(13,665,1),
(13,664,1),
(13,663,1),
(13,662,1),
(13,661,1),
(13,300,1),
(13,878,1),
(13,273,2),
(13,877,1),
(13,876,1),
(13,875,1),
(13,258,1),
(13,259,1),
(13,256,1),
(13,255,1),
(13,874,1),
(13,873,1),
(13,872,1),
(13,871,1),
(13,677,1),
(13,676,1),
(13,675,1),
(13,674,1),
(13,673,1),
(13,389,4),
(13,672,1),
(13,671,1),
(13,492,1),
(13,265,5),
(13,670,1),
(13,669,1),
(13,668,1),
(13,391,3),
(13,298,3),
(13,266,12),
(13,262,8),
(13,667,1),
(13,497,1),
(13,401,4),
(13,666,2),
(13,504,1),
(13,1077,6),
(13,1076,6),
(13,486,2),
(13,243,3),
(13,227,1),
(13,226,1),
(13,225,1),
(13,224,1),
(13,223,1),
(13,384,2),
(13,382,2),
(13,381,2),
(13,380,2),
(13,379,2),
(13,378,2),
(13,377,2),
(13,376,2),
(13,375,2),
(13,374,2),
(13,372,2),
(13,236,2),
(13,234,2),
(13,233,2),
(13,232,4),
(13,231,2),
(13,230,2),
(13,229,2),
(13,228,4),
(13,222,2),
(13,221,2),
(13,220,2),
(13,219,2),
(13,218,5),
(13,217,2),
(13,204,2),
(13,216,2),
(13,206,2),
(13,215,1),
(13,214,1),
(13,205,3),
(13,213,1),
(13,212,1),
(13,211,1),
(13,209,1),
(13,638,1),
(13,637,1),
(13,636,1),
(13,635,1),
(13,634,1),
(13,237,1),
(13,856,1),
(13,210,2),
(13,855,1),
(13,854,1),
(13,853,1),
(13,195,1),
(13,196,1),
(13,193,1),
(13,192,1),
(13,852,1),
(13,851,1),
(13,850,1),
(13,849,1),
(13,650,1),
(13,649,1),
(13,648,1),
(13,647,1),
(13,646,1),
(13,371,4),
(13,645,1),
(13,644,1),
(13,471,1),
(13,202,5),
(13,643,1),
(13,642,1),
(13,641,1),
(13,373,3),
(13,235,3),
(13,203,12),
(13,199,8),
(13,640,1),
(13,476,1),
(13,383,4),
(13,639,2),
(13,483,1),
(13,1075,6),
(13,1074,6),
(13,465,2),
(13,180,3),
(13,164,1),
(13,163,1),
(13,162,1),
(13,161,1),
(13,160,1),
(13,366,2),
(13,364,2),
(13,363,2),
(13,362,2),
(13,361,2),
(13,360,2),
(13,359,2),
(13,358,2),
(13,357,2),
(13,356,2),
(13,354,2),
(13,173,2),
(13,171,2),
(13,170,2),
(13,169,4),
(13,168,2),
(13,167,2),
(13,166,2),
(13,165,4),
(13,159,2),
(13,158,2),
(13,157,2),
(13,156,2),
(13,155,5),
(13,154,2),
(13,141,2),
(13,153,2),
(13,143,2),
(13,152,1),
(13,151,1),
(13,142,3),
(13,150,1),
(13,149,1),
(13,148,1),
(13,146,1),
(13,611,1),
(13,610,1),
(13,609,1),
(13,608,1),
(13,607,1),
(13,174,1),
(13,834,1),
(13,147,2),
(13,833,1),
(13,832,1),
(13,831,1),
(13,132,1),
(13,133,1),
(13,130,1),
(13,129,1),
(13,830,1),
(13,829,1),
(13,828,1),
(13,827,1),
(13,623,1),
(13,622,1),
(13,621,1),
(13,620,1),
(13,619,1),
(13,353,4),
(13,618,1),
(13,617,1),
(13,450,1),
(13,139,5),
(13,616,1),
(13,615,1),
(13,614,1),
(13,355,3),
(13,172,3),
(13,140,12),
(13,136,8),
(13,613,1),
(13,455,1),
(13,365,4),
(13,612,2),
(13,462,1),
(13,1073,6),
(13,1072,6),
(13,444,2),
(13,117,3),
(13,101,1),
(13,100,1),
(13,99,1),
(13,98,1),
(13,97,1),
(13,348,2),
(13,346,2),
(13,345,2),
(13,344,2),
(13,343,2),
(13,342,2),
(13,341,2),
(13,340,2),
(13,339,2),
(13,338,2),
(13,336,2),
(13,110,2),
(13,108,2),
(13,107,2),
(13,106,4),
(13,105,2),
(13,104,2),
(13,103,2),
(13,102,4),
(13,96,2),
(13,95,2),
(13,94,2),
(13,93,2),
(13,92,5),
(13,91,2),
(13,78,2),
(13,90,2),
(13,80,2),
(13,89,1),
(13,88,1),
(13,79,3),
(13,87,1),
(13,86,1),
(13,85,1),
(13,83,1),
(13,584,1),
(13,583,1),
(13,582,1),
(13,581,1),
(13,580,1),
(13,111,1),
(13,812,1),
(13,84,2),
(13,811,1),
(13,810,1),
(13,809,1),
(13,69,1),
(13,70,1),
(13,67,1),
(13,66,1),
(13,808,1),
(13,807,1),
(13,806,1),
(13,805,1),
(13,596,1),
(13,595,1),
(13,594,1),
(13,593,1),
(13,592,1),
(13,335,4),
(13,591,1),
(13,590,1),
(13,429,1),
(13,76,5),
(13,589,1),
(13,588,1),
(13,587,1),
(13,337,3),
(13,109,3),
(13,77,12),
(13,73,8),
(13,586,1),
(13,434,1),
(13,347,4),
(13,585,2),
(13,441,1),
(13,1071,6),
(13,1070,6),
(13,423,2),
(13,1319,4),
(13,1318,4),
(13,40,1),
(13,39,1),
(11,993,6),
(11,994,6),
(11,1048,6),
(11,1049,6),
(11,319,3),
(11,510,2),
(11,511,2),
(11,32,3),
(11,512,2),
(11,9,3),
(11,42,2),
(11,547,2),
(11,548,2),
(11,549,2),
(11,15,5),
(11,550,2),
(11,6,4),
(11,551,2),
(11,24,3),
(11,552,2),
(11,420,1),
(11,558,2),
(11,329,2),
(11,413,2),
(11,559,1),
(11,16,8),
(11,47,1),
(11,560,1),
(11,561,1),
(11,562,1),
(11,408,4),
(11,563,1),
(11,564,1),
(11,317,5),
(11,565,1),
(11,566,1),
(11,567,1),
(11,568,1),
(11,569,1),
(11,682,1),
(11,683,1),
(11,684,1),
(11,685,1),
(11,686,1),
(11,687,1),
(11,1015,1),
(11,48,1),
(11,1016,1),
(11,1017,1),
(11,1018,1),
(11,1019,1),
(11,22,6),
(11,23,3),
(11,5,2),
(11,7,1),
(11,8,1),
(11,10,1),
(11,11,1),
(11,12,2),
(11,13,1),
(11,14,1),
(11,17,1),
(11,18,2),
(11,19,1),
(11,20,1),
(11,21,1),
(11,25,1),
(11,26,1),
(11,27,2),
(11,28,1),
(11,36,1),
(11,37,1),
(11,38,1),
(11,39,1),
(11,40,1),
(11,31,1),
(11,407,2),
(11,409,2),
(11,410,1),
(11,411,1),
(11,412,1),
(11,33,1),
(11,49,2),
(11,50,1),
(11,51,1),
(11,52,1),
(11,53,1),
(11,54,1),
(11,553,1),
(11,554,1),
(11,555,1),
(11,556,1),
(11,557,1),
(11,997,6),
(11,998,6),
(11,1050,6),
(11,1051,6),
(11,337,3),
(11,517,2),
(11,518,2),
(11,93,3),
(11,519,2),
(11,69,3),
(11,103,2),
(11,574,2),
(11,575,2),
(11,576,2),
(11,76,5),
(11,577,2),
(11,66,4),
(11,578,2),
(11,85,3),
(11,579,2),
(11,441,1),
(11,585,2),
(11,347,2),
(11,434,2),
(11,586,1),
(11,73,9),
(11,77,8),
(11,109,1),
(11,587,1),
(11,588,1),
(11,589,1),
(11,429,4),
(11,590,1),
(11,591,1),
(11,335,5),
(11,592,1),
(11,593,1),
(11,594,1),
(11,595,1),
(11,596,1),
(11,702,1),
(11,703,1),
(11,704,1),
(11,705,1),
(11,706,1),
(11,707,1),
(11,1022,1),
(11,110,1),
(11,1023,1),
(11,1024,1),
(11,1025,1),
(11,1026,1),
(11,83,3),
(11,84,3),
(11,65,2),
(11,67,1),
(11,68,1),
(11,70,1),
(11,71,1),
(11,72,2),
(11,74,1),
(11,75,1),
(11,78,1),
(11,79,2),
(11,80,1),
(11,81,1),
(11,82,1),
(11,86,1),
(11,87,1),
(11,88,2),
(11,89,1),
(11,97,1),
(11,98,1),
(11,99,1),
(11,100,1),
(11,101,1),
(11,92,1),
(11,428,2),
(11,430,2),
(11,431,1),
(11,432,1),
(11,433,1),
(11,94,1),
(11,111,2),
(11,106,1),
(11,112,1),
(11,113,1),
(11,114,1),
(11,115,1),
(11,116,1),
(11,580,1),
(11,581,1),
(11,582,1),
(11,583,1),
(11,584,1),
(11,117,3),
(11,1001,6),
(11,1002,6),
(11,1052,6),
(11,1053,6),
(11,355,3),
(11,524,2),
(11,525,2),
(11,156,3),
(11,526,2),
(11,132,3),
(11,166,2),
(11,601,2),
(11,602,2),
(11,603,2),
(11,139,5),
(11,604,2),
(11,129,4),
(11,605,2),
(11,148,3),
(11,606,2),
(11,462,1),
(11,612,2),
(11,365,2),
(11,455,2),
(11,613,1),
(11,136,9),
(11,140,8),
(11,172,1),
(11,614,1),
(11,615,1),
(11,616,1),
(11,450,4),
(11,617,1),
(11,618,1),
(11,353,5),
(11,619,1),
(11,620,1),
(11,621,1),
(11,622,1),
(11,623,1),
(11,722,1),
(11,723,1),
(11,724,1),
(11,725,1),
(11,726,1),
(11,727,1),
(11,1029,1),
(11,173,1),
(11,1030,1),
(11,1031,1),
(11,1032,1),
(11,1033,1),
(11,146,3),
(11,147,3),
(11,128,2),
(11,130,1),
(11,131,1),
(11,133,1),
(11,134,1),
(11,135,2),
(11,137,1),
(11,138,1),
(11,141,1),
(11,142,2),
(11,143,1),
(11,144,1),
(11,145,1),
(11,149,1),
(11,150,1),
(11,151,2),
(11,152,1),
(11,160,1),
(11,161,1),
(11,162,1),
(11,163,1),
(11,164,1),
(11,155,1),
(11,449,2),
(11,451,2),
(11,452,1),
(11,453,1),
(11,454,1),
(11,157,1),
(11,174,2),
(11,169,1),
(11,175,1),
(11,176,1),
(11,177,1),
(11,178,1),
(11,179,1),
(11,607,1),
(11,608,1),
(11,609,1),
(11,610,1),
(11,611,1),
(11,180,3),
(11,1005,6),
(11,1006,6),
(11,1054,6),
(11,1055,6),
(11,373,3),
(11,531,2),
(11,532,2),
(11,219,3),
(11,533,2),
(11,195,3),
(11,229,2),
(11,628,2),
(11,629,2),
(11,630,2),
(11,202,5),
(11,631,2),
(11,192,4),
(11,632,2),
(11,211,3),
(11,633,2),
(11,483,1),
(11,639,2),
(11,383,2),
(11,476,2),
(11,640,1),
(11,199,9),
(11,203,8),
(11,235,1),
(11,641,1),
(11,642,1),
(11,643,1),
(11,471,4),
(11,644,1),
(11,645,1),
(11,371,5),
(11,646,1),
(11,647,1),
(11,648,1),
(11,649,1),
(11,650,1),
(11,742,1),
(11,743,1),
(11,744,1),
(11,745,1),
(11,746,1),
(11,747,1),
(11,1036,1),
(11,236,1),
(11,1037,1),
(11,1038,1),
(11,1039,1),
(11,1040,1),
(11,209,3),
(11,210,3),
(11,191,2),
(11,193,1),
(11,194,1),
(11,196,1),
(11,197,1),
(11,198,2),
(11,200,1),
(11,201,1),
(11,204,1),
(11,205,2),
(11,206,1),
(11,207,1),
(11,208,1),
(11,212,1),
(11,213,1),
(11,214,2),
(11,215,1),
(11,223,1),
(11,224,1),
(11,225,1),
(11,226,1),
(11,227,1),
(11,218,1),
(11,470,2),
(11,472,2),
(11,473,1),
(11,474,1),
(11,475,1),
(11,220,1),
(11,237,2),
(11,232,1),
(11,238,1),
(11,239,1),
(11,240,1),
(11,241,1),
(11,242,1),
(11,634,1),
(11,635,1),
(11,636,1),
(11,637,1),
(11,638,1),
(11,243,3),
(11,1009,6),
(11,1010,6),
(11,1056,6),
(11,1057,6),
(11,391,3),
(11,538,2),
(11,539,2),
(11,282,3),
(11,540,2),
(11,258,3),
(11,292,2),
(11,655,2),
(11,656,2),
(11,657,2),
(11,265,5),
(11,658,2),
(11,255,4),
(11,659,2),
(11,274,3),
(11,660,2),
(11,504,1),
(11,666,2),
(11,401,2),
(11,497,2),
(11,667,1),
(11,262,9),
(11,266,8),
(11,298,1),
(11,668,1),
(11,669,1),
(11,670,1),
(11,492,4),
(11,671,1),
(11,672,1),
(11,389,5),
(11,673,1),
(11,674,1),
(11,675,1),
(11,676,1),
(11,677,1),
(11,762,1),
(11,763,1),
(11,764,1),
(11,765,1),
(11,766,1),
(11,767,1),
(11,1043,1),
(11,299,1),
(11,1044,1),
(11,1045,1),
(11,1046,1),
(11,1047,1),
(11,272,6),
(11,273,3),
(11,254,2),
(11,256,1),
(11,257,1),
(11,259,1),
(11,260,1),
(11,261,2),
(11,263,1),
(11,264,1),
(11,267,1),
(11,268,2),
(11,269,1),
(11,270,1),
(11,271,1),
(11,275,1),
(11,276,1),
(11,277,2),
(11,278,1),
(11,286,1),
(11,287,1),
(11,288,1),
(11,289,1),
(11,290,1),
(11,281,1),
(11,491,2),
(11,493,2),
(11,494,1),
(11,495,1),
(11,496,1),
(11,283,1),
(11,300,2),
(11,295,1),
(11,301,1),
(11,302,1),
(11,303,1),
(11,304,1),
(11,305,1),
(11,661,1),
(11,662,1),
(11,663,1),
(11,664,1),
(11,665,1),
(11,306,3),
(12,993,6),
(12,1058,6),
(12,888,6),
(12,1059,6),
(12,9,2),
(12,42,2),
(12,547,1),
(12,548,1),
(12,549,1),
(12,15,6),
(12,550,1),
(12,6,2),
(12,551,1),
(12,24,3),
(12,552,1),
(12,420,1),
(12,558,2),
(12,329,1),
(12,413,1),
(12,559,1),
(12,16,14),
(12,47,2),
(12,319,1),
(12,560,1),
(12,561,1),
(12,562,1),
(12,408,3),
(12,563,1),
(12,564,1),
(12,317,4),
(12,565,1),
(12,566,1),
(12,567,1),
(12,568,1),
(12,569,1),
(12,682,1),
(12,688,1),
(12,689,1),
(12,690,1),
(12,48,2),
(12,10,2),
(12,691,1),
(12,32,3),
(12,692,1),
(12,693,1),
(12,694,1),
(12,695,1),
(12,696,1),
(12,697,1),
(12,5,1),
(12,7,1),
(12,8,1),
(12,11,1),
(12,12,1),
(12,13,1),
(12,14,2),
(12,17,4),
(12,18,6),
(12,19,4),
(12,20,2),
(12,21,2),
(12,22,5),
(12,23,2),
(12,25,2),
(12,26,2),
(12,27,2),
(12,28,2),
(12,29,2),
(12,30,2),
(12,31,3),
(12,33,3),
(12,34,2),
(12,35,2),
(12,36,1),
(12,37,1),
(12,38,1),
(12,39,1),
(12,40,1),
(12,41,1),
(12,43,1),
(12,44,1),
(12,45,1),
(12,46,1),
(12,49,1),
(12,50,1),
(12,51,1),
(12,52,1),
(12,53,1),
(12,54,1),
(12,997,6),
(12,1060,6),
(12,909,6),
(12,1061,6),
(12,69,2),
(12,103,2),
(12,574,1),
(12,575,1),
(12,576,1),
(12,76,6),
(12,577,1),
(12,66,2),
(12,578,1),
(12,85,3),
(12,579,1),
(12,441,1),
(12,585,2),
(12,347,1),
(12,434,1),
(12,586,1),
(12,73,9),
(12,77,14),
(12,109,2),
(12,337,1),
(12,587,1),
(12,588,1),
(12,589,1),
(12,429,3),
(12,590,1),
(12,591,1),
(12,335,4),
(12,592,1),
(12,593,1),
(12,594,1),
(12,595,1),
(12,596,1),
(12,702,1),
(12,708,1),
(12,709,1),
(12,710,1),
(12,110,2),
(12,70,2),
(12,711,1),
(12,93,3),
(12,712,1),
(12,713,1),
(12,714,1),
(12,715,1),
(12,716,1),
(12,717,1),
(12,65,1),
(12,67,1),
(12,68,1),
(12,71,1),
(12,72,1),
(12,74,1),
(12,75,2),
(12,78,4),
(12,79,6),
(12,80,4),
(12,81,2),
(12,82,2),
(12,83,2),
(12,84,2),
(12,86,2),
(12,87,2),
(12,88,2),
(12,89,2),
(12,90,2),
(12,91,2),
(12,92,3),
(12,94,3),
(12,95,2),
(12,96,2),
(12,97,1),
(12,98,1),
(12,99,1),
(12,100,1),
(12,101,1),
(12,102,1),
(12,104,1),
(12,105,1),
(12,106,2),
(12,107,1),
(12,108,1),
(12,111,1),
(12,112,1),
(12,113,1),
(12,114,1),
(12,115,1),
(12,116,1),
(12,117,3),
(12,1001,6),
(12,1062,6),
(12,930,6),
(12,1063,6),
(12,132,2),
(12,166,2),
(12,601,1),
(12,602,1),
(12,603,1),
(12,139,6),
(12,604,1),
(12,129,2),
(12,605,1),
(12,148,3),
(12,606,1),
(12,462,1),
(12,612,2),
(12,365,1),
(12,455,1),
(12,613,1),
(12,136,9),
(12,140,14),
(12,172,2),
(12,355,1),
(12,614,1),
(12,615,1),
(12,616,1),
(12,450,3),
(12,617,1),
(12,618,1),
(12,353,4),
(12,619,1),
(12,620,1),
(12,621,1),
(12,622,1),
(12,623,1),
(12,722,1),
(12,728,1),
(12,729,1),
(12,730,1),
(12,173,2),
(12,133,2),
(12,731,1),
(12,156,3),
(12,732,1),
(12,733,1),
(12,734,1),
(12,735,1),
(12,736,1),
(12,737,1),
(12,128,1),
(12,130,1),
(12,131,1),
(12,134,1),
(12,135,1),
(12,137,1),
(12,138,2),
(12,141,4),
(12,142,6),
(12,143,4),
(12,144,2),
(12,145,2),
(12,146,2),
(12,147,2),
(12,149,2),
(12,150,2),
(12,151,2),
(12,152,2),
(12,153,2),
(12,154,2),
(12,155,3),
(12,157,3),
(12,158,2),
(12,159,2),
(12,160,1),
(12,161,1),
(12,162,1),
(12,163,1),
(12,164,1),
(12,165,1),
(12,167,1),
(12,168,1),
(12,169,2),
(12,170,1),
(12,171,1),
(12,174,1),
(12,175,1),
(12,176,1),
(12,177,1),
(12,178,1),
(12,179,1),
(12,180,3),
(12,1005,6),
(12,1064,6),
(12,951,6),
(12,1065,6),
(12,195,2),
(12,229,2),
(12,628,1),
(12,629,1),
(12,630,1),
(12,202,6),
(12,631,1),
(12,192,2),
(12,632,1),
(12,211,3),
(12,633,1),
(12,483,1),
(12,639,2),
(12,383,1),
(12,476,1),
(12,640,1),
(12,199,9),
(12,203,14),
(12,235,2),
(12,373,1),
(12,641,1),
(12,642,1),
(12,643,1),
(12,471,3),
(12,644,1),
(12,645,1),
(12,371,4),
(12,646,1),
(12,647,1),
(12,648,1),
(12,649,1),
(12,650,1),
(12,742,1),
(12,748,1),
(12,749,1),
(12,750,1),
(12,236,2),
(12,196,2),
(12,751,1),
(12,219,3),
(12,752,1),
(12,753,1),
(12,754,1),
(12,755,1),
(12,756,1),
(12,757,1),
(12,191,1),
(12,193,1),
(12,194,1),
(12,197,1),
(12,198,1),
(12,200,1),
(12,201,2),
(12,204,4),
(12,205,6),
(12,206,4),
(12,207,2),
(12,208,2),
(12,209,2),
(12,210,2),
(12,212,2),
(12,213,2),
(12,214,2),
(12,215,2),
(12,216,2),
(12,217,2),
(12,218,3),
(12,220,3),
(12,221,2),
(12,222,2),
(12,223,1),
(12,224,1),
(12,225,1),
(12,226,1),
(12,227,1),
(12,228,1),
(12,230,1),
(12,231,1),
(12,232,2),
(12,233,1),
(12,234,1),
(12,237,1),
(12,238,1),
(12,239,1),
(12,240,1),
(12,241,1),
(12,242,1),
(12,243,3),
(12,1009,6),
(12,1066,6),
(12,972,6),
(12,1067,6),
(12,258,2),
(12,292,2),
(12,655,1),
(12,656,1),
(12,657,1),
(12,265,6),
(12,658,1),
(12,255,2),
(12,659,1),
(12,274,3),
(12,660,1),
(12,504,1),
(12,666,2),
(12,401,1),
(12,497,1),
(12,667,1),
(12,262,9),
(12,266,14),
(12,298,2),
(12,391,1),
(12,668,1),
(12,669,1),
(12,670,1),
(12,492,3),
(12,671,1),
(12,672,1),
(12,389,4),
(12,673,1),
(12,674,1),
(12,675,1),
(12,676,1),
(12,677,1),
(12,762,1),
(12,768,1),
(12,769,1),
(12,770,1),
(12,299,2),
(12,259,2),
(12,771,1),
(12,282,3),
(12,772,1),
(12,773,1),
(12,774,1),
(12,775,1),
(12,776,1),
(12,777,1),
(12,254,1),
(12,256,1),
(12,257,1),
(12,260,1),
(12,261,1),
(12,263,1),
(12,264,2),
(12,267,4),
(12,268,6),
(12,269,4),
(12,270,2),
(12,271,2),
(12,272,5),
(12,273,2),
(12,275,2),
(12,276,2),
(12,277,2),
(12,278,2),
(12,279,2),
(12,280,2),
(12,281,3),
(12,283,3),
(12,284,2),
(12,285,2),
(12,286,1),
(12,287,1),
(12,288,1),
(12,289,1),
(12,290,1),
(12,291,1),
(12,293,1),
(12,294,1),
(12,295,2),
(12,296,1),
(12,297,1),
(12,300,1),
(12,301,1),
(12,302,1),
(12,303,1),
(12,304,1),
(12,305,1),
(12,306,3),
(13,38,1),
(13,37,1),
(13,36,1),
(13,330,2),
(13,328,2),
(13,327,2),
(13,326,2),
(13,325,2),
(13,324,2),
(13,323,2),
(13,322,2),
(13,321,2),
(13,320,2),
(13,318,2),
(13,48,2),
(13,46,2),
(13,45,2),
(13,44,2),
(13,43,2),
(13,42,2),
(13,41,4),
(13,35,2),
(13,34,2),
(13,33,2),
(13,32,2),
(13,31,5),
(13,30,2),
(13,17,2),
(13,29,2),
(13,19,2),
(13,28,1),
(13,27,1),
(13,18,3),
(13,26,1),
(13,25,1),
(13,24,1),
(13,22,4),
(13,557,1),
(13,556,1),
(13,555,1),
(13,554,1),
(13,553,1),
(13,49,1),
(13,790,1),
(13,23,2),
(13,789,1),
(13,788,1),
(13,787,1),
(13,9,1),
(13,10,1),
(13,7,1),
(13,6,1),
(13,786,1),
(13,785,1),
(13,784,1),
(13,783,1),
(13,569,1),
(13,568,1),
(13,567,1),
(13,566,1),
(13,565,1),
(13,317,4),
(13,564,1),
(13,563,1),
(13,408,1),
(13,15,5),
(13,562,1),
(13,561,1),
(13,560,1),
(13,319,3),
(13,47,3),
(13,16,12),
(13,559,1),
(13,413,1),
(13,329,4),
(13,558,2),
(13,420,1),
(13,1069,6),
(13,1068,6),
(10,587,1),
(10,109,1),
(10,586,1),
(10,434,1),
(10,347,3),
(10,585,3),
(10,441,1),
(10,579,1),
(10,85,1),
(10,578,1),
(10,66,4),
(10,577,1),
(10,76,4),
(10,576,1),
(10,575,1),
(10,574,1),
(10,103,1),
(10,69,2),
(10,519,1),
(10,93,3),
(10,518,1),
(10,517,1),
(10,337,2),
(10,116,1),
(10,115,1),
(10,73,12),
(10,114,1),
(10,113,1),
(10,112,1),
(10,106,1),
(10,111,1),
(10,94,2),
(10,77,9),
(10,1021,6),
(10,1020,6),
(10,998,6),
(10,997,6),
(10,1320,4),
(10,1319,4),
(10,1318,4),
(10,31,1),
(10,40,1),
(10,39,1),
(10,38,1),
(10,37,1),
(10,36,1),
(10,13,1),
(10,12,1),
(10,11,1),
(10,8,1),
(10,7,1),
(10,5,1),
(10,23,2),
(10,22,5),
(10,1019,2),
(10,1018,2),
(10,1017,2),
(10,1016,2),
(10,1015,2),
(10,697,2),
(10,695,2),
(10,694,2),
(10,693,2),
(10,692,2),
(10,691,2),
(10,10,3),
(10,48,4),
(10,690,2),
(10,689,2),
(10,688,2),
(10,682,2),
(10,908,1),
(10,907,1),
(10,906,1),
(10,905,1),
(10,904,1),
(10,903,1),
(10,696,3),
(10,902,1),
(10,901,1),
(10,900,1),
(10,899,1),
(10,27,1),
(10,318,1),
(10,898,1),
(10,569,1),
(10,568,1),
(10,567,1),
(10,566,1),
(10,565,1),
(10,317,10),
(10,564,1),
(10,563,1),
(10,408,8),
(10,562,1),
(10,561,1),
(10,560,1),
(10,47,1),
(10,559,1),
(10,413,1),
(10,329,3),
(10,558,3),
(10,420,1),
(10,552,1),
(10,24,1),
(10,551,1),
(10,6,4),
(10,550,1),
(10,15,4),
(10,549,1),
(10,548,1),
(10,547,1),
(10,42,1),
(10,9,2),
(10,512,1),
(10,32,3),
(10,511,1),
(10,510,1),
(10,319,2),
(10,54,1),
(10,53,1),
(10,52,1),
(10,51,1),
(10,50,1),
(10,49,1),
(10,33,2),
(10,16,9),
(10,1014,6),
(10,1013,6),
(10,994,6),
(10,993,6),
(2,312,4),
(2,311,6),
(2,310,6),
(2,309,4),
(2,308,4),
(2,307,3),
(2,306,3),
(2,290,1),
(2,289,1),
(2,288,1),
(2,287,1),
(2,286,1),
(2,402,2),
(2,401,2),
(2,400,2),
(2,399,2),
(2,398,2),
(2,397,2),
(2,396,2),
(2,395,2),
(2,394,2),
(2,393,2),
(2,392,2),
(2,391,2),
(2,390,2),
(2,389,2),
(2,305,1),
(2,304,1),
(2,303,1),
(2,302,1),
(2,301,1),
(2,300,1),
(2,299,3),
(2,298,3),
(2,297,3),
(2,296,3),
(2,295,6),
(2,294,3),
(2,293,3),
(2,292,3),
(2,291,5),
(2,285,3),
(2,284,3),
(2,283,4),
(2,282,3),
(2,281,6),
(2,280,3),
(2,279,3),
(2,278,2),
(2,277,2),
(2,276,2),
(2,262,6),
(2,275,2),
(2,274,2),
(2,273,2),
(2,272,5),
(2,271,1),
(2,270,1),
(2,269,4),
(2,268,6),
(2,267,4),
(2,266,16),
(2,265,6),
(2,264,1),
(2,388,6),
(2,387,6),
(2,386,6),
(2,385,6),
(2,249,4),
(2,248,6),
(2,247,6),
(2,246,4),
(2,245,4),
(2,244,3),
(2,243,3),
(2,227,1),
(2,226,1),
(2,225,1),
(2,224,1),
(2,223,1),
(2,384,2),
(2,383,2),
(2,382,2),
(2,381,2),
(2,380,2),
(2,379,2),
(2,378,2),
(2,377,2),
(2,376,2),
(2,375,2),
(2,374,2),
(2,373,2),
(2,372,2),
(2,371,2),
(2,242,1),
(2,241,1),
(2,240,1),
(2,239,1),
(2,238,1),
(2,237,1),
(2,236,3),
(2,235,3),
(2,234,3),
(2,233,3),
(2,232,6),
(2,231,3),
(2,230,3),
(2,229,3),
(2,228,5),
(2,222,3),
(2,221,3),
(2,220,4),
(2,219,3),
(2,218,6),
(2,217,3),
(2,216,3),
(2,215,2),
(2,214,2),
(2,213,2),
(2,199,6),
(2,212,2),
(2,211,2),
(2,210,2),
(2,209,2),
(2,208,1),
(2,207,1),
(2,206,4),
(2,205,6),
(2,204,4),
(2,203,16),
(2,202,6),
(2,201,1),
(2,370,6),
(2,369,6),
(2,368,6),
(2,367,6),
(2,186,4),
(2,185,6),
(2,184,6),
(2,183,4),
(2,182,4),
(2,181,3),
(2,180,3),
(2,164,1),
(2,163,1),
(2,162,1),
(2,161,1),
(2,160,1),
(2,366,2),
(2,365,2),
(2,364,2),
(2,363,2),
(2,362,2),
(2,361,2),
(2,360,2),
(2,359,2),
(2,358,2),
(2,357,2),
(2,356,2),
(2,355,2),
(2,354,2),
(2,353,2),
(2,179,1),
(2,178,1),
(2,177,1),
(2,176,1),
(2,175,1),
(2,174,1),
(2,173,3),
(2,172,3),
(2,171,3),
(2,170,3),
(2,169,6),
(2,168,3),
(2,167,3),
(2,166,3),
(2,165,5),
(2,159,3),
(2,158,3),
(2,157,4),
(2,156,3),
(2,155,6),
(2,154,3),
(2,153,3),
(2,152,2),
(2,151,2),
(2,150,2),
(2,136,6),
(2,149,2),
(2,148,2),
(2,147,2),
(2,146,2),
(2,145,1),
(2,144,1),
(2,143,4),
(2,142,6),
(2,141,4),
(2,140,16),
(2,139,6),
(2,138,1),
(2,352,6),
(2,351,6),
(2,350,6),
(2,349,6),
(2,123,4),
(2,122,6),
(2,121,6),
(2,120,4),
(2,119,4),
(2,118,3),
(2,117,3),
(2,101,1),
(14,1078,6),
(14,1079,6),
(14,1080,6),
(14,1081,6),
(14,317,5),
(14,565,1),
(14,566,1),
(14,567,1),
(14,568,1),
(14,569,1),
(14,16,7),
(14,783,1),
(14,784,1),
(14,558,2),
(14,329,3),
(14,785,1),
(14,786,1),
(14,6,3),
(14,7,1),
(14,10,1),
(14,9,1),
(14,787,1),
(14,788,1),
(14,789,1),
(14,23,2),
(14,790,1),
(14,682,1),
(14,32,1),
(14,683,1),
(14,684,1),
(14,685,1),
(14,686,1),
(14,687,1),
(14,791,1),
(14,792,1),
(14,793,1),
(14,794,1),
(14,409,3),
(14,795,1),
(14,796,1),
(14,42,3),
(14,797,1),
(14,696,1),
(14,798,1),
(14,799,1),
(14,41,3),
(14,43,1),
(14,44,1),
(14,45,1),
(14,46,1),
(14,47,2),
(14,48,1),
(14,318,2),
(14,319,2),
(14,320,2),
(14,321,2),
(14,322,2),
(14,323,2),
(14,324,2),
(14,325,2),
(14,326,2),
(14,327,2),
(14,15,3),
(14,328,2),
(14,31,4),
(14,330,2),
(14,36,2),
(14,37,2),
(14,38,2),
(14,39,2),
(14,40,2),
(14,407,2),
(14,408,2),
(14,410,1),
(14,27,1),
(14,411,1),
(14,412,1),
(14,22,4),
(14,413,1),
(14,5,1),
(14,12,1),
(14,414,1),
(14,415,1),
(14,416,1),
(14,417,1),
(14,418,1),
(14,49,3),
(14,419,1),
(14,420,1),
(14,421,1),
(14,422,1),
(14,33,1),
(14,50,1),
(14,51,1),
(14,52,1),
(14,53,1),
(14,54,1),
(14,1082,6),
(14,1083,6),
(14,1084,6),
(14,1085,6),
(14,335,5),
(14,592,1),
(14,593,1),
(14,594,1),
(14,595,1),
(14,73,12),
(14,596,1),
(14,77,7),
(14,805,1),
(14,806,1),
(14,585,2),
(14,347,3),
(14,807,1),
(14,808,1),
(14,66,3),
(14,67,1),
(14,70,1),
(14,69,1),
(14,809,1),
(14,810,1),
(14,811,1),
(14,84,2),
(14,812,1),
(14,702,1),
(14,93,1),
(14,703,1),
(14,704,1),
(14,705,1),
(14,706,1),
(14,707,1),
(14,106,6),
(14,813,1),
(14,814,1),
(14,815,1),
(14,816,1),
(14,430,3),
(14,817,1),
(14,818,1),
(14,103,3),
(14,819,1),
(14,716,1),
(14,820,1),
(14,821,1),
(14,102,3),
(14,104,1),
(14,105,1),
(14,107,1),
(14,108,1),
(14,109,2),
(14,110,1),
(14,336,2),
(14,337,2),
(14,338,2),
(14,339,2),
(14,340,2),
(14,341,2),
(14,342,2),
(14,343,2),
(14,344,2),
(14,345,2),
(14,76,3),
(14,346,2),
(14,92,4),
(14,348,2),
(14,97,2),
(14,98,2),
(14,99,2),
(14,100,2),
(14,101,2),
(14,428,2),
(14,429,2),
(14,431,1),
(14,88,1),
(14,432,1),
(14,433,1),
(14,83,1),
(14,434,1),
(14,65,1),
(14,72,1),
(14,435,1),
(14,436,1),
(14,437,1),
(14,438,1),
(14,439,1),
(14,111,3),
(14,440,1),
(14,441,1),
(14,442,1),
(14,443,1),
(14,94,1),
(14,112,1),
(14,113,1),
(14,114,1),
(14,115,1),
(14,116,1),
(14,117,3),
(14,1086,6),
(14,1087,6),
(14,1088,6),
(14,1089,6),
(14,353,5),
(14,619,1),
(14,620,1),
(14,621,1),
(14,622,1),
(14,136,12),
(14,623,1),
(14,140,7),
(14,827,1),
(14,828,1),
(14,612,2),
(14,365,3),
(14,829,1),
(14,830,1),
(14,129,3),
(14,130,1),
(14,133,1),
(14,132,1),
(14,831,1),
(14,832,1),
(14,833,1),
(14,147,2),
(14,834,1),
(14,722,1),
(14,156,1),
(14,723,1),
(14,724,1),
(14,725,1),
(14,726,1),
(14,727,1),
(14,169,6),
(14,835,1),
(14,836,1),
(14,837,1),
(14,838,1),
(14,451,3),
(14,839,1),
(14,840,1),
(14,166,3),
(14,841,1),
(14,736,1),
(14,842,1),
(14,843,1),
(14,165,3),
(14,167,1),
(14,168,1),
(14,170,1),
(14,171,1),
(14,172,2),
(14,173,1),
(14,354,2),
(14,355,2),
(14,356,2),
(14,357,2),
(14,358,2),
(14,359,2),
(14,360,2),
(14,361,2),
(14,362,2),
(14,363,2),
(14,139,3),
(14,364,2),
(14,155,4),
(14,366,2),
(14,160,2),
(14,161,2),
(14,162,2),
(14,163,2),
(14,164,2),
(14,449,2),
(14,450,2),
(14,452,1),
(14,151,1),
(14,453,1),
(14,454,1),
(14,146,1),
(14,455,1),
(14,128,1),
(14,135,1),
(14,456,1),
(14,457,1),
(14,458,1),
(14,459,1),
(14,460,1),
(14,174,3),
(14,461,1),
(14,462,1),
(14,463,1),
(14,464,1),
(14,157,1),
(14,175,1),
(14,176,1),
(14,177,1),
(14,178,1),
(14,179,1),
(14,180,3),
(14,1090,6),
(14,1091,6),
(14,1092,6),
(14,1093,6),
(14,371,5),
(14,646,1),
(14,647,1),
(14,648,1),
(14,649,1),
(14,199,12),
(14,650,1),
(14,203,7),
(14,849,1),
(14,850,1),
(14,639,2),
(14,383,3),
(14,851,1),
(14,852,1),
(14,192,3),
(14,193,1),
(14,196,1),
(14,195,1),
(14,853,1),
(14,854,1),
(14,855,1),
(14,210,2),
(14,856,1),
(14,742,1),
(14,219,1),
(14,743,1),
(14,744,1),
(14,745,1),
(14,746,1),
(14,747,1),
(14,232,6),
(14,857,1),
(14,858,1),
(14,859,1),
(14,860,1),
(14,472,3),
(14,861,1),
(14,862,1),
(14,229,3),
(14,863,1),
(14,756,1),
(14,864,1),
(14,865,1),
(14,228,3),
(14,230,1),
(14,231,1),
(14,233,1),
(14,234,1),
(14,235,2),
(14,236,1),
(14,372,2),
(14,373,2),
(14,374,2),
(14,375,2),
(14,376,2),
(14,377,2),
(14,378,2),
(14,379,2),
(14,380,2),
(14,381,2),
(14,202,3),
(14,382,2),
(14,218,4),
(14,384,2),
(14,223,2),
(14,224,2),
(14,225,2),
(14,226,2),
(14,227,2),
(14,470,2),
(14,471,2),
(14,473,1),
(14,214,1),
(14,474,1),
(14,475,1),
(14,209,1),
(14,476,1),
(14,191,1),
(14,198,1),
(14,477,1),
(14,478,1),
(14,479,1),
(14,480,1),
(14,481,1),
(14,237,3),
(14,482,1),
(14,483,1),
(14,484,1),
(14,485,1),
(14,220,1),
(14,238,1),
(14,239,1),
(14,240,1),
(14,241,1),
(14,242,1),
(14,243,3),
(14,1094,6),
(14,1095,6),
(14,1096,6),
(14,1097,6),
(14,389,5),
(14,673,1),
(14,674,1),
(14,675,1),
(14,676,1),
(14,262,12),
(14,677,1),
(14,266,7),
(14,871,1),
(14,872,1),
(14,666,2),
(14,401,3),
(14,873,1),
(14,874,1),
(14,255,3),
(14,256,1),
(14,259,1),
(14,258,1),
(14,875,1),
(14,876,1),
(14,877,1),
(14,273,2),
(14,878,1),
(14,762,1),
(14,282,1),
(14,763,1),
(14,764,1),
(14,765,1),
(14,766,1),
(14,767,1),
(14,295,6),
(14,879,1),
(14,880,1),
(14,881,1),
(14,882,1),
(14,493,3),
(14,883,1),
(14,884,1),
(14,292,3),
(14,885,1),
(14,776,1),
(14,886,1),
(14,887,1),
(14,291,3),
(14,293,1),
(14,294,1),
(14,296,1),
(14,297,1),
(14,298,2),
(14,299,1),
(14,390,2),
(14,391,2),
(14,392,2),
(14,393,2),
(14,394,2),
(14,395,2),
(14,396,2),
(14,397,2),
(14,398,2),
(14,399,2),
(14,265,3),
(14,400,2),
(14,281,4),
(14,402,2),
(14,286,2),
(14,287,2),
(14,288,2),
(14,289,2),
(14,290,2),
(14,491,2),
(14,492,2),
(14,494,1),
(14,277,1),
(14,495,1),
(14,496,1),
(14,272,4),
(14,497,1),
(14,254,1),
(14,261,1),
(14,498,1),
(14,499,1),
(14,500,1),
(14,501,1),
(14,502,1),
(14,300,3),
(14,503,1),
(14,504,1),
(14,505,1),
(14,506,1),
(14,283,1),
(14,301,1),
(14,302,1),
(14,303,1),
(14,304,1),
(14,305,1),
(14,306,3),
(15,1078,6),
(15,1098,6),
(15,1099,6),
(15,16,7),
(15,783,1),
(15,784,1),
(15,558,2),
(15,329,1),
(15,785,1),
(15,786,1),
(15,6,5),
(15,7,1),
(15,10,1),
(15,9,1),
(15,787,1),
(15,788,1),
(15,789,1),
(15,23,3),
(15,790,1),
(15,682,1),
(15,32,2),
(15,683,1),
(15,684,1),
(15,685,1),
(15,686,1),
(15,687,1),
(15,791,1),
(15,792,1),
(15,793,1),
(15,794,1),
(15,409,5),
(15,795,1),
(15,796,1),
(15,42,3),
(15,797,1),
(15,696,1),
(15,798,1),
(15,799,1),
(15,36,2),
(15,37,2),
(15,38,2),
(15,39,2),
(15,40,2),
(15,31,2),
(15,414,2),
(15,15,2),
(15,415,2),
(15,416,2),
(15,417,2),
(15,418,2),
(15,49,6),
(15,419,2),
(15,420,2),
(15,47,2),
(15,421,2),
(15,422,2),
(15,407,4),
(15,317,4),
(15,408,4),
(15,410,2),
(15,27,2),
(15,411,2),
(15,412,2),
(15,22,5),
(15,413,2),
(15,5,2),
(15,12,2),
(15,33,2),
(15,50,2),
(15,51,2),
(15,52,2),
(15,53,2),
(15,54,2),
(15,319,1),
(15,510,1),
(15,511,1),
(15,512,1),
(15,1082,6),
(15,1100,6),
(15,1101,6),
(15,77,7),
(15,805,1),
(15,73,12),
(15,806,1),
(15,585,2),
(15,347,1),
(15,807,1),
(15,808,1),
(15,66,5),
(15,67,1),
(15,70,1),
(15,69,1),
(15,809,1),
(15,810,1),
(15,811,1),
(15,84,3),
(15,812,1),
(15,702,1),
(15,93,2),
(15,703,1),
(15,704,1),
(15,705,1),
(15,706,1),
(15,707,1),
(15,106,4),
(15,813,1),
(15,814,1),
(15,815,1),
(15,816,1),
(15,430,5),
(15,817,1),
(15,818,1),
(15,103,3),
(15,819,1),
(15,716,1),
(15,820,1),
(15,821,1),
(15,97,2),
(15,98,2),
(15,99,2),
(15,100,2),
(15,101,2),
(15,92,2),
(15,435,2),
(15,76,2),
(15,436,2),
(15,437,2),
(15,438,2),
(15,439,2),
(15,111,6),
(15,440,2),
(15,441,2),
(15,109,2),
(15,442,2),
(15,443,2),
(15,428,4),
(15,335,4),
(15,429,4),
(15,431,2),
(15,88,2),
(15,432,2),
(15,433,2),
(15,83,2),
(15,434,2),
(15,65,2),
(15,72,2),
(15,94,2),
(15,112,2),
(15,113,2),
(15,114,2),
(15,115,2),
(15,116,2),
(15,337,1),
(15,517,1),
(15,518,1),
(15,519,1),
(15,117,3),
(15,1086,6),
(15,1102,6),
(15,1103,6),
(15,140,7),
(15,827,1),
(15,136,12),
(15,828,1),
(15,612,2),
(15,365,1),
(15,829,1),
(15,830,1),
(15,129,5),
(15,130,1),
(15,133,1),
(15,132,1),
(15,831,1),
(15,832,1),
(15,833,1),
(15,147,3),
(15,834,1),
(15,722,1),
(15,156,2),
(15,723,1),
(15,724,1),
(15,725,1),
(15,726,1),
(15,727,1),
(15,169,4),
(15,835,1),
(15,836,1),
(15,837,1),
(15,838,1),
(15,451,5),
(15,839,1),
(15,840,1),
(15,166,3),
(15,841,1),
(15,736,1),
(15,842,1),
(15,843,1),
(15,160,2),
(15,161,2),
(15,162,2),
(15,163,2),
(15,164,2),
(15,155,2),
(15,456,2),
(15,139,2),
(15,457,2),
(15,458,2),
(15,459,2),
(15,460,2),
(15,174,6),
(15,461,2),
(15,462,2),
(15,172,2),
(15,463,2),
(15,464,2),
(15,449,4),
(15,353,4),
(15,450,4),
(15,452,2),
(15,151,2),
(15,453,2),
(15,454,2),
(15,146,2),
(15,455,2),
(15,128,2),
(15,135,2),
(15,157,2),
(15,175,2),
(15,176,2),
(15,177,2),
(15,178,2),
(15,179,2),
(15,355,1),
(15,524,1),
(15,525,1),
(15,526,1),
(15,180,3),
(15,1090,6),
(15,1104,6),
(15,1105,6),
(15,203,7),
(15,849,1),
(15,199,12),
(15,850,1),
(15,639,2),
(15,383,1),
(15,851,1),
(15,852,1),
(15,192,5),
(15,193,1),
(15,196,1),
(15,195,1),
(15,853,1),
(15,854,1),
(15,855,1),
(15,210,3),
(15,856,1),
(15,742,1),
(15,219,2),
(15,743,1),
(15,744,1),
(15,745,1),
(15,746,1),
(15,747,1),
(15,232,4),
(15,857,1),
(15,858,1),
(15,859,1),
(15,860,1),
(15,472,5),
(15,861,1),
(15,862,1),
(15,229,3),
(15,863,1),
(15,756,1),
(15,864,1),
(15,865,1),
(15,223,2),
(15,224,2),
(15,225,2),
(15,226,2),
(15,227,2),
(15,218,2),
(15,477,2),
(15,202,2),
(15,478,2),
(15,479,2),
(15,480,2),
(15,481,2),
(15,237,6),
(15,482,2),
(15,483,2),
(15,235,2),
(15,484,2),
(15,485,2),
(15,470,4),
(15,371,4),
(15,471,4),
(15,473,2),
(15,214,2),
(15,474,2),
(15,475,2),
(15,209,2),
(15,476,2),
(15,191,2),
(15,198,2),
(15,220,2),
(15,238,2),
(15,239,2),
(15,240,2),
(15,241,2),
(15,242,2),
(15,373,1),
(15,531,1),
(15,532,1),
(15,533,1),
(15,243,3),
(15,1094,6),
(15,1106,6),
(15,1107,6),
(15,266,7),
(15,871,1),
(15,262,12),
(15,872,1),
(15,666,2),
(15,401,1),
(15,873,1),
(15,874,1),
(15,255,5),
(15,256,1),
(15,259,1),
(15,258,1),
(15,875,1),
(15,876,1),
(15,877,1),
(15,273,3),
(15,878,1),
(15,762,1),
(15,282,2),
(15,763,1),
(15,764,1),
(15,765,1),
(15,766,1),
(15,767,1),
(15,295,4),
(15,879,1),
(15,880,1),
(15,881,1),
(15,882,1),
(15,493,5),
(15,883,1),
(15,884,1),
(15,292,3),
(15,885,1),
(15,776,1),
(15,886,1),
(15,887,1),
(15,286,2),
(15,287,2),
(15,288,2),
(15,289,2),
(15,290,2),
(15,281,2),
(15,498,2),
(15,265,2),
(15,499,2),
(15,500,2),
(15,501,2),
(15,502,2),
(15,300,6),
(15,503,2),
(15,504,2),
(15,298,2),
(15,505,2),
(15,506,2),
(15,491,4),
(15,389,4),
(15,492,4),
(15,494,2),
(15,277,2),
(15,495,2),
(15,496,2),
(15,272,5),
(15,497,2),
(15,254,2),
(15,261,2),
(15,283,2),
(15,301,2),
(15,302,2),
(15,303,2),
(15,304,2),
(15,305,2),
(15,391,1),
(15,538,1),
(15,539,1),
(15,540,1),
(15,306,3),
(16,1078,6),
(16,1108,6),
(16,1109,6),
(16,682,1),
(16,558,2),
(16,32,3),
(16,683,1),
(16,684,1),
(16,685,1),
(16,686,1),
(16,687,1),
(16,791,1),
(16,792,1),
(16,793,1),
(16,794,1),
(16,409,3),
(16,795,1),
(16,796,1),
(16,42,3),
(16,797,1),
(16,696,2),
(16,798,1),
(16,799,1),
(16,49,4),
(16,553,2),
(16,554,2),
(16,555,2),
(16,556,2),
(16,16,7),
(16,557,2),
(16,317,6),
(16,898,1),
(16,318,1),
(16,27,2),
(16,899,1),
(16,900,1),
(16,33,3),
(16,901,1),
(16,902,1),
(16,903,1),
(16,408,4),
(16,904,1),
(16,905,1),
(16,906,1),
(16,907,1),
(16,908,1),
(16,407,2),
(16,410,1),
(16,411,1),
(16,412,1),
(16,22,4),
(16,23,1),
(16,413,2),
(16,5,1),
(16,12,1),
(16,50,2),
(16,51,2),
(16,52,2),
(16,53,2),
(16,54,2),
(16,319,3),
(16,510,2),
(16,511,2),
(16,512,2),
(16,9,2),
(16,547,2),
(16,548,2),
(16,549,2),
(16,15,3),
(16,550,2),
(16,6,2),
(16,551,2),
(16,24,2),
(16,552,2),
(16,420,1),
(16,329,1),
(16,559,1),
(16,47,1),
(16,560,1),
(16,561,1),
(16,562,1),
(16,563,1),
(16,564,1),
(16,565,1),
(16,566,1),
(16,567,1),
(16,568,1),
(16,569,1),
(16,1082,6),
(16,1110,6),
(16,1111,6),
(16,702,1),
(16,585,2),
(16,93,3),
(16,703,1),
(16,704,1),
(16,73,8),
(16,705,1),
(16,706,1),
(16,707,1),
(16,106,4),
(16,813,1),
(16,814,1),
(16,815,1),
(16,816,1),
(16,430,3),
(16,817,1),
(16,818,1),
(16,103,3),
(16,819,1),
(16,716,2),
(16,820,1),
(16,821,1),
(16,111,4),
(16,580,2),
(16,581,2),
(16,582,2),
(16,583,2),
(16,77,7),
(16,584,2),
(16,335,6),
(16,919,1),
(16,336,1),
(16,88,2),
(16,920,1),
(16,921,1),
(16,94,3),
(16,922,1),
(16,923,1),
(16,924,1),
(16,429,4),
(16,925,1),
(16,926,1),
(16,927,1),
(16,928,1),
(16,929,1),
(16,428,2),
(16,431,1),
(16,432,1),
(16,433,1),
(16,83,1),
(16,84,1),
(16,434,2),
(16,65,1),
(16,72,1),
(16,112,2),
(16,113,2),
(16,114,2),
(16,115,2),
(16,116,2),
(16,337,3),
(16,517,2),
(16,518,2),
(16,519,2),
(16,69,2),
(16,574,2),
(16,575,2),
(16,576,2),
(16,76,3),
(16,577,2),
(16,66,2),
(16,578,2),
(16,85,2),
(16,579,2),
(16,441,1),
(16,347,1),
(16,586,1),
(16,109,1),
(16,587,1),
(16,588,1),
(16,589,1),
(16,590,1),
(16,591,1),
(16,592,1),
(16,593,1),
(16,594,1),
(16,595,1),
(16,596,1),
(16,117,3),
(16,1086,6),
(16,1112,6),
(16,1113,6),
(16,722,1),
(16,612,2),
(16,156,3),
(16,723,1),
(16,724,1),
(16,136,8),
(16,725,1),
(16,726,1),
(16,727,1),
(16,169,4),
(16,835,1),
(16,836,1),
(16,837,1),
(16,838,1),
(16,451,3),
(16,839,1),
(16,840,1),
(16,166,3),
(16,841,1),
(16,736,2),
(16,842,1),
(16,843,1),
(16,174,4),
(16,607,2),
(16,608,2),
(16,609,2),
(16,610,2),
(16,140,7),
(16,611,2),
(16,353,6),
(16,940,1),
(16,354,1),
(16,151,2),
(16,941,1),
(16,942,1),
(16,157,3),
(16,943,1),
(16,944,1),
(16,945,1),
(16,450,4),
(16,946,1),
(16,947,1),
(16,948,1),
(16,949,1),
(16,950,1),
(16,449,2),
(16,452,1),
(16,453,1),
(16,454,1),
(16,146,1),
(16,147,1),
(16,455,2),
(16,128,1),
(16,135,1),
(16,175,2),
(16,176,2),
(16,177,2),
(16,178,2),
(16,179,2),
(16,355,3),
(16,524,2),
(16,525,2),
(16,526,2),
(16,132,2),
(16,601,2),
(16,602,2),
(16,603,2),
(16,139,3),
(16,604,2),
(16,129,2),
(16,605,2),
(16,148,2),
(16,606,2),
(16,462,1),
(16,365,1),
(16,613,1),
(16,172,1),
(16,614,1),
(16,615,1),
(16,616,1),
(16,617,1),
(16,618,1),
(16,619,1),
(16,620,1),
(16,621,1),
(16,622,1),
(16,623,1),
(16,180,3),
(16,1090,6),
(16,1114,6),
(16,1115,6),
(16,742,1),
(16,639,2),
(16,219,3),
(16,743,1),
(16,744,1),
(16,199,8),
(16,745,1),
(16,746,1),
(16,747,1),
(16,232,4),
(16,857,1),
(16,858,1),
(16,859,1),
(16,860,1),
(16,472,3),
(16,861,1),
(16,862,1),
(16,229,3),
(16,863,1),
(16,756,2),
(16,864,1),
(16,865,1),
(16,237,4),
(16,634,2),
(16,635,2),
(16,636,2),
(16,637,2),
(16,203,7),
(16,638,2),
(16,371,6),
(16,961,1),
(16,372,1),
(16,214,2),
(16,962,1),
(16,963,1),
(16,220,3),
(16,964,1),
(16,965,1),
(16,966,1),
(16,471,4),
(16,967,1),
(16,968,1),
(16,969,1),
(16,970,1),
(16,971,1),
(16,470,2),
(16,473,1),
(16,474,1),
(16,475,1),
(16,209,1),
(16,210,1),
(16,476,2),
(16,191,1),
(16,198,1),
(16,238,2),
(16,239,2),
(16,240,2),
(16,241,2),
(16,242,2),
(16,373,3),
(16,531,2),
(16,532,2),
(16,533,2),
(16,195,2),
(16,628,2),
(16,629,2),
(16,630,2),
(16,202,3),
(16,631,2),
(16,192,2),
(16,632,2),
(16,211,2),
(16,633,2),
(16,483,1),
(16,383,1),
(16,640,1),
(16,235,1),
(16,641,1),
(16,642,1),
(16,643,1),
(16,644,1),
(16,645,1),
(16,646,1),
(16,647,1),
(16,648,1),
(16,649,1),
(16,650,1),
(16,243,3),
(16,1094,6),
(16,1116,6),
(16,1117,6),
(16,762,1),
(16,666,2),
(16,282,3),
(16,763,1),
(16,764,1),
(16,262,8),
(16,765,1),
(16,766,1),
(16,767,1),
(16,295,4),
(16,879,1),
(16,880,1),
(16,881,1),
(16,882,1),
(16,493,3),
(16,883,1),
(16,884,1),
(16,292,3),
(16,885,1),
(16,776,2),
(16,886,1),
(16,887,1),
(16,300,4),
(16,661,2),
(16,662,2),
(16,663,2),
(16,664,2),
(16,266,7),
(16,665,2),
(16,389,6),
(16,982,1),
(16,390,1),
(16,277,2),
(16,983,1),
(16,984,1),
(16,283,3),
(16,985,1),
(16,986,1),
(16,987,1),
(16,492,4),
(16,988,1),
(16,989,1),
(16,990,1),
(16,991,1),
(16,992,1),
(16,491,2),
(16,494,1),
(16,495,1),
(16,496,1),
(16,272,4),
(16,273,1),
(16,497,2),
(16,254,1),
(16,261,1),
(16,301,2),
(16,302,2),
(16,303,2),
(16,304,2),
(16,305,2),
(16,391,3),
(16,538,2),
(16,539,2),
(16,540,2),
(16,258,2),
(16,655,2),
(16,656,2),
(16,657,2),
(16,265,3),
(16,658,2),
(16,255,2),
(16,659,2),
(16,274,2),
(16,660,2),
(16,504,1),
(16,401,1),
(16,667,1),
(16,298,1),
(16,668,1),
(16,669,1),
(16,670,1),
(16,671,1),
(16,672,1),
(16,673,1),
(16,674,1),
(16,675,1),
(16,676,1),
(16,677,1),
(16,306,3),
(17,1118,6),
(17,1119,6),
(17,1120,6),
(17,1121,6),
(17,780,6),
(17,1122,6),
(17,791,1),
(17,792,1),
(17,793,1),
(17,794,1),
(17,409,1),
(17,795,1),
(17,796,1),
(17,42,3),
(17,797,1),
(17,696,3),
(17,798,1),
(17,799,1),
(17,49,2),
(17,553,1),
(17,554,1),
(17,555,1),
(17,556,1),
(17,16,7),
(17,557,1),
(17,317,8),
(17,898,1),
(17,318,1),
(17,27,1),
(17,899,1),
(17,900,1),
(17,33,2),
(17,901,1),
(17,902,1),
(17,903,1),
(17,408,5),
(17,904,1),
(17,905,1),
(17,906,1),
(17,907,1),
(17,908,1),
(17,50,1),
(17,51,1),
(17,52,1),
(17,53,1),
(17,54,1),
(17,319,3),
(17,510,1),
(17,511,1),
(17,32,3),
(17,512,1),
(17,9,2),
(17,547,2),
(17,548,2),
(17,549,2),
(17,15,4),
(17,550,2),
(17,6,2),
(17,551,2),
(17,24,2),
(17,552,2),
(17,420,2),
(17,558,4),
(17,329,2),
(17,413,2),
(17,559,2),
(17,47,2),
(17,560,2),
(17,561,2),
(17,562,2),
(17,563,2),
(17,564,2),
(17,565,2),
(17,566,2),
(17,567,2),
(17,568,2),
(17,569,2),
(17,682,2),
(17,683,1),
(17,684,1),
(17,685,1),
(17,686,1),
(17,687,1),
(17,688,1),
(17,689,1),
(17,690,1),
(17,48,1),
(17,10,1),
(17,691,1),
(17,692,1),
(17,693,1),
(17,694,1),
(17,695,1),
(17,697,1),
(17,22,3),
(17,1123,6),
(17,1124,6),
(17,1125,6),
(17,1126,6),
(17,802,6),
(17,1127,6),
(17,106,3),
(17,813,1),
(17,814,1),
(17,815,1),
(17,816,1),
(17,430,1),
(17,817,1),
(17,818,1),
(17,103,3),
(17,819,1),
(17,73,10),
(17,716,3),
(17,820,1),
(17,821,1),
(17,111,2),
(17,580,1),
(17,581,1),
(17,582,1),
(17,583,1),
(17,77,7),
(17,584,1),
(17,335,8),
(17,919,1),
(17,336,1),
(17,88,1),
(17,920,1),
(17,921,1),
(17,94,2),
(17,922,1),
(17,923,1),
(17,924,1),
(17,429,5),
(17,925,1),
(17,926,1),
(17,927,1),
(17,928,1),
(17,929,1),
(17,112,1),
(17,113,1),
(17,114,1),
(17,115,1),
(17,116,1),
(17,337,3),
(17,517,1),
(17,518,1),
(17,93,3),
(17,519,1),
(17,69,2),
(17,574,2),
(17,575,2),
(17,576,2),
(17,76,4),
(17,577,2),
(17,66,2),
(17,578,2),
(17,85,2),
(17,579,2),
(17,441,2),
(17,585,4),
(17,347,2),
(17,434,2),
(17,586,2),
(17,109,2),
(17,587,2),
(17,588,2),
(17,589,2),
(17,590,2),
(17,591,2),
(17,592,2),
(17,593,2),
(17,594,2),
(17,595,2),
(17,596,2),
(17,702,2),
(17,703,1),
(17,704,1),
(17,705,1),
(17,706,1),
(17,707,1),
(17,708,1),
(17,709,1),
(17,710,1),
(17,110,1),
(17,70,1),
(17,711,1),
(17,712,1),
(17,713,1),
(17,714,1),
(17,715,1),
(17,717,1),
(17,117,3),
(17,1128,6),
(17,1129,6),
(17,1130,6),
(17,1131,6),
(17,824,6),
(17,1132,6),
(17,169,3),
(17,835,1),
(17,836,1),
(17,837,1),
(17,838,1),
(17,451,1),
(17,839,1),
(17,840,1),
(17,166,3),
(17,841,1),
(17,136,10),
(17,736,3),
(17,842,1),
(17,843,1),
(17,174,2),
(17,607,1),
(17,608,1),
(17,609,1),
(17,610,1),
(17,140,7),
(17,611,1),
(17,353,8),
(17,940,1),
(17,354,1),
(17,151,1),
(17,941,1),
(17,942,1),
(17,157,2),
(17,943,1),
(17,944,1),
(17,945,1),
(17,450,5),
(17,946,1),
(17,947,1),
(17,948,1),
(17,949,1),
(17,950,1),
(17,175,1),
(17,176,1),
(17,177,1),
(17,178,1),
(17,179,1),
(17,355,3),
(17,524,1),
(17,525,1),
(17,156,3),
(17,526,1),
(17,132,2),
(17,601,2),
(17,602,2),
(17,603,2),
(17,139,4),
(17,604,2),
(17,129,2),
(17,605,2),
(17,148,2),
(17,606,2),
(17,462,2),
(17,612,4),
(17,365,2),
(17,455,2),
(17,613,2),
(17,172,2),
(17,614,2),
(17,615,2),
(17,616,2),
(17,617,2),
(17,618,2),
(17,619,2),
(17,620,2),
(17,621,2),
(17,622,2),
(17,623,2),
(17,722,2),
(17,723,1),
(17,724,1),
(17,725,1),
(17,726,1),
(17,727,1),
(17,728,1),
(17,729,1),
(17,730,1),
(17,173,1),
(17,133,1),
(17,731,1),
(17,732,1),
(17,733,1),
(17,734,1),
(17,735,1),
(17,737,1),
(17,180,3),
(17,1133,6),
(17,1134,6),
(17,1135,6),
(17,1136,6),
(17,846,6),
(17,1137,6),
(17,232,3),
(17,857,1),
(17,858,1),
(17,859,1),
(17,860,1),
(17,472,1),
(17,861,1),
(17,862,1),
(17,229,3),
(17,863,1),
(17,199,10),
(17,756,3),
(17,864,1),
(17,865,1),
(17,237,2),
(17,634,1),
(17,635,1),
(17,636,1),
(17,637,1),
(17,203,7),
(17,638,1),
(17,371,8),
(17,961,1),
(17,372,1),
(17,214,1),
(17,962,1),
(17,963,1),
(17,220,2),
(17,964,1),
(17,965,1),
(17,966,1),
(17,471,5),
(17,967,1),
(17,968,1),
(17,969,1),
(17,970,1),
(17,971,1),
(17,238,1),
(17,239,1),
(17,240,1),
(17,241,1),
(17,242,1),
(17,373,3),
(17,531,1),
(17,532,1),
(17,219,3),
(17,533,1),
(17,195,2),
(17,628,2),
(17,629,2),
(17,630,2),
(17,202,4),
(17,631,2),
(17,192,2),
(17,632,2),
(17,211,2),
(17,633,2),
(17,483,2),
(17,639,4),
(17,383,2),
(17,476,2),
(17,640,2),
(17,235,2),
(17,641,2),
(17,642,2),
(17,643,2),
(17,644,2),
(17,645,2),
(17,646,2),
(17,647,2),
(17,648,2),
(17,649,2),
(17,650,2),
(17,742,2),
(17,743,1),
(17,744,1),
(17,745,1),
(17,746,1),
(17,747,1),
(17,748,1),
(17,749,1),
(17,750,1),
(17,236,1),
(17,196,1),
(17,751,1),
(17,752,1),
(17,753,1),
(17,754,1),
(17,755,1),
(17,757,1),
(17,243,3),
(17,1138,6),
(17,1139,6),
(17,1140,6),
(17,1141,6),
(17,868,6),
(17,1142,6),
(17,295,3),
(17,879,1),
(17,880,1),
(17,881,1),
(17,882,1),
(17,493,1),
(17,883,1),
(17,884,1),
(17,292,3),
(17,885,1),
(17,262,10),
(17,776,3),
(17,886,1),
(17,887,1),
(17,300,2),
(17,661,1),
(17,662,1),
(17,663,1),
(17,664,1),
(17,266,7),
(17,665,1),
(17,389,8),
(17,982,1),
(17,390,1),
(17,277,1),
(17,983,1),
(17,984,1),
(17,283,2),
(17,985,1),
(17,986,1),
(17,987,1),
(17,492,5),
(17,988,1),
(17,989,1),
(17,990,1),
(17,991,1),
(17,992,1),
(17,301,1),
(17,302,1),
(17,303,1),
(17,304,1),
(17,305,1),
(17,391,3),
(17,538,1),
(17,539,1),
(17,282,3),
(17,540,1),
(17,258,2),
(17,655,2),
(17,656,2),
(17,657,2),
(17,265,4),
(17,658,2),
(17,255,2),
(17,659,2),
(17,274,2),
(17,660,2),
(17,504,2),
(17,666,4),
(17,401,2),
(17,497,2),
(17,667,2),
(17,298,2),
(17,668,2),
(17,669,2),
(17,670,2),
(17,671,2),
(17,672,2),
(17,673,2),
(17,674,2),
(17,675,2),
(17,676,2),
(17,677,2),
(17,762,2),
(17,763,1),
(17,764,1),
(17,765,1),
(17,766,1),
(17,767,1),
(17,768,1),
(17,769,1),
(17,770,1),
(17,299,1),
(17,259,1),
(17,771,1),
(17,772,1),
(17,773,1),
(17,774,1),
(17,775,1),
(17,777,1),
(17,272,3),
(17,306,3),
(18,403,6),
(18,1143,6),
(18,1144,6),
(18,1145,6),
(18,1146,6),
(18,49,2),
(18,553,2),
(18,554,2),
(18,555,2),
(18,556,2),
(18,16,8),
(18,557,2),
(18,317,7),
(18,898,1),
(18,318,1),
(18,27,1),
(18,899,1),
(18,900,1),
(18,33,1),
(18,901,1),
(18,902,1),
(18,696,3),
(18,903,1),
(18,408,4),
(18,904,1),
(18,905,1),
(18,906,1),
(18,907,1),
(18,908,1),
(18,682,2),
(18,688,1),
(18,689,1),
(18,690,1),
(18,48,1),
(18,10,3),
(18,691,1),
(18,558,5),
(18,32,3),
(18,692,1),
(18,693,1),
(18,694,1),
(18,695,1),
(18,697,1),
(18,319,2),
(18,510,1),
(18,511,1),
(18,512,1),
(18,420,1),
(18,329,3),
(18,413,1),
(18,559,1),
(18,47,1),
(18,560,1),
(18,561,1),
(18,562,1),
(18,15,1),
(18,563,1),
(18,564,1),
(18,565,2),
(18,566,2),
(18,567,2),
(18,568,2),
(18,569,2),
(18,783,2),
(18,784,2),
(18,785,2),
(18,786,2),
(18,6,2),
(18,7,2),
(18,9,2),
(18,787,2),
(18,788,2),
(18,789,2),
(18,23,2),
(18,790,2),
(18,683,1),
(18,684,1),
(18,685,1),
(18,686,1),
(18,687,1),
(18,791,1),
(18,792,1),
(18,793,1),
(18,794,1),
(18,409,1),
(18,795,1),
(18,796,1),
(18,42,1),
(18,797,1),
(18,798,1),
(18,799,1),
(18,22,3),
(18,424,6),
(18,1147,6),
(18,1148,6),
(18,1149,6),
(18,1150,6),
(18,111,2),
(18,580,2),
(18,581,2),
(18,582,2),
(18,583,2),
(18,77,8),
(18,584,2),
(18,335,7),
(18,919,1),
(18,336,1),
(18,88,1),
(18,920,1),
(18,921,1),
(18,94,1),
(18,922,1),
(18,923,1),
(18,73,12),
(18,716,3),
(18,924,1),
(18,429,4),
(18,925,1),
(18,926,1),
(18,927,1),
(18,928,1),
(18,929,1),
(18,702,2),
(18,708,1),
(18,709,1),
(18,710,1),
(18,110,1),
(18,70,3),
(18,711,1),
(18,585,5),
(18,93,3),
(18,712,1),
(18,713,1),
(18,714,1),
(18,715,1),
(18,717,1),
(18,337,2),
(18,517,1),
(18,518,1),
(18,519,1),
(18,441,1),
(18,347,3),
(18,434,1),
(18,586,1),
(18,109,1),
(18,587,1),
(18,588,1),
(18,589,1),
(18,76,1),
(18,590,1),
(18,591,1),
(18,592,2),
(18,593,2),
(18,594,2),
(18,595,2),
(18,596,2),
(18,805,2),
(18,806,2),
(18,807,2),
(18,808,2),
(18,66,2),
(18,67,2),
(18,69,2),
(18,809,2),
(18,810,2),
(18,811,2),
(18,84,2),
(18,812,2),
(18,703,1),
(18,704,1),
(18,705,1),
(18,706,1),
(18,707,1),
(18,106,2),
(18,813,1),
(18,814,1),
(18,815,1),
(18,816,1),
(18,430,1),
(18,817,1),
(18,818,1),
(18,103,1),
(18,819,1),
(18,820,1),
(18,821,1),
(18,117,3),
(18,445,6),
(18,1151,6),
(18,1152,6),
(18,1153,6),
(18,1154,6),
(18,174,2),
(18,607,2),
(18,608,2),
(18,609,2),
(18,610,2),
(18,140,8),
(18,611,2),
(18,353,7),
(18,940,1),
(18,354,1),
(18,151,1),
(18,941,1),
(18,942,1),
(18,157,1),
(18,943,1),
(18,944,1),
(18,136,12),
(18,736,3),
(18,945,1),
(18,450,4),
(18,946,1),
(18,947,1),
(18,948,1),
(18,949,1),
(18,950,1),
(18,722,2),
(18,728,1),
(18,729,1),
(18,730,1),
(18,173,1),
(18,133,3),
(18,731,1),
(18,612,5),
(18,156,3),
(18,732,1),
(18,733,1),
(18,734,1),
(18,735,1),
(18,737,1),
(18,355,2),
(18,524,1),
(18,525,1),
(18,526,1),
(18,462,1),
(18,365,3),
(18,455,1),
(18,613,1),
(18,172,1),
(18,614,1),
(18,615,1),
(18,616,1),
(18,139,1),
(18,617,1),
(18,618,1),
(18,619,2),
(18,620,2),
(18,621,2),
(18,622,2),
(18,623,2),
(18,827,2),
(18,828,2),
(18,829,2),
(18,830,2),
(18,129,2),
(18,130,2),
(18,132,2),
(18,831,2),
(18,832,2),
(18,833,2),
(18,147,2),
(18,834,2),
(18,723,1),
(18,724,1),
(18,725,1),
(18,726,1),
(18,727,1),
(18,169,2),
(18,835,1),
(18,836,1),
(18,837,1),
(18,838,1),
(18,451,1),
(18,839,1),
(18,840,1),
(18,166,1),
(18,841,1),
(18,842,1),
(18,843,1),
(18,180,3),
(18,466,6),
(18,1155,6),
(18,1156,6),
(18,1157,6),
(18,1158,6),
(18,237,2),
(18,634,2),
(18,635,2),
(18,636,2),
(18,637,2),
(18,203,8),
(18,638,2),
(18,371,7),
(18,961,1),
(18,372,1),
(18,214,1),
(18,962,1),
(18,963,1),
(18,220,1),
(18,964,1),
(18,965,1),
(18,199,12),
(18,756,3),
(18,966,1),
(18,471,4),
(18,967,1),
(18,968,1),
(18,969,1),
(18,970,1),
(18,971,1),
(18,742,2),
(18,748,1),
(18,749,1),
(18,750,1),
(18,236,1),
(18,196,3),
(18,751,1),
(18,639,5),
(18,219,3),
(18,752,1),
(18,753,1),
(18,754,1),
(18,755,1),
(18,757,1),
(18,373,2),
(18,531,1),
(18,532,1),
(18,533,1),
(18,483,1),
(18,383,3),
(18,476,1),
(18,640,1),
(18,235,1),
(18,641,1),
(18,642,1),
(18,643,1),
(18,202,1),
(18,644,1),
(18,645,1),
(18,646,2),
(18,647,2),
(18,648,2),
(18,649,2),
(18,650,2),
(18,849,2),
(18,850,2),
(18,851,2),
(18,852,2),
(18,192,2),
(18,193,2),
(18,195,2),
(18,853,2),
(18,854,2),
(18,855,2),
(18,210,2),
(18,856,2),
(18,743,1),
(18,744,1),
(18,745,1),
(18,746,1),
(18,747,1),
(18,232,2),
(18,857,1),
(18,858,1),
(18,859,1),
(18,860,1),
(18,472,1),
(18,861,1),
(18,862,1),
(18,229,1),
(18,863,1),
(18,864,1),
(18,865,1),
(18,243,3),
(18,487,6),
(18,1159,6),
(18,1160,6),
(18,1161,6),
(18,1162,6),
(18,300,2),
(18,661,2),
(18,662,2),
(18,663,2),
(18,664,2),
(18,266,8),
(18,665,2),
(18,389,7),
(18,982,1),
(18,390,1),
(18,277,1),
(18,983,1),
(18,984,1),
(18,283,1),
(18,985,1),
(18,986,1),
(18,262,12),
(18,776,3),
(18,987,1),
(18,492,4),
(18,988,1),
(18,989,1),
(18,990,1),
(18,991,1),
(18,992,1),
(18,762,2),
(18,768,1),
(18,769,1),
(18,770,1),
(18,299,1),
(18,259,3),
(18,771,1),
(18,666,5),
(18,282,3),
(18,772,1),
(18,773,1),
(18,774,1),
(18,775,1),
(18,777,1),
(18,391,2),
(18,538,1),
(18,539,1),
(18,540,1),
(18,504,1),
(18,401,3),
(18,497,1),
(18,667,1),
(18,298,1),
(18,668,1),
(18,669,1),
(18,670,1),
(18,265,1),
(18,671,1),
(18,672,1),
(18,673,2),
(18,674,2),
(18,675,2),
(18,676,2),
(18,677,2),
(18,871,2),
(18,872,2),
(18,873,2),
(18,874,2),
(18,255,2),
(18,256,2),
(18,258,2),
(18,875,2),
(18,876,2),
(18,877,2),
(18,273,2),
(18,878,2),
(18,763,1),
(18,764,1),
(18,765,1),
(18,766,1),
(18,767,1),
(18,295,2),
(18,879,1),
(18,880,1),
(18,881,1),
(18,882,1),
(18,493,1),
(18,883,1),
(18,884,1),
(18,292,1),
(18,885,1),
(18,886,1),
(18,887,1),
(18,272,3),
(18,306,3),
(19,403,6),
(19,1163,6),
(19,1164,6),
(19,56,6),
(19,317,7),
(19,898,2),
(19,318,2),
(19,27,2),
(19,899,2),
(19,900,2),
(19,16,9),
(19,33,2),
(19,901,2),
(19,902,2),
(19,696,5),
(19,903,2),
(19,408,5),
(19,904,2),
(19,905,2),
(19,906,2),
(19,907,2),
(19,908,2),
(19,682,3),
(19,688,1),
(19,689,1),
(19,690,1),
(19,48,2),
(19,10,2),
(19,691,1),
(19,558,4),
(19,32,3),
(19,692,1),
(19,693,1),
(19,694,1),
(19,695,1),
(19,697,1),
(19,1015,1),
(19,15,1),
(19,329,2),
(19,1016,1),
(19,1017,1),
(19,1018,1),
(19,6,2),
(19,1019,1),
(19,22,4),
(19,23,2),
(19,783,1),
(19,784,1),
(19,785,1),
(19,786,1),
(19,7,1),
(19,9,1),
(19,787,1),
(19,788,1),
(19,789,1),
(19,790,1),
(19,683,2),
(19,684,2),
(19,685,2),
(19,686,2),
(19,687,2),
(19,791,2),
(19,792,2),
(19,793,2),
(19,794,2),
(19,409,2),
(19,795,2),
(19,796,2),
(19,42,2),
(19,797,2),
(19,798,2),
(19,799,2),
(19,36,1),
(19,37,1),
(19,38,1),
(19,39,1),
(19,40,1),
(19,31,1),
(19,49,1),
(19,553,1),
(19,554,1),
(19,555,1),
(19,556,1),
(19,557,1),
(19,424,6),
(19,1165,6),
(19,1166,6),
(19,119,6),
(19,335,7),
(19,919,2),
(19,336,2),
(19,88,2),
(19,920,2),
(19,921,2),
(19,77,9),
(19,94,2),
(19,922,2),
(19,923,2),
(19,73,12),
(19,716,5),
(19,924,2),
(19,429,5),
(19,925,2),
(19,926,2),
(19,927,2),
(19,928,2),
(19,929,2),
(19,702,3),
(19,708,1),
(19,709,1),
(19,710,1),
(19,110,2),
(19,70,2),
(19,711,1),
(19,585,4),
(19,93,3),
(19,712,1),
(19,713,1),
(19,714,1),
(19,715,1),
(19,717,1),
(19,1022,1),
(19,76,1),
(19,347,2),
(19,1023,1),
(19,1024,1),
(19,1025,1),
(19,66,2),
(19,1026,1),
(19,83,1),
(19,84,2),
(19,805,1),
(19,806,1),
(19,807,1),
(19,808,1),
(19,67,1),
(19,69,1),
(19,809,1),
(19,810,1),
(19,811,1),
(19,812,1),
(19,703,2),
(19,704,2),
(19,705,2),
(19,706,2),
(19,707,2),
(19,106,4),
(19,813,2),
(19,814,2),
(19,815,2),
(19,816,2),
(19,430,2),
(19,817,2),
(19,818,2),
(19,103,2),
(19,819,2),
(19,820,2),
(19,821,2),
(19,97,1),
(19,98,1),
(19,99,1),
(19,100,1),
(19,101,1),
(19,92,1),
(19,111,1),
(19,580,1),
(19,581,1),
(19,582,1),
(19,583,1),
(19,584,1),
(19,117,3),
(19,445,6),
(19,1167,6),
(19,1168,6),
(19,182,6),
(19,353,7),
(19,940,2),
(19,354,2),
(19,151,2),
(19,941,2),
(19,942,2),
(19,140,9),
(19,157,2),
(19,943,2),
(19,944,2),
(19,136,12),
(19,736,5),
(19,945,2),
(19,450,5),
(19,946,2),
(19,947,2),
(19,948,2),
(19,949,2),
(19,950,2),
(19,722,3),
(19,728,1),
(19,729,1),
(19,730,1),
(19,173,2),
(19,133,2),
(19,731,1),
(19,612,4),
(19,156,3),
(19,732,1),
(19,733,1),
(19,734,1),
(19,735,1),
(19,737,1),
(19,1029,1),
(19,139,1),
(19,365,2),
(19,1030,1),
(19,1031,1),
(19,1032,1),
(19,129,2),
(19,1033,1),
(19,146,1),
(19,147,2),
(19,827,1),
(19,828,1),
(19,829,1),
(19,830,1),
(19,130,1),
(19,132,1),
(19,831,1),
(19,832,1),
(19,833,1),
(19,834,1),
(19,723,2),
(19,724,2),
(19,725,2),
(19,726,2),
(19,727,2),
(19,169,4),
(19,835,2),
(19,836,2),
(19,837,2),
(19,838,2),
(19,451,2),
(19,839,2),
(19,840,2),
(19,166,2),
(19,841,2),
(19,842,2),
(19,843,2),
(19,160,1),
(19,161,1),
(19,162,1),
(19,163,1),
(19,164,1),
(19,155,1),
(19,174,1),
(19,607,1),
(19,608,1),
(19,609,1),
(19,610,1),
(19,611,1),
(19,180,3),
(19,466,6),
(19,1169,6),
(19,1170,6),
(19,245,6),
(19,371,7),
(19,961,2),
(19,372,2),
(19,214,2),
(19,962,2),
(19,963,2),
(19,203,9),
(19,220,2),
(19,964,2),
(19,965,2),
(19,199,12),
(19,756,5),
(19,966,2),
(19,471,5),
(19,967,2),
(19,968,2),
(19,969,2),
(19,970,2),
(19,971,2),
(19,742,3),
(19,748,1),
(19,749,1),
(19,750,1),
(19,236,2),
(19,196,2),
(19,751,1),
(19,639,4),
(19,219,3),
(19,752,1),
(19,753,1),
(19,754,1),
(19,755,1),
(19,757,1),
(19,1036,1),
(19,202,1),
(19,383,2),
(19,1037,1),
(19,1038,1),
(19,1039,1),
(19,192,2),
(19,1040,1),
(19,209,1),
(19,210,2),
(19,849,1),
(19,850,1),
(19,851,1),
(19,852,1),
(19,193,1),
(19,195,1),
(19,853,1),
(19,854,1),
(19,855,1),
(19,856,1),
(19,743,2),
(19,744,2),
(19,745,2),
(19,746,2),
(19,747,2),
(19,232,4),
(19,857,2),
(19,858,2),
(19,859,2),
(19,860,2),
(19,472,2),
(19,861,2),
(19,862,2),
(19,229,2),
(19,863,2),
(19,864,2),
(19,865,2),
(19,223,1),
(19,224,1),
(19,225,1),
(19,226,1),
(19,227,1),
(19,218,1),
(19,237,1),
(19,634,1),
(19,635,1),
(19,636,1),
(19,637,1),
(19,638,1),
(19,243,3),
(19,487,6),
(19,1171,6),
(19,1172,6),
(19,308,6),
(19,389,7),
(19,982,2),
(19,390,2),
(19,277,2),
(19,983,2),
(19,984,2),
(19,266,9),
(19,283,2),
(19,985,2),
(19,986,2),
(19,262,12),
(19,776,5),
(19,987,2),
(19,492,5),
(19,988,2),
(19,989,2),
(19,990,2),
(19,991,2),
(19,992,2),
(19,762,3),
(19,768,1),
(19,769,1),
(19,770,1),
(19,299,2),
(19,259,2),
(19,771,1),
(19,666,4),
(19,282,3),
(19,772,1),
(19,773,1),
(19,774,1),
(19,775,1),
(19,777,1),
(19,1043,1),
(19,265,1),
(19,401,2),
(19,1044,1),
(19,1045,1),
(19,1046,1),
(19,255,2),
(19,1047,1),
(19,272,4),
(19,273,2),
(19,871,1),
(19,872,1),
(19,873,1),
(19,874,1),
(19,256,1),
(19,258,1),
(19,875,1),
(19,876,1),
(19,877,1),
(19,878,1),
(19,763,2),
(19,764,2),
(19,765,2),
(19,766,2),
(19,767,2),
(19,295,4),
(19,879,2),
(19,880,2),
(19,881,2),
(19,882,2),
(19,493,2),
(19,883,2),
(19,884,2),
(19,292,2),
(19,885,2),
(19,886,2),
(19,887,2),
(19,286,1),
(19,287,1),
(19,288,1),
(19,289,1),
(19,290,1),
(19,281,1),
(19,300,1),
(19,661,1),
(19,662,1),
(19,663,1),
(19,664,1),
(19,665,1),
(19,306,3),
(20,403,6),
(20,1173,6),
(20,1174,6),
(20,682,2),
(20,317,9),
(20,408,7),
(20,688,2),
(20,689,2),
(20,690,2),
(20,16,11),
(20,48,3),
(20,10,3),
(20,691,2),
(20,558,2),
(20,32,3),
(20,692,2),
(20,693,2),
(20,694,2),
(20,695,2),
(20,696,5),
(20,697,2),
(20,1015,1),
(20,15,1),
(20,329,1),
(20,1016,1),
(20,1017,1),
(20,1018,1),
(20,6,2),
(20,1019,1),
(20,22,4),
(20,23,1),
(20,5,1),
(20,7,1),
(20,8,1),
(20,9,1),
(20,11,1),
(20,12,1),
(20,13,1),
(20,36,1),
(20,37,1),
(20,38,1),
(20,39,1),
(20,40,1),
(20,31,1),
(20,791,1),
(20,792,1),
(20,793,1),
(20,794,1),
(20,409,1),
(20,795,1),
(20,796,1),
(20,42,1),
(20,797,1),
(20,798,1),
(20,799,1),
(20,49,3),
(20,553,2),
(20,554,2),
(20,555,2),
(20,556,2),
(20,557,2),
(20,898,2),
(20,318,2),
(20,27,2),
(20,899,2),
(20,900,2),
(20,33,3),
(20,901,2),
(20,902,2),
(20,903,2),
(20,904,2),
(20,905,2),
(20,906,2),
(20,907,2),
(20,908,2),
(20,50,1),
(20,51,1),
(20,52,1),
(20,53,1),
(20,54,1),
(20,319,1),
(20,510,1),
(20,511,1),
(20,512,1),
(20,424,6),
(20,1175,6),
(20,1176,6),
(20,702,2),
(20,335,9),
(20,429,7),
(20,708,2),
(20,709,2),
(20,710,2),
(20,77,11),
(20,110,3),
(20,70,3),
(20,711,2),
(20,585,2),
(20,93,3),
(20,712,2),
(20,73,11),
(20,713,2),
(20,714,2),
(20,715,2),
(20,716,5),
(20,717,2),
(20,1022,1),
(20,76,1),
(20,347,1),
(20,1023,1),
(20,1024,1),
(20,1025,1),
(20,66,2),
(20,1026,1),
(20,83,1),
(20,84,1),
(20,65,1),
(20,67,1),
(20,68,1),
(20,69,1),
(20,71,1),
(20,72,1),
(20,74,1),
(20,97,1),
(20,98,1),
(20,99,1),
(20,100,1),
(20,101,1),
(20,92,1),
(20,106,3),
(20,813,1),
(20,814,1),
(20,815,1),
(20,816,1),
(20,430,1),
(20,817,1),
(20,818,1),
(20,103,1),
(20,819,1),
(20,820,1),
(20,821,1),
(20,111,3),
(20,580,2),
(20,581,2),
(20,582,2),
(20,583,2),
(20,584,2),
(20,919,2),
(20,336,2),
(20,88,2),
(20,920,2),
(20,921,2),
(20,94,3),
(20,922,2),
(20,923,2),
(20,924,2),
(20,925,2),
(20,926,2),
(20,927,2),
(20,928,2),
(20,929,2),
(20,112,1),
(20,113,1),
(20,114,1),
(20,115,1),
(20,116,1),
(20,337,1),
(20,517,1),
(20,518,1),
(20,519,1),
(20,117,3),
(20,445,6),
(20,1177,6),
(20,1178,6),
(20,722,2),
(20,353,9),
(20,450,7),
(20,728,2),
(20,729,2),
(20,730,2),
(20,140,11),
(20,173,3),
(20,133,3),
(20,731,2),
(20,612,2),
(20,156,3),
(20,732,2),
(20,136,11),
(20,733,2),
(20,734,2),
(20,735,2),
(20,736,5),
(20,737,2),
(20,1029,1),
(20,139,1),
(20,365,1),
(20,1030,1),
(20,1031,1),
(20,1032,1),
(20,129,2),
(20,1033,1),
(20,146,1),
(20,147,1),
(20,128,1),
(20,130,1),
(20,131,1),
(20,132,1),
(20,134,1),
(20,135,1),
(20,137,1),
(20,160,1),
(20,161,1),
(20,162,1),
(20,163,1),
(20,164,1),
(20,155,1),
(20,169,3),
(20,835,1),
(20,836,1),
(20,837,1),
(20,838,1),
(20,451,1),
(20,839,1),
(20,840,1),
(20,166,1),
(20,841,1),
(20,842,1),
(20,843,1),
(20,174,3),
(20,607,2),
(20,608,2),
(20,609,2),
(20,610,2),
(20,611,2),
(20,940,2),
(20,354,2),
(20,151,2),
(20,941,2),
(20,942,2),
(20,157,3),
(20,943,2),
(20,944,2),
(20,945,2),
(20,946,2),
(20,947,2),
(20,948,2),
(20,949,2),
(20,950,2),
(20,175,1),
(20,176,1),
(20,177,1),
(20,178,1),
(20,179,1),
(20,355,1),
(20,524,1),
(20,525,1),
(20,526,1),
(20,180,3),
(20,466,6),
(20,1179,6),
(20,1180,6),
(20,742,2),
(20,371,9),
(20,471,7),
(20,748,2),
(20,749,2),
(20,750,2),
(20,203,11),
(20,236,3),
(20,196,3),
(20,751,2),
(20,639,2),
(20,219,3),
(20,752,2),
(20,199,11),
(20,753,2),
(20,754,2),
(20,755,2),
(20,756,5),
(20,757,2),
(20,1036,1),
(20,202,1),
(20,383,1),
(20,1037,1),
(20,1038,1),
(20,1039,1),
(20,192,2),
(20,1040,1),
(20,209,1),
(20,210,1),
(20,191,1),
(20,193,1),
(20,194,1),
(20,195,1),
(20,197,1),
(20,198,1),
(20,200,1),
(20,223,1),
(20,224,1),
(20,225,1),
(20,226,1),
(20,227,1),
(20,218,1),
(20,232,3),
(20,857,1),
(20,858,1),
(20,859,1),
(20,860,1),
(20,472,1),
(20,861,1),
(20,862,1),
(20,229,1),
(20,863,1),
(20,864,1),
(20,865,1),
(20,237,3),
(20,634,2),
(20,635,2),
(20,636,2),
(20,637,2),
(20,638,2),
(20,961,2),
(20,372,2),
(20,214,2),
(20,962,2),
(20,963,2),
(20,220,3),
(20,964,2),
(20,965,2),
(20,966,2),
(20,967,2),
(20,968,2),
(20,969,2),
(20,970,2),
(20,971,2),
(20,238,1),
(20,239,1),
(20,240,1),
(20,241,1),
(20,242,1),
(20,373,1),
(20,531,1),
(20,532,1),
(20,533,1),
(20,243,3),
(20,487,6),
(20,1181,6),
(20,1182,6),
(20,762,2),
(20,389,9),
(20,492,7),
(20,768,2),
(20,769,2),
(20,770,2),
(20,266,11),
(20,299,3),
(20,259,3),
(20,771,2),
(20,666,2),
(20,282,3),
(20,772,2),
(20,262,11),
(20,773,2),
(20,774,2),
(20,775,2),
(20,776,5),
(20,777,2),
(20,1043,1),
(20,265,1),
(20,401,1),
(20,1044,1),
(20,1045,1),
(20,1046,1),
(20,255,2),
(20,1047,1),
(20,272,4),
(20,273,1),
(20,254,1),
(20,256,1),
(20,257,1),
(20,258,1),
(20,260,1),
(20,261,1),
(20,263,1),
(20,286,1),
(20,287,1),
(20,288,1),
(20,289,1),
(20,290,1),
(20,281,1),
(20,295,3),
(20,879,1),
(20,880,1),
(20,881,1),
(20,882,1),
(20,493,1),
(20,883,1),
(20,884,1),
(20,292,1),
(20,885,1),
(20,886,1),
(20,887,1),
(20,300,3),
(20,661,2),
(20,662,2),
(20,663,2),
(20,664,2),
(20,665,2),
(20,982,2),
(20,390,2),
(20,277,2),
(20,983,2),
(20,984,2),
(20,283,3),
(20,985,2),
(20,986,2),
(20,987,2),
(20,988,2),
(20,989,2),
(20,990,2),
(20,991,2),
(20,992,2),
(20,301,1),
(20,302,1),
(20,303,1),
(20,304,1),
(20,305,1),
(20,391,1),
(20,538,1),
(20,539,1),
(20,540,1),
(20,306,3),
(21,1183,6),
(21,1184,6),
(21,1185,6),
(21,315,6),
(21,316,6),
(21,1015,3),
(21,15,4),
(21,329,3),
(21,16,12),
(21,48,5),
(21,317,9),
(21,408,8),
(21,1016,3),
(21,1017,3),
(21,1018,3),
(21,6,5),
(21,1019,3),
(21,22,7),
(21,23,4),
(21,5,2),
(21,7,2),
(21,8,2),
(21,9,2),
(21,10,4),
(21,11,2),
(21,12,2),
(21,13,2),
(21,14,1),
(21,17,1),
(21,18,2),
(21,19,1),
(21,20,1),
(21,21,1),
(21,24,1),
(21,25,1),
(21,26,1),
(21,27,2),
(21,28,1),
(21,36,2),
(21,37,2),
(21,38,2),
(21,39,2),
(21,40,2),
(21,31,2),
(21,898,1),
(21,318,1),
(21,899,1),
(21,900,1),
(21,33,1),
(21,901,1),
(21,902,1),
(21,696,3),
(21,903,1),
(21,904,1),
(21,905,1),
(21,906,1),
(21,907,1),
(21,908,1),
(21,682,2),
(21,688,2),
(21,689,2),
(21,690,2),
(21,691,2),
(21,558,2),
(21,32,2),
(21,692,2),
(21,693,2),
(21,694,2),
(21,695,2),
(21,697,2),
(21,1186,6),
(21,1187,6),
(21,1188,6),
(21,333,6),
(21,334,6),
(21,1022,3),
(21,76,4),
(21,347,3),
(21,77,12),
(21,110,5),
(21,335,9),
(21,429,8),
(21,1023,3),
(21,1024,3),
(21,1025,3),
(21,73,13),
(21,66,5),
(21,1026,3),
(21,83,4),
(21,84,4),
(21,65,2),
(21,67,2),
(21,68,2),
(21,69,2),
(21,70,4),
(21,71,2),
(21,72,2),
(21,74,2),
(21,75,1),
(21,78,1),
(21,79,2),
(21,80,1),
(21,81,1),
(21,82,1),
(21,85,1),
(21,86,1),
(21,87,1),
(21,88,2),
(21,89,1),
(21,97,2),
(21,98,2),
(21,99,2),
(21,100,2),
(21,101,2),
(21,92,2),
(21,919,1),
(21,336,1),
(21,920,1),
(21,921,1),
(21,94,1),
(21,922,1),
(21,923,1),
(21,716,3),
(21,924,1),
(21,925,1),
(21,926,1),
(21,927,1),
(21,928,1),
(21,929,1),
(21,702,2),
(21,708,2),
(21,709,2),
(21,710,2),
(21,711,2),
(21,585,2),
(21,93,2),
(21,712,2),
(21,713,2),
(21,714,2),
(21,715,2),
(21,717,2),
(21,117,3),
(21,1189,6),
(21,1190,6),
(21,1191,6),
(21,351,6),
(21,352,6),
(21,1029,3),
(21,139,4),
(21,365,3),
(21,140,12),
(21,173,5),
(21,353,9),
(21,450,8),
(21,1030,3),
(21,1031,3),
(21,1032,3),
(21,136,13),
(21,129,5),
(21,1033,3),
(21,146,4),
(21,147,4),
(21,128,2),
(21,130,2),
(21,131,2),
(21,132,2),
(21,133,4),
(21,134,2),
(21,135,2),
(21,137,2),
(21,138,1),
(21,141,1),
(21,142,2),
(21,143,1),
(21,144,1),
(21,145,1),
(21,148,1),
(21,149,1),
(21,150,1),
(21,151,2),
(21,152,1),
(21,160,2),
(21,161,2),
(21,162,2),
(21,163,2),
(21,164,2),
(21,155,2),
(21,940,1),
(21,354,1),
(21,941,1),
(21,942,1),
(21,157,1),
(21,943,1),
(21,944,1),
(21,736,3),
(21,945,1),
(21,946,1),
(21,947,1),
(21,948,1),
(21,949,1),
(21,950,1),
(21,722,2),
(21,728,2),
(21,729,2),
(21,730,2),
(21,731,2),
(21,612,2),
(21,156,2),
(21,732,2),
(21,733,2),
(21,734,2),
(21,735,2),
(21,737,2),
(21,180,3),
(21,1192,6),
(21,1193,6),
(21,1194,6),
(21,369,6),
(21,370,6),
(21,1036,3),
(21,202,4),
(21,383,3),
(21,203,12),
(21,236,5),
(21,371,9),
(21,471,8),
(21,1037,3),
(21,1038,3),
(21,1039,3),
(21,199,13),
(21,192,5),
(21,1040,3),
(21,209,4),
(21,210,4),
(21,191,2),
(21,193,2),
(21,194,2),
(21,195,2),
(21,196,4),
(21,197,2),
(21,198,2),
(21,200,2),
(21,201,1),
(21,204,1),
(21,205,2),
(21,206,1),
(21,207,1),
(21,208,1),
(21,211,1),
(21,212,1),
(21,213,1),
(21,214,2),
(21,215,1),
(21,223,2),
(21,224,2),
(21,225,2),
(21,226,2),
(21,227,2),
(21,218,2),
(21,961,1),
(21,372,1),
(21,962,1),
(21,963,1),
(21,220,1),
(21,964,1),
(21,965,1),
(21,756,3),
(21,966,1),
(21,967,1),
(21,968,1),
(21,969,1),
(21,970,1),
(21,971,1),
(21,742,2),
(21,748,2),
(21,749,2),
(21,750,2),
(21,751,2),
(21,639,2),
(21,219,2),
(21,752,2),
(21,753,2),
(21,754,2),
(21,755,2),
(21,757,2),
(21,243,3),
(21,1195,6),
(21,1196,6),
(21,1197,6),
(21,387,6),
(21,388,6),
(21,1043,3),
(21,265,4),
(21,401,3),
(21,266,12),
(21,299,5),
(21,389,9),
(21,492,8),
(21,1044,3),
(21,1045,3),
(21,1046,3),
(21,262,13),
(21,255,5),
(21,1047,3),
(21,272,7),
(21,273,4),
(21,254,2),
(21,256,2),
(21,257,2),
(21,258,2),
(21,259,4),
(21,260,2),
(21,261,2),
(21,263,2),
(21,264,1),
(21,267,1),
(21,268,2),
(21,269,1),
(21,270,1),
(21,271,1),
(21,274,1),
(21,275,1),
(21,276,1),
(21,277,2),
(21,278,1),
(21,286,2),
(21,287,2),
(21,288,2),
(21,289,2),
(21,290,2),
(21,281,2),
(21,982,1),
(21,390,1),
(21,983,1),
(21,984,1),
(21,283,1),
(21,985,1),
(21,986,1),
(21,776,3),
(21,987,1),
(21,988,1),
(21,989,1),
(21,990,1),
(21,991,1),
(21,992,1),
(21,762,2),
(21,768,2),
(21,769,2),
(21,770,2),
(21,771,2),
(21,666,2),
(21,282,2),
(21,772,2),
(21,773,2),
(21,774,2),
(21,775,2),
(21,777,2),
(21,306,3),
(22,1013,6),
(22,678,6),
(22,679,6),
(22,1198,6),
(22,1199,6),
(22,1200,6),
(22,1201,6),
(22,5,3),
(22,6,4),
(22,7,2),
(22,8,2),
(22,9,3),
(22,10,2),
(22,11,2),
(22,12,3),
(22,13,2),
(22,14,2),
(22,15,5),
(22,16,12),
(22,17,3),
(22,18,5),
(22,19,3),
(22,20,2),
(22,21,2),
(22,22,7),
(22,23,4),
(22,24,3),
(22,25,2),
(22,26,2),
(22,27,3),
(22,28,2),
(22,29,1),
(22,30,1),
(22,31,3),
(22,32,2),
(22,33,2),
(22,34,1),
(22,35,1),
(22,36,2),
(22,37,2),
(22,38,2),
(22,39,2),
(22,40,2),
(22,1015,1),
(22,329,1),
(22,48,1),
(22,317,3),
(22,408,3),
(22,1016,1),
(22,1017,1),
(22,1018,1),
(22,1019,1),
(22,407,2),
(22,409,2),
(22,410,1),
(22,411,1),
(22,412,1),
(22,413,1),
(22,49,2),
(22,50,1),
(22,51,1),
(22,52,1),
(22,53,1),
(22,54,1),
(22,319,1),
(22,510,1),
(22,511,1),
(22,512,1),
(22,42,1),
(22,547,1),
(22,548,1),
(22,549,1),
(22,550,1),
(22,551,1),
(22,552,1),
(22,553,1),
(22,554,1),
(22,555,1),
(22,556,1),
(22,557,1),
(22,423,2),
(22,1020,6),
(22,698,6),
(22,699,6),
(22,1202,6),
(22,1203,6),
(22,1204,6),
(22,1205,6),
(22,65,3),
(22,66,4),
(22,67,2),
(22,68,2),
(22,69,3),
(22,70,2),
(22,71,2),
(22,72,3),
(22,73,9),
(22,74,2),
(22,75,2),
(22,76,5),
(22,77,12),
(22,78,3),
(22,79,5),
(22,80,3),
(22,81,2),
(22,82,2),
(22,83,4),
(22,84,4),
(22,85,3),
(22,86,2),
(22,87,2),
(22,88,3),
(22,89,2),
(22,90,1),
(22,91,1),
(22,92,3),
(22,93,2),
(22,94,2),
(22,95,1),
(22,96,1),
(22,97,2),
(22,98,2),
(22,99,2),
(22,100,2),
(22,101,2),
(22,1022,1),
(22,347,1),
(22,110,1),
(22,335,3),
(22,429,3),
(22,1023,1),
(22,1024,1),
(22,1025,1),
(22,1026,1),
(22,428,2),
(22,430,2),
(22,431,1),
(22,432,1),
(22,433,1),
(22,434,1),
(22,111,2),
(22,106,1),
(22,112,1),
(22,113,1),
(22,114,1),
(22,115,1),
(22,116,1),
(22,337,1),
(22,517,1),
(22,518,1),
(22,519,1),
(22,103,1),
(22,574,1),
(22,575,1),
(22,576,1),
(22,577,1),
(22,578,1),
(22,579,1),
(22,580,1),
(22,581,1),
(22,582,1),
(22,583,1),
(22,584,1),
(22,117,3),
(22,444,2),
(22,1027,6),
(22,718,6),
(22,719,6),
(22,1206,6),
(22,1207,6),
(22,1208,6),
(22,1209,6),
(22,128,3),
(22,129,4),
(22,130,2),
(22,131,2),
(22,132,3),
(22,133,2),
(22,134,2),
(22,135,3),
(22,136,9),
(22,137,2),
(22,138,2),
(22,139,5),
(22,140,12),
(22,141,3),
(22,142,5),
(22,143,3),
(22,144,2),
(22,145,2),
(22,146,4),
(22,147,4),
(22,148,3),
(22,149,2),
(22,150,2),
(22,151,3),
(22,152,2),
(22,153,1),
(22,154,1),
(22,155,3),
(22,156,2),
(22,157,2),
(22,158,1),
(22,159,1),
(22,160,2),
(22,161,2),
(22,162,2),
(22,163,2),
(22,164,2),
(22,1029,1),
(22,365,1),
(22,173,1),
(22,353,3),
(22,450,3),
(22,1030,1),
(22,1031,1),
(22,1032,1),
(22,1033,1),
(22,449,2),
(22,451,2),
(22,452,1),
(22,453,1),
(22,454,1),
(22,455,1),
(22,174,2),
(22,169,1),
(22,175,1),
(22,176,1),
(22,177,1),
(22,178,1),
(22,179,1),
(22,355,1),
(22,524,1),
(22,525,1),
(22,526,1),
(22,166,1),
(22,601,1),
(22,602,1),
(22,603,1),
(22,604,1),
(22,605,1),
(22,606,1),
(22,607,1),
(22,608,1),
(22,609,1),
(22,610,1),
(22,611,1),
(22,180,3),
(22,465,2),
(22,1034,6),
(22,738,6),
(22,739,6),
(22,1210,6),
(22,1211,6),
(22,1212,6),
(22,1213,6),
(22,191,3),
(22,192,4),
(22,193,2),
(22,194,2),
(22,195,3),
(22,196,2),
(22,197,2),
(22,198,3),
(22,199,9),
(22,200,2),
(22,201,2),
(22,202,5),
(22,203,12),
(22,204,3),
(22,205,5),
(22,206,3),
(22,207,2),
(22,208,2),
(22,209,4),
(22,210,4),
(22,211,3),
(22,212,2),
(22,213,2),
(22,214,3),
(22,215,2),
(22,216,1),
(22,217,1),
(22,218,3),
(22,219,2),
(22,220,2),
(22,221,1),
(22,222,1),
(22,223,2),
(22,224,2),
(22,225,2),
(22,226,2),
(22,227,2),
(22,1036,1),
(22,383,1),
(22,236,1),
(22,371,3),
(22,471,3),
(22,1037,1),
(22,1038,1),
(22,1039,1),
(22,1040,1),
(22,470,2),
(22,472,2),
(22,473,1),
(22,474,1),
(22,475,1),
(22,476,1),
(22,237,2),
(22,232,1),
(22,238,1),
(22,239,1),
(22,240,1),
(22,241,1),
(22,242,1),
(22,373,1),
(22,531,1),
(22,532,1),
(22,533,1),
(22,229,1),
(22,628,1),
(22,629,1),
(22,630,1),
(22,631,1),
(22,632,1),
(22,633,1),
(22,634,1),
(22,635,1),
(22,636,1),
(22,637,1),
(22,638,1),
(22,243,3),
(22,486,2),
(22,1041,6),
(22,758,6),
(22,759,6),
(22,1214,6),
(22,1215,6),
(22,1216,6),
(22,1217,6),
(22,254,3),
(22,255,4),
(22,256,2),
(22,257,2),
(22,258,3),
(22,259,2),
(22,260,2),
(22,261,3),
(22,262,9),
(22,263,2),
(22,264,2),
(22,265,5),
(22,266,12),
(22,267,3),
(22,268,5),
(22,269,3),
(22,270,2),
(22,271,2),
(22,272,7),
(22,273,4),
(22,274,3),
(22,275,2),
(22,276,2),
(22,277,3),
(22,278,2),
(22,279,1),
(22,280,1),
(22,281,3),
(22,282,2),
(22,283,2),
(22,284,1),
(22,285,1),
(22,286,2),
(22,287,2),
(22,288,2),
(22,289,2),
(22,290,2),
(22,1043,1),
(22,401,1),
(22,299,1),
(22,389,3),
(22,492,3),
(22,1044,1),
(22,1045,1),
(22,1046,1),
(22,1047,1),
(22,491,2),
(22,493,2),
(22,494,1),
(22,495,1),
(22,496,1),
(22,497,1),
(22,300,2),
(22,295,1),
(22,301,1),
(22,302,1),
(22,303,1),
(22,304,1),
(22,305,1),
(22,391,1),
(22,538,1),
(22,539,1),
(22,540,1),
(22,292,1),
(22,655,1),
(22,656,1),
(22,657,1),
(22,658,1),
(22,659,1),
(22,660,1),
(22,661,1),
(22,662,1),
(22,663,1),
(22,664,1),
(22,665,1),
(22,306,3),
(22,507,2),
(2,100,1),
(2,99,1),
(2,98,1),
(2,97,1),
(2,348,2),
(2,347,2),
(2,346,2),
(2,345,2),
(2,344,2),
(2,343,2),
(2,342,2),
(2,341,2),
(2,340,2),
(2,339,2),
(2,338,2),
(2,337,2),
(2,336,2),
(2,335,2),
(2,116,1),
(2,115,1),
(2,114,1),
(2,113,1),
(2,112,1),
(2,111,1),
(2,110,3),
(2,109,3),
(2,108,3),
(2,107,3),
(2,106,6),
(2,105,3),
(2,104,3),
(2,103,3),
(2,102,5),
(2,96,3),
(2,95,3),
(2,94,4),
(2,93,3),
(2,92,6),
(2,91,3),
(2,90,3),
(2,89,2),
(2,88,2),
(2,87,2),
(2,73,6),
(2,86,2),
(2,85,2),
(2,84,2),
(2,83,2),
(2,82,1),
(2,81,1),
(2,80,4),
(2,79,6),
(2,78,4),
(2,77,16),
(2,76,6),
(2,75,1),
(2,334,6),
(2,333,6),
(2,332,6),
(2,331,6),
(2,60,4),
(2,59,6),
(2,58,6),
(2,57,4),
(2,56,4),
(2,1320,4),
(2,55,3),
(2,40,1),
(2,39,1),
(2,38,1),
(2,37,1),
(2,36,1),
(2,330,2),
(2,329,2),
(2,328,2),
(2,327,2),
(2,326,2),
(2,325,2),
(2,324,2),
(2,323,2),
(2,322,2),
(2,321,2),
(2,320,2),
(2,319,2),
(2,318,2),
(2,317,2),
(2,54,1),
(2,53,1),
(2,52,1),
(2,51,1),
(2,50,1),
(2,49,1),
(2,48,3),
(2,47,3),
(2,46,3),
(2,45,3),
(2,44,3),
(2,43,3),
(2,42,3),
(2,41,5),
(2,35,3),
(2,34,3),
(2,33,4),
(2,32,3),
(2,31,6),
(2,30,3),
(2,29,3),
(2,28,2),
(2,27,2),
(2,26,2),
(2,25,2),
(2,24,2),
(2,23,2),
(2,22,5),
(2,21,1),
(2,20,1),
(2,19,4),
(2,18,6),
(2,17,4),
(2,16,16),
(2,15,6),
(2,14,1),
(2,316,6),
(2,315,6),
(2,314,6),
(2,313,6),
(7,306,3),
(7,887,1),
(7,886,1),
(7,776,1),
(7,885,1),
(7,884,1),
(7,883,1),
(7,882,1),
(7,881,1),
(7,880,1),
(7,879,1),
(7,767,1),
(7,766,1),
(7,765,1),
(7,764,1),
(7,763,1),
(7,282,1),
(7,762,1),
(7,665,1),
(7,664,1),
(7,663,1),
(7,662,1),
(7,661,1),
(7,878,2),
(7,877,2),
(7,876,2),
(7,875,2),
(7,258,2),
(7,259,2),
(7,256,2),
(7,874,2),
(7,873,2),
(7,872,2),
(7,871,2),
(7,677,2),
(7,676,2),
(7,675,2),
(7,674,2),
(7,673,2),
(7,672,1),
(7,671,1),
(7,670,1),
(7,669,1),
(7,668,1),
(7,391,1),
(7,667,1),
(7,401,3),
(7,666,4),
(7,305,1),
(7,304,1),
(7,303,1),
(7,302,1),
(7,301,1),
(7,295,3),
(7,283,1),
(7,261,1),
(7,254,1),
(7,497,2),
(7,273,3),
(7,272,4),
(7,496,1),
(7,495,1),
(7,277,1),
(7,494,1),
(7,493,3),
(7,492,3),
(7,389,5),
(7,491,2),
(7,506,1),
(7,505,1),
(7,298,2),
(7,504,2),
(7,503,1),
(7,300,4),
(7,502,1),
(7,292,2),
(7,501,1),
(7,500,1),
(7,499,1),
(7,255,4),
(7,265,2),
(7,498,1),
(7,281,1),
(7,290,1),
(7,262,13),
(7,289,1),
(7,288,1),
(7,287,1),
(7,266,7),
(7,286,1),
(7,870,6),
(7,869,6),
(7,868,6),
(7,867,6),
(7,866,6),
(7,243,3),
(7,865,1),
(7,864,1),
(7,756,1),
(7,863,1),
(7,862,1),
(7,861,1),
(7,860,1),
(7,859,1),
(7,858,1),
(7,857,1),
(7,747,1),
(7,746,1),
(7,745,1),
(7,744,1),
(7,743,1),
(7,219,1),
(7,742,1),
(7,638,1),
(7,637,1),
(7,636,1),
(7,635,1),
(7,634,1),
(7,856,2),
(7,855,2),
(7,854,2),
(7,853,2),
(7,195,2),
(7,196,2),
(7,193,2),
(7,852,2),
(7,851,2),
(7,850,2),
(7,849,2),
(7,650,2),
(7,649,2),
(7,648,2),
(7,647,2),
(7,646,2),
(7,645,1),
(7,644,1),
(7,643,1),
(7,642,1),
(7,641,1),
(7,373,1),
(7,640,1),
(7,383,3),
(7,639,4),
(7,242,1),
(7,241,1),
(7,240,1),
(7,239,1),
(7,238,1),
(7,232,3),
(7,220,1),
(7,198,1),
(7,191,1),
(7,476,2),
(7,210,3),
(7,209,1),
(7,475,1),
(24,678,6),
(24,679,6),
(24,1238,6),
(24,1239,6),
(24,22,5),
(24,23,2),
(24,24,2),
(24,16,14),
(24,25,2),
(24,26,2),
(24,18,5),
(24,27,2),
(24,28,2),
(24,19,3),
(24,29,3),
(24,15,6),
(24,17,3),
(24,30,3),
(24,31,7),
(24,32,3),
(24,33,3),
(24,34,3),
(24,35,3),
(24,41,6),
(24,42,3),
(24,43,3),
(24,44,3),
(24,45,3),
(24,46,3),
(24,47,3),
(24,48,3),
(24,317,3),
(24,318,3),
(24,319,3),
(24,320,3),
(24,321,3),
(24,322,3),
(24,323,3),
(24,324,3),
(24,325,3),
(24,326,3),
(24,327,3),
(24,328,3),
(24,329,3),
(24,330,3),
(24,36,1),
(24,37,1),
(24,38,1),
(24,39,1),
(24,40,1),
(24,698,6),
(24,699,6),
(24,1240,6),
(24,1241,6),
(24,83,2),
(24,84,2),
(24,85,2),
(24,77,14),
(24,86,2),
(24,73,6),
(24,87,2),
(24,79,5),
(24,88,2),
(24,89,2),
(24,80,3),
(24,90,3),
(24,76,6),
(24,78,3),
(24,91,3),
(24,92,7),
(24,93,3),
(24,94,3),
(24,95,3),
(24,96,3),
(24,102,6),
(24,103,3),
(24,104,3),
(24,105,3),
(24,106,6),
(24,107,3),
(24,108,3),
(24,109,3),
(24,110,3),
(24,335,3),
(24,336,3),
(24,337,3),
(24,338,3),
(24,339,3),
(24,340,3),
(24,341,3),
(24,342,3),
(24,343,3),
(24,344,3),
(24,345,3),
(24,346,3),
(24,347,3),
(24,348,3),
(24,97,1),
(24,98,1),
(24,99,1),
(24,100,1),
(24,101,1),
(24,117,3),
(24,718,6),
(24,719,6),
(24,1242,6),
(24,1243,6),
(24,146,2),
(24,147,2),
(24,148,2),
(24,140,14),
(24,149,2),
(24,136,6),
(24,150,2),
(24,142,5),
(24,151,2),
(24,152,2),
(24,143,3),
(24,153,3),
(24,139,6),
(24,141,3),
(24,154,3),
(24,155,7),
(24,156,3),
(24,157,3),
(24,158,3),
(24,159,3),
(24,165,6),
(24,166,3),
(24,167,3),
(24,168,3),
(24,169,6),
(24,170,3),
(24,171,3),
(24,172,3),
(24,173,3),
(24,353,3),
(24,354,3),
(24,355,3),
(24,356,3),
(24,357,3),
(24,358,3),
(24,359,3),
(24,360,3),
(24,361,3),
(24,362,3),
(24,363,3),
(24,364,3),
(24,365,3),
(24,366,3),
(24,160,1),
(24,161,1),
(24,162,1),
(24,163,1),
(24,164,1),
(24,180,3),
(24,738,6),
(24,739,6),
(24,1244,6),
(24,1245,6),
(24,209,2),
(24,210,2),
(24,211,2),
(24,203,14),
(24,212,2),
(24,199,6),
(24,213,2),
(24,205,5),
(24,214,2),
(24,215,2),
(24,206,3),
(24,216,3),
(24,202,6),
(24,204,3),
(24,217,3),
(24,218,7),
(24,219,3),
(24,220,3),
(24,221,3),
(24,222,3),
(24,228,6),
(24,229,3),
(24,230,3),
(24,231,3),
(24,232,6),
(24,233,3),
(24,234,3),
(24,235,3),
(24,236,3),
(24,371,3),
(24,372,3),
(24,373,3),
(24,374,3),
(24,375,3),
(24,376,3),
(24,377,3),
(24,378,3),
(24,379,3),
(24,380,3),
(24,381,3),
(24,382,3),
(24,383,3),
(24,384,3),
(24,223,1),
(24,224,1),
(24,225,1),
(24,226,1),
(24,227,1),
(24,243,3),
(24,758,6),
(24,759,6),
(24,1246,6),
(24,1247,6),
(24,272,5),
(24,273,2),
(24,274,2),
(24,266,14),
(24,275,2),
(24,262,6),
(24,276,2),
(24,268,5),
(24,277,2),
(24,278,2),
(24,269,3),
(24,279,3),
(24,265,6),
(24,267,3),
(24,280,3),
(24,281,7),
(24,282,3),
(24,283,3),
(24,284,3),
(24,285,3),
(24,291,6),
(24,292,3),
(24,293,3),
(24,294,3),
(24,295,6),
(24,296,3),
(24,297,3),
(24,298,3),
(24,299,3),
(24,389,3),
(24,390,3),
(24,391,3),
(24,392,3),
(24,393,3),
(24,394,3),
(24,395,3),
(24,396,3),
(24,397,3),
(24,398,3),
(24,399,3),
(24,400,3),
(24,401,3),
(24,402,3),
(24,286,1),
(24,287,1),
(24,288,1),
(24,289,1),
(24,290,1),
(24,306,3),
(25,678,6),
(25,679,6),
(25,1248,6),
(25,19,1),
(25,29,1),
(25,15,5),
(25,16,10),
(25,17,1),
(25,18,1),
(25,30,1),
(25,31,7),
(25,32,1),
(25,33,2),
(25,34,1),
(25,35,1),
(25,41,5),
(25,42,3),
(25,43,2),
(25,44,2),
(25,45,2),
(25,46,2),
(25,47,3),
(25,48,2),
(25,317,5),
(25,318,3),
(25,319,3),
(25,320,3),
(25,321,3),
(25,322,3),
(25,323,3),
(25,324,3),
(25,325,3),
(25,326,3),
(25,327,3),
(25,328,3),
(25,329,3),
(25,330,3),
(25,36,3),
(25,37,3),
(25,38,3),
(25,39,3),
(25,40,3),
(25,407,2),
(25,408,2),
(25,409,2),
(25,410,1),
(25,27,1),
(25,411,1),
(25,412,1),
(25,22,4),
(25,23,1),
(25,413,1),
(25,5,1),
(25,12,1),
(25,414,1),
(25,6,2),
(25,415,1),
(25,416,1),
(25,417,1),
(25,418,1),
(25,49,3),
(25,419,1),
(25,420,1),
(25,421,1),
(25,422,1),
(25,50,1),
(25,51,1),
(25,52,1),
(25,53,1),
(25,54,1),
(25,698,6),
(25,699,6),
(25,1249,6),
(25,80,1),
(25,90,1),
(25,76,5),
(25,77,10),
(25,78,1),
(25,79,1),
(25,91,1),
(25,92,7),
(25,93,1),
(25,94,2),
(25,95,1),
(25,96,1),
(25,102,5),
(25,103,3),
(25,104,2),
(25,105,2),
(25,106,6),
(25,107,2),
(25,108,2),
(25,109,3),
(25,110,2),
(25,335,5),
(25,336,3),
(25,337,3),
(25,338,3),
(25,339,3),
(25,340,3),
(25,341,3),
(25,342,3),
(25,73,9),
(25,343,3),
(25,344,3),
(25,345,3),
(25,346,3),
(25,347,3),
(25,348,3),
(25,97,3),
(25,98,3),
(25,99,3),
(25,100,3),
(25,101,3),
(25,428,2),
(25,429,2),
(25,430,2),
(25,431,1),
(25,88,1),
(25,432,1),
(25,433,1),
(25,83,1),
(25,84,1),
(25,434,1),
(25,65,1),
(25,72,1),
(25,435,1),
(25,66,2),
(25,436,1),
(25,437,1),
(25,438,1),
(25,439,1),
(25,111,3),
(25,440,1),
(25,441,1),
(25,442,1),
(25,443,1),
(25,112,1),
(25,113,1),
(25,114,1),
(25,115,1),
(25,116,1),
(25,117,3),
(25,718,6),
(25,719,6),
(25,1250,6),
(25,143,1),
(25,153,1),
(25,139,5),
(25,140,10),
(25,141,1),
(25,142,1),
(25,154,1),
(25,155,7),
(25,156,1),
(25,157,2),
(25,158,1),
(25,159,1),
(25,165,5),
(25,166,3),
(25,167,2),
(25,168,2),
(25,169,6),
(25,170,2),
(25,171,2),
(25,172,3),
(25,173,2),
(25,353,5),
(25,354,3),
(25,355,3),
(25,356,3),
(25,357,3),
(25,358,3),
(25,359,3),
(25,360,3),
(25,136,9),
(25,361,3),
(25,362,3),
(25,363,3),
(25,364,3),
(25,365,3),
(25,366,3),
(25,160,3),
(25,161,3),
(25,162,3),
(25,163,3),
(25,164,3),
(25,449,2),
(25,450,2),
(25,451,2),
(25,452,1),
(25,151,1),
(25,453,1),
(25,454,1),
(25,146,1),
(25,147,1),
(25,455,1),
(25,128,1),
(25,135,1),
(25,456,1),
(25,129,2),
(25,457,1),
(25,458,1),
(25,459,1),
(25,460,1),
(25,174,3),
(25,461,1),
(25,462,1),
(25,463,1),
(25,464,1),
(25,175,1),
(25,176,1),
(25,177,1),
(25,178,1),
(25,179,1),
(25,180,3),
(25,738,6),
(25,739,6),
(25,1251,6),
(25,206,1),
(25,216,1),
(25,202,5),
(25,203,10),
(25,204,1),
(25,205,1),
(25,217,1),
(25,218,7),
(25,219,1),
(25,220,2),
(25,221,1),
(25,222,1),
(25,228,5),
(25,229,3),
(25,230,2),
(25,231,2),
(25,232,6),
(25,233,2),
(25,234,2),
(25,235,3),
(25,236,2),
(25,371,5),
(25,372,3),
(25,373,3),
(25,374,3),
(25,375,3),
(25,376,3),
(25,377,3),
(25,378,3),
(25,199,9),
(25,379,3),
(25,380,3),
(25,381,3),
(25,382,3),
(25,383,3),
(25,384,3),
(25,223,3),
(25,224,3),
(25,225,3),
(25,226,3),
(25,227,3),
(25,470,2),
(25,471,2),
(25,472,2),
(25,473,1),
(25,214,1),
(25,474,1),
(25,475,1),
(25,209,1),
(25,210,1),
(25,476,1),
(25,191,1),
(25,198,1),
(25,477,1),
(25,192,2),
(25,478,1),
(25,479,1),
(25,480,1),
(25,481,1),
(25,237,3),
(25,482,1),
(25,483,1),
(25,484,1),
(25,485,1),
(25,238,1),
(25,239,1),
(25,240,1),
(25,241,1),
(25,242,1),
(25,243,3),
(25,758,6),
(25,759,6),
(25,1252,6),
(25,269,1),
(25,279,1),
(25,265,5),
(25,266,10),
(25,267,1),
(25,268,1),
(25,280,1),
(25,281,7),
(25,282,1),
(25,283,2),
(25,284,1),
(25,285,1),
(25,291,5),
(25,292,3),
(25,293,2),
(25,294,2),
(25,295,6),
(25,296,2),
(25,297,2),
(25,298,3),
(25,299,2),
(25,389,5),
(25,390,3),
(25,391,3),
(25,392,3),
(25,393,3),
(25,394,3),
(25,395,3),
(25,396,3),
(25,262,9),
(25,397,3),
(25,398,3),
(25,399,3),
(25,400,3),
(25,401,3),
(25,402,3),
(25,286,3),
(25,287,3),
(25,288,3),
(25,289,3),
(25,290,3),
(25,491,2),
(25,492,2),
(25,493,2),
(25,494,1),
(25,277,1),
(25,495,1),
(25,496,1),
(25,272,4),
(25,273,1),
(25,497,1),
(25,254,1),
(25,261,1),
(25,498,1),
(25,255,2),
(25,499,1),
(25,500,1),
(25,501,1),
(25,502,1),
(25,300,3),
(25,503,1),
(25,504,1),
(25,505,1),
(25,506,1),
(25,301,1),
(25,302,1),
(25,303,1),
(25,304,1),
(25,305,1),
(25,306,3),
(7,474,1),
(7,214,1),
(7,473,1),
(7,472,3),
(7,471,3),
(7,371,5),
(7,470,2),
(7,485,1),
(7,484,1),
(7,235,2),
(7,483,2),
(7,482,1),
(7,237,4),
(7,481,1),
(7,229,2),
(7,480,1),
(7,479,1),
(7,478,1),
(7,192,4),
(7,202,2),
(7,477,1),
(7,218,1),
(7,227,1),
(7,199,13),
(7,226,1),
(7,225,1),
(7,224,1),
(7,203,7),
(7,223,1),
(7,848,6),
(7,847,6),
(7,846,6),
(7,845,6),
(7,844,6),
(7,180,3),
(7,843,1),
(7,842,1),
(7,736,1),
(7,841,1),
(7,840,1),
(7,839,1),
(7,838,1),
(7,837,1),
(7,836,1),
(7,835,1),
(7,727,1),
(7,726,1),
(7,725,1),
(7,724,1),
(7,723,1),
(7,156,1),
(7,722,1),
(7,611,1),
(7,610,1),
(7,609,1),
(7,608,1),
(7,607,1),
(7,834,2),
(7,833,2),
(7,832,2),
(7,831,2),
(7,132,2),
(7,133,2),
(7,130,2),
(7,830,2),
(7,829,2),
(7,828,2),
(7,827,2),
(7,623,2),
(7,622,2),
(7,621,2),
(7,620,2),
(7,619,2),
(7,618,1),
(7,617,1),
(7,616,1),
(7,615,1),
(7,614,1),
(7,355,1),
(7,613,1),
(7,365,3),
(7,612,4),
(7,179,1),
(7,178,1),
(7,177,1),
(7,176,1),
(7,175,1),
(7,169,3),
(7,157,1),
(7,135,1),
(7,128,1),
(7,455,2),
(7,147,3),
(7,146,1),
(7,454,1),
(7,453,1),
(7,151,1),
(7,452,1),
(7,451,3),
(7,450,3),
(7,353,5),
(7,449,2),
(7,464,1),
(7,463,1),
(7,172,2),
(7,462,2),
(7,461,1),
(7,174,4),
(7,460,1),
(7,166,2),
(7,459,1),
(7,458,1),
(7,457,1),
(7,129,4),
(7,139,2),
(7,456,1),
(7,155,1),
(7,164,1),
(7,136,13),
(7,163,1),
(7,162,1),
(7,161,1),
(7,140,7),
(7,160,1),
(7,826,6),
(7,825,6),
(7,824,6),
(7,823,6),
(7,822,6),
(7,117,3),
(7,821,1),
(7,820,1),
(7,716,1),
(7,819,1),
(7,818,1),
(7,817,1),
(7,816,1),
(7,815,1),
(7,814,1),
(7,813,1),
(7,707,1),
(7,706,1),
(7,705,1),
(7,704,1),
(7,703,1),
(7,93,1),
(7,702,1),
(7,584,1),
(7,583,1),
(7,582,1),
(7,581,1),
(7,580,1),
(7,812,2),
(7,811,2),
(7,810,2),
(7,809,2),
(7,69,2),
(7,70,2),
(7,67,2),
(7,808,2),
(7,807,2),
(7,806,2),
(7,805,2),
(7,596,2),
(7,595,2),
(7,594,2),
(7,593,2),
(7,592,2),
(7,591,1),
(7,590,1),
(7,589,1),
(7,588,1),
(7,587,1),
(7,337,1),
(7,586,1),
(7,347,3),
(7,585,4),
(7,116,1),
(7,115,1),
(7,114,1),
(7,113,1),
(7,112,1),
(7,106,3),
(7,94,1),
(7,72,1),
(7,65,1),
(7,434,2),
(7,84,3),
(7,83,1),
(7,433,1),
(7,432,1),
(7,88,1),
(7,431,1),
(7,430,3),
(7,429,3),
(7,335,5),
(7,428,2),
(7,443,1),
(7,442,1),
(7,109,2),
(7,441,2),
(7,440,1),
(7,111,4),
(7,439,1),
(7,103,2),
(7,438,1),
(7,437,1),
(7,436,1),
(7,66,4),
(7,76,2),
(7,435,1),
(7,92,1),
(7,101,1),
(7,73,13),
(7,100,1),
(7,99,1),
(7,98,1),
(7,77,7),
(7,97,1),
(7,804,6),
(7,803,6),
(7,802,6),
(7,801,6),
(7,800,6),
(7,1319,4),
(7,1318,4),
(7,799,1),
(7,798,1),
(7,696,1),
(7,797,1),
(7,796,1),
(7,795,1),
(7,794,1),
(7,793,1),
(7,792,1),
(7,791,1),
(7,687,1),
(7,686,1),
(7,685,1),
(7,684,1),
(7,683,1),
(7,32,1),
(7,682,1),
(7,557,1),
(7,556,1),
(7,555,1),
(7,554,1),
(7,553,1),
(7,790,2),
(7,789,2),
(7,788,2),
(7,787,2),
(7,9,2),
(7,10,2),
(7,7,2),
(7,786,2),
(7,785,2),
(7,784,2),
(7,783,2),
(7,569,2),
(7,568,2),
(7,567,2),
(7,566,2),
(7,565,2),
(7,564,1),
(7,563,1),
(7,562,1),
(7,561,1),
(7,560,1),
(7,319,1),
(7,559,1),
(7,329,3),
(7,558,4),
(7,54,1),
(7,53,1),
(7,52,1),
(7,51,1),
(7,50,1),
(7,33,1),
(7,12,1),
(7,5,1),
(7,413,2),
(7,23,3),
(7,22,4),
(7,412,1),
(7,411,1),
(7,27,1),
(7,410,1),
(7,409,3),
(7,408,3),
(7,317,5),
(7,407,2),
(7,422,1),
(7,421,1),
(7,47,2),
(7,420,2),
(7,419,1),
(7,49,4),
(7,418,1),
(7,42,2),
(7,417,1),
(7,416,1),
(7,415,1),
(7,6,4),
(7,15,2),
(7,414,1),
(7,31,1),
(7,40,1),
(7,39,1),
(7,38,1),
(7,37,1),
(7,16,7),
(7,36,1),
(7,782,6),
(7,781,6),
(7,780,6),
(7,779,6),
(7,778,6),
(6,312,4),
(6,311,6),
(6,310,6),
(6,309,4),
(6,308,4),
(6,306,3),
(6,272,3),
(6,777,1),
(6,776,1),
(6,775,1),
(6,774,1),
(6,773,1),
(6,772,1),
(6,771,1),
(6,259,1),
(6,299,1),
(6,770,1),
(6,769,1),
(6,768,1),
(6,767,1),
(6,766,1),
(6,765,1),
(6,764,1),
(6,763,1),
(6,762,2),
(6,677,2),
(6,676,2),
(6,675,2),
(6,674,2),
(6,673,2),
(6,672,2),
(6,671,2),
(6,492,4),
(6,670,2),
(27,1268,6),
(27,314,6),
(27,1218,6),
(27,317,5),
(27,318,1),
(27,319,4),
(27,41,1),
(27,320,1),
(27,321,1),
(27,322,1),
(27,323,1),
(27,324,1),
(27,325,1),
(27,326,1),
(27,327,1),
(27,15,5),
(27,328,1),
(27,329,2),
(27,31,2),
(27,330,1),
(27,36,1),
(27,16,7),
(27,37,1),
(27,38,1),
(27,39,1),
(27,40,1),
(27,414,1),
(27,6,4),
(27,415,1),
(27,416,1),
(27,417,1),
(27,42,3),
(27,418,1),
(27,49,6),
(27,419,1),
(27,420,2),
(27,47,2),
(27,421,1),
(27,422,1),
(27,33,3),
(27,50,3),
(27,51,3),
(27,52,3),
(27,53,3),
(27,54,3),
(27,407,2),
(27,408,3),
(27,409,2),
(27,410,1),
(27,27,1),
(27,411,1),
(27,412,1),
(27,22,4),
(27,23,1),
(27,413,2),
(27,5,1),
(27,12,1),
(27,510,2),
(27,511,2),
(27,32,2),
(27,512,2),
(27,9,2),
(27,547,2),
(27,548,2),
(27,549,2),
(27,550,2),
(27,551,2),
(27,24,2),
(27,552,2),
(27,553,1),
(27,554,1),
(27,555,1),
(27,556,1),
(27,557,1),
(27,558,1),
(27,559,1),
(27,560,1),
(27,561,1),
(27,562,1),
(27,563,1),
(27,564,1),
(27,565,1),
(27,566,1),
(27,567,1),
(27,568,1),
(27,569,1),
(27,1269,6),
(27,332,6),
(27,1222,6),
(27,335,5),
(27,336,1),
(27,337,4),
(27,102,1),
(27,338,1),
(27,339,1),
(27,340,1),
(27,341,1),
(27,106,4),
(27,342,1),
(27,73,9),
(27,343,1),
(27,344,1),
(27,345,1),
(27,76,5),
(27,346,1),
(27,347,2),
(27,92,2),
(27,348,1),
(27,97,1),
(27,77,7),
(27,98,1),
(27,99,1),
(27,100,1),
(27,101,1),
(27,435,1),
(27,66,4),
(27,436,1),
(27,437,1),
(27,438,1),
(27,103,3),
(27,439,1),
(27,111,6),
(27,440,1),
(27,441,2),
(27,109,2),
(27,442,1),
(27,443,1),
(27,94,3),
(27,112,3),
(27,113,3),
(27,114,3),
(27,115,3),
(27,116,3),
(27,428,2),
(27,429,3),
(27,430,2),
(27,431,1),
(27,88,1),
(27,432,1),
(27,433,1),
(27,83,1),
(27,84,1),
(27,434,2),
(27,65,1),
(27,72,1),
(27,517,2),
(27,518,2),
(27,93,2),
(27,519,2),
(27,69,2),
(27,574,2),
(27,575,2),
(27,576,2),
(27,577,2),
(27,578,2),
(27,85,2),
(27,579,2),
(27,580,1),
(27,581,1),
(27,582,1),
(27,583,1),
(27,584,1),
(27,585,1),
(27,586,1),
(27,587,1),
(27,588,1),
(27,589,1),
(27,590,1),
(27,591,1),
(27,592,1),
(27,593,1),
(27,594,1),
(27,595,1),
(27,596,1),
(27,117,3),
(27,1270,6),
(27,350,6),
(27,1226,6),
(27,353,5),
(27,354,1),
(27,355,4),
(27,165,1),
(27,356,1),
(27,357,1),
(27,358,1),
(27,359,1),
(27,169,4),
(27,360,1),
(27,136,9),
(27,361,1),
(27,362,1),
(27,363,1),
(27,139,5),
(27,364,1),
(27,365,2),
(27,155,2),
(27,366,1),
(27,160,1),
(27,140,7),
(27,161,1),
(27,162,1),
(27,163,1),
(27,164,1),
(27,456,1),
(27,129,4),
(27,457,1),
(27,458,1),
(27,459,1),
(27,166,3),
(27,460,1),
(27,174,6),
(27,461,1),
(27,462,2),
(27,172,2),
(27,463,1),
(27,464,1),
(27,157,3),
(27,175,3),
(27,176,3),
(27,177,3),
(27,178,3),
(27,179,3),
(27,449,2),
(27,450,3),
(27,451,2),
(27,452,1),
(27,151,1),
(27,453,1),
(27,454,1),
(27,146,1),
(27,147,1),
(27,455,2),
(27,128,1),
(27,135,1),
(27,524,2),
(27,525,2),
(27,156,2),
(27,526,2),
(27,132,2),
(27,601,2),
(27,602,2),
(27,603,2),
(27,604,2),
(27,605,2),
(27,148,2),
(27,606,2),
(27,607,1),
(27,608,1),
(27,609,1),
(27,610,1),
(27,611,1),
(27,612,1),
(27,613,1),
(27,614,1),
(27,615,1),
(27,616,1),
(27,617,1),
(27,618,1),
(27,619,1),
(27,620,1),
(27,621,1),
(27,622,1),
(27,623,1),
(27,180,3),
(27,1271,6),
(27,368,6),
(27,1230,6),
(27,371,5),
(27,372,1),
(27,373,4),
(27,228,1),
(27,374,1),
(27,375,1),
(27,376,1),
(27,377,1),
(27,232,4),
(27,378,1),
(27,199,9),
(27,379,1),
(27,380,1),
(27,381,1),
(27,202,5),
(27,382,1),
(27,383,2),
(27,218,2),
(27,384,1),
(27,223,1),
(27,203,7),
(27,224,1),
(27,225,1),
(27,226,1),
(27,227,1),
(27,477,1),
(27,192,4),
(27,478,1),
(27,479,1),
(27,480,1),
(27,229,3),
(27,481,1),
(27,237,6),
(27,482,1),
(27,483,2),
(27,235,2),
(27,484,1),
(27,485,1),
(27,220,3),
(27,238,3),
(27,239,3),
(27,240,3),
(27,241,3),
(27,242,3),
(27,470,2),
(27,471,3),
(27,472,2),
(27,473,1),
(27,214,1),
(27,474,1),
(27,475,1),
(27,209,1),
(27,210,1),
(27,476,2),
(27,191,1),
(27,198,1),
(27,531,2),
(27,532,2),
(27,219,2),
(27,533,2),
(27,195,2),
(27,628,2),
(27,629,2),
(27,630,2),
(27,631,2),
(27,632,2),
(27,211,2),
(27,633,2),
(27,634,1),
(27,635,1),
(27,636,1),
(27,637,1),
(27,638,1),
(27,639,1),
(27,640,1),
(27,641,1),
(27,642,1),
(27,643,1),
(27,644,1),
(27,645,1),
(27,646,1),
(27,647,1),
(27,648,1),
(27,649,1),
(27,650,1),
(27,243,3),
(27,1272,6),
(27,386,6),
(27,1234,6),
(27,389,5),
(27,390,1),
(27,391,4),
(27,291,1),
(27,392,1),
(27,393,1),
(27,394,1),
(27,395,1),
(27,295,4),
(27,396,1),
(27,262,9),
(27,397,1),
(27,398,1),
(27,399,1),
(27,265,5),
(27,400,1),
(27,401,2),
(27,281,2),
(27,402,1),
(27,286,1),
(27,266,7),
(27,287,1),
(27,288,1),
(27,289,1),
(27,290,1),
(27,498,1),
(27,255,4),
(27,499,1),
(27,500,1),
(27,501,1),
(27,292,3),
(27,502,1),
(27,300,6),
(27,503,1),
(27,504,2),
(27,298,2),
(27,505,1),
(27,506,1),
(27,283,3),
(27,301,3),
(27,302,3),
(27,303,3),
(27,304,3),
(27,305,3),
(27,491,2),
(27,492,3),
(27,493,2),
(27,494,1),
(27,277,1),
(27,495,1),
(27,496,1),
(27,272,4),
(27,273,1),
(27,497,2),
(27,254,1),
(27,261,1),
(27,538,2),
(27,539,2),
(27,282,2),
(27,540,2),
(27,258,2),
(27,655,2),
(27,656,2),
(27,657,2),
(27,658,2),
(27,659,2),
(27,274,2),
(27,660,2),
(27,661,1),
(27,662,1),
(27,663,1),
(27,664,1),
(27,665,1),
(27,666,1),
(27,667,1),
(27,668,1),
(27,669,1),
(27,670,1),
(27,671,1),
(27,672,1),
(27,673,1),
(27,674,1),
(27,675,1),
(27,676,1),
(27,677,1),
(27,306,3),
(6,669,2),
(6,668,2),
(6,667,2),
(6,497,2),
(6,666,4),
(6,660,2),
(6,274,2),
(6,659,2),
(6,658,2),
(6,657,2),
(6,656,2),
(6,655,2),
(6,258,2),
(6,540,1),
(6,282,3),
(6,539,1),
(6,538,1),
(6,305,1),
(6,304,1),
(6,303,1),
(6,302,1),
(6,301,1),
(6,283,1),
(6,506,1),
(6,505,1),
(6,298,3),
(6,504,3),
(6,503,1),
(6,300,3),
(6,502,1),
(6,292,3),
(6,501,1),
(6,500,1),
(6,499,1),
(6,255,4),
(6,498,1),
(6,290,1),
(6,289,1),
(6,288,1),
(6,287,1),
(6,266,6),
(6,286,1),
(6,402,1),
(6,281,2),
(6,401,3),
(6,400,1),
(6,265,6),
(6,399,1),
(6,398,1),
(6,397,1),
(6,262,11),
(6,396,1),
(6,295,2),
(6,395,1),
(6,394,1),
(6,393,1),
(6,392,1),
(6,291,1),
(6,391,4),
(6,390,1),
(6,389,7),
(6,761,6),
(6,760,6),
(6,759,6),
(6,758,6),
(6,249,4),
(6,248,6),
(6,247,6),
(6,246,4),
(6,245,4),
(6,243,3),
(6,757,1),
(6,756,1),
(6,755,1),
(6,754,1),
(6,753,1),
(6,752,1),
(6,751,1),
(6,196,1),
(6,236,1),
(6,750,1),
(6,749,1),
(6,748,1),
(6,747,1),
(6,746,1),
(6,745,1),
(6,744,1),
(6,743,1),
(6,742,2),
(6,650,2),
(6,649,2),
(6,648,2),
(6,647,2),
(6,646,2),
(6,645,2),
(6,644,2),
(6,471,4),
(6,643,2),
(6,642,2),
(6,641,2),
(6,640,2),
(6,476,2),
(6,639,4),
(6,633,2),
(6,211,2),
(6,632,2),
(6,631,2),
(6,630,2),
(6,629,2),
(6,628,2),
(6,195,2),
(6,533,1),
(6,219,3),
(6,532,1),
(6,531,1),
(6,242,1),
(6,241,1),
(6,240,1),
(6,239,1),
(6,238,1),
(6,220,1),
(6,485,1),
(6,484,1),
(6,235,3),
(6,483,3),
(6,482,1),
(6,237,3),
(6,481,1),
(6,229,3),
(6,480,1),
(6,479,1),
(6,478,1),
(6,192,4),
(6,477,1),
(6,227,1),
(6,226,1),
(6,225,1),
(6,224,1),
(6,203,6),
(6,223,1),
(6,384,1),
(6,218,2),
(6,383,3),
(6,382,1),
(6,202,6),
(6,381,1),
(6,380,1),
(6,379,1),
(6,199,11),
(6,378,1),
(6,232,2),
(6,377,1),
(6,376,1),
(6,375,1),
(6,374,1),
(6,228,1),
(6,373,4),
(6,372,1),
(6,371,7),
(6,741,6),
(6,740,6),
(6,739,6),
(6,738,6),
(6,186,4),
(6,185,6),
(6,184,6),
(6,183,4),
(6,182,4),
(6,180,3),
(6,737,1),
(6,736,1),
(6,735,1),
(6,734,1),
(6,733,1),
(6,732,1),
(6,731,1),
(6,133,1),
(6,173,1),
(6,730,1),
(6,729,1),
(6,728,1),
(6,727,1),
(6,726,1),
(6,725,1),
(6,724,1),
(6,723,1),
(6,722,2),
(6,623,2),
(6,622,2),
(6,621,2),
(6,620,2),
(6,619,2),
(6,618,2),
(6,617,2),
(6,450,4),
(6,616,2),
(6,615,2),
(6,614,2),
(6,613,2),
(6,455,2),
(6,612,4),
(6,606,2),
(6,148,2),
(6,605,2),
(6,604,2),
(6,603,2),
(6,602,2),
(6,601,2),
(6,132,2),
(6,526,1),
(6,156,3),
(6,525,1),
(6,524,1),
(6,179,1),
(6,178,1),
(6,177,1),
(6,176,1),
(6,175,1),
(6,157,1),
(6,464,1),
(6,463,1),
(6,172,3),
(6,462,3),
(6,461,1),
(6,174,3),
(6,460,1),
(6,166,3),
(6,459,1),
(6,458,1),
(6,457,1),
(6,129,4),
(6,456,1),
(6,164,1),
(6,163,1),
(6,162,1),
(6,161,1),
(6,140,6),
(6,160,1),
(6,366,1),
(6,155,2),
(6,365,3),
(6,364,1),
(6,139,6),
(6,363,1),
(6,362,1),
(6,361,1),
(6,136,11),
(6,360,1),
(6,169,2),
(6,359,1),
(6,358,1),
(6,357,1),
(6,356,1),
(6,165,1),
(6,355,4),
(6,354,1),
(6,353,7),
(6,721,6),
(6,720,6),
(6,719,6),
(6,718,6),
(6,123,4),
(6,122,6),
(6,121,6),
(6,120,4),
(6,119,4),
(6,117,3),
(6,717,1),
(6,716,1),
(6,715,1),
(6,714,1),
(6,713,1),
(6,712,1),
(6,711,1),
(6,70,1),
(6,110,1),
(6,710,1),
(6,709,1),
(6,708,1),
(6,707,1),
(6,706,1),
(6,705,1),
(6,704,1),
(6,703,1),
(6,702,2),
(6,596,2),
(6,595,2),
(6,594,2),
(6,593,2),
(6,592,2),
(6,591,2),
(6,590,2),
(6,429,4),
(6,589,2),
(6,588,2),
(6,587,2),
(6,586,2),
(6,434,2),
(6,585,4),
(6,579,2),
(6,85,2),
(6,578,2),
(6,577,2),
(6,576,2),
(6,575,2),
(6,574,2),
(6,69,2),
(6,519,1),
(6,93,3),
(6,518,1),
(6,517,1),
(6,116,1),
(6,115,1),
(6,114,1),
(6,113,1),
(6,112,1),
(6,94,1),
(6,443,1),
(6,442,1),
(6,109,3),
(6,441,3),
(6,440,1),
(6,111,3),
(6,439,1),
(6,103,3),
(6,438,1),
(6,437,1),
(6,436,1),
(6,66,4),
(6,435,1),
(6,101,1),
(6,100,1),
(6,99,1),
(6,98,1),
(6,77,6),
(6,97,1),
(6,348,1),
(6,92,2),
(6,347,3),
(6,346,1),
(6,76,6),
(6,345,1),
(6,344,1),
(6,343,1),
(6,73,11),
(6,342,1),
(6,106,2),
(6,341,1),
(6,340,1),
(6,339,1),
(6,338,1),
(6,102,1),
(6,337,4),
(6,336,1),
(6,335,7),
(6,701,6),
(6,700,6),
(6,699,6),
(6,698,6),
(6,60,4),
(6,59,6),
(6,58,6),
(6,57,4),
(6,56,4),
(6,1319,4),
(6,1318,4),
(6,22,3),
(6,697,1),
(6,696,1),
(6,695,1),
(6,694,1),
(6,693,1),
(6,692,1),
(6,691,1),
(6,10,1),
(6,48,1),
(6,690,1),
(6,689,1),
(6,688,1),
(6,687,1),
(6,686,1),
(6,685,1),
(6,684,1),
(6,683,1),
(6,682,2),
(6,569,2),
(6,568,2),
(6,567,2),
(6,566,2),
(6,565,2),
(6,564,2),
(6,563,2),
(6,408,4),
(6,562,2),
(6,561,2),
(6,560,2),
(6,559,2),
(6,413,2),
(6,558,4),
(6,552,2),
(6,24,2),
(6,551,2),
(6,550,2),
(6,549,2),
(6,548,2),
(6,547,2),
(6,9,2),
(6,512,1),
(6,32,3),
(6,511,1),
(6,510,1),
(6,54,1),
(6,53,1),
(6,52,1),
(6,51,1),
(6,50,1),
(6,33,1),
(6,422,1),
(6,421,1),
(6,47,3),
(6,420,3),
(6,419,1),
(6,49,3),
(6,418,1),
(6,42,3),
(6,417,1),
(6,416,1),
(6,415,1),
(6,6,4),
(6,414,1),
(6,40,1),
(6,39,1),
(6,38,1),
(6,37,1),
(6,16,6),
(6,36,1),
(6,330,1),
(6,31,2),
(6,329,3),
(6,328,1),
(6,15,6),
(6,327,1),
(6,326,1),
(6,325,1),
(6,324,1),
(6,323,1),
(6,322,1),
(6,321,1),
(6,320,1),
(6,41,1),
(6,319,4),
(6,318,1),
(6,317,7),
(6,681,6),
(6,680,6),
(6,679,6),
(6,678,6),
(29,1273,6),
(29,1293,6),
(29,1218,6),
(29,1294,6),
(29,414,1),
(29,15,2),
(29,6,4),
(29,415,1),
(29,416,1),
(29,417,1),
(29,42,2),
(29,418,1),
(29,49,4),
(29,419,1),
(29,420,2),
(29,16,6),
(29,47,2),
(29,421,1),
(29,422,1),
(29,407,2),
(29,317,5),
(29,408,3),
(29,409,3),
(29,410,1),
(29,27,1),
(29,411,1),
(29,412,1),
(29,22,4),
(29,23,3),
(29,413,2),
(29,5,1),
(29,12,1),
(29,33,1),
(29,50,1),
(29,51,1),
(29,52,1),
(29,53,1),
(29,54,1),
(29,319,2),
(29,510,1),
(29,511,1),
(29,32,2),
(29,512,1),
(29,558,4),
(29,329,3),
(29,559,1),
(29,560,1),
(29,561,1),
(29,562,1),
(29,563,1),
(29,564,1),
(29,565,2),
(29,566,2),
(29,567,2),
(29,568,2),
(29,569,2),
(29,783,2),
(29,784,2),
(29,785,2),
(29,786,2),
(29,7,2),
(29,10,2),
(29,9,2),
(29,787,2),
(29,788,2),
(29,789,2),
(29,790,2),
(29,553,1),
(29,554,1),
(29,555,1),
(29,556,1),
(29,557,1),
(29,682,1),
(29,683,1),
(29,684,1),
(29,685,1),
(29,686,1),
(29,687,1),
(29,791,1),
(29,792,1),
(29,793,1),
(29,794,1),
(29,795,1),
(29,796,1),
(29,797,1),
(29,696,1),
(29,798,1),
(29,799,1),
(29,1277,6),
(29,1295,6),
(29,1222,6),
(29,1296,6),
(29,435,1),
(29,76,2),
(29,66,4),
(29,436,1),
(29,437,1),
(29,438,1),
(29,103,2),
(29,439,1),
(29,111,4),
(29,440,1),
(29,441,2),
(29,77,6),
(29,109,2),
(29,442,1),
(29,73,12),
(29,443,1),
(29,428,2),
(29,335,5),
(29,429,3),
(29,430,3),
(29,431,1),
(29,88,1),
(29,432,1),
(29,433,1),
(29,83,1),
(29,84,3),
(29,434,2),
(29,65,1),
(29,72,1),
(29,94,1),
(29,106,3),
(29,112,1),
(29,113,1),
(29,114,1),
(29,115,1),
(29,116,1),
(29,337,2),
(29,517,1),
(29,518,1),
(29,93,2),
(29,519,1),
(29,585,4),
(29,347,3),
(29,586,1),
(29,587,1),
(29,588,1),
(29,589,1),
(29,590,1),
(29,591,1),
(29,592,2),
(29,593,2),
(29,594,2),
(29,595,2),
(29,596,2),
(29,805,2),
(29,806,2),
(29,807,2),
(29,808,2),
(29,67,2),
(29,70,2),
(29,69,2),
(29,809,2),
(29,810,2),
(29,811,2),
(29,812,2),
(29,580,1),
(29,581,1),
(29,582,1),
(29,583,1),
(29,584,1),
(29,702,1),
(29,703,1),
(29,704,1),
(29,705,1),
(29,706,1),
(29,707,1),
(29,813,1),
(29,814,1),
(29,815,1),
(29,816,1),
(29,817,1),
(29,818,1),
(29,819,1),
(29,716,1),
(29,820,1),
(29,821,1),
(29,117,3),
(29,1281,6),
(29,1297,6),
(29,1226,6),
(29,1298,6),
(29,456,1),
(29,139,2),
(29,129,4),
(29,457,1),
(29,458,1),
(29,459,1),
(29,166,2),
(29,460,1),
(29,174,4),
(29,461,1),
(29,462,2),
(29,140,6),
(29,172,2),
(29,463,1),
(29,136,12),
(29,464,1),
(29,449,2),
(29,353,5),
(29,450,3),
(29,451,3),
(29,452,1),
(29,151,1),
(29,453,1),
(29,454,1),
(29,146,1),
(29,147,3),
(29,455,2),
(29,128,1),
(29,135,1),
(29,157,1),
(29,169,3),
(29,175,1),
(29,176,1),
(29,177,1),
(29,178,1),
(29,179,1),
(29,355,2),
(29,524,1),
(29,525,1),
(29,156,2),
(29,526,1),
(29,612,4),
(29,365,3),
(29,613,1),
(29,614,1),
(29,615,1),
(29,616,1),
(29,617,1),
(29,618,1),
(29,619,2),
(29,620,2),
(29,621,2),
(29,622,2),
(29,623,2),
(29,827,2),
(29,828,2),
(29,829,2),
(29,830,2),
(29,130,2),
(29,133,2),
(29,132,2),
(29,831,2),
(29,832,2),
(29,833,2),
(29,834,2),
(29,607,1),
(29,608,1),
(29,609,1),
(29,610,1),
(29,611,1),
(29,722,1),
(29,723,1),
(29,724,1),
(29,725,1),
(29,726,1),
(29,727,1),
(29,835,1),
(29,836,1),
(29,837,1),
(29,838,1),
(29,839,1),
(29,840,1),
(29,841,1),
(29,736,1),
(29,842,1),
(29,843,1),
(29,180,3),
(29,1285,6),
(29,1299,6),
(29,1230,6),
(29,1300,6),
(29,477,1),
(29,202,2),
(29,192,4),
(29,478,1),
(29,479,1),
(29,480,1),
(29,229,2),
(29,481,1),
(29,237,4),
(29,482,1),
(29,483,2),
(29,203,6),
(29,235,2),
(29,484,1),
(29,199,12),
(29,485,1),
(29,470,2),
(29,371,5),
(29,471,3),
(29,472,3),
(29,473,1),
(29,214,1),
(29,474,1),
(29,475,1),
(29,209,1),
(29,210,3),
(29,476,2),
(29,191,1),
(29,198,1),
(29,220,1),
(29,232,3),
(29,238,1),
(29,239,1),
(29,240,1),
(29,241,1),
(29,242,1),
(29,373,2),
(29,531,1),
(29,532,1),
(29,219,2),
(29,533,1),
(29,639,4),
(29,383,3),
(29,640,1),
(29,641,1),
(29,642,1),
(29,643,1),
(29,644,1),
(29,645,1),
(29,646,2),
(29,647,2),
(29,648,2),
(29,649,2),
(29,650,2),
(29,849,2),
(29,850,2),
(29,851,2),
(29,852,2),
(29,193,2),
(29,196,2),
(29,195,2),
(29,853,2),
(29,854,2),
(29,855,2),
(29,856,2),
(29,634,1),
(29,635,1),
(29,636,1),
(29,637,1),
(29,638,1),
(29,742,1),
(29,743,1),
(29,744,1),
(29,745,1),
(29,746,1),
(29,747,1),
(29,857,1),
(29,858,1),
(29,859,1),
(29,860,1),
(29,861,1),
(29,862,1),
(29,863,1),
(29,756,1),
(29,864,1),
(29,865,1),
(29,243,3),
(29,1289,6),
(29,1301,6),
(29,1234,6),
(29,1302,6),
(29,498,1),
(29,265,2),
(29,255,4),
(29,499,1),
(29,500,1),
(29,501,1),
(29,292,2),
(29,502,1),
(29,300,4),
(29,503,1),
(29,504,2),
(29,266,6),
(29,298,2),
(29,505,1),
(29,262,12),
(29,506,1),
(29,491,2),
(29,389,5),
(29,492,3),
(29,493,3),
(29,494,1),
(29,277,1),
(29,495,1),
(29,496,1),
(29,272,4),
(29,273,3),
(29,497,2),
(29,254,1),
(29,261,1),
(29,283,1),
(29,295,3),
(29,301,1),
(29,302,1),
(29,303,1),
(29,304,1),
(29,305,1),
(29,391,2),
(29,538,1),
(29,539,1),
(29,282,2),
(29,540,1),
(29,666,4),
(29,401,3),
(29,667,1),
(29,668,1),
(29,669,1),
(29,670,1),
(29,671,1),
(29,672,1),
(29,673,2),
(29,674,2),
(29,675,2),
(29,676,2),
(29,677,2),
(29,871,2),
(29,872,2),
(29,873,2),
(29,874,2),
(29,256,2),
(29,259,2),
(29,258,2),
(29,875,2),
(29,876,2),
(29,877,2),
(29,878,2),
(29,661,1),
(29,662,1),
(29,663,1),
(29,664,1),
(29,665,1),
(29,762,1),
(29,763,1),
(29,764,1),
(29,765,1),
(29,766,1),
(29,767,1),
(29,879,1),
(29,880,1),
(29,881,1),
(29,882,1),
(29,883,1),
(29,884,1),
(29,885,1),
(29,776,1),
(29,886,1),
(29,887,1),
(29,306,3),
(30,1303,6),
(30,315,6),
(30,316,6),
(30,1304,6),
(30,1305,6),
(30,407,2),
(30,317,4),
(30,408,3),
(30,409,4),
(30,410,1),
(30,27,2),
(30,411,1),
(30,412,1),
(30,22,4),
(30,23,2),
(30,413,1),
(30,5,1),
(30,12,1),
(30,16,7),
(30,33,2),
(30,49,3),
(30,50,1),
(30,51,1),
(30,52,1),
(30,53,1),
(30,54,1),
(30,319,1),
(30,510,1),
(30,511,1),
(30,32,3),
(30,512,1),
(30,9,2),
(30,42,3),
(30,547,1),
(30,548,1),
(30,549,1),
(30,15,1),
(30,550,1),
(30,6,2),
(30,551,1),
(30,24,1),
(30,552,1),
(30,553,2),
(30,554,2),
(30,555,2),
(30,556,2),
(30,557,2),
(30,783,1),
(30,784,1),
(30,558,3),
(30,329,1),
(30,785,1),
(30,786,1),
(30,7,1),
(30,10,1),
(30,787,1),
(30,788,1),
(30,789,1),
(30,790,1),
(30,682,2),
(30,683,2),
(30,684,2),
(30,685,2),
(30,686,2),
(30,687,2),
(30,791,2),
(30,792,2),
(30,793,2),
(30,794,2),
(30,795,2),
(30,796,2),
(30,797,2),
(30,696,3),
(30,798,2),
(30,799,2),
(30,36,1),
(30,37,1),
(30,38,1),
(30,39,1),
(30,40,1),
(30,31,1),
(30,898,1),
(30,318,1),
(30,899,1),
(30,900,1),
(30,901,1),
(30,902,1),
(30,903,1),
(30,904,1),
(30,905,1),
(30,906,1),
(30,907,1),
(30,908,1),
(30,1306,6),
(30,333,6),
(30,334,6),
(30,1307,6),
(30,1308,6),
(30,428,2),
(30,335,4),
(30,429,3),
(30,430,4),
(30,431,1),
(30,88,2),
(30,432,1),
(30,433,1),
(30,83,1),
(30,84,2),
(30,434,1),
(30,65,1),
(30,73,10),
(30,72,1),
(30,77,7),
(30,94,2),
(30,111,3),
(30,106,5),
(30,112,1),
(30,113,1),
(30,114,1),
(30,115,1),
(30,116,1),
(30,337,1),
(30,517,1),
(30,518,1),
(30,93,3),
(30,519,1),
(30,69,2),
(30,103,3),
(30,574,1),
(30,575,1),
(30,576,1),
(30,76,1),
(30,577,1),
(30,66,2),
(30,578,1),
(30,85,1),
(30,579,1),
(30,580,2),
(30,581,2),
(30,582,2),
(30,583,2),
(30,584,2),
(30,805,1),
(30,806,1),
(30,585,3),
(30,347,1),
(30,807,1),
(30,808,1),
(30,67,1),
(30,70,1),
(30,809,1),
(30,810,1),
(30,811,1),
(30,812,1),
(30,702,2),
(30,703,2),
(30,704,2),
(30,705,2),
(30,706,2),
(30,707,2),
(30,813,2),
(30,814,2),
(30,815,2),
(30,816,2),
(30,817,2),
(30,818,2),
(30,819,2),
(30,716,3),
(30,820,2),
(30,821,2),
(30,97,1),
(30,98,1),
(30,99,1),
(30,100,1),
(30,101,1),
(30,92,1),
(30,919,1),
(30,336,1),
(30,920,1),
(30,921,1),
(30,922,1),
(30,923,1),
(30,924,1),
(30,925,1),
(30,926,1),
(30,927,1),
(30,928,1),
(30,929,1),
(30,117,3),
(30,1309,6),
(30,351,6),
(30,352,6),
(30,1310,6),
(30,1311,6),
(30,449,2),
(30,353,4),
(30,450,3),
(30,451,4),
(30,452,1),
(30,151,2),
(30,453,1),
(30,454,1),
(30,146,1),
(30,147,2),
(30,455,1),
(30,128,1),
(30,136,10),
(30,135,1),
(30,140,7),
(30,157,2),
(30,174,3),
(30,169,5),
(30,175,1),
(30,176,1),
(30,177,1),
(30,178,1),
(30,179,1),
(30,355,1),
(30,524,1),
(30,525,1),
(30,156,3),
(30,526,1),
(30,132,2),
(30,166,3),
(30,601,1),
(30,602,1),
(30,603,1),
(30,139,1),
(30,604,1),
(30,129,2),
(30,605,1),
(30,148,1),
(30,606,1),
(30,607,2),
(30,608,2),
(30,609,2),
(30,610,2),
(30,611,2),
(30,827,1),
(30,828,1),
(30,612,3),
(30,365,1),
(30,829,1),
(30,830,1),
(30,130,1),
(30,133,1),
(30,831,1),
(30,832,1),
(30,833,1),
(30,834,1),
(30,722,2),
(30,723,2),
(30,724,2),
(30,725,2),
(30,726,2),
(30,727,2),
(30,835,2),
(30,836,2),
(30,837,2),
(30,838,2),
(30,839,2),
(30,840,2),
(30,841,2),
(30,736,3),
(30,842,2),
(30,843,2),
(30,160,1),
(30,161,1),
(30,162,1),
(30,163,1),
(30,164,1),
(30,155,1),
(30,940,1),
(30,354,1),
(30,941,1),
(30,942,1),
(30,943,1),
(30,944,1),
(30,945,1),
(30,946,1),
(30,947,1),
(30,948,1),
(30,949,1),
(30,950,1),
(30,180,3),
(30,1312,6),
(30,369,6),
(30,370,6),
(30,1313,6),
(30,1314,6),
(30,470,2),
(30,371,4),
(30,471,3),
(30,472,4),
(30,473,1),
(30,214,2),
(30,474,1),
(30,475,1),
(30,209,1),
(30,210,2),
(30,476,1),
(30,191,1),
(30,199,10),
(30,198,1),
(30,203,7),
(30,220,2),
(30,237,3),
(30,232,5),
(30,238,1),
(30,239,1),
(30,240,1),
(30,241,1),
(30,242,1),
(30,373,1),
(30,531,1),
(30,532,1),
(30,219,3),
(30,533,1),
(30,195,2),
(30,229,3),
(30,628,1),
(30,629,1),
(30,630,1),
(30,202,1),
(30,631,1),
(30,192,2),
(30,632,1),
(30,211,1),
(30,633,1),
(30,634,2),
(30,635,2),
(30,636,2),
(30,637,2),
(30,638,2),
(30,849,1),
(30,850,1),
(30,639,3),
(30,383,1),
(30,851,1),
(30,852,1),
(30,193,1),
(30,196,1),
(30,853,1),
(30,854,1),
(30,855,1),
(30,856,1),
(30,742,2),
(30,743,2),
(30,744,2),
(30,745,2),
(30,746,2),
(30,747,2),
(30,857,2),
(30,858,2),
(30,859,2),
(30,860,2),
(30,861,2),
(30,862,2),
(30,863,2),
(30,756,3),
(30,864,2),
(30,865,2),
(30,223,1),
(30,224,1),
(30,225,1),
(30,226,1),
(30,227,1),
(30,218,1),
(30,961,1),
(30,372,1),
(30,962,1),
(30,963,1),
(30,964,1),
(30,965,1),
(30,966,1),
(30,967,1),
(30,968,1),
(30,969,1),
(30,970,1),
(30,971,1),
(30,243,3),
(30,1315,6),
(30,387,6),
(30,388,6),
(30,1316,6),
(30,1317,6),
(30,491,2),
(30,389,4),
(30,492,3),
(30,493,4),
(30,494,1),
(30,277,2),
(30,495,1),
(30,496,1),
(30,272,4),
(30,273,2),
(30,497,1),
(30,254,1),
(30,262,10),
(30,261,1),
(30,266,7),
(30,283,2),
(30,300,3),
(30,295,5),
(30,301,1),
(30,302,1),
(30,303,1),
(30,304,1),
(30,305,1),
(30,391,1),
(30,538,1),
(30,539,1),
(30,282,3),
(30,540,1),
(30,258,2),
(30,292,3),
(30,655,1),
(30,656,1),
(30,657,1),
(30,265,1),
(30,658,1),
(30,255,2),
(30,659,1),
(30,274,1),
(30,660,1),
(30,661,2),
(30,662,2),
(30,663,2),
(30,664,2),
(30,665,2),
(30,871,1),
(30,872,1),
(30,666,3),
(30,401,1),
(30,873,1),
(30,874,1),
(30,256,1),
(30,259,1),
(30,875,1),
(30,876,1),
(30,877,1),
(30,878,1),
(30,762,2),
(30,763,2),
(30,764,2),
(30,765,2),
(30,766,2),
(30,767,2),
(30,879,2),
(30,880,2),
(30,881,2),
(30,882,2),
(30,883,2),
(30,884,2),
(30,885,2),
(30,776,3),
(30,886,2),
(30,887,2),
(30,286,1),
(30,287,1),
(30,288,1),
(30,289,1),
(30,290,1),
(30,281,1),
(30,982,1),
(30,390,1),
(30,983,1),
(30,984,1),
(30,985,1),
(30,986,1),
(30,987,1),
(30,988,1),
(30,989,1),
(30,990,1),
(30,991,1),
(30,992,1),
(30,306,3),
(28,767,1),
(28,768,1),
(28,769,1),
(28,770,1),
(28,299,1),
(28,259,1),
(28,771,1),
(28,772,1),
(28,773,1),
(28,774,1),
(28,775,1),
(28,776,1),
(28,777,1),
(28,306,3),
(10,281,1),
(10,306,3),
(23,290,1),
(23,306,3);

/* Table structure for table `ps_search_word` */
DROP TABLE IF EXISTS `ps_search_word`;

CREATE TABLE `ps_search_word` (
  `id_word` int(10) unsigned NOT NULL auto_increment,
  `id_lang` int(10) unsigned NOT NULL,
  `word` varchar(15) NOT NULL,
  PRIMARY KEY  (`id_word`),
  UNIQUE KEY `id_lang` (`id_lang`,`word`)
) ENGINE=MyISAM AUTO_INCREMENT=1323 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_search_word` */
INSERT INTO `ps_search_word` VALUES
(1,1,'water'),
(2,1,'kettler'),
(3,1,'swk'),
(4,1,'1753'),
(5,1,'comfort'),
(6,1,'very'),
(7,1,'important'),
(8,1,'thing'),
(9,1,'nowadays'),
(10,1,'because'),
(11,1,'condition'),
(12,1,'satisfaction'),
(13,1,'calmness'),
(14,1,'clear'),
(15,1,'that'),
(16,1,'our'),
(17,1,'way'),
(18,1,'life'),
(19,1,'must'),
(20,1,'comfortable'),
(21,1,'possible'),
(22,1,'home'),
(23,1,'electronics'),
(24,1,'satisfy'),
(25,1,'wishes'),
(26,1,'make'),
(27,1,'more'),
(28,1,'pleasant'),
(29,1,'admit'),
(30,1,'depends'),
(31,1,'quality'),
(32,1,'different'),
(33,1,'goods'),
(34,1,'popular'),
(35,1,'brands'),
(36,1,'recipe'),
(37,1,'success'),
(38,1,'fair'),
(39,1,'price'),
(40,1,'premium'),
(41,1,'many'),
(42,1,'clients'),
(43,1,'were'),
(44,1,'surprised'),
(45,1,'incredible'),
(46,1,'assortment'),
(47,1,'products'),
(48,1,'store'),
(49,1,'are'),
(50,1,'combination'),
(51,1,'perfect'),
(52,1,'design'),
(53,1,'ideal'),
(54,1,'functionality'),
(55,1,'adipisicing'),
(56,1,'black'),
(57,1,'green'),
(58,1,'metal'),
(59,1,'plastic'),
(60,1,'red'),
(61,2,'water'),
(62,2,'kettler'),
(63,2,'swk'),
(64,2,'1753'),
(65,2,'comfort'),
(66,2,'very'),
(67,2,'important'),
(68,2,'thing'),
(69,2,'nowadays'),
(70,2,'because'),
(71,2,'condition'),
(72,2,'satisfaction'),
(73,2,'and'),
(74,2,'calmness'),
(75,2,'clear'),
(76,2,'that'),
(77,2,'our'),
(78,2,'way'),
(79,2,'life'),
(80,2,'must'),
(81,2,'comfortable'),
(82,2,'possible'),
(83,2,'home'),
(84,2,'electronics'),
(85,2,'satisfy'),
(86,2,'wishes'),
(87,2,'make'),
(88,2,'more'),
(89,2,'pleasant'),
(90,2,'admit'),
(91,2,'depends'),
(92,2,'quality'),
(93,2,'different'),
(94,2,'goods'),
(95,2,'popular'),
(96,2,'brands'),
(97,2,'recipe'),
(98,2,'success'),
(99,2,'fair'),
(100,2,'price'),
(101,2,'premium'),
(102,2,'many'),
(103,2,'clients'),
(104,2,'were'),
(105,2,'surprised'),
(106,2,'the'),
(107,2,'incredible'),
(108,2,'assortment'),
(109,2,'products'),
(110,2,'store'),
(111,2,'are'),
(112,2,'combination'),
(113,2,'perfect'),
(114,2,'design'),
(115,2,'ideal'),
(116,2,'functionality'),
(117,2,'accueil'),
(118,2,'adipisicing'),
(119,2,'black'),
(120,2,'green'),
(121,2,'metal'),
(122,2,'plastic'),
(123,2,'red'),
(124,3,'water'),
(125,3,'kettler'),
(126,3,'swk'),
(127,3,'1753'),
(128,3,'comfort'),
(129,3,'very'),
(130,3,'important'),
(131,3,'thing'),
(132,3,'nowadays'),
(133,3,'because'),
(134,3,'condition'),
(135,3,'satisfaction'),
(136,3,'and'),
(137,3,'calmness'),
(138,3,'clear'),
(139,3,'that'),
(140,3,'our'),
(141,3,'way'),
(142,3,'life'),
(143,3,'must'),
(144,3,'comfortable'),
(145,3,'possible'),
(146,3,'home'),
(147,3,'electronics'),
(148,3,'satisfy'),
(149,3,'wishes'),
(150,3,'make'),
(151,3,'more'),
(152,3,'pleasant'),
(153,3,'admit'),
(154,3,'depends'),
(155,3,'quality'),
(156,3,'different'),
(157,3,'goods'),
(158,3,'popular'),
(159,3,'brands'),
(160,3,'recipe'),
(161,3,'success'),
(162,3,'fair'),
(163,3,'price'),
(164,3,'premium'),
(165,3,'many'),
(166,3,'clients'),
(167,3,'were'),
(168,3,'surprised'),
(169,3,'the'),
(170,3,'incredible'),
(171,3,'assortment'),
(172,3,'products'),
(173,3,'store'),
(174,3,'are'),
(175,3,'combination'),
(176,3,'perfect'),
(177,3,'design'),
(178,3,'ideal'),
(179,3,'functionality'),
(180,3,'inicio'),
(181,3,'adipisicing'),
(182,3,'black'),
(183,3,'green'),
(184,3,'metal'),
(185,3,'plastic'),
(186,3,'red'),
(187,4,'water'),
(188,4,'kettler'),
(189,4,'swk'),
(190,4,'1753'),
(191,4,'comfort'),
(192,4,'very'),
(193,4,'important'),
(194,4,'thing'),
(195,4,'nowadays'),
(196,4,'because'),
(197,4,'condition'),
(198,4,'satisfaction'),
(199,4,'and'),
(200,4,'calmness'),
(201,4,'clear'),
(202,4,'that'),
(203,4,'our'),
(204,4,'way'),
(205,4,'life'),
(206,4,'must'),
(207,4,'comfortable'),
(208,4,'possible'),
(209,4,'home'),
(210,4,'electronics'),
(211,4,'satisfy'),
(212,4,'wishes'),
(213,4,'make'),
(214,4,'more'),
(215,4,'pleasant'),
(216,4,'admit'),
(217,4,'depends'),
(218,4,'quality'),
(219,4,'different'),
(220,4,'goods'),
(221,4,'popular'),
(222,4,'brands'),
(223,4,'recipe'),
(224,4,'success'),
(225,4,'fair'),
(226,4,'price'),
(227,4,'premium'),
(228,4,'many'),
(229,4,'clients'),
(230,4,'were'),
(231,4,'surprised'),
(232,4,'the'),
(233,4,'incredible'),
(234,4,'assortment'),
(235,4,'products'),
(236,4,'store'),
(237,4,'are'),
(238,4,'combination'),
(239,4,'perfect'),
(240,4,'design'),
(241,4,'ideal'),
(242,4,'functionality'),
(243,4,'start'),
(244,4,'adipisicing'),
(245,4,'black'),
(246,4,'green'),
(247,4,'metal'),
(248,4,'plastic'),
(249,4,'red'),
(250,5,'water'),
(251,5,'kettler'),
(252,5,'swk'),
(253,5,'1753'),
(254,5,'comfort'),
(255,5,'very'),
(256,5,'important'),
(257,5,'thing'),
(258,5,'nowadays'),
(259,5,'because'),
(260,5,'condition'),
(261,5,'satisfaction'),
(262,5,'and'),
(263,5,'calmness'),
(264,5,'clear'),
(265,5,'that'),
(266,5,'our'),
(267,5,'way'),
(268,5,'life'),
(269,5,'must'),
(270,5,'comfortable'),
(271,5,'possible'),
(272,5,'home'),
(273,5,'electronics'),
(274,5,'satisfy'),
(275,5,'wishes'),
(276,5,'make'),
(277,5,'more'),
(278,5,'pleasant'),
(279,5,'admit'),
(280,5,'depends'),
(281,5,'quality'),
(282,5,'different'),
(283,5,'goods'),
(284,5,'popular'),
(285,5,'brands'),
(286,5,'recipe'),
(287,5,'success'),
(288,5,'fair'),
(289,5,'price'),
(290,5,'premium'),
(291,5,'many'),
(292,5,'clients'),
(293,5,'were'),
(294,5,'surprised'),
(295,5,'the'),
(296,5,'incredible'),
(297,5,'assortment'),
(298,5,'products'),
(299,5,'store'),
(300,5,'are'),
(301,5,'combination'),
(302,5,'perfect'),
(303,5,'design'),
(304,5,'ideal'),
(305,5,'functionality'),
(306,5,'page'),
(307,5,'adipisicing'),
(308,5,'black'),
(309,5,'green'),
(310,5,'metal'),
(311,5,'plastic'),
(312,5,'red'),
(313,1,'eclipse'),
(314,1,'electrolux'),
(315,1,'vacuum'),
(316,1,'cleaner'),
(317,1,'you'),
(318,1,'know'),
(319,1,'have'),
(320,1,'devoted'),
(321,1,'customers'),
(322,1,'all'),
(323,1,'over'),
(324,1,'world'),
(325,1,'this'),
(326,1,'fact'),
(327,1,'proves'),
(328,1,'sell'),
(329,1,'only'),
(330,1,'commodities'),
(331,2,'eclipse'),
(332,2,'electrolux'),
(333,2,'vacuum'),
(334,2,'cleaner'),
(335,2,'you'),
(336,2,'know'),
(337,2,'have'),
(338,2,'devoted'),
(339,2,'customers'),
(340,2,'all'),
(341,2,'over'),
(342,2,'world'),
(343,2,'this'),
(344,2,'fact'),
(345,2,'proves'),
(346,2,'sell'),
(347,2,'only'),
(348,2,'commodities'),
(349,3,'eclipse'),
(350,3,'electrolux'),
(351,3,'vacuum'),
(352,3,'cleaner'),
(353,3,'you'),
(354,3,'know'),
(355,3,'have'),
(356,3,'devoted'),
(357,3,'customers'),
(358,3,'all'),
(359,3,'over'),
(360,3,'world'),
(361,3,'this'),
(362,3,'fact'),
(363,3,'proves'),
(364,3,'sell'),
(365,3,'only'),
(366,3,'commodities'),
(367,4,'eclipse'),
(368,4,'electrolux'),
(369,4,'vacuum'),
(370,4,'cleaner'),
(371,4,'you'),
(372,4,'know'),
(373,4,'have'),
(374,4,'devoted'),
(375,4,'customers'),
(376,4,'all'),
(377,4,'over'),
(378,4,'world'),
(379,4,'this'),
(380,4,'fact'),
(381,4,'proves'),
(382,4,'sell'),
(383,4,'only'),
(384,4,'commodities'),
(385,5,'eclipse'),
(386,5,'electrolux'),
(387,5,'vacuum'),
(388,5,'cleaner'),
(389,5,'you'),
(390,5,'know'),
(391,5,'have'),
(392,5,'devoted'),
(393,5,'customers'),
(394,5,'all'),
(395,5,'over'),
(396,5,'world'),
(397,5,'this'),
(398,5,'fact'),
(399,5,'proves'),
(400,5,'sell'),
(401,5,'only'),
(402,5,'commodities'),
(403,1,'hood'),
(404,1,'scholtes'),
(405,1,'hse'),
(406,1,'159'),
(407,1,'here'),
(408,1,'can'),
(409,1,'find'),
(410,1,'something'),
(411,1,'than'),
(412,1,'just'),
(413,1,'real'),
(414,1,'understand'),
(415,1,'complicated'),
(416,1,'amaze'),
(417,1,'present'),
(418,1,'they'),
(419,1,'whimsical'),
(420,1,'but'),
(421,1,'flexible'),
(422,1,'reliable'),
(423,1,'xxl'),
(424,2,'hood'),
(425,2,'scholtes'),
(426,2,'hse'),
(427,2,'159'),
(428,2,'here'),
(429,2,'can'),
(430,2,'find'),
(431,2,'something'),
(432,2,'than'),
(433,2,'just'),
(434,2,'real'),
(435,2,'understand'),
(436,2,'complicated'),
(437,2,'amaze'),
(438,2,'present'),
(439,2,'they'),
(440,2,'whimsical'),
(441,2,'but'),
(442,2,'flexible'),
(443,2,'reliable'),
(444,2,'xxl'),
(445,3,'hood'),
(446,3,'scholtes'),
(447,3,'hse'),
(448,3,'159'),
(449,3,'here'),
(450,3,'can'),
(451,3,'find'),
(452,3,'something'),
(453,3,'than'),
(454,3,'just'),
(455,3,'real'),
(456,3,'understand'),
(457,3,'complicated'),
(458,3,'amaze'),
(459,3,'present'),
(460,3,'they'),
(461,3,'whimsical'),
(462,3,'but'),
(463,3,'flexible'),
(464,3,'reliable'),
(465,3,'xxl'),
(466,4,'hood'),
(467,4,'scholtes'),
(468,4,'hse'),
(469,4,'159'),
(470,4,'here'),
(471,4,'can'),
(472,4,'find'),
(473,4,'something'),
(474,4,'than'),
(475,4,'just'),
(476,4,'real'),
(477,4,'understand'),
(478,4,'complicated'),
(479,4,'amaze'),
(480,4,'present'),
(481,4,'they'),
(482,4,'whimsical'),
(483,4,'but'),
(484,4,'flexible'),
(485,4,'reliable'),
(486,4,'xxl'),
(487,5,'hood'),
(488,5,'scholtes'),
(489,5,'hse'),
(490,5,'159'),
(491,5,'here'),
(492,5,'can'),
(493,5,'find'),
(494,5,'something'),
(495,5,'than'),
(496,5,'just'),
(497,5,'real'),
(498,5,'understand'),
(499,5,'complicated'),
(500,5,'amaze'),
(501,5,'present'),
(502,5,'they'),
(503,5,'whimsical'),
(504,5,'but'),
(505,5,'flexible'),
(506,5,'reliable'),
(507,5,'xxl'),
(508,1,'aeg'),
(509,1,'ultraactive'),
(510,1,'tremendous'),
(511,1,'variety'),
(512,1,'models'),
(513,1,'consectetur'),
(514,1,'elit'),
(515,2,'aeg'),
(516,2,'ultraactive'),
(517,2,'tremendous'),
(518,2,'variety'),
(519,2,'models'),
(520,2,'consectetur'),
(521,2,'elit'),
(522,3,'aeg'),
(523,3,'ultraactive'),
(524,3,'tremendous'),
(525,3,'variety'),
(526,3,'models'),
(527,3,'consectetur'),
(528,3,'elit'),
(529,4,'aeg'),
(530,4,'ultraactive'),
(531,4,'tremendous'),
(532,4,'variety'),
(533,4,'models'),
(534,4,'consectetur'),
(535,4,'elit'),
(536,5,'aeg'),
(537,5,'ultraactive'),
(538,5,'tremendous'),
(539,5,'variety'),
(540,5,'models'),
(541,5,'consectetur'),
(542,5,'elit'),
(543,1,'siemens'),
(544,1,'kd36na40'),
(545,1,'fridge'),
(546,1,'freezer'),
(547,1,'claims'),
(548,1,'become'),
(549,1,'scrupulous'),
(550,1,'sometimes'),
(551,1,'hard'),
(552,1,'them'),
(553,1,'trying'),
(554,1,'introduce'),
(555,1,'positive'),
(556,1,'results'),
(557,1,'explorations'),
(558,1,'provide'),
(559,1,'bestsellers'),
(560,1,'great'),
(561,1,'number'),
(562,1,'options'),
(563,1,'really'),
(564,1,'help'),
(565,1,'amazed'),
(566,1,'with'),
(567,1,'its'),
(568,1,'simplicity'),
(569,1,'durability'),
(570,2,'siemens'),
(571,2,'kd36na40'),
(572,2,'fridge'),
(573,2,'freezer'),
(574,2,'claims'),
(575,2,'become'),
(576,2,'scrupulous'),
(577,2,'sometimes'),
(578,2,'hard'),
(579,2,'them'),
(580,2,'trying'),
(581,2,'introduce'),
(582,2,'positive'),
(583,2,'results'),
(584,2,'explorations'),
(585,2,'provide'),
(586,2,'bestsellers'),
(587,2,'great'),
(588,2,'number'),
(589,2,'options'),
(590,2,'really'),
(591,2,'help'),
(592,2,'amazed'),
(593,2,'with'),
(594,2,'its'),
(595,2,'simplicity'),
(596,2,'durability'),
(597,3,'siemens'),
(598,3,'kd36na40'),
(599,3,'fridge'),
(600,3,'freezer'),
(601,3,'claims'),
(602,3,'become'),
(603,3,'scrupulous'),
(604,3,'sometimes'),
(605,3,'hard'),
(606,3,'them'),
(607,3,'trying'),
(608,3,'introduce'),
(609,3,'positive'),
(610,3,'results'),
(611,3,'explorations'),
(612,3,'provide'),
(613,3,'bestsellers'),
(614,3,'great'),
(615,3,'number'),
(616,3,'options'),
(617,3,'really'),
(618,3,'help'),
(619,3,'amazed'),
(620,3,'with'),
(621,3,'its'),
(622,3,'simplicity'),
(623,3,'durability'),
(624,4,'siemens'),
(625,4,'kd36na40'),
(626,4,'fridge'),
(627,4,'freezer'),
(628,4,'claims'),
(629,4,'become'),
(630,4,'scrupulous'),
(631,4,'sometimes'),
(632,4,'hard'),
(633,4,'them'),
(634,4,'trying'),
(635,4,'introduce'),
(636,4,'positive'),
(637,4,'results'),
(638,4,'explorations'),
(639,4,'provide'),
(640,4,'bestsellers'),
(641,4,'great'),
(642,4,'number'),
(643,4,'options'),
(644,4,'really'),
(645,4,'help'),
(646,4,'amazed'),
(647,4,'with'),
(648,4,'its'),
(649,4,'simplicity'),
(650,4,'durability'),
(651,5,'siemens'),
(652,5,'kd36na40'),
(653,5,'fridge'),
(654,5,'freezer'),
(655,5,'claims'),
(656,5,'become'),
(657,5,'scrupulous'),
(658,5,'sometimes'),
(659,5,'hard'),
(660,5,'them'),
(661,5,'trying'),
(662,5,'introduce'),
(663,5,'positive'),
(664,5,'results'),
(665,5,'explorations'),
(666,5,'provide'),
(667,5,'bestsellers'),
(668,5,'great'),
(669,5,'number'),
(670,5,'options'),
(671,5,'really'),
(672,5,'help'),
(673,5,'amazed'),
(674,5,'with'),
(675,5,'its'),
(676,5,'simplicity'),
(677,5,'durability'),
(678,1,'meat'),
(679,1,'grinder'),
(680,1,'smg'),
(681,1,'4382'),
(682,1,'also'),
(683,1,'economical'),
(684,1,'social'),
(685,1,'even'),
(686,1,'technological'),
(687,1,'researches'),
(688,1,'save'),
(689,1,'some'),
(690,1,'money'),
(691,1,'always'),
(692,1,'promos'),
(693,1,'get'),
(694,1,'good'),
(695,1,'discount'),
(696,1,'other'),
(697,1,'benefits'),
(698,2,'meat'),
(699,2,'grinder'),
(700,2,'smg'),
(701,2,'4382'),
(702,2,'also'),
(703,2,'economical'),
(704,2,'social'),
(705,2,'even'),
(706,2,'technological'),
(707,2,'researches'),
(708,2,'save'),
(709,2,'some'),
(710,2,'money'),
(711,2,'always'),
(712,2,'promos'),
(713,2,'get'),
(714,2,'good'),
(715,2,'discount'),
(716,2,'other'),
(717,2,'benefits'),
(718,3,'meat'),
(719,3,'grinder'),
(720,3,'smg'),
(721,3,'4382'),
(722,3,'also'),
(723,3,'economical'),
(724,3,'social'),
(725,3,'even'),
(726,3,'technological'),
(727,3,'researches'),
(728,3,'save'),
(729,3,'some'),
(730,3,'money'),
(731,3,'always'),
(732,3,'promos'),
(733,3,'get'),
(734,3,'good'),
(735,3,'discount'),
(736,3,'other'),
(737,3,'benefits'),
(738,4,'meat'),
(739,4,'grinder'),
(740,4,'smg'),
(741,4,'4382'),
(742,4,'also'),
(743,4,'economical'),
(744,4,'social'),
(745,4,'even'),
(746,4,'technological'),
(747,4,'researches'),
(748,4,'save'),
(749,4,'some'),
(750,4,'money'),
(751,4,'always'),
(752,4,'promos'),
(753,4,'get'),
(754,4,'good'),
(755,4,'discount'),
(756,4,'other'),
(757,4,'benefits'),
(758,5,'meat'),
(759,5,'grinder'),
(760,5,'smg'),
(761,5,'4382'),
(762,5,'also'),
(763,5,'economical'),
(764,5,'social'),
(765,5,'even'),
(766,5,'technological'),
(767,5,'researches'),
(768,5,'save'),
(769,5,'some'),
(770,5,'money'),
(771,5,'always'),
(772,5,'promos'),
(773,5,'get'),
(774,5,'good'),
(775,5,'discount'),
(776,5,'other'),
(777,5,'benefits'),
(778,1,'applica'),
(779,1,'fp1600b'),
(780,1,'cup'),
(781,1,'food'),
(782,1,'processor'),
(783,1,'manufacturers'),
(784,1,'vendors'),
(785,1,'new'),
(786,1,'technologies'),
(787,1,'see'),
(788,1,'furious'),
(789,1,'development'),
(790,1,'industry'),
(791,1,'main'),
(792,1,'goal'),
(793,1,'their'),
(794,1,'analysis'),
(795,1,'out'),
(796,1,'changes'),
(797,1,'demands'),
(798,1,'useful'),
(799,1,'data'),
(800,2,'applica'),
(801,2,'fp1600b'),
(802,2,'cup'),
(803,2,'food'),
(804,2,'processor'),
(805,2,'manufacturers'),
(806,2,'vendors'),
(807,2,'new'),
(808,2,'technologies'),
(809,2,'see'),
(810,2,'furious'),
(811,2,'development'),
(812,2,'industry'),
(813,2,'main'),
(814,2,'goal'),
(815,2,'their'),
(816,2,'analysis'),
(817,2,'out'),
(818,2,'changes'),
(819,2,'demands'),
(820,2,'useful'),
(821,2,'data'),
(822,3,'applica'),
(823,3,'fp1600b'),
(824,3,'cup'),
(825,3,'food'),
(826,3,'processor'),
(827,3,'manufacturers'),
(828,3,'vendors'),
(829,3,'new'),
(830,3,'technologies'),
(831,3,'see'),
(832,3,'furious'),
(833,3,'development'),
(834,3,'industry'),
(835,3,'main'),
(836,3,'goal'),
(837,3,'their'),
(838,3,'analysis'),
(839,3,'out'),
(840,3,'changes'),
(841,3,'demands'),
(842,3,'useful'),
(843,3,'data'),
(844,4,'applica'),
(845,4,'fp1600b'),
(846,4,'cup'),
(847,4,'food'),
(848,4,'processor'),
(849,4,'manufacturers'),
(850,4,'vendors'),
(851,4,'new'),
(852,4,'technologies'),
(853,4,'see'),
(854,4,'furious'),
(855,4,'development'),
(856,4,'industry'),
(857,4,'main'),
(858,4,'goal'),
(859,4,'their'),
(860,4,'analysis'),
(861,4,'out'),
(862,4,'changes'),
(863,4,'demands'),
(864,4,'useful'),
(865,4,'data'),
(866,5,'applica'),
(867,5,'fp1600b'),
(868,5,'cup'),
(869,5,'food'),
(870,5,'processor'),
(871,5,'manufacturers'),
(872,5,'vendors'),
(873,5,'new'),
(874,5,'technologies'),
(875,5,'see'),
(876,5,'furious'),
(877,5,'development'),
(878,5,'industry'),
(879,5,'main'),
(880,5,'goal'),
(881,5,'their'),
(882,5,'analysis'),
(883,5,'out'),
(884,5,'changes'),
(885,5,'demands'),
(886,5,'useful'),
(887,5,'data'),
(888,1,'bosch'),
(889,1,'tds3569gb'),
(890,1,'2800w'),
(891,1,'sensixx'),
(892,1,'b35l'),
(893,1,'premier'),
(894,1,'power'),
(895,1,'steam'),
(896,1,'generator'),
(897,1,'iron'),
(898,1,'want'),
(899,1,'information'),
(900,1,'about'),
(901,1,'terms'),
(902,1,'guarantees'),
(903,1,'features'),
(904,1,'address'),
(905,1,'superb'),
(906,1,'247'),
(907,1,'support'),
(908,1,'system'),
(909,2,'bosch'),
(910,2,'tds3569gb'),
(911,2,'2800w'),
(912,2,'sensixx'),
(913,2,'b35l'),
(914,2,'premier'),
(915,2,'power'),
(916,2,'steam'),
(917,2,'generator'),
(918,2,'iron'),
(919,2,'want'),
(920,2,'information'),
(921,2,'about'),
(922,2,'terms'),
(923,2,'guarantees'),
(924,2,'features'),
(925,2,'address'),
(926,2,'superb'),
(927,2,'247'),
(928,2,'support'),
(929,2,'system'),
(930,3,'bosch'),
(931,3,'tds3569gb'),
(932,3,'2800w'),
(933,3,'sensixx'),
(934,3,'b35l'),
(935,3,'premier'),
(936,3,'power'),
(937,3,'steam'),
(938,3,'generator'),
(939,3,'iron'),
(940,3,'want'),
(941,3,'information'),
(942,3,'about'),
(943,3,'terms'),
(944,3,'guarantees'),
(945,3,'features'),
(946,3,'address'),
(947,3,'superb'),
(948,3,'247'),
(949,3,'support'),
(950,3,'system'),
(951,4,'bosch'),
(952,4,'tds3569gb'),
(953,4,'2800w'),
(954,4,'sensixx'),
(955,4,'b35l'),
(956,4,'premier'),
(957,4,'power'),
(958,4,'steam'),
(959,4,'generator'),
(960,4,'iron'),
(961,4,'want'),
(962,4,'information'),
(963,4,'about'),
(964,4,'terms'),
(965,4,'guarantees'),
(966,4,'features'),
(967,4,'address'),
(968,4,'superb'),
(969,4,'247'),
(970,4,'support'),
(971,4,'system'),
(972,5,'bosch'),
(973,5,'tds3569gb'),
(974,5,'2800w'),
(975,5,'sensixx'),
(976,5,'b35l'),
(977,5,'premier'),
(978,5,'power'),
(979,5,'steam'),
(980,5,'generator'),
(981,5,'iron'),
(982,5,'want'),
(983,5,'information'),
(984,5,'about'),
(985,5,'terms'),
(986,5,'guarantees'),
(987,5,'features'),
(988,5,'address'),
(989,5,'superb'),
(990,5,'247'),
(991,5,'support'),
(992,5,'system'),
(993,1,'coffee'),
(994,1,'machine'),
(995,1,'bugatti'),
(996,1,'diva'),
(997,2,'coffee'),
(998,2,'machine'),
(999,2,'bugatti'),
(1000,2,'diva'),
(1001,3,'coffee'),
(1002,3,'machine'),
(1003,3,'bugatti'),
(1004,3,'diva'),
(1005,4,'coffee'),
(1006,4,'machine'),
(1007,4,'bugatti'),
(1008,4,'diva'),
(1009,5,'coffee'),
(1010,5,'machine'),
(1011,5,'bugatti'),
(1012,5,'diva'),
(1013,1,'kalorik'),
(1014,1,'aztec'),
(1015,1,'remember'),
(1016,1,'buy'),
(1017,1,'fashionable'),
(1018,1,'solid'),
(1019,1,'functional'),
(1020,2,'kalorik'),
(1021,2,'aztec'),
(1022,2,'remember'),
(1023,2,'buy'),
(1024,2,'fashionable'),
(1025,2,'solid'),
(1026,2,'functional'),
(1027,3,'kalorik'),
(1028,3,'aztec'),
(1029,3,'remember'),
(1030,3,'buy'),
(1031,3,'fashionable'),
(1032,3,'solid'),
(1033,3,'functional'),
(1034,4,'kalorik'),
(1035,4,'aztec'),
(1036,4,'remember'),
(1037,4,'buy'),
(1038,4,'fashionable'),
(1039,4,'solid'),
(1040,4,'functional'),
(1041,5,'kalorik'),
(1042,5,'aztec'),
(1043,5,'remember'),
(1044,5,'buy'),
(1045,5,'fashionable'),
(1046,5,'solid'),
(1047,5,'functional'),
(1048,1,'malongo'),
(1049,1,'espressogold'),
(1050,2,'malongo'),
(1051,2,'espressogold'),
(1052,3,'malongo'),
(1053,3,'espressogold'),
(1054,4,'malongo'),
(1055,4,'espressogold'),
(1056,5,'malongo'),
(1057,5,'espressogold'),
(1058,1,'maker'),
(1059,1,'assimo'),
(1060,2,'maker'),
(1061,2,'assimo'),
(1062,3,'maker'),
(1063,3,'assimo'),
(1064,4,'maker'),
(1065,4,'assimo'),
(1066,5,'maker'),
(1067,5,'assimo'),
(1068,1,'def'),
(1069,1,'18w804'),
(1070,2,'def'),
(1071,2,'18w804'),
(1072,3,'def'),
(1073,3,'18w804'),
(1074,4,'def'),
(1075,4,'18w804'),
(1076,5,'def'),
(1077,5,'18w804'),
(1078,1,'hairdryer'),
(1079,1,'d4444'),
(1080,1,'shine'),
(1081,1,'dryer'),
(1082,2,'hairdryer'),
(1083,2,'d4444'),
(1084,2,'shine'),
(1085,2,'dryer'),
(1086,3,'hairdryer'),
(1087,3,'d4444'),
(1088,3,'shine'),
(1089,3,'dryer'),
(1090,4,'hairdryer'),
(1091,4,'d4444'),
(1092,4,'shine'),
(1093,4,'dryer'),
(1094,5,'hairdryer'),
(1095,5,'d4444'),
(1096,5,'shine'),
(1097,5,'dryer'),
(1098,1,'fhd'),
(1099,1,'10c666'),
(1100,2,'fhd'),
(1101,2,'10c666'),
(1102,3,'fhd'),
(1103,3,'10c666'),
(1104,4,'fhd'),
(1105,4,'10c666'),
(1106,5,'fhd'),
(1107,5,'10c666'),
(1108,1,'phd'),
(1109,1,'30b661'),
(1110,2,'phd'),
(1111,2,'30b661'),
(1112,3,'phd'),
(1113,3,'30b661'),
(1114,4,'phd'),
(1115,4,'30b661'),
(1116,5,'phd'),
(1117,5,'30b661'),
(1118,1,'hamilton'),
(1119,1,'beach'),
(1120,1,'72703'),
(1121,1,'ensemble'),
(1122,1,'chopper'),
(1123,2,'hamilton'),
(1124,2,'beach'),
(1125,2,'72703'),
(1126,2,'ensemble'),
(1127,2,'chopper'),
(1128,3,'hamilton'),
(1129,3,'beach'),
(1130,3,'72703'),
(1131,3,'ensemble'),
(1132,3,'chopper'),
(1133,4,'hamilton'),
(1134,4,'beach'),
(1135,4,'72703'),
(1136,4,'ensemble'),
(1137,4,'chopper'),
(1138,5,'hamilton'),
(1139,5,'beach'),
(1140,5,'72703'),
(1141,5,'ensemble'),
(1142,5,'chopper'),
(1143,1,'cda'),
(1144,1,'evck4ss'),
(1145,1,'40cm'),
(1146,1,'cylinder'),
(1147,2,'cda'),
(1148,2,'evck4ss'),
(1149,2,'40cm'),
(1150,2,'cylinder'),
(1151,3,'cda'),
(1152,3,'evck4ss'),
(1153,3,'40cm'),
(1154,3,'cylinder'),
(1155,4,'cda'),
(1156,4,'evck4ss'),
(1157,4,'40cm'),
(1158,4,'cylinder'),
(1159,5,'cda'),
(1160,5,'evck4ss'),
(1161,5,'40cm'),
(1162,5,'cylinder'),
(1163,1,'faber'),
(1164,1,'klima'),
(1165,2,'faber'),
(1166,2,'klima'),
(1167,3,'faber'),
(1168,3,'klima'),
(1169,4,'faber'),
(1170,4,'klima'),
(1171,5,'faber'),
(1172,5,'klima'),
(1173,1,'whirpool'),
(1174,1,'akr806ix'),
(1175,2,'whirpool'),
(1176,2,'akr806ix'),
(1177,3,'whirpool'),
(1178,3,'akr806ix'),
(1179,4,'whirpool'),
(1180,4,'akr806ix'),
(1181,5,'whirpool'),
(1182,5,'akr806ix'),
(1183,1,'hoover'),
(1184,1,'xarion'),
(1185,1,'bagless'),
(1186,2,'hoover'),
(1187,2,'xarion'),
(1188,2,'bagless'),
(1189,3,'hoover'),
(1190,3,'xarion'),
(1191,3,'bagless'),
(1192,4,'hoover'),
(1193,4,'xarion'),
(1194,4,'bagless'),
(1195,5,'hoover'),
(1196,5,'xarion'),
(1197,5,'bagless'),
(1198,1,'mgr25959'),
(1199,1,'stainless'),
(1200,1,'steel'),
(1201,1,'blade'),
(1202,2,'mgr25959'),
(1203,2,'stainless'),
(1204,2,'steel'),
(1205,2,'blade'),
(1206,3,'mgr25959'),
(1207,3,'stainless'),
(1208,3,'steel'),
(1209,3,'blade'),
(1210,4,'mgr25959'),
(1211,4,'stainless'),
(1212,4,'steel'),
(1213,4,'blade'),
(1214,5,'mgr25959'),
(1215,5,'stainless'),
(1216,5,'steel'),
(1217,5,'blade'),
(1218,1,'refrigerator'),
(1219,1,'floral'),
(1220,1,'collection'),
(1221,1,'t676'),
(1222,2,'refrigerator'),
(1223,2,'floral'),
(1224,2,'collection'),
(1225,2,'t676'),
(1226,3,'refrigerator'),
(1227,3,'floral'),
(1228,3,'collection'),
(1229,3,'t676'),
(1230,4,'refrigerator'),
(1231,4,'floral'),
(1232,4,'collection'),
(1233,4,'t676'),
(1234,5,'refrigerator'),
(1235,5,'floral'),
(1236,5,'collection'),
(1237,5,'t676'),
(1238,1,'avilla'),
(1239,1,'av0304'),
(1240,2,'avilla'),
(1241,2,'av0304'),
(1242,3,'avilla'),
(1243,3,'av0304'),
(1244,4,'avilla'),
(1245,4,'av0304'),
(1246,5,'avilla'),
(1247,5,'av0304'),
(1248,1,'mg2050'),
(1249,2,'mg2050'),
(1250,3,'mg2050'),
(1251,4,'mg2050'),
(1252,5,'mg2050'),
(1253,1,'modern'),
(1254,1,'fagor'),
(1255,1,'ffa8865'),
(1256,2,'modern'),
(1257,2,'fagor'),
(1258,2,'ffa8865'),
(1259,3,'modern'),
(1260,3,'fagor'),
(1261,3,'ffa8865'),
(1262,4,'modern'),
(1263,4,'fagor'),
(1264,4,'ffa8865'),
(1265,5,'modern'),
(1266,5,'fagor'),
(1267,5,'ffa8865'),
(1268,1,'sidebyside'),
(1269,2,'sidebyside'),
(1270,3,'sidebyside'),
(1271,4,'sidebyside'),
(1272,5,'sidebyside'),
(1273,1,'smeg'),
(1274,1,'compact'),
(1275,1,'minifridge'),
(1276,1,'fab10uj'),
(1277,2,'smeg'),
(1278,2,'compact'),
(1279,2,'minifridge'),
(1280,2,'fab10uj'),
(1281,3,'smeg'),
(1282,3,'compact'),
(1283,3,'minifridge'),
(1284,3,'fab10uj'),
(1285,4,'smeg'),
(1286,4,'compact'),
(1287,4,'minifridge'),
(1288,4,'fab10uj'),
(1289,5,'smeg'),
(1290,5,'compact'),
(1291,5,'minifridge'),
(1292,5,'fab10uj'),
(1293,1,'contemporary'),
(1294,1,'fpd'),
(1295,2,'contemporary'),
(1296,2,'fpd'),
(1297,3,'contemporary'),
(1298,3,'fpd'),
(1299,4,'contemporary'),
(1300,4,'fpd'),
(1301,5,'contemporary'),
(1302,5,'fpd'),
(1303,1,'wash'),
(1304,1,'thomas'),
(1305,1,'twin'),
(1306,2,'wash'),
(1307,2,'thomas'),
(1308,2,'twin'),
(1309,3,'wash'),
(1310,3,'thomas'),
(1311,3,'twin'),
(1312,4,'wash'),
(1313,4,'thomas'),
(1314,4,'twin'),
(1315,5,'wash'),
(1316,5,'thomas'),
(1317,5,'twin'),
(1318,1,'lorem'),
(1319,1,'ipsum'),
(1320,1,'dolor'),
(1321,1,'sit'),
(1322,1,'amet');

/* Table structure for table `ps_specific_price` */
DROP TABLE IF EXISTS `ps_specific_price`;

CREATE TABLE `ps_specific_price` (
  `id_specific_price` int(10) unsigned NOT NULL auto_increment,
  `id_product` int(10) unsigned NOT NULL,
  `id_shop` tinyint(3) unsigned NOT NULL,
  `id_currency` int(10) unsigned NOT NULL,
  `id_country` int(10) unsigned NOT NULL,
  `id_group` int(10) unsigned NOT NULL,
  `price` decimal(20,6) NOT NULL,
  `from_quantity` mediumint(8) unsigned NOT NULL,
  `reduction` decimal(20,6) NOT NULL,
  `reduction_type` enum('amount','percentage') NOT NULL,
  `from` datetime NOT NULL,
  `to` datetime NOT NULL,
  PRIMARY KEY  (`id_specific_price`),
  KEY `id_product` (`id_product`,`id_shop`,`id_currency`,`id_country`,`id_group`,`from_quantity`,`from`,`to`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_specific_price` */
INSERT INTO `ps_specific_price` VALUES
(1,1,0,0,0,0,'0.000000',10,'0.200000','percentage','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(2,3,0,0,0,0,'0.000000',1,'0.100000','percentage','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(3,13,0,0,0,0,'0.000000',1,'0.300000','percentage','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(4,17,0,0,0,0,'0.000000',1,'0.200000','percentage','0000-00-00 00:00:00','0000-00-00 00:00:00');

/* Table structure for table `ps_specific_price_priority` */
DROP TABLE IF EXISTS `ps_specific_price_priority`;

CREATE TABLE `ps_specific_price_priority` (
  `id_specific_price_priority` int(11) NOT NULL auto_increment,
  `id_product` int(11) NOT NULL,
  `priority` varchar(80) NOT NULL,
  PRIMARY KEY  (`id_specific_price_priority`,`id_product`),
  UNIQUE KEY `id_product` (`id_product`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;


/* Table structure for table `ps_store` */
DROP TABLE IF EXISTS `ps_store`;

CREATE TABLE `ps_store` (
  `id_store` int(10) unsigned NOT NULL auto_increment,
  `id_country` int(10) unsigned NOT NULL,
  `id_state` int(10) unsigned default NULL,
  `name` varchar(128) NOT NULL,
  `address1` varchar(128) NOT NULL,
  `address2` varchar(128) default NULL,
  `city` varchar(64) NOT NULL,
  `postcode` varchar(12) NOT NULL,
  `latitude` decimal(11,8) default NULL,
  `longitude` decimal(11,8) default NULL,
  `hours` varchar(254) default NULL,
  `phone` varchar(16) default NULL,
  `fax` varchar(16) default NULL,
  `email` varchar(128) default NULL,
  `note` text,
  `active` tinyint(1) unsigned NOT NULL default '0',
  `date_add` datetime NOT NULL,
  `date_upd` datetime NOT NULL,
  PRIMARY KEY  (`id_store`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_store` */
INSERT INTO `ps_store` VALUES
(1,21,9,'Dade County','3030 SW 8th St Miami','','Miami',' 33135','25.76500500','-80.24379700','a:7:{i:0;s:13:\"09:00 - 19:00\";i:1;s:13:\"09:00 - 19:00\";i:2;s:13:\"09:00 - 19:00\";i:3;s:13:\"09:00 - 19:00\";i:4;s:13:\"09:00 - 19:00\";i:5;s:13:\"10:00 - 16:00\";i:6;s:13:\"10:00 - 16:00\";}','','','','',1,'2010-11-09 10:53:13','2010-11-09 10:53:13'),
(2,21,9,'E Fort Lauderdale','1000 Northeast 4th Ave Fort Lauderdale','','Miami',' 33304','26.13793600','-80.13943500','a:7:{i:0;s:13:\"09:00 - 19:00\";i:1;s:13:\"09:00 - 19:00\";i:2;s:13:\"09:00 - 19:00\";i:3;s:13:\"09:00 - 19:00\";i:4;s:13:\"09:00 - 19:00\";i:5;s:13:\"10:00 - 16:00\";i:6;s:13:\"10:00 - 16:00\";}','','','','',1,'2010-11-09 10:56:26','2010-11-09 10:56:26'),
(3,21,9,'Pembroke Pines','11001 Pines Blvd Pembroke Pines','','Miami','33026','26.00998700','-80.29447200','a:7:{i:0;s:13:\"09:00 - 19:00\";i:1;s:13:\"09:00 - 19:00\";i:2;s:13:\"09:00 - 19:00\";i:3;s:13:\"09:00 - 19:00\";i:4;s:13:\"09:00 - 19:00\";i:5;s:13:\"10:00 - 16:00\";i:6;s:13:\"10:00 - 16:00\";}','','','','',1,'2010-11-09 10:58:42','2010-11-09 11:01:11'),
(4,21,9,'Coconut Grove','2999 SW 32nd Avenue','',' Miami',' 33133','25.73629600','-80.24479700','a:7:{i:0;s:13:\"09:00 - 19:00\";i:1;s:13:\"09:00 - 19:00\";i:2;s:13:\"09:00 - 19:00\";i:3;s:13:\"09:00 - 19:00\";i:4;s:13:\"09:00 - 19:00\";i:5;s:13:\"10:00 - 16:00\";i:6;s:13:\"10:00 - 16:00\";}','','','','',1,'2010-11-09 11:00:38','2010-11-09 11:04:52'),
(5,21,9,'N Miami/Biscayne','12055 Biscayne Blvd','','Miami','33181','25.88674000','-80.16329200','a:7:{i:0;s:13:\"09:00 - 19:00\";i:1;s:13:\"09:00 - 19:00\";i:2;s:13:\"09:00 - 19:00\";i:3;s:13:\"09:00 - 19:00\";i:4;s:13:\"09:00 - 19:00\";i:5;s:13:\"10:00 - 16:00\";i:6;s:13:\"10:00 - 16:00\";}','','','','',1,'2010-11-09 11:11:28','2010-11-09 11:11:28');

/* Table structure for table `ps_supplier` */
DROP TABLE IF EXISTS `ps_supplier`;

CREATE TABLE `ps_supplier` (
  `id_supplier` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(64) NOT NULL,
  `date_add` datetime NOT NULL,
  `date_upd` datetime NOT NULL,
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id_supplier`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_supplier` */
INSERT INTO `ps_supplier` VALUES
(1,'Adipisicing','2012-05-21 14:38:05','2012-05-22 13:01:51',1),
(2,'Consectetur elit','2012-05-21 14:38:05','2012-05-22 13:01:44',1);

/* Table structure for table `ps_supplier_lang` */
DROP TABLE IF EXISTS `ps_supplier_lang`;

CREATE TABLE `ps_supplier_lang` (
  `id_supplier` int(10) unsigned NOT NULL,
  `id_lang` int(10) unsigned NOT NULL,
  `description` text,
  `meta_title` varchar(128) default NULL,
  `meta_keywords` varchar(255) default NULL,
  `meta_description` varchar(255) default NULL,
  PRIMARY KEY  (`id_supplier`,`id_lang`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

/* dumping data for table `ps_supplier_lang` */
INSERT INTO `ps_supplier_lang` VALUES
(1,1,'','','',''),
(1,2,'','','',''),
(1,3,'','','',''),
(1,4,'','','',''),
(1,5,'','','',''),
(2,1,'Donec condimentum accumsan erat ut vestibulum. Aenean vestibulum commodo faucibus','','',''),
(2,2,'','','',''),
(2,3,'','','',''),
(2,4,'','','',''),
(2,5,'','','','');

/* Table structure for table `ps_tag` */
DROP TABLE IF EXISTS `ps_tag`;

CREATE TABLE `ps_tag` (
  `id_tag` int(10) unsigned NOT NULL auto_increment,
  `id_lang` int(10) unsigned NOT NULL,
  `name` varchar(32) NOT NULL,
  PRIMARY KEY  (`id_tag`),
  KEY `tag_name` (`name`),
  KEY `id_lang` (`id_lang`)
) ENGINE=MyISAM AUTO_INCREMENT=38 DEFAULT CHARSET=utf8;

/* dumping data for table `ps_tag` */
INSERT INTO `ps_tag` VALUES
(5,1,'Lorem Ipsum'),
(6,1,'Dolor'),
(7,1,'Sit Amet');

